<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////
							
						admin_validate_section("getpaid",1);
						$action = $GLOBALS["Get"]->val("action");
								
							switch($action){
										
								case '':
									getpaid_manager();
									break;
									
								case 'getpaid_switch':
									getpaid_switch();
									break;
								
								case 'getpaid_edit_settings':
									getpaid_edit_settings();
									break;
									
								case 'getpaid_save_settings':
									getpaid_save_settings();
									break;
									
								case 'getpaid_create_package':
									getpaid_create_package();
									break;
									
								case 'getpaid_save_package':
									getpaid_save_package();
									break;
									
								case 'getpaid_system':
									getpaid_system();
									break;
									
								case 'getpaid_save_system':
									getpaid_save_system();
									break;
									
								case 'getpaid_delete_package':
									getpaid_delete_package();
									break;
									
								case 'getpaid_delete_system':
									getpaid_delete_system();
									break;
									
							}//switch
							
						///////////////////////////////////////
						
function getpaid_manager(){
	
	admin_validate();
	
	$data["section"] = "getpaid";
	$data["subsection"] = 1;
	$data["title_id"] = "14";	
	$data["themes"] = admin_get_themes();	
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
		
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	$data["getpaid"] = $getpaid;
	
	$layout[0] = "getpaid_settings";
	
	admin_output($layout,$data);
	
}//getpaid_manager
						
function getpaid_switch(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$getpaid["enabled"] = abs($getpaid["enabled"]-1);
	
	module_save_settings($theme,"getpaid",$getpaid);
	
	load_page("index.php?section=getpaid&theme=".$data["theme"]);
	
}//getpaid_switch

function getpaid_edit_settings(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$data["title_id"] = "15";
	$data["section"] = "getpaid";
	$data["subsection"] = 1;

	$data["values"] = $getpaid["free"];
	
	$cats = handle_empties( explode(",", $data["values"]["categories"]) );
	$data["values"]["categories"] = array();
	foreach($cats as $c) {
		$data["values"]["categories"][$c] = 1;
	}
	
	include(DOC_ROOT."/themes/".$theme."/system/video_categories.inc.php");
	$data["categories"] = $categories;
	
	$data["link"] = "index.php?section=getpaid&theme=".$data["theme"];
	
	$data["javascript"] = <<<HTMLTEXT
<script language="JavaScript">
<!--
	function HS_ShowBlock(BlockID){
		var El = document.getElementById(BlockID);
		if(El)
			El.style.display = "";
	}//HS_ShowBlock
	function HS_HideBlocks(Blocks){
		var IDs = new Array;
		IDs = Blocks.split(",");
		for(var i=0;i<IDs.length;i++){
			var Elem = document.getElementById(IDs[i]);
			Elem.style.display = "none";
		}//for
	}//HS_HideBlocks
//-->
</script>
HTMLTEXT;
	
	$layout[0] = "getpaid_edit_settings";
	
	admin_output($layout,$data);
	
}

function getpaid_save_settings(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$vals = array(
		"allow",
		"access",
		"download",
		"categories",
		"seconds"
	);
	
	$values = $GLOBALS["Get"]->arr($vals,1);
	
	$getpaid["free"]["allow"]  = $values["allow"];
	$getpaid["free"]["access"] = $values["access"];
	$getpaid["free"]["download"] = $values["download"];
	
	if($values["access"] == 1) {
		$cats = array_keys( $values["categories"] );
		$getpaid["free"]["categories"] = implode(",", $cats);
	}
	
	if($values["access"] == 2) {
		$getpaid["free"]["seconds"] = $values["seconds"];
	}
	
	module_save_settings($theme,"getpaid",$getpaid);
	
	load_page("index.php?section=getpaid&action=getpaid_edit_settings&theme=".$data["theme"]);
	
}

function getpaid_create_package(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$data["title_id"] = "15";
	$data["section"] = "getpaid";
	$data["subsection"] = 1;
	
	$package_id = $GLOBALS["Get"]->type_val("package_id","integer");
	
	if(!$package_id){
	
		$vals = array(
			"name",
			"price",
			"currency",
			"period"
		);
	
		$data["values"] = $GLOBALS["Get"]->arr($vals,1);
	
		$interval = $GLOBALS["Get"]->val("interval");
		if(!empty($data["values"]["period"])){
			$ind = strtolower($data["values"]["period"]);
			$data["values"]["interval"] = $interval[$ind];
		}//if
		
	}//if
	else{
		
		$data["package_id"] = $package_id;
		$data["values"] = $getpaid["membership"][$package_id];
		
	}//else
	
	$data["link"] = "index.php?section=getpaid&theme=".$data["theme"];
	
	$layout[0] = "getpaid_create_package";
	
	admin_output($layout,$data);
	
}//getpaid_create_package

function getpaid_save_package(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	$package_id = $GLOBALS["Get"]->type_val("package_id","integer");
	if(empty($package_id))
		$package_id = @max(array_keys($getpaid["membership"])) + 1;
	
	$vals = array(
		"name",
		"price",
		"currency",
		"period"
	);
	
	$values = $GLOBALS["Get"]->arr($vals,1);
	
	$interval = $GLOBALS["Get"]->val("interval");
	if(!empty($values["period"])){
		$ind = strtolower($values["period"]);
		$values["interval"] = $interval[$ind];
	}//if
	
	if(empty($values["name"])){
		$GLOBALS["aerr_id"] = 5;
		getpaid_create_package();
		exit;
	}//if
	if(empty($values["price"]) && !$free_account_available){
		$GLOBALS["aerr_id"] = 6;
		getpaid_create_package();
		exit;
	}//if	
	if(!empty($values["period"]) && empty($values["interval"])){
		$GLOBALS["aerr_id"] = 7;
		getpaid_create_package();
		exit;
	}//if
	
	$getpaid["membership"][$package_id] = $values;
	
	module_save_settings($theme,"getpaid",$getpaid);
	
	load_page("index.php?section=getpaid&theme=".$data["theme"]);
	
}//getpaid_save_package

function getpaid_system(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	$data["section"] = "getpaid";
	$data["subsection"] = 1;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$data["title_id"] = "15";	
	$system_id = $GLOBALS["Get"]->type_val("system_id","integer");
	
	if(!$system_id){
	
		$vals = array(
			"name",
			"payment_processor",
			"cancel_processor"
		);
	
		$data["values"] = $GLOBALS["Get"]->arr($vals,1);
		
	}//if
	else{
		
		$data["system_id"] = $system_id;
		$data["values"] = $getpaid["systems"][$system_id];
		
	}//else
	
	if(empty($data["values"]["payment_processor"]))
		$data["values"]["payment_processor"] = URL."/psystems/paypal/payment_processor.php";
		
	if(empty($data["values"][cancel_processor]))
		$data["values"][cancel_processor] = URL."/psystems/paypal/cancel_processor.php";
	
	$data["link"] = "index.php?section=getpaid&theme=".$data["theme"];
	
	$layout[0] = "getpaid_system";
	
	admin_output($layout,$data);
	
}//getpaid_system

function getpaid_save_system(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$vals = array(
		"name",
		"payment_processor",
		"cancel_processor"
	);
	
	$values = $GLOBALS["Get"]->arr($vals,1);
	
	if(empty($values["name"])){
		$GLOBALS["aerr_id"] = 3;
		getpaid_system();
		exit;
	}//if
	if(empty($values["payment_processor"])){
		$GLOBALS["aerr_id"] = 4;
		getpaid_system();
		exit;
	}//if
	
	$system_id = $GLOBALS["Get"]->type_val("system_id","integer");
	if(empty($system_id)){
		$system_id = @max(array_keys($getpaid["systems"])) + 1;
	}//if
	
	$getpaid["systems"][$system_id] = $values;
	
	module_save_settings($theme,"getpaid",$getpaid);
	
	load_page("index.php?section=getpaid&theme=".$theme);
	
}//getpaid_save_system

function getpaid_delete_package(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$package_id = $GLOBALS["Get"]->type_val("package_id","integer");
	if($package_id)
		unset($getpaid["membership"][$package_id]);
	
	module_save_settings($theme,"getpaid",$getpaid);
	
	load_page("index.php?section=getpaid&theme=".$data["theme"]);
	
}//getpaid_delete_package

function getpaid_delete_system(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/modules/getpaid.inc.php");
	
	$system_id = $GLOBALS["Get"]->type_val("system_id","integer");
	if($system_id)
		unset($getpaid["systems"][$system_id]);
	
	module_save_settings($theme,"getpaid",$getpaid);
	
	load_page("index.php?section=getpaid&theme=".$theme);
	
}//getpaid_delete_system
						
?>