<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						///////////////////////////////////////

						admin_validate_section("mailbox",1);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case 'reports':
									reports();
									break;

								case 'delete':
									delete_message();
									break;

								case 'delete_all':
									delete_all_messages();
									break;
									
								case 'send':
									message_send();
									break;

								case 'do_send':
									do_send_message();
									break;
									
								case 'sent':
									sent();
									break;
									
								case 'view_sent':
									view_sent_message();
									break;

							}//switch

						///////////////////////////////////////

function reports(){

	admin_validate();

	$data["section"] = "mailbox";
	$data["subsection"] = 3;
	$data["title_id"] = "22";
	$p = $GLOBALS["Get"]->val("p");

	$sql_query = "SELECT COUNT(*) FROM reports WHERE 1";
	$total = $GLOBALS["DB"]->single($sql_query);
	$data["link"] = "index.php?section=mailbox&action=reports";

	$pages = handle_multipages($p,$total,$data["link"],30);
	$start = $p*30;

	$data["link"].= "&p=".$p;

	$sql_query = "SELECT * FROM reports WHERE 1
				  ORDER BY date DESC
				  LIMIT ".$start.",30";
	$result = $GLOBALS["DB"]->result($sql_query);

	$data["messages"] = array();

	foreach($result as $res){
		$message["rep_id"]  = $res["rep_id"];
		$message["mem_id"]  = $res["mem_id"];
		$message["report_type"] = report_type($res["report"]);
		$message["report_subject"] = report_subject($res["special"]);
		$message["date"]    = extract_time($res["date"],1);
		$message["sender"]  = $GLOBALS["Member"]->card($message["mem_id"]);
		$message["delete"]  = "index.php?section=mailbox&action=delete&rep_id=".$res["rep_id"]."&ret_link=".urlencode($data["link"]);
		$data["messages"][] = $message;
	}//foreach

	$data["pages"] = $pages;

	$layout[0] = "mailbox_reports";

	admin_output($layout,$data);

}//reports

function report_type($type){

	switch($type){
		case 'copyright':
			return "Copyrights Infringement";
		case 'spam':
			return 'Spam';
		case 'mature':
			return 'Mature';
		case 'mis-categorized':
			return 'Mis-Categorized';
	}//switch

}//report_type

function report_subject($special){

	$sql_query = "SELECT title FROM videos WHERE vid_id=".$special;
	$title = $GLOBALS["DB"]->single( $sql_query );
	$title_cut = handle_string_cut( $title, 50 );
	
	$ret["title"] = $title_cut;
	$ret["link"] = URL."/index.php?page=videos&section=view&vid_id=".$special;
	
	return $ret;

}//report_subject

function delete_message(){

	admin_validate();

	$mes_id = $GLOBALS["Get"]->val("mes_id");
	$rep_id = $GLOBALS["Get"]->val("rep_id");
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	if(is_array($mes_id) && count($mes_id)){
		$sql_query = "DELETE FROM admin_mail WHERE mes_id IN (".implode(",",$mes_id).")";
		$GLOBALS["DB"]->execute($sql_query);
	}//if
	elseif(is_array($rep_id) && count($rep_id)){
		$sql_query = "DELETE FROM reports WHERE rep_id IN (".implode(",",$rep_id).")";
		$GLOBALS["DB"]->execute($sql_query);
	}//if
	elseif($mes_id){
		$sql_query = "DELETE FROM admin_mail WHERE mes_id=".$mes_id;
		$GLOBALS["DB"]->execute($sql_query);
	}//elseif
	elseif($rep_id){
		$sql_query = "DELETE FROM reports WHERE rep_id=".$rep_id;
		$GLOBALS["DB"]->execute($sql_query);
	}//elseif

	load_page($ret_link);

}//delete_message

function delete_all_messages(){

	admin_validate();

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	$pro = $GLOBALS["Get"]->val("pro");

	switch($pro){
		case 'reports':
			$sql_query = "DELETE FROM reports";
			break;
		case 'sent':
			$sql_query = "DELETE FROM admin_mail";
			break;
	}//switch

	$GLOBALS["DB"]->execute($sql_query);

	load_page($ret_link);

}//delete_all_messages

function message_send(){

	admin_validate();

	$data["section"] = "mailbox";
	$data["subsection"] = 0;
	$data["title_id"] = "22";
	$mes_id = $GLOBALS["Get"]->type_val("mes_id","integer");
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	$data["link"] = $ret_link;

	$data["subject"] = $GLOBALS["Get"]->val("subject");
	$data["message"] = $GLOBALS["Get"]->val("message");
	$data["send_to"] = $GLOBALS["Get"]->val("send_to");

	if(!$data["send_to"])
		$data["send_to"] = "external";

	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$pro    = $GLOBALS["Get"]->val("pro");
	if($pro == "all")
		$mem_id = "all";

	if(is_array($mem_id) && count($mem_id)){
		$data["mem_id"] = $mem_id;
		foreach($mem_id as $mem){
			$data["recipients"].= "<a href='".build_channel_link_by_id($mem)."' target='_blank'>".$GLOBALS["Member"]->username($mem)."</a><br>";
		}//foreach
	}//if
	elseif($mem_id){
		$data["mem_id"][] = $mem_id;
		if($mem_id != "all"){
			$data["recipients"] = "<a href='".build_channel_link_by_id($mem_id)."' target='_blank'>".$GLOBALS["Member"]->username($mem_id)."</a>";
		}//if
		else
			$data["recipients"] = "All Members";
	}//else

	if(!count($data["mem_id"])){
		load_page($data["link"]."&err_id=2");
	}//if

	$layout[0] = "mailbox_send";

	admin_output($layout,$data);

}//message_send

function do_send_message(){

	set_time_limit(0);

	$info = admin_validate();

	$vals = array("mem_id","send_to","subject","message");
	$values = $GLOBALS["Get"]->arr($vals,1);

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	if(!count($values["mem_id"])){
		load_page($ret_link."&err_id=2");
	}//if

	if(empty($values["send_to"]) || empty($values["subject"]) || empty($values["message"])){
		$GLOBALS["aerr_id"] = 10;
		message_send();
		exit;
	}//if

	include_once(DOC_ROOT."/classes/Mail.class.php");

	if($values["send_to"] == "internal" || $values["send_to"] == "both"){
		$mail_details["sender"]  = $info["mem_id"];
		$mail_details["subject"] = $values["subject"];
		$mail_details["body"]    = $values["message"];
		if($values["mem_id"][0] == "all"){
			$sql_query = "SELECT mem_id FROM members WHERE verified='1'";
			$result = $GLOBALS["DB"]->execute($sql_query);
			while($get = mysql_fetch_assoc($result)){
				$GLOBALS["Mail"]->details = $mail_details;
				$GLOBALS["Mail"]->details["recipient"] = $get["mem_id"];
				$GLOBALS["Mail"]->details["admin"] = 1;
				$GLOBALS["Mail"]->send_internal();
			}//while
		}//if
		else{
			foreach($values["mem_id"] as $mem_id){
				$GLOBALS["Mail"]->details = $mail_details;
				$GLOBALS["Mail"]->details["recipient"] = $mem_id;
				$GLOBALS["Mail"]->details["admin"] = 1;
				$GLOBALS["Mail"]->send_internal();
			}//foreach
		}//else
	}//if

	if($values["send_to"] == "external" || $values["send_to"] == "both"){
		$mail_details["sender"]  = "Admin";
		$mail_details["subject"] = stripslashes(html_entity_decode($values["subject"]));
		$mail_details["body"]    = stripslashes(html_entity_decode($values["message"]));
		if($values["mem_id"][0] == "all"){
			$sql_query = "SELECT mem_id FROM members WHERE verified='1'";
			$result = $GLOBALS["DB"]->execute($sql_query);
			while($get = mysql_fetch_assoc($result)){
				$GLOBALS["Mail"]->details = $mail_details;
				$GLOBALS["Mail"]->details["recipient"] = $get["mem_id"];
				$GLOBALS["Mail"]->send_mass();
			}//while
		}//if
		else{
			foreach($values["mem_id"] as $mem_id){
				$GLOBALS["Mail"]->details = $mail_details;
				$GLOBALS["Mail"]->details["recipient"] = $mem_id;
				$GLOBALS["Mail"]->send_mass();
			}//foreach
		}//else
	}//if

	$sql_query = "INSERT INTO admin_mail (subject,message,date,recipients)
				  VALUES (':subject:',':message:',:time:,':recipients:')";

	$dbvals["subject"] = $values["subject"];
	$dbvals["message"] = $values["message"];
	$dbvals["time"]    = time();
	$dbvals["recipients"] = implode(",",$values["mem_id"]);

	$GLOBALS["DB"]->values = $dbvals;
	$GLOBALS["DB"]->execute($sql_query);

	load_page($ret_link);

}//do_send_message

function sent(){

	admin_validate();

	$data["section"] = "mailbox";
	$data["subsection"] = 4;
	$data["title_id"] = "22";
	$p = $GLOBALS["Get"]->val("p");

	$sql_query = "SELECT COUNT(*) FROM admin_mail";
	$total = $GLOBALS["DB"]->single($sql_query);
	$data["link"] = "index.php?section=mailbox&action=sent";

	$pages = handle_multipages($p,$total,$data["link"],30);
	$start = $p*30;

	$data["link"].= "&p=".$p;

	$sql_query = "SELECT * FROM admin_mail WHERE 1
				  ORDER BY date DESC
				  LIMIT ".$start.",30";
	$result = $GLOBALS["DB"]->result($sql_query);

	$data["messages"] = array();

	foreach($result as $res){
		$message["mes_id"]  = $res["mes_id"];
		$message["subject"] = (hs_strlen($res["subject"]) > 48) ? hs_substr($res["subject"],0,50) : $res["subject"];
		$message["message"] = nl2br($res["message"]);
		$message["date"]    = extract_time($res["date"],1);
		$message["view"]    = "index.php?section=mailbox&action=view_sent&mes_id=".$res["mes_id"]."&ret_link=".urlencode($data["link"]);
		$message["delete"]  = "index.php?section=mailbox&action=delete&mes_id=".$res["mes_id"]."&ret_link=".urlencode($data["link"]);
		$recipients = handle_empties(explode(",",$res["recipients"]));
		if($recipients[0] == "all")
			$message["recipients"] = "All Members";
		else{
			$message["recipients"] = "";
			$count = 1;
			foreach($recipients as $rec){
				$message["recipients"].= "<a href='".build_channel_link_by_id($rec)."' target='_blank'>".$GLOBALS["Member"]->username($rec)."</a>"." (ID: ".$rec.")<br>";
				if($count == 5){
					$message["recipients"].= "...";
					break;
				}//if
				$count++;
			}//foreach
		}//else
		$data["messages"][] = $message;
	}//foreach

	$data["pages"] = $pages;

	$layout[0] = "mailbox_sent";

	admin_output($layout,$data);

}//sent

function view_sent_message(){

	admin_validate();

	$data["section"] = "mailbox";
	$data["subsection"] = 0;
	$data["title_id"] = "22";
	$mes_id = $GLOBALS["Get"]->type_val("mes_id","integer");
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	$sql_query = "SELECT * FROM admin_mail WHERE mes_id=".$mes_id;
	$message = $GLOBALS["DB"]->row($sql_query);

	$data["mes_id"]  = $mes_id;
	$data["date"]    = extract_time($message["date"],1);
	$data["subject"] = $message["subject"];
	$data["message"] = nl2br($message["message"]);
	$data["link"]    = $ret_link;

	$recipients = handle_empties(explode(",",$message["recipients"]));
	if($recipients[0] == "all")
		$data["recipients"] = "All Members";
	else{
		$data["recipients"] = "";
		foreach($recipients as $rec){
			$data["recipients"].= "<a href='".build_channel_link_by_id($rec)."' target='_blank'>".$GLOBALS["Member"]->username($rec)."</a>"." (ID: ".$rec.")<br>";
		}//foreach
	}//else

	$data["ret_name"] = "Mailbox - Sent";

	$layout[0] = "mailbox_view_sent_message";

	admin_output($layout,$data);

}//view_sent_message

?>