<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Groups.class.php");

						///////////////////////////////////////

						admin_validate_section("manage",5);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case '':
									manage_groups();
									break;

								case 'delete':
									do_delete_groups();
									break;

								case 'edit':
									edit_group();
									break;

								case 'save_group':
									save_group();
									break;

								case 'remove_member':
									remove_member();
									break;
									
								case 'remove_video':
									remove_video();
									break;

								case 'update_categories':
									update_categories();
									break;

								case 'featured_add':
									featured_add_group();
									break;

								case 'featured_remove':
									featured_remove_group();
									break;

							}//switch

						///////////////////////////////////////

function manage_groups(){

	admin_validate();

	$data["section"] = "manage";
	$data["subsection"] = 5;
	$data["title_id"] = "25";
	$p = $GLOBALS["Get"]->val("p");

	$sql_query_total  = "SELECT COUNT(*) FROM groups,members WHERE groups.mem_id = members.mem_id";
	$sql_query_result = "SELECT groups.grp_id,COUNT(group_members.mem_id) AS total_members ";

	$sql_query_result.= "FROM groups, members, group_members
				  		 WHERE groups.mem_id = members.mem_id
				  		 AND groups.grp_id = group_members.grp_id ";

	$valnames = array("search_text","search_for","sort_by","sort_order","category");

	$values = $GLOBALS["Get"]->arr($valnames,1);

	if(!empty($values["search_text"]) && !empty($values["search_for"])){

		switch($values["search_for"]){
			case 'grp_id':
				settype($values["search_text"],"integer");
				$sql_query.= " AND groups.grp_id=".$values["search_text"];
				break;
			case 'name':
				$sql_query.= " AND groups.name LIKE '%".$values["search_text"]."%' ";
				break;
			case 'description':
				$sql_query.= " AND groups.description LIKE '%".$values["search_text"]."%' ";
				break;
			case 'mem_id':
				settype($values["search_text"],"integer");
				$sql_query.= " AND groups.mem_id=".$values["search_text"];
				break;
			case 'fname':
				$sql_query.= " AND members.fname LIKE '".$values["search_text"]."%' ";
				break;
			case 'lname':
				$sql_query.= " AND members.lname LIKE '".$values["search_text"]."%' ";
				break;
			case 'email':
				$sql_query.= " AND members.email LIKE '".$values["search_text"]."%' ";
				break;
		}//switch

	}//if

	if(!empty($values["category"]))
		$sql_query.= " AND groups.category=".$values["category"];

	$sql_query_total.= $sql_query;

	$sql_query.= " GROUP BY groups.grp_id ";

	switch($values["sort_by"]){
		case '':
			$sql_query.= " ORDER BY groups.created DESC ";
			break;
		case 'name':
			$sql_query.= " ORDER BY groups.name ".$values["sort_order"];
			break;
		case 'grp_id':
			$sql_query.= " ORDER BY groups.grp_id ".$values["sort_order"];
			break;
		case 'created':
			$sql_query.= " ORDER BY groups.created ".$values["sort_order"];
			break;
		case 'members':
			$sql_query.= " ORDER BY total_members ".$values["sort_order"];
			break;
		case 'featured':
			$sql_query.= " ORDER BY featured ".$values["sort_order"];
			break;
		case 'membership':
			$sql_query.= " ORDER BY privacy ".$values["sort_order"];
			break;
	}//switch

	$data["values"] = $values;
	$data["groups"] = array();

	$start = $p*30;
	$total = $GLOBALS["DB"]->single($sql_query_total);

	$sql_query.= " LIMIT ".$start.",30";
	$results = $GLOBALS["DB"]->result($sql_query_result.$sql_query);


	$search_link = "index.php?section=manage_groups";
	while(list($key,$val) = each($values)){
		$search_link.= "&".$key."=".urlencode(stripslashes(html_entity_decode($val)));
	}//while
	$data["pages"] = handle_multipages($p,$total,$search_link,30);


	$data["link"] = $search_link."&p=".$p;

	foreach($results as $res){
		$sql_query = "SELECT * FROM groups WHERE grp_id=".$res["grp_id"];
		$result = $GLOBALS["DB"]->row( $sql_query );
		if(hs_strlen($result["name"] > 30))
			$result["name"] = hs_substr($result["name"],0,27)."...";

		$group["id"] = $result["grp_id"];
		$group["name"] = handle_string_cut( $result["name"], 30 );
		$group["moderator"] = handle_string_cut( $GLOBALS["Member"]->username($result["mem_id"]), 30 );
		$group["date"] = extract_date($result["created"]);
		$group["view"] = build_group_link_by_id($result["grp_id"]);
		$group["edit"] = "index.php?section=manage_groups&action=edit&grp_id=".$result["grp_id"]."&ret_link=".urlencode($data["link"]);
		$group["delete"] = "index.php?section=manage_groups&action=delete&grp_id=".$result["grp_id"]."&ret_link=".urlencode($data["link"]);
		$group["featured"] = $result["featured"];
		$group["featured_add"] = "index.php?section=manage_groups&action=featured_add&grp_id=".$result["grp_id"]."&ret_link=".urlencode($data["link"]);
		$group["featured_remove"] = "index.php?section=manage_groups&action=featured_remove&grp_id=".$result["grp_id"]."&ret_link=".urlencode($data["link"]);
		$group["members"] = $res["total_members"];
		
		if($result["privacy"] == 1)
			$group["type"] = "Public";
		if($result["privacy"] == 2)
			$group["type"] = "Moderated";
		if($result["privacy"] == 3)
			$group["type"] = "Private";
		
		$data["groups"][] = $group;
	}//foreach

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/group_categories.inc.php");

	$data["categories"] = $categories;

	$layout[0] = "groups_list";
	
	admin_output($layout,$data);

}//manage_groups

function edit_group(){

	admin_validate();

	$data["section"] = "manage";
	$data["subsection"] = 5;
	$data["title_id"] = "25";

	$ret_link  = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	$data["link"] = $ret_link;

	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	$data["grp_id"] = $grp_id;

	$ret_link2 = "index.php?section=manage_groups&action=edit&grp_id=".$grp_id."&ret_link=".urlencode($ret_link);

	build_form("group_edit",$grp_id);

	$group_members = $GLOBALS["Groups"]->members($grp_id);
	$owner = $GLOBALS["Groups"]->owner($grp_id);
	foreach($group_members as $member){
		if($member != $owner){
			$card["name"]   = implode(" ",$GLOBALS["Member"]->name($member));
			$card["mem_id"] = $member;
			$card["delete"] = "index.php?section=manage_groups&action=remove_member&grp_id=".$grp_id."&per_id=".$member."&ret_link=".urlencode($ret_link2);
			$data["cards"][] = $card;
		}//if
	}//foreach

	include_once(DOC_ROOT."/classes/Videos.class.php");
	$sql_query = "SELECT vid_id FROM group_videos WHERE grp_id=".$grp_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$card["delete"] = "index.php?section=manage_groups&action=remove_video&grp_id=".$grp_id."&vid_id=".$res["vid_id"]."&ret_link=".urlencode($ret_link2);
		$videos[] = $card;
	}
	
	$data["videos"] = $videos;

	$layout[0] = "edit_group";

	admin_output($layout,$data);

}//edit_group

function remove_member(){

	admin_validate();
	$grp_id = $GLOBALS["Get"]->val("grp_id");
	$per_id = $GLOBALS["Get"]->val("per_id");

	$GLOBALS["Groups"]->remove_member($per_id,$grp_id);

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page("index.php?section=manage_groups&action=edit&grp_id=".$grp_id."&ret_link=".urlencode($ret_link));

}//remove_member

function remove_video(){

	admin_validate();
	$grp_id = $GLOBALS["Get"]->val("grp_id");
	$vid_id = $GLOBALS["Get"]->val("vid_id");

	$sql_query = "DELETE FROM group_videos WHERE grp_id=".$grp_id." AND vid_id=".$vid_id;
	$GLOBALS["DB"]->execute( $sql_query );

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page("index.php?section=manage_groups&action=edit&grp_id=".$grp_id."&ret_link=".urlencode($ret_link));

}//remove_video

function save_group(){

	admin_validate();

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/groups.inc.php");
	include_once(DOC_ROOT."/functions/form_functions.php");

	$values = form_handle_input("group_edit",1,1);

	if(!extract_null_value($values["err_id"])){
		$GLOBALS["uerr_id"] = $values["err_id"];
		edit_group();
		exit;
	}//if

	$sql_query = "SELECT folder FROM groups
				  WHERE grp_id=".$values["grp_id"];
	$folder = $GLOBALS["DB"]->single($sql_query);
	if($folder != $values["folder"]){
		$exists = $GLOBALS["Groups"]->verify_folder($values["folder"]);
		if($exists){
			$GLOBALS["uerr_id"] = 24;
			edit_group();
			exit;
		}//if
	}//if
	
	$tags = explode(" ", $values["tags"]);
	$tags = handle_empties( $tags );
	$values["tags"] = "|".implode("|", $tags)."|";

	load_db_update( "group_edit", $values, array("grp_id",$values["grp_id"] ) );

	$sql_query = "UPDATE groups SET
                  updated=:time:
                  WHERE grp_id=:grp_id:";

	$values["time"] = time();
	$GLOBALS["DB"]->values = $values;
	$GLOBALS["DB"]->execute($sql_query);

	$ret_link = $GLOBALS["Get"]->val("ret_link");
	load_page("index.php?section=manage_groups&action=edit&grp_id=".$values["grp_id"]."&ret_link=".urlencode(html_entity_decode(stripslashes($ret_link))));

}//save_group

function do_delete_groups(){

	admin_validate();

	$grp_id = $GLOBALS["Get"]->val("grp_id");

	include_once(DOC_ROOT."/functions/delete_functions.php");

	if(is_array($grp_id) && count($grp_id) > 0){
		foreach($grp_id as $id){
			delete_group($id);
		}//foreach
	}//if
	elseif(!empty($grp_id))
		delete_group($grp_id);

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);

}//do_delete_groups

function update_categories(){

	admin_validate();

	$cats = stripslashes(html_entity_decode($GLOBALS["Get"]->val("res_categories")));
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	$cats = hs_ereg_replace(preg_quote("&#124;"),"|",$cats);

	$cats_exp = handle_empties(explode("==|==",$cats));

	$e_cats = array();

	foreach($cats_exp as $cat){
		$its = explode("|",$cat);
		$e_cats[$its[0]] = $its[1];
	}//foreach

	$str = "<?php\n\n";
	while(list($key,$val) = each($e_cats)){
		$str.= "\$categories[".$key."] = \"".hs_ereg_replace('"','\"',$val)."\";\n";
	}//while
	$str.= "\n?>";

	$file_handler = fopen(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/group_categories.inc.php","w");
	fwrite($file_handler,$str);
	fclose($file_handler);

	load_page($ret_link);

}//update_categories

function featured_add_group(){

	admin_validate();

	$grp_id = $GLOBALS["Get"]->val("grp_id");

	$sql_query = "UPDATE groups SET featured='1' WHERE grp_id=".$grp_id;
	$GLOBALS["DB"]->execute($sql_query);

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);

}//featured_add_group

function featured_remove_group(){

	admin_validate();

	$grp_id = $GLOBALS["Get"]->val("grp_id");

	$sql_query = "UPDATE groups SET featured='0' WHERE grp_id=".$grp_id;
	$GLOBALS["DB"]->execute($sql_query);

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);

}//featured_remove_group

?>