<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						///////////////////////////////////////

						admin_validate_section("manage",1);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case 'members':
									manage_members();
									break;

								case 'ban_member':
									ban_member();
									break;

								case 'unban_member':
									unban_member();
									break;

								case 'delete_member':
									do_delete_member();
									break;

								case 'edit_member':
									edit_member();
									break;

								case 'do_edit_member':
									do_edit_member();
									break;

							}//switch

						///////////////////////////////////////

function manage_members(){

	admin_validate();

	$data["section"] = "manage";
	$data["subsection"] = 1;
	$data["title_id"] = "30";

	$search_link = "index.php?section=manage_members&action=members";

	$form = array (
		"search_for",
		"search_text",
		"sort_by",
		"sort_order",
		"only_banned",
		"only_with_photo",
		"unverified",
		"country",
		"zip",
		"city",
		"gender",
		"age_from",
		"age_to"
	);

	foreach($form as $el){
		$values[$el] = $GLOBALS["Get"]->val($el);
		$search_link.= "&".$el."=".urlencode(stripslashes(html_entity_decode($values[$el])));
	}//foreach

	$p = $GLOBALS["Get"]->val("p");

	if(empty($values["gender"]))
		$values["gender"] = 0;

	$sql_query_total = "SELECT count(members.mem_id) ";
	$sql_query_result = "SELECT members.mem_id ";

	$sql_query="FROM members,profiles
				WHERE members.mem_id = profiles.mem_id
				AND members.mem_id > 100000";

	if(!empty($values["search_for"]) && hs_strlen($values["search_text"]) > 0){
		$values["search_text"] = admin_replace_search_string($values["search_text"]);
		switch($values["search_for"]){
			case 'mem_id':
				settype($values["search_text"],"integer");
				$sql_query.= " AND members.mem_id IN (".$values["search_text"].")";
				break;
			case 'username':
				$username = $values["search_text"];
				$sql_query.= " AND members.username LIKE '".$username."%' ";
				break;
			case 'email':
				$emails = explode(",",$values["search_text"]);
				$sql_query.= " AND ( ";
				foreach($emails as $email){
					$sql_query.= " members.email LIKE '".$email."' OR ";
				}//foreach
				$sql_query = rtrim($sql_query,' OR ');
				$sql_query.= " ) ";
				break;
			case 'fname':
				$fnames = explode(",",$values["search_text"]);
				$sql_query.= " AND ( ";
				foreach($fnames as $fname){
					$sql_query.= " members.fname LIKE '".$fname."' OR ";
				}//foreach
				$sql_query = rtrim($sql_query,' OR ');
				$sql_query.= " ) ";
				break;
			case 'lname':
				$lnames = explode(",",$values["search_text"]);
				$sql_query.= " AND ( ";
				foreach($lnames as $lname){
					$sql_query.= " members.lname LIKE '".$lname."' OR ";
				}//foreach
				$sql_query = rtrim($sql_query,' OR ');
				$sql_query.= " ) ";
				break;
		}//switch
	}//if

	if($values["only_banned"])
		$sql_query.= " AND members.banned = '1' ";

	if($values["only_with_photo"])
		$sql_query.= " AND profiles.avatar <> '' ";

	if(!$values["unverified"])
		$sql_query.= " AND members.verified = '1' ";

	if($values["country"])
		$sql_query.= " AND profiles.country = '".$values["country"]."' ";

	if($values["city"])
		$sql_query.= " AND profiles.city LIKE '".$values["city"]."%' ";
		
	if($values["zip"])
		$sql_query.= " AND profiles.zip = '".$values["zip"]."' ";

	if($values["gender"])
		$sql_query.= " AND profiles.gender = '".$values["gender"]."' ";

	if($values["age_from"]){
		include_once(DOC_ROOT."/functions/adodb-time.php");
		$born_from = adodb_mktime(23,59,59,date("n"),date("j"),date("Y")-$values["age_from"]);
		$sql_query.= " AND profiles.birthdate <= ".$born_from." ";
	}//if

	if($values["age_to"]){
		include_once(DOC_ROOT."/functions/adodb-time.php");
		$born_to = adodb_mktime(23,59,59,date("n")-1,date("j"),date("Y")-$values["age_to"]-1);
		$sql_query.= " AND profiles.birthdate >= ".$born_to." ";
	}//if
	
	$total = $GLOBALS["DB"]->single($sql_query_total.$sql_query);

	if(!empty($values["sort_by"])){
		switch($values["sort_by"]){
			case 'username':
				$sql_query.= " ORDER BY members.username ";
				break;
			case 'email':
				$sql_query.= " ORDER BY members.email ";
				break;
			case 'fname':
				$sql_query.= " ORDER BY members.fname ";
				break;
			case 'lname':
				$sql_query.= " ORDER BY members.lname ";
				break;
			case 'jdate':
				$sql_query.= " ORDER BY profiles.joined ";
				break;
			case 'activity':
				$sql_query.= " ORDER BY profiles.last_click ";
				break;
			case 'mlevel':
				$sql_query.= " ORDER BY members.membership ";
				break;
		}//switch
		if(!empty($values["sort_order"])){
			$sql_query.= $values["sort_order"];
		}//if
	}//if
	else{
    $sql_query.= " ORDER BY members.mem_id";
	}

	$start = $p*30;

	$sql_query.= " LIMIT ".$start.",30";
	$result = $GLOBALS["DB"]->result($sql_query_result.$sql_query);

	$data["cards"] = admin_build_cards($result,$search_link."&p=".$p);
	$data["cards_total"] = count($result);

	$data["pages"] = handle_multipages($p,$total,$search_link,30);
	$data["values"] = $values;

	$data["link"] = $search_link."&p=".$p;

	$layout[0] = "members_list";

	admin_output($layout,$data);

}//manage_members

function ban_member(){

	admin_validate();

	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	if(!empty($mem_id)){

	$sql_query="UPDATE members
				SET banned='1'
				WHERE mem_id";

	if(is_array($mem_id))
		$sql_query.= " IN (".implode(",",$mem_id).") ";
	else
		$sql_query.= "=".$mem_id;

	$GLOBALS["DB"]->execute($sql_query);

	}//if

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);
	load_page($ret_link);

}//ban_member

function unban_member(){

	admin_validate();

	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	if(!empty($mem_id)){

	$sql_query="UPDATE members
				SET banned='0'
				WHERE mem_id";

	if(is_array($mem_id))
		$sql_query.= " IN (".implode(",",$mem_id).") ";
	else
		$sql_query.= "=".$mem_id;

	$GLOBALS["DB"]->execute($sql_query);

	}//if

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);

	load_page($ret_link);

}//unban_member

function do_delete_member(){

	$admin = admin_validate();

	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	include_once(DOC_ROOT."/functions/delete_functions.php");

	if(is_array($mem_id) && count($mem_id) > 0){
		foreach($mem_id as $id){
			delete_member($id);
		}//foreach
	}//if
	elseif(!empty($mem_id))
		delete_member($mem_id);

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);
	load_page($ret_link);

}//do_delete_member

function edit_member(){

	$data["section"] = "manage";
	$data["subsection"] = 1;
	$data["title_id"] = "30";
	$admin = admin_validate();
	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link  = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	$ret_link2 = "index.php?section=manage_members&action=edit_member&mem_id=".$mem_id."&ret_link=".urlencode($ret_link);

	$forms_arr = array (
		"account_change_email",
		"account_personal",
		"account_info",
		"channel_info"
	);

	foreach($forms_arr as $form_name){
		build_form($form_name,$mem_id);
	}//foreach

	$data["values"]["mem_id"] = $mem_id;
	$data["link"] = $ret_link;

	$member_info = $GLOBALS["Member"]->info($mem_id);
	$getpaid_packages = admin_get_getpaid_packages();

	if(count($getpaid_packages)){

	$data["packages"][0] = "Awaiting for payment";
	while(list($key,$val) = each($getpaid_packages)){
		$data["packages"][$key] = $val;
	}//while

	if(!$member_info["access_end"] && $member_info["membership"])
		$data["access_end"][type] = "unlimited";
	elseif($member_info["membership"]){
		$data["access_end"][type] = "date";
		$data["access_end"][date] = date("d/m/Y",$member_info["access_end"]);
	}//else

	$data["member_info"] = $member_info;

	}//if
	
	$data["avatar"]["img"] = $member_info["avatar"];
	$data["avatar"]["delete"] = "index.php?section=manage_avatars&action=delete&mem_id=".$mem_id."&ret_link=".urlencode($ret_link2);

	$layout[0] = "edit_member";
	admin_output($layout,$data);

}//edit_member

function do_edit_member(){

	$admin = admin_validate();
	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	$forms_arr = array (
		"account_change_email",
		"account_personal",
		"account_info",
		"channel_info"
	);

	include_once(DOC_ROOT."/functions/form_functions.php");

	foreach($forms_arr as $form_name){		

			$values = form_handle_input($form_name,0,1);

			if(!extract_null_value($values["err_id"])){
				$GLOBALS["uerr_id"] = $values["err_id"];
				edit_member();
				exit;
			}//if

			if($form_name == "channel_info"){
				$sql_query = "UPDATE channels SET title=':title:', description=':description:'
							  WHERE mem_id=".$mem_id;
				$GLOBALS["DB"]->values = $values;
				$GLOBALS["DB"]->execute( $sql_query );				
			}//if
			else
				load_db_update($form_name,$values,array("mem_id",$mem_id));
	}//foreach

	if(admin_getpaid_isenabled()){

	$membership  = $GLOBALS["Get"]->val("membership");
	$access_type = $GLOBALS["Get"]->val("access_type");
	$access_end  = $GLOBALS["Get"]->val("access_end");

	if($access_type == "date"){
		$date = explode("/",$access_end);
		$access_end_value = mktime(0,0,0,$date[1],$date[0],$date[2]);
	}//if
	else
		$access_end_value = 0;

	$sql_query="UPDATE members
				SET membership='".$membership."',access_end=".$access_end_value."
				WHERE mem_id=".$mem_id;

	$GLOBALS["DB"]->execute($sql_query);

	}//if

	load_page("index.php?section=manage_members&action=edit_member&mem_id=".$mem_id."&ret_link=".urlencode(html_entity_decode(stripslashes($ret_link))));

}//do_edit_member

?>