<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						///////////////////////////////////////

						admin_validate_section("setup",4);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case '':
									modules_settings();
									break;

								case 'update_module':
									update_module();
									break;

								case 'categories':
									module_categories();
									break;

								case 'save_categories':
									module_save_categories();
									break;

								case 'videos_delete_format':
									videos_delete_format();
									break;

								case 'videos_add_format':
									videos_add_format();
									break;
									
								case 'videos_update_logo':
									videos_update_logo();
									break;

								case 'sb_add':
									sb_add();
									break;

								case 'sb_enable':
									sb_enable();
									break;

								case 'sb_delete':
									sb_delete();
									break;

							}//switch

						///////////////////////////////////////

function modules_settings(){

	include(DOC_ROOT."/includes/config/modules.inc.php");

	admin_validate();

	$data["section"] = "setup";
	$data["subsection"] = 4;
	$data["title_id"] = "38";
	$data["themes"] = admin_get_themes();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];

	$data["theme"] = $theme;
	$data["modules"] = array();

	while(list($key,$name) = each($modules)){
		if($key != "getpaid") {
			if(file_exists(DOC_ROOT."/themes/".$theme."/modules/".$key.".inc.php")){
				include(DOC_ROOT."/themes/".$theme."/modules/".$key.".inc.php");
				$data[$key] = ${$key};
			}//if
			$data["modules"][$key] = $name;
		}
	}//while

	$data["social_bookmarking"]["engines"] = array();
	$sql_query = "SELECT * FROM social_bookmarking_engines";
	$result = $GLOBALS["DB"]->result($sql_query);
	foreach($result as $res){
		$data["social_bookmarking"]["engines"][] = $res;
	}//foreach

	$layout[0] = "modules_settings";

	admin_output($layout,$data);

}//modules_settings

function update_module(){

	admin_validate();

	set_time_limit(0);

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;

	$module = $GLOBALS["Get"]->val("module");

	switch($module){
		case 'videos':
			$vals = array("maxsize","maxtime","approve","show_unapproved","screenshots","screenshot_width","screenshot_height","diskspace","width","height","abitrate","vbitrate","progress_bar","download","convert","pwidth","pheight");
			break;
		case 'social_bookmarking':
			$vals = array("enabled");
			break;
		case 'tags':
			$vals = array("enabled","minimum_amount","maximum_amount","minimum_length","cache_lifetime","minimum_font","maximum_font","cache_depth");
			break;
		default:
			$values = $GLOBALS["Get"]->val( $module );
			break;
	}//switch

	if(!$values)
		$values = $GLOBALS["Get"]->arr($vals,1);
	
	include(DOC_ROOT."/themes/".$theme."/modules/".$module.".inc.php");

	while(list($key,$val) = each($values)){
		${$module}[$key] = $val;
	}//while
	
	module_save_settings($theme,$module,${$module});

	load_page("index.php?section=modules&theme=".$theme."#".$module);

}//update_module

function module_categories(){

	admin_validate();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	$module = $GLOBALS["Get"]->val("module");
	
	$data["modules"] = admin_get_modules();
	$data["module"] = $module;

	$data["title_id"] = "38";
	$data["link"] = "index.php?section=modules&theme=".$data["theme"]."#".$module;

	$data["section"] = "setup";
	$data["subsection"] = 4;

	switch($module) {
		case 'videos':
			include(DOC_ROOT."/themes/".$theme."/system/video_categories.inc.php");
			break;
		case 'groups':
			include(DOC_ROOT."/themes/".$theme."/system/group_categories.inc.php");
			break;
	}

	$data["categories"] = $categories;

	$jscode = "";
	while(list($key,$val) = each($categories)){
		$jscode.= "HS_Categories[".$key."] = \"".hs_ereg_replace('"','\"',$val)."\";\n";
	}//while

	$data["javascript"] = <<<JAVASCRIPTCODE
<script language="JavaScript">
<!--
	var HS_Categories = new Array;
	var Category = 0;
	function HS_InitCategories(){
		$jscode
	}//HS_InitCategories
	function HS_EditCategory(){
		var FormHandler = document.cls_categories;
		Category = FormHandler.categories.options[FormHandler.categories.selectedIndex].value;
		FormHandler.edit_category.value = HS_Categories[Category];
	}//HS_Edit Category
	function HS_AddCategory(){
		var FormHandler = document.cls_categories;
		var CategoryName = FormHandler.new_category.value;
		var CatID = HS_Categories.length+1;
		HS_Categories[CatID] = CategoryName;
		FormHandler.categories.options[FormHandler.categories.options.length] = new Option(CategoryName,CatID);
		FormHandler.new_category.value = "";
	}//HS_AddCategory
	function HS_UpdateCategory(){
		if(Category){
			var FormHandler = document.cls_categories;
			var CategoryName = FormHandler.edit_category.value;
			HS_Categories[Category] = CategoryName;
			var Selected = FormHandler.categories.selectedIndex;
			FormHandler.categories.options[Selected] = new Option(CategoryName,Category);
			FormHandler.categories.selectedIndex = Selected;
		}//if
	}//HS_UpdateCategory
	function HS_DeleteCategory(){
		if(Category){
			var FormHandler = document.cls_categories;
			HS_Categories[Category] = "EMPTY";
			FormHandler.categories.options[FormHandler.categories.selectedIndex] = null;
			FormHandler.edit_category.value = "";
			FormHandler.edit_subcategory.value = "";
			Category = 0;
		}//if
	}//HS_DeleteCategory
	function HS_UpdateData(){
		var CatsLine = "";
		var TotalCats = 0;
		var FormHandler = document.cls_categories;
		for(var Item in HS_Categories){
			if(HS_Categories[Item] != "EMPTY"){
				CatsLine+= Item+"|"+HS_Categories[Item]+"==|==";
				TotalCats++;
			}//if
		}//for

		if(TotalCats == 0)
			Error = 2;

		if(Error == 2){
			alert("Please, make sure to add at least one category.");
		}//else if
		else{
			FormHandler.res_categories.value = CatsLine;
			FormHandler.submit();
		}//else
	}//HS_UpdateData
//-->
</script>
JAVASCRIPTCODE;

	$data["onload"] = "HS_InitCategories();";

	$layout[0] = "module_categories";

	admin_output($layout,$data);

}//video_categories

function module_save_categories(){

	admin_validate();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;
	
	$module = $GLOBALS["Get"]->val("module");

	switch($module) {
		case 'videos':
			$file = DOC_ROOT."/themes/".$theme."/system/video_categories.inc.php";
			break;
		case 'groups':
			$file = DOC_ROOT."/themes/".$theme."/system/group_categories.inc.php";
			break;
	}

	$cats = stripslashes(html_entity_decode($GLOBALS["Get"]->val("res_categories")));
	$cats = hs_ereg_replace(preg_quote("&#124;"),"|",$cats);
	$cats_exp = handle_empties(explode("==|==",$cats));

	$e_cats = array();
	$e_subcats = array();

	foreach($cats_exp as $cat){
		$its = explode("|",$cat);
		if($its[1] != "EMPTY")
			$e_cats[$its[0]] = $its[1];
	}//foreach
	
	asort( $e_cats );

	$str = "<?php\n\n";
	while(list($key,$val) = each($e_cats)){
		$str.= "\$categories[".$key."] = \"".hs_ereg_replace('"','\"',$val)."\";\n";
	}//while
	$str.= "\n?>";

	$file_handler = fopen($file,"w");
	fwrite($file_handler,$str);
	fclose($file_handler);

	load_page("index.php?section=modules&action=categories&theme=".$theme."&module=".$module);

}

function videos_delete_format(){

	admin_validate();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;

	$format_id = $GLOBALS["Get"]->type_val("format_id","integer");

	include(DOC_ROOT."/themes/".$theme."/modules/videos.inc.php");

	if($format_id){
		unset($videos["formats"][$format_id]);
	}//if

	module_save_settings($theme,"videos",$videos);

	load_page("index.php?section=modules&theme=".$data["theme"]."#videos");

}//videos_delete_format

function videos_add_format(){

	admin_validate();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;

	$ext  = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ext")));

	include(DOC_ROOT."/themes/".$theme."/modules/videos.inc.php");

	$format_id = @max(array_keys($videos["formats"]))+1;

	$videos["formats"][$format_id]  = $ext;

	module_save_settings($theme,"videos",$videos);

	load_page("index.php?section=modules&theme=".$data["theme"]."#videos");

}//videos_add_format

function videos_update_logo(){

	admin_validate();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;

	$logo = $GLOBALS["GetFromForm"]->file( "logo" );

	if($logo["tmp"]) {
		
		if(eregi("flash", $logo["type"]))
			$ext = ".swf";
		elseif(eregi("jpeg|jpg", $logo["type"]))
			$ext = ".jpg";
		else
			load_page("index.php?section=modules&theme=".$theme."&err_id=42");
			
		if(file_exists( DOC_ROOT."/includes/logo.jpg" ))
			@unlink( DOC_ROOT."/includes/logo.jpg" );
			
		if(file_exists( DOC_ROOT."/includes/logo.swf" ))
			@unlink( DOC_ROOT."/includes/logo.swf" );
			
		move_uploaded_file( $logo["tmp"], DOC_ROOT."/includes/logo".$ext );
		include(DOC_ROOT."/themes/".$theme."/modules/videos.inc.php");
		$videos["logo"] = "logo".$ext;
		module_save_settings($theme,"videos",$videos);
		
			
	} else {
		load_page("index.php?section=modules&theme=".$theme."&err_id=42");
	}

	load_page("index.php?section=modules&theme=".$data["theme"]."#videos");

}

function sb_add(){

	admin_validate();

	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
	$data["theme"] = $theme;

	$name  = stripslashes(html_entity_decode($GLOBALS["Get"]->val("name")));
	$url   = stripslashes(html_entity_decode($GLOBALS["Get"]->val("url")));
	$icon  = $GLOBALS["GetFromForm"]->file("icon");
	if(!empty($icon["tmp"])){

		$ext = substr( $icon["name"], strrpos( $icon["name"], "." ) );

		mt_srand((double) microtime() * 100000);
		$icon_file = hs_substr(md5(time().mt_rand(0,100)),0,10).$ext;

		move_uploaded_file( $icon["tmp"], DOC_ROOT."/includes/sbicons/".$icon_file );

	} else {
		$icon_file = "";
	}

	$sql_query = "INSERT INTO social_bookmarking_engines (name, url, icon, enabled)
				  VALUES (':name:',':url:',':icon:','1')";

	$vals["name"] = $name;
	$vals["url"]  = $url;
	$vals["icon"] = $icon_file;

	$GLOBALS["DB"]->values = $vals;
	$GLOBALS["DB"]->execute($sql_query);

	load_page("index.php?section=modules&theme=".$theme."#social_bookmarking");

}//sb_add

function sb_enable(){

	admin_validate();
	$theme = $GLOBALS["Get"]->val("theme");
	$eng_id = $GLOBALS["Get"]->type_val("eng_id","integer");

	$sql_query = "SELECT enabled FROM social_bookmarking_engines WHERE eng_id=".$eng_id;
	$status = $GLOBALS["DB"]->single($sql_query);
	$update_status = abs($status-1);

	$sql_query = "UPDATE social_bookmarking_engines SET enabled='".$update_status."' WHERE eng_id=".$eng_id;
	$GLOBALS["DB"]->execute($sql_query);

	load_page("index.php?section=modules&theme=".$theme."#social_bookmarking");

}//sb_enable

function sb_delete(){

	admin_validate();
	$theme = $GLOBALS["Get"]->val("theme");
	$eng_id = $GLOBALS["Get"]->type_val("eng_id","integer");

	$sql_query = "SELECT icon FROM social_bookmarking_engines WHERE eng_id=".$eng_id;
	$icon = $GLOBALS["DB"]->single($sql_query);

	if($icon && file_exists( DOC_ROOT."/includes/sbicons/".$icon )) {
		@unlink(DOC_ROOT."/includes/sbicons/".$icon);
	}

	$sql_query = "DELETE FROM social_bookmarking_engines WHERE eng_id=".$eng_id;
	$GLOBALS["DB"]->execute($sql_query);

	load_page("index.php?section=modules&theme=".$theme."#social_bookmarking");

}//sb_delete

?>