<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("act");
						$section = $GLOBALS["Get"]->val("section");

							switch($section){
									
								case 'videos':
									channel_videos_view();
									break;
									
								case 'my_videos':
									channel_my_videos_view();
									break;
									
								case 'my_favorites':
									channel_my_favorites_view();
									break;
									
								case 'subscribers':
									channel_subscribers_view();
									break;
									
								case 'friends':
									channel_friends_view();
									break;
									
								case 'comments':
									channel_comments_view();
									break;

							}//switch
							
							switch($action){

								case 'subscribe':
									channel_subscribe_process();
									break;

							}//switch

						///////////////////////////////////////
						
function channel_videos_view() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	$vids = handle_empties(explode(",", $GLOBALS["Get"]->val("videos")));
	$videos = array();
	
	if(count($vids)) {	
	
		foreach($vids as $vid_id) {
			$card = $GLOBALS["Videos"]->card( $vid_id );
			$videos[] = $card;
		}
		
	}//if
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("type", "remove");
	$GLOBALS["smarty"]->display( "boxes/channel_edit_videos.tpl" );
	exit;
}

function channel_my_videos_view() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$info["mem_id"]." ".$GLOBALS["Videos"]->filter();
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	$link  = "CH_ChannelMyVideosChangePage(|p|)";
	$pages = handle_multipages($p,$total,$link);
	
	$vids = handle_empties(explode(",", $GLOBALS["Get"]->val("videos")));

	$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$info["mem_id"]." ".$GLOBALS["Videos"]->filter()."
				  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$card = $GLOBALS["Videos"]->card($res["vid_id"]);
		if(in_array($res["vid_id"], $vids))
			$card["channel"] = 1;
		else
			$card["channel"] = 0;
			
		$videos[] = $card;
	}//foreach

	$GLOBALS["smarty"]->assign("videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);
	$GLOBALS["smarty"]->assign("type", "add");
	$GLOBALS["smarty"]->display( "boxes/channel_edit_videos.tpl" );
	exit;
}

function channel_my_favorites_view() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	$sql_query = "SELECT COUNT(*) FROM bookmarks AS b, videos AS v WHERE b.item_id=v.vid_id AND b.mem_id=".$info["mem_id"]." ".$GLOBALS["Videos"]->filter("v.");
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	$link  = "CH_ChannelMyFavoritesChangePage(|p|)";
	$pages = handle_multipages($p,$total,$link);
	
	$vids = handle_empties(explode(",", $GLOBALS["Get"]->val("videos")));

	$sql_query = "SELECT item_id FROM bookmarks AS b, videos AS v WHERE b.item_id=v.vid_id AND b.mem_id=".$info["mem_id"]."
				  ".$GLOBALS["Videos"]->filter("v.")."
				  ORDER BY b.added DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$card = array();
		$card = $GLOBALS["Videos"]->card($res["item_id"]);
		
		if(in_array($res["item_id"], $vids))
			$card["channel"] = 1;
		else
			$card["channel"] = 0;
		
		$videos[] = $card;
	}//foreach

	$GLOBALS["smarty"]->assign("videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);
	$GLOBALS["smarty"]->assign("type", "add");
	$GLOBALS["smarty"]->display( "boxes/channel_edit_videos.tpl" );
	exit;
}

function channel_subscribers_view() {
	
	$start    = $GLOBALS["Get"]->type_val("s","integer");
	$username = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $username );
	
	if(!$mem_id)
		die;
		
	$channel["username"] = $username;
	
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'";
	$subscribers["total"] = $GLOBALS["DB"]->single( $sql_query );
	
	$subscribers["pages"] = handle_roundpages( $start, $subscribers["total"] );
	
	//subscribers
	$sql_query = "SELECT mem_id FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'
				  ORDER BY id DESC LIMIT ".$start.",4";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$subscribers["cards"][] = $card;
	}
	
	if(count( $subscribers["cards"] ) < 4) {
		$missing = 4 - count( $subscribers["cards"] );
		$sql_query = "SELECT mem_id FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'
					  ORDER BY id DESC LIMIT 0,".$missing;
		$result = $GLOBALS["DB"]->result( $sql_query );
		foreach($result as $res) {
			$card = $GLOBALS["Member"]->card( $res["mem_id"] );
			$subscribers["cards"][] = $card;
		}
	}
	
	$GLOBALS["smarty"]->assign("channel", $channel);
	$GLOBALS["smarty"]->assign("subscribers", $subscribers);
	$GLOBALS["smarty"]->display( "channel/subscribers_content.tpl" );
	exit;
	
}

function channel_friends_view() {
	
	$start    = $GLOBALS["Get"]->type_val("s","integer");
	$username = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $username );
	
	if(!$mem_id)
		die;
		
	$channel["username"] = $username;
	
	$cache = $GLOBALS["Network"]->get_cache( $mem_id );
	
	$friends["total"] = $cache["friends_count"];
	
	$friends["pages"] = handle_roundpages( $start, $friends["total"] );
	
	//friends
	$sql_query = "SELECT mem_id FROM network WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] )."
				  ORDER BY mem_id DESC LIMIT ".$start.",4";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$friends["cards"][] = $card;
	}
	
	if(count( $friends["cards"] ) < 4) {
		$missing = 4 - count( $friends["cards"] );
		//friends
		$sql_query = "SELECT mem_id FROM network WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] )."
					  ORDER BY mem_id DESC LIMIT 0,".$missing;
		$result = $GLOBALS["DB"]->result( $sql_query );
		foreach($result as $res) {
			$card = $GLOBALS["Member"]->card( $res["mem_id"] );
			$friends["cards"][] = $card;
		}
	}
	
	$GLOBALS["smarty"]->assign("channel", $channel);
	$GLOBALS["smarty"]->assign("friends", $friends);
	$GLOBALS["smarty"]->display( "channel/friends_content.tpl" );
	exit;
	
}

function channel_comments_view() {
	
	$info = $GLOBALS["Member"]->info();
	
	$start    = $GLOBALS["Get"]->type_val("s","integer");
	$username = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $username );
	$p      = $GLOBALS["Get"]->type_val("p", "integer");
	
	if(!$mem_id)
		die;
		
	$channel["username"] = $username;
	
	$sql_query = "SELECT COUNT(*) FROM channel_comments WHERE mem_id=".$mem_id;
	$comments["total"] = $GLOBALS["DB"]->single( $sql_query );
	
	$pages = handle_multipages( $p, $comments["total"], "CH_AjaxRequest( 'ajax.php?module=channels&section=comments&u=".$username."&p=|p|', 'commentsBoxHandler', 'no' )", 5 );
	$comments["pages"] = $pages;
	
	$sql_query = "SELECT * FROM channel_comments WHERE mem_id=".$mem_id." ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = array();
		$card["com_id"] = $res["com_id"];
		$card["from"] = $GLOBALS["Member"]->card( $res["from"] );
		$card["comment"] = nl2br( $res["comment"] );
		$card["posted"] = extract_date( $res["posted"] );
		if($info["mem_id"] == $mem_id || $res["from"] == $info["mem_id"])
			$card["delete"] = 1;
		$comments["cards"][] = $card;
	}	
	
	$GLOBALS["smarty"]->assign("channel", $channel);
	$GLOBALS["smarty"]->assign("comments", $comments);
	$GLOBALS["smarty"]->display( "lists/channel_comments.tpl" );
	exit;
	
}

function channel_subscribe_process() {
	
	$info = auth_member_ajax();
	if(!$info) {
		build_error(9, null, null, 1);
		exit;
	}
	
	$username = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $username );
	
	if(!$mem_id)
		die;
		
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$mem_id." AND mem_id=".$info["mem_id"]." AND type='channel'";
	$exists = $GLOBALS["DB"]->single( $sql_query );
	
	if($exists) {
		$sql_query = "DELETE FROM subscriptions WHERE sub_id=".$mem_id." AND mem_id=".$info["mem_id"]." AND type='channel'";
		$cmp_id = 25;
	}
	else {
		$sql_query = "INSERT INTO subscriptions (sub_id,mem_id,type) VALUES (".$mem_id.",".$info["mem_id"].",'channel')";
		$cmp_id = 24;
	}
	
	$GLOBALS["DB"]->execute( $sql_query );
	
	echo "js:CH4";
	build_complete( $cmp_id, 1 );
	exit;
		
}

?>