<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

class Get{

    function Get(){

        $this->referer = $_SERVER["HTTP_REFERER"];
        $this->cookies = $_COOKIE;
        $this->quotes  = get_magic_quotes_gpc();

        switch($_SERVER["REQUEST_METHOD"]){

            case 'GET':

                $this->vals = $_GET;

                break;

            case 'POST':

                $this->vals = $_POST;

                break;

        }//switch

    }//Get

    function val($name){

        $value  = $this->vals["$name"];
        $retval = $this->escape_value($value);

        return $retval;

    }//val

    function parse_values($str){

    	$vals = hs_parse_str($str);

    	while(list($name,$value) = each($vals)){
    		$retval[$name] = $this->escape_value($value);
    	}//while

    	return $retval;

    }//parse_values

    function escape_value($value){

    	if(is_array($value)){

            while(list($key,$val) = each($value)){

            	if(is_array($val)){

            		while(list($k,$v) = each($val)){
            			if($this->quotes){
            				$k = stripslashes($k);
            				$v = stripslashes($v);
            			}//if

            			$k = htmlspecialchars($k);
            			$v = htmlspecialchars($v);

                		$k = addslashes($k);
                    	$v = addslashes($v);

                		$k = hs_ereg_replace(preg_quote("|"),
                        		            "&#124;",
                                		    $k);

                		$v = hs_ereg_replace(preg_quote("|"),
                        		            "&#124;",
                                		    $v);

                		$retval[$key][$k] = $v;
            		}//while

            	}//if
            	else{
            	if($this->quotes){
            		$key = stripslashes($key);
            		$val = stripslashes($val);
            	}//if

            	$key = htmlspecialchars($key);
            	$val = htmlspecialchars($val);

                $key = addslashes($key);
                $val = addslashes($val);

                $key = hs_ereg_replace(preg_quote("|"),
                                    preg_quote("&#124;"),
                                    $key);

                $val = hs_ereg_replace(preg_quote("|"),
                                    preg_quote("&#124;"),
                                    $val);

                $retval[$key] = $val;
            	}//else

            }//while

        }//if
        else{
			if($this->quotes)
				$value = stripslashes($value);

			$value = htmlspecialchars($value);
            $value = addslashes($value);

            $value = hs_ereg_replace(preg_quote("|"),
                                  preg_quote("&#124;"),
                                  $value);

            $retval = $value;

        }//else

        return $retval;

    }//escape_value

    function type_val($name,$type){

        $value = $this->val($name);
        settype($value,$type);
        return $value;

    }//type_value

    function referer(){
        return $this->referer;
    }//referer

    function arr($ar,$assoc=0){

        while(list($key,$val) = each($ar)){

        	if($assoc)
        		$retar[$val] = $this->val($val);
        	else
            	$retar[$key] = $this->val($val);

        }//while

        return $retar;

    }//arr

    function cookie($name,$type=0){

    	static $cache = array();

    	if(isset($cache[$name]))
    		return $cache[$name];

        $value = $this->cookies["$name"];

        $value = htmlspecialchars($value);

        if(!$this->quotes){

            $value = addslashes($value);

        }//if

        $value = hs_ereg_replace(preg_quote("|"),
                              preg_quote("&#124;"),
                              $value);

        if($type){
        	settype($value,$type);
        }//if

        $retval = $value;

        $cache[$name] = $retval;

        return $retval;

    }//cookie

    function page_details($p_details=0){

    	$info = $GLOBALS["Member"]->info();

    	if(!$p_details){
    		$page_details["page"]    = handle_non_alpha($this->val("page"));
    		$page_details["section"] = handle_non_alpha($this->val("section"));
    		$page_details["handler"] = handle_non_alpha($this->val("handler"));
    		$page_details["action"]  = handle_non_alpha($this->val("action"));
    		$page_details["err_id"]  = $this->val("err_id");
    		$page_details["cmp_id"]  = $this->val("cmp_id");
    	}//if
    	else{
    		$page_details = $p_details;
    		$page_details["err_id"]  = $this->val("err_id");
    		$page_details["cmp_id"]  = $this->val("cmp_id");
    	}//else

    	if(empty($page_details["page"])){
    		$u = $this->val("u");
    		$g = $this->val("g");
    		if($u)
    			$page_details["page"] = "channels";
    		elseif($g) {
    			$page_details["page"] = "groups";
    			if($GLOBALS["settings"]["mod_rewrite"]){
    				$GLOBALS["smarty"]->assign("root", "../themes/".$GLOBALS["THEME"]."/gfx");
    			}
    		}
    		else
    			$page_details["page"] = "homepage";
    	}//if

    	if(empty($page_details["section"])){
    		$page_details["items_file"] = $page_details["page"];
    	}//if
    	else{
    		$page_details["items_file"] = $page_details["page"]."_".$page_details["section"];
    	}//else

    	$page_details["onload"] = $GLOBALS["page_details"]["onload"];
    	$page_details["code"]   = $GLOBALS["page_details"]["code"];

    	return($page_details);

    }//page_details
    
    function ajax_module(){    	
    	return handle_non_alpha($this->val("module"));
    }

    function modules(){

    	include(DOC_ROOT."/includes/config/modules.inc.php");
    	return array_keys($modules);

    }//modules

    function country_supported($country){

    	$sql_query = "SELECT codes_db
    				  FROM geo_countries
    				  WHERE con_id=".$country;

    	$codes_db = $GLOBALS["DB"]->single($sql_query);
    	return $codes_db;

    }//country_supported

}//Get class

class GetFromForm extends Get{

	function field($name,$type){

		$value = null;

		switch($type){

			case 'val':
				if(isset($this->vals[$name])){
					$name = hs_ereg_replace("\[\]$","",$name);
					$value = $this->val("$name");
				}//if
				break;

			case 'alnum':
				if(isset($this->vals[$name])){
					$value = $this->val($name);
					$value = ereg_replace("[^A-Za-z|0-9|_]","",$value);
					$value = strtolower($value);
				}//if
				break;

			case 'set':
				if(isset($this->vals[$name])){
					$ar = $this->val("$name");
					if(is_array($ar)){
						$ar = handle_empties($ar);
						if(count($ar))
						$value = build_sep_line($ar,"|");
					}//if
					else
						$value = $ar;
				}//if
				break;

			case 'switch':
				$value = $this->type_val("$name","integer");
				break;

			case 'time':
				$day   = $this->type_val("day","integer");
				$month = $this->type_val("month","integer");
				$year  = $this->type_val("year","integer");
				if(empty($day))
					$day = date("j");
				if(empty($month))
					$month = date("n");
				if(empty($year))
					$year = date("Y");
				$val   = $this->val("$name");
				if($val && !is_array($val))
					return $val;

				if(!extract_null_value($val[0]) && !extract_null_value($val[1]) &&
				   !extract_null_value($day) && !extract_null_value($month) &&
				   !extract_null_value($year)){

				   	if(!extract_null_value($val[2])){
						if($val[2] == 2 && $val[0] < 12)
							$val[0]+= 12;
						if($val[0] == 24)
							$val[0] = 0;
					}//if
				   	include_once(DOC_ROOT."/functions/adodb-time.php");
					$value = adodb_mktime($val[0],$val[1],0,$month,$day,$year);

				}//if
				break;

			case 'date':
				$val = $this->val("$name");
				if($val && !is_array($val))
					return $val;
				if(extract_null_value($val[3]) || extract_null_value($val[4])){
					$val[3] = 0;
					$val[4] = 0;
					$val[6] = 59;
				}//if
				else{
					$val[6] = 0;
				}//else

				if(!extract_null_value($val[5])){
					if($val[5] == 2 && $val[3] < 12)
						$val[3]+= 12;
					if($val[3] == 24)
						$val[3] = 0;
				}//if

				if(!extract_null_value($val[1]) && !extract_null_value($val[2]) && !extract_null_value($val[0])){
					include_once(DOC_ROOT."/functions/adodb-time.php");
					$value = adodb_mktime($val[3],$val[4],$val[6],$val[1],$val[0],$val[2]);
				}//if
				break;

			case 'pass':
				if(isset($this->vals[$name])){
					$value = $this->val("$name");
					if($value !== ''){
						$value = md5($value);
					}//if
				}//if
				break;

			case 'file':
				$value = $this->file($name);
				break;

			case 'html':
				$name = "html_".$name;
				if(isset($this->vals[$name])){
					$value = $this->val("$name");
					$value = stripslashes(html_entity_decode($value));
					$value = preg_replace('/<SCRIPT.*?<\/SCRIPT>/ims',"",$value);
					$value = preg_replace('/on(Load|Click|DblClick|DragStart|KeyDown|KeyPress|KeyUp|MouseDown|MouseMove|MouseOut'.
					'|MouseOver|SelectStart|Blur|Focus|Scroll|Select|Unload|Change)s*=s*(\'|").*?\2/smi',"",$value);
					$value = preg_replace('/(\'|")Javascript:.*?\1/smi','',$value);
					$value = addslashes(htmlspecialchars($value));
				}//if
				break;

		}//switch

		return $value;

	}//field

	function file($name){

		$file["tmp"]  = $_FILES[$name]["tmp_name"];
		$file["type"] = hs_strtolower($_FILES[$name]["type"]);
		$file["size"] = $_FILES[$name]["size"];
		$file["name"] = $_FILES[$name]["name"];

		return $file;

	}//file

}//GetFromForm class

$Get = new Get;
$GetFromForm = new GetFromForm;

?>