<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/
						
include(DOC_ROOT."/classes/phpmailer/class.phpmailer.php");

class Mail extends DB {
	
	function Mail(){
		
		$this->values  = array();
		$this->details = array();
		$this->mail_query = "";
		
	}//Mail
	
	function prepare(){
		
		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/messages.inc.php");
		
		if(extract_null_value($this->details["mes_id"])){
			$subject = $this->details["subject"];
			$body    = $this->details["body"];
		}//if
		else{
			$subject = $messages["subject"][$this->details["mes_id"]];
			$body    = $messages["body"][$this->details["mes_id"]];						
		}//else		
		
		if(is_numeric($this->details["recipient"])){
			
			$sql_query="SELECT email,notifications,username
						FROM members,members_settings
						WHERE members.mem_id=members_settings.mem_id
						AND members.mem_id=".$this->details["recipient"];
			
			$this->clean();
			$row = $this->row($sql_query);
			$this->details["recipient_email"] = (eregi("@",$row["email"]) || $this->details["recipient"] != 100000) ? $row["email"] : $GLOBALS["settings"]["system_mail"];
			$this->details["recipient_name"]  = $row["username"];
			if(!$this->details["notifications"])
				$this->details["notifications"]   = $row["notifications"];
			
		}//if
		else{			
			$this->details["recipient_email"] = $this->details["recipient"];			
			$this->details["notifications"]   = 1;
			$this->details["recipient_name"]  = $this->details["recipient_name"];
		}//else
		
		if($this->details["sender"] == "Admin"){
			$sql_query = "SELECT email,username FROM members WHERE member_type='a'";
			$admin = $this->row($sql_query);
			$this->details["sender_email"] = (eregi("@",$admin["email"])) ? $admin["email"] : $GLOBALS["settings"]["system_mail"];
			$this->details["sender_name"]  = $admin["username"];
		}//if
		elseif($this->details["sender"] && is_numeric($this->details["sender"])){
			
			$sql_query="SELECT email,username
						FROM members
						WHERE mem_id=".$this->details["sender"];
			
			$this->clean();
			$row = $this->row($sql_query);
			$this->details["sender_email"] = (eregi("@",$row["email"])) ? $row["email"] : $GLOBALS["settings"]["system_mail"];
			$this->details["sender_name"]  = $row["username"];
			
		}//if
		else{
			$this->details["sender_email"] = $GLOBALS["settings"]["system_mail"];
			if(!$this->details["sender_name"])
				$this->details["sender_name"]  = $GLOBALS["settings"]["site_name"];
		}//else
		
		$this->details["subject"] = html_entity_decode(handle_mail_patterns($subject,$this->details));
		$this->details["body"]    = nl2br(handle_mail_patterns($body,$this->details));
		
	}//prepare
	
	function instant(){	
		
		$encoding = strtoupper(extract_encoding("html"));
		
		$this->mail = new PHPMailer;
		
		//mailer settings
		$this->mail->Mailer = $GLOBALS["settings"]["mailer"];
		if($GLOBALS["settings"]["mailer"] == "sendmail")
			$this->mail->Sendmail = $GLOBALS["settings"]["mailsetup"];
		elseif($GLOBALS["settings"]["mailer"] == "smtp"){
			$smtp = explode("|",$GLOBALS["settings"]["mailsetup"]);
			$this->mail->Host = $smtp[0];
			$this->mail->Port = $smtp[1];
			if($smtp[2]){
				$this->mail->SMTPAuth = 1;
				$this->mail->Username = $smtp[2];
				$this->mail->Password = $smtp[3];
			}//if
		}//elseif
		
		//mail data
		$this->mail->AddAddress($this->details["recipient_email"],$this->details["recipient_name"]);
		$this->mail->From = $this->details["sender_email"];
		$this->mail->FromName = $this->details["sender_name"];
		$this->mail->CharSet = $encoding;
		$this->mail->ContentType = "text/html";
		$this->mail->Body = $this->details["body"];
		$this->mail->Subject = $this->details["subject"];
		$this->mail->AddReplyTo($this->details["sender_email"]);
		$this->mail->Sender = $this->details["sender_email"];
		$this->mail->send();
		
	}//instant
	
	function send_external(){
		
		$this->prepare();		
		if($this->details["notifications"]){
			$this->instant();
		}//if
		
	}//send_external
	
	function send_mass(){
		
		$this->prepare();
		if($this->details["notifications"]){
			
			$sql_query = "INSERT INTO mass_mail(`to`,`subject`,`message`,`headers`)
						  VALUES (':to:',':subject:',':message:',':headers:')";
		
			$values["to"] = $this->details["recipient_email"]."|".$this->details["recipient_name"];
			$values["subject"] = $this->details["subject"];
			$values["message"] = $this->details["body"];
			$values["headers"] = $this->details["sender_email"]."|".$this->details["sender_name"];
		
			$this->values = $values;
			$this->execute($sql_query);
		}//if
		
	}//send_mass
	
	function send_internal(){
		
		if($GLOBALS["Member"]->is_ignored( $this->details["recipient"], $this->details["sender"] ))
			return false;
				
		$mes_id = $this->details["mes_id"];
		
		if(!$this->details["mailbox"])
			$this->details["mailbox"] = "inbox";
		
		if($mes_id){
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/messages.inc.php");
			$subject = handle_mail_patterns($messages["subject"][$mes_id],$this->details);
			$body    = handle_mail_patterns($messages["body"][$mes_id],$this->details);
		}//if
		else{
			$subject = $this->details["subject"];
			$body    = $this->details["body"];
		}//else		
				
		$sql_query = "INSERT INTO mailbox(mem_id,per_id,subject,message,mailbox,special,video,date)
					  VALUES (:mem_id:,:per_id:,':subject:',':message:',':mailbox:',':special:',:video:,:time:)";
		
		$values = array();
		
		$values["mem_id"]  = $this->details["recipient"];
		$values["per_id"]  = $this->details["sender"];
		$values["subject"] = $subject;
		$values["message"] = $body;
		$values["time"]    = time();		
		$values["special"] = $this->details["special"];
		$values["mailbox"] = $this->details["mailbox"];
		$values["video"]   = ($this->details["video"]) ? (int)($this->details["video"]) : 0;
	
		$this->values = $values;
		$this->execute($sql_query);
		
		if( $this->details["mailbox"] == "inbox" ) {
			
			$values = array();
				
			$values["mem_id"]  = $this->details["sender"];
			$values["per_id"]  = $this->details["recipient"];
			$values["subject"] = $subject;
			$values["message"] = $body;
			$values["time"]    = time();
			$values["special"] = $this->details["special"];
			$values["mailbox"] = "sent";
			$values["video"]   = ($this->details["video"]) ? (int)($this->details["video"]) : 0;
			
			$this->values = $values;
			$this->execute($sql_query);
			
		}
		
		return true;
		
	}//send_internal
	
}//Mail class

$GLOBALS["Mail"] = new Mail;

?>