<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function auth_member(){

	global $page_details,$settings;

	$info = $GLOBALS["Member"]->info();

	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
	}//if

	if($info["mem_id"] && $page_details["items_file"] != "homepage" &&
	   $page_details["page"] != "join" && $page_details["handler"] != "join" &&
	   $page_details["items_file"] != "account" && $page_details["handler"] != "account" &&
	   $page_details["page"] != "getpaid" && $page_details["handler"] != "getpaid"){

		if($GLOBALS["settings"]["limit_unapproved"] && !$info["approved"] && $info["member_type"] != 'a')
			load_page(URL."/index.php?page=account&err_id=39");

		if($GLOBALS["settings"]["min_member_age"] && !$info["birthdate"])
			load_page(URL."/index.php?page=account&err_id=38");

	}//if

	$allowed_pages = array(
		"videos_view",
		"playlists",
		"channels",
		"playlists_view",
		"videos",
		"channels_browse",
		"groups",
		"groups_videos",
		"groups_view_discussion",
		"groups_discussions",
		"groups_browse",
		"search"
	);
	
	$allowed_handlers = array (
		"search"
	);
	
	if((in_array($page_details["items_file"],$allowed_pages) && empty($page_details["handler"])) || in_array($page_details["handler"], $allowed_handlers))
		$allowed_page = 1;
	else
		$allowed_page = 0;
	
	$is_invitation = validate_invitation();
	switch( $page_details["items_file"] ) {
		case 'videos_view':
			$id = $GLOBALS["Get"]->type_val("vid_id","integer");
			$type = "video";
			break;
		case 'playlists_view':
			$id = $GLOBALS["Get"]->type_val("pla_id","integer");
			$type = "playlist";
			break;
		case 'groups':
			$type = "group";
			$g = $GLOBALS["Get"]->val("g");
			$id = $GLOBALS["Get"]->type_val("grp_id","integer");
			
			if($g) {
				$sql_query = "SELECT grp_id FROM groups WHERE folder=':g:'";
				$GLOBALS["DB"]->values = array( "g" => $g );
				$id = $GLOBALS["DB"]->single( $sql_query );
			}
			break;
	}
	if($id && $type) {
		$is_viewkey = validate_viewkey( $id, $type, $GLOBALS["Get"]->val("viewkey") );
	}
	
	$verify = 0;
	
	if($settings["secure_site"] && !$is_invitation && !$is_viewkey)
		$verify = 1;
		
	if($info["mem_id"] || !$allowed_page)
		$verify = 1;
	
	if($verify){

		$sql_query="SELECT COUNT(*) FROM members
					WHERE mem_id=':0:' AND password=':1:'";
	
		$GLOBALS["DB"]->values = array($info["mem_id"],$info["password"]);
		$exist = $GLOBALS["DB"]->single($sql_query);
	
		if(!$exist){
			load_page(URL."/index.php?err_id=9&route_to=".urlencode("http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]));
		}//if
		
		if(extract_getpaid_enabled()){
	
		$valid_membership = validate_membership($info["mem_id"],$info["membership"],$info["access_end"]);
	
		if(!$valid_membership && ($page_details["page"] != "upgrade") && $page_details["handler"] != "upgrade"){
			load_page(URL."/index.php?page=upgrade");
		}//if
		
		}
		
	}//if
	elseif(extract_getpaid_enabled() && empty($info["mem_id"])){
		$free_membership = extract_free_package();
		if(!$free_membership) {
			load_page(URL."/index.php?err_id=9");
		}
	}//elseif
	
	if( $info["mem_id"] ) {
		$sql_query  = "SELECT last_click FROM profiles WHERE mem_id = ".$info["mem_id"];
		$last_click = $GLOBALS["DB"]->single( $sql_query );
		if($last_click < ( time()- $GLOBALS["settings"]["autologout"] * 60 ) ) {
			$sql_query = "UPDATE profiles SET last_visit = last_click
						  WHERE mem_id = ".$info["mem_id"];
			$GLOBALS["DB"]->execute( $sql_query );
		}
	
		$sql_query="UPDATE profiles
					SET last_click=".time()."
					WHERE mem_id=".$info["mem_id"];
	
		$GLOBALS["DB"]->execute($sql_query);
	}

	return $info;

}//auth_member

function auth_member_ajax() {

	$info = $GLOBALS["Member"]->info();
	if($info["mem_id"])
		return $info;
	else
		return false;
}

function auth_view_message( $mes_id = 0 ){

	$info = $GLOBALS["Member"]->info();

	if(!$mes_id)
		$mes_id = $GLOBALS["Get"]->type_val("mes_id","integer");

	$sql_query="SELECT count(mes_id)
				FROM mailbox
				WHERE mes_id=".$mes_id."
				AND mem_id=".$info["mem_id"];

	$exists = $GLOBALS["DB"]->single($sql_query);

	if(!$exists){
		$link = "index.php?page=mailbox&err_id=17";
		load_page($link);
	}//if
	
	return true;

}//auth_view_message

function auth_group_edit_access(){

	$info = $GLOBALS["Member"]->info();

	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");

	if(!$grp_id)
		$grp_id = $GLOBALS["Get"]->type_val("id","integer");

	if(!$grp_id)
		return true;

	$sql_query = "SELECT count(grp_id)
				  FROM groups
				  WHERE grp_id=".$grp_id." AND mem_id=".$info["mem_id"];

	$owner = $GLOBALS["DB"]->single($sql_query);

	if($owner)
		return true;
	else
		load_page( build_group_link_by_id ( $grp_id, 1 )."err_id=400" );

}//auth_group_manage

function auth_group_action_access(){

	$info = $GLOBALS["Member"]->info();
	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		return true;
	}//if
	elseif($info["member_type"] == 'm'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		if(admin_validate_section("manage",5,0))
			return true;
	}//elseif
	
	$g = $GLOBALS["Get"]->val("g");
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	
	if($g) {
		$sql_query = "SELECT grp_id FROM groups WHERE folder=':g:'";
		$GLOBALS["DB"]->values = array( "g" => $g );
		$grp_id = $GLOBALS["DB"]->single( $sql_query );
	}

	if($grp_id){

		$sql_query = "SELECT count(mem_id)
					  FROM group_members
					  WHERE mem_id=".$info["mem_id"]." AND grp_id=".$grp_id;

		$is_member = $GLOBALS["DB"]->single($sql_query);

	}//if
	else
		$is_member = 0;
	
	if($is_member)
		return true;
	else
		load_page(build_group_link_by_id($grp_id,1)."err_id=401");

}//auth_group_action_access

function auth_group_access(){

	$info = $GLOBALS["Member"]->info();
	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		$access = true;
	}//if
	elseif($info["member_type"] == 'm'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		if(admin_validate_section("manage",5,0))
			$access = true;
	}//elseif

	$g = $GLOBALS["Get"]->val("g");
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	
	if($g) {
		$sql_query = "SELECT grp_id FROM groups WHERE folder=':g:'";
		$GLOBALS["DB"]->values = array( "g" => $g );
		$grp_id = $GLOBALS["DB"]->single( $sql_query );
	}

	if($grp_id){
		$group_type = $GLOBALS["DB"]->single("SELECT privacy FROM groups WHERE grp_id=".$grp_id);
		$viewkey = $GLOBALS["Get"]->val("viewkey");
		include(DOC_ROOT."/classes/Groups.class.php");
		if($access || $group_type < 3 || $GLOBALS["Groups"]->is_member($info["mem_id"],$grp_id)){
			return true;
		}//if
		elseif($group_type == 3 && (($info["mem_id"] && validate_access( $grp_id, "group" )) || validate_viewkey( $grp_id, "group", $viewkey ) ) )
			return true;
		elseif(!$info["mem_id"])
			load_page(URL."/index.php?err_id=9");
		else
			load_page(URL."/index.php?page=groups&err_id=403");
	}//if

}//auth_group_access

function auth_video_edit_access( $vid_id = 0 ){
	
	if(!$vid_id) {
		
		$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");

		if(!$vid_id)
			$vid_id = $GLOBALS["Get"]->type_val("id","integer");
	
		if(!$vid_id)
			return true;
		
	}

	$info = $GLOBALS["Member"]->info();
	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		return true;
	}//if
	elseif($info["member_type"] == 'm'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		if(admin_validate_section("manage",8,0))
			return true;
	}//elseif

	$sql_query = "SELECT count(vid_id)
				  FROM videos
				  WHERE mem_id=".$info["mem_id"]."
				  AND vid_id=".$vid_id;

	$owner = $GLOBALS["DB"]->single($sql_query);

	if($owner)
		return true;
	else
		load_page(URL."/index.php?page=videos&err_id=14");

}//auth_video_edit_access

function auth_playlist_edit_access( $ret = 0 ){

	$info = $GLOBALS["Member"]->info();
	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		return true;
	}//if
	elseif($info["member_type"] == 'm'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		if(admin_validate_section("manage",8,0))
			return true;
	}//elseif

	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");

	if(!$pla_id)
		$pla_id = $GLOBALS["Get"]->type_val("id","integer");

	if(!$pla_id)
		return true;

	$sql_query = "SELECT count(pla_id)
				  FROM playlists
				  WHERE mem_id=".$info["mem_id"]."
				  AND pla_id=".$pla_id;

	$owner = $GLOBALS["DB"]->single($sql_query);

	if($owner)
		return true;
	elseif( $ret )
		return false;
	else
		load_page(URL."/index.php?page=videos&err_id=14");

}

function auth_join(){

	if($GLOBALS["settings"]["invite_only"] && !validate_invitation())
		load_page(URL."/index.php?err_id=31");

	return true;

}//auth_join

function auth_video_access( $vid_id = 0 ) {	
	
	$info = $GLOBALS["Member"]->info();
	if(!$vid_id){
		$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	}
	
	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		return true;
	}//if
	elseif($info["member_type"] == 'm'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		if(admin_validate_section("manage",8,0) || admin_validate_section("manage",16,0))
			return true;
	}//elseif
	
	$sql_query = "SELECT mem_id,broadcast,category FROM videos WHERE vid_id=".$vid_id;
	$video = $GLOBALS["DB"]->row( $sql_query );
	
	if(!auth_getpaid_category_access( $info["membership"], $video["category"] )) {
		load_page( "index.php?page=upgrade" );
	}
	
	if($video["mem_id"] == $info["mem_id"])
		return true;
		
	$broadcast = $video["broadcast"];
	
	if($broadcast == 0)
		return true;
	else{
		$viewkey = $GLOBALS["Get"]->val("viewkey");
		if( ! ( ( ($info["mem_id"] && validate_access( $vid_id, "video" ) ) || validate_viewkey( $vid_id, "video", $viewkey ) ) ) ) {
			if(!$info["mem_id"])
				load_page(URL."/index.php?err_id=9");
			else
				build_error(47, "videos");
		}
	}
	
	return true;
	
}

function auth_getpaid_category_access( $membership, $category ) {
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	if(!$getpaid["enabled"])
		return true;
		
	$cats = handle_empties(explode(",", $getpaid["free"]["categories"]));
	if(!$membership && $getpaid["free"]["access"] == 1 && in_array( $category, $cats )) {
		return false;
	}
	
	return true;
	
}

function auth_getpaid_download_access() {
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	if(!$getpaid["enabled"])
		return true;
	
	$info = $GLOBALS["Member"]->info();
	if($info["membership"] || $getpaid["free"]["download"])
		return true;
		
	return false;
	
}

function auth_getpaid_video_watch_access() {
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	if(!$getpaid["enabled"])
		return 0;
		
	if( $getpaid["free"]["access"] == 2 )
		return $getpaid["free"]["seconds"];
		
	return 0;
	
}

function auth_video_access_ajax( $vid_id = 0 ) {
	
	$info = $GLOBALS["Member"]->info();
	if(!$vid_id){
		$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	}
	
	if($info["member_type"] == 'a'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		return true;
	}//if
	elseif($info["member_type"] == 'm'){
		include_once(DOC_ROOT."/functions/admin_functions.php");
		admin_validate();
		if(admin_validate_section("manage",8,0) || admin_validate_section("manage",16,0))
			return true;
	}//elseif
	
	$sql_query = "SELECT mem_id,broadcast FROM videos WHERE vid_id=".$vid_id;
	$video = $GLOBALS["DB"]->row( $sql_query );
	
	if(!auth_getpaid_category_access( $info["membership"], $video["category"] ))
		return false;
	
	if($video["mem_id"] == $info["mem_id"])
		return true;
		
	$broadcast = $video["broadcast"];
	
	if($broadcast == 0)
		return true;
	else{
		if( ! ( ( ($info["mem_id"] && validate_access( $vid_id, "video" ) ) || validate_viewkey( $vid_id, "video", $viewkey ) ) ) )
			return false;
	}
	
	return true;
}

function auth_playlist_access(){
	
	$info = $GLOBALS["Member"]->info();
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");
	
	$sql_query = "SELECT mem_id,privacy FROM playlists WHERE pla_id=".$pla_id;
	$playlist = $GLOBALS["DB"]->row( $sql_query );
	
	if($playlist["mem_id"] == $info["mem_id"])
		return true;
	
	$privacy = $playlist["privacy"];
	
	if($privacy == 0)
		return true;
	else{
		$viewkey = $GLOBALS["Get"]->val("viewkey");
		if( ! ( ( ($info["mem_id"] && validate_access( $pla_id, "playlist" ) ) || validate_viewkey( $pla_id, "playlist", $viewkey ) ) ) ) {
			if(!$info["mem_id"])
				load_page(URL."/index.php?err_id=9");
			else
				build_error(48, "videos");
		}
	}
	
	return true;
}

function auth_channel_comment( $mem_id ) {
	
	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT comments,comment_allow FROM channels WHERE mem_id=".$mem_id;
	$channel = $GLOBALS["DB"]->row( $sql_query );
	
	$allow = 0;
	if($channel["comments"]) {
		if($channel["comment_allow"] == 1)
			$allow = 1;
		elseif($GLOBALS["Network"]->is_trusted( $info["mem_id"], $mem_id, 1)) {
			$allow = 1;
		}
	}
	
	return $allow;
	
}

?>