<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/
						
function converter_data( $file, $info ) {
		
	exec($GLOBALS["paths"]["ffmpeg"]." -i ".$file." 2>&1", $out);
	
	if($info == "width" || $info == "height")
		$search = "Video: ";
	elseif( $info == "duration" )
		$search = "Duration: ";
	
	while(list($k,$v)=each($out)){		
		if($data = strstr($v,$search))
		break;
	}
	
	if($info == "width" || $info == "height") {
		preg_match( "/[0-9]+x[0-9]+/", $data, $m );
		list($width, $height) = explode("x", $m[0]);
	} elseif( $info == "duration" ) {
		$data = substr( $data, strpos($data,":") + 1 );
		$data = trim( substr( $data, 0, strpos($data, "," ) ) );
		list($h,$m,$s) = explode( ":", $data );
		$duration = $h * 3600 + $m * 60 + $s;
	}
	
	return ${$info};
	
}

function converter_convert( $in, $out, $ext ) {
	
	$original_width  = converter_data( $in, "width" );
	$original_height = converter_data( $in, "height" );
	
	$scale = "";
	if( $original_width > $original_height ) {
		if( $original_width > $GLOBALS["Videos"]->width ) {
			$ratio = $GLOBALS["Videos"]->width / $original_width;
			$new_height = round( $original_height * $ratio );
			$scale = " -s ".$GLOBALS["Videos"]->width."x".$new_height;
		}
	} else {
		if( $original_height > $GLOBALS["Videos"]->height ) {
			$ratio = $GLOBALS["Videos"]->height / $original_height;
			$new_width = round( $original_width * $ratio );
			$scale = " -s ".$new_width."x".$GLOBALS["Videos"]->height;
		}
	}
		
	if($ext == ".flv" && !$scale) {
		if( $in != $out )
			copy( $in, $out );
		exec($GLOBALS["paths"]["flvtool2"]." -Uv ".$out." ".$out.".tmp");
		rename( $out.".tmp", $out );
		return true;
	}
		
	exec($GLOBALS["paths"]["ffmpeg"]." -y -i ".$in." -b ".$GLOBALS["Videos"]->vbitrate."k -ab ".$GLOBALS["Videos"]->abitrate."k -ar 22050 ".$out.$scale);
	exec($GLOBALS["paths"]["flvtool2"]." -Uv ".$out." ".$out.".tmp");
	rename( $out.".tmp", $out );
	
	return file_exists( $out );
	
}

function converter_screenshot( $file, $time, $tmpdir ) {
	
	$cmd = $GLOBALS["paths"]["ffmpeg"]." -y -i ".$file." -f mjpeg -r 1 -ss ".$time." -vframes 1 -an ".$tmpdir."/00000001.jpg";
	exec($cmd);
				
	$file = $tmpdir."/00000001.jpg";
		
	return $file;
	
}

?>