<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

function validate_join_email($email){
	
	$sql_query="SELECT count(mem_id)
				FROM members
				WHERE email=':0:'";
	
	$GLOBALS["DB"]->values = array($email);
	$exist = $GLOBALS["DB"]->single($sql_query);
	
	if($exist > 0){
		
		return false;
		
	}//if
	else{
		
		return true;
		
	}//else
	
}//validate_join_email 

function validate_username($username){
	
	$dir = opendir( DOC_ROOT );
	while($file = readdir( $dir )) {
		if($file == $username)
			return false;
	}
	closedir( $dir );
	
	$sql_query="SELECT count(mem_id)
				FROM members
				WHERE username=':0:'";
	
	$GLOBALS["DB"]->values = array($username);
	$exist = $GLOBALS["DB"]->single($sql_query);
	
	if($exist > 0 || $username == ""){
		
		return false;
		
	}//if
	else{
		
		return true;
		
	}//else
	
}//validate_username

function validate_invitation(){
	
	$inv_id = $GLOBALS["Get"]->val("inv_id");
	
	$sql_query = "SELECT COUNT(*) FROM invitations WHERE inv_id=':0:' AND stat='p'";
	$GLOBALS["DB"]->values = array($inv_id);	
	$exists = $GLOBALS["DB"]->single($sql_query);
	
	return $exists;
	
}//validate_invitation

function validate_membership($mem_id,$membership,$access_end){
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	
	if(!$getpaid["enabled"])
		return true;
	
	if(!$membership){
		$free_account = extract_free_package();
		if(!$free_account)
			return false;
	}//if
	elseif($access_end && $access_end < time()){
		$free_account = extract_free_package();
		if(!$free_account)
			return false;
		else{
			$sql_query = "UPDATE members SET membership=0, access_end=0
						  WHERE mem_id=".$mem_id;
			$GLOBALS["DB"]->execute($sql_query);
		}//else
	}//elseif
	
	return true;
	
}//validate_membership

function validate_email_syntax($email){
	
	$atom = '[-a-z0-9!#$%&\'*+/=?^_`{|}~]';    // allowed characters for part before "at" character
	$domain = '([-a-z0-9]*[a-z0-9]+)'; // allowed characters for part after "at" character

	$regex = '^' . $atom . '+' .        // One or more atom characters.
	'(\.' . $atom . '+)*'.              // Followed by zero or more dot separated sets of one or more atom characters.
	'@'.                                // Followed by an "at" character.
	'(' . $domain . '{1,63}\.)+'.       // Followed by one or max 63 domain characters (dot separated).
	$domain . '{2,63}'.                 // Must be followed by one set consisting a period of two
	'$';                                // or max 63 domain characters.

	if(eregi($regex,$email))
		return true;
	else
		return false;
	
}//validate_email_syntax

function validate_viewkey( $id, $type, $key ) {
	
	$sql_query = "SELECT COUNT(*) FROM viewkeys WHERE id=:id: AND type=':type:' AND `viewkey`=':key:'";
	$GLOBALS["DB"]->values = array("id" => $id, "type" => $type, "key" => $key);
	return $GLOBALS["DB"]->single( $sql_query );
	
}

function validate_access( $id, $type ) {
	
	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT COUNT(*) FROM private_access WHERE id=:id: AND type=':type:' AND `mem_id`=:mem_id:";
	$GLOBALS["DB"]->values = array("id" => $id, "type" => $type, "mem_id" => $info["mem_id"]);
	return $GLOBALS["DB"]->single( $sql_query );
	
}

?>