{include file="items/channel_style.tpl"}
<div id="channelContainer">
	{include file="menus/normal.tpl" menu="channel"}
	
	{if $channel_page == "main"}
	
	<div class="channelColumnRight">
		{if $boxes.featured}
		<div class="marginTop5"><div class="video">{$boxes.featured.video}</div></div>
		<div class="channelBoxBasic"><div class="body padded5">
			<div class="featuredTitle"><a href="{$boxes.featured.link}">{$boxes.featured.title}</a></div>
			<span class="label">{$language.from}:</span> {include file="link.tpl" link=$boxes.featured.from.link name=$boxes.featured.from.username_cut}<br />
			<span class="label">{$language.views}:</span> {$boxes.featured.views}<br />
			<span class="label">{$language.comments}:</span> {$boxes.featured.comments}
		</div></div>
		{/if}
		
		{if $sbmodule == "enabled"}<div class="channelBoxBasic marginTop5"><div class="body padded3" style="font-size: 10pt;font-weight:bold;">
			<div class="column" style="padding: 2px 0 0 1px">{$language.bookmark}</div>
			<div>{include file="items/sb_bar.tpl"}</div>
			<div class="listClear"></div>
		</div></div>{/if}
		
		{if $boxes.playlists}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.playlists` (<a href='`$channel.linkq`pro=playlists'>`$boxes.playlists.total`</a>)" box="playlists"}</div>{/if}
		{if $boxes.videos}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.videos` (<a href='`$channel.linkq`pro=videos'>`$boxes.videos.total`</a>)" box="videos"}</div>{/if}
		{if $boxes.favorites}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.favorites` (<a href='`$channel.linkq`pro=favorites'>`$boxes.favorites.total`</a>)" box="favorites"}</div>{/if}
		{if $boxes.subscribers.total > 0}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.subscribers` (<a href='`$channel.linkq`pro=subscribers'>`$boxes.subscribers.total`</a>)" box="subscribers" subscribers=$boxes.subscribers}</div>{/if}
		{if $boxes.friends.total > 0}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.friends` (<a href='`$channel.linkq`pro=friends'>`$boxes.friends.total`</a>)" box="friends" friends=$boxes.friends}</div>{/if}
		{if $boxes.comments}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.comments` (`$boxes.comments.total`)" box="comments" comments=$boxes.comments}</div>{/if}
	</div>
	<div class="channelColumnLeft">
		<div class="marginTop5">{include file="channel/box.tpl" style="Highlight" title=$channel.title box="info" button=$language.subscribe}</div>
		<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title=$language.connect_with_username|replace:":username:":$channel.username box="connect"}</div>
		{if $boxes.subscriptions}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.subscriptions` (<a href='`$channel.linkq`pro=subscriptions'>`$boxes.subscriptions.total`</a>)" box="subscriptions"}</div>{/if}
		{if $boxes.bulletins}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.bulletins` (<a href='`$channel.linkq`pro=bulletins'>`$boxes.bulletins.total`</a>)" box="bulletins"}</div>{/if}
		{if count($boxes.recent_ratings)}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.my_recent_ratings`" box="recent_ratings"}</div>{/if}
		{if count($boxes.recent_comments)}<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$language.my_recent_comments`" box="recent_comments"}</div>{/if}
	</div>
	
	{elseif $channel_page == "videos"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.videos`" box="sub/videos"}</div>
	
	{elseif $channel_page == "favorites"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.favorites`" box="sub/favorites"}</div>
	
	{elseif $channel_page == "playlists"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.playlists`" box="sub/playlists"}</div>
	
	{elseif $channel_page == "groups"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.groups`" box="sub/groups"}</div>
	
	{elseif $channel_page == "friends"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.friends`" box="sub/friends"}</div>
	
	{elseif $channel_page == "subscribers"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.subscribers`" box="sub/subscribers"}</div>
	
	{elseif $channel_page == "subscriptions"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.subscriptions`" box="sub/subscriptions"}</div>
	
	{elseif $channel_page == "bulletins"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.bulletins`" box="sub/bulletins"}</div>
	
	{elseif $channel_page == "view_bulletin"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.bulletins`" box="sub/view_bulletin"}</div>
	
	{elseif $channel_page == "add_comment"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.add_comment`" box="sub/add_comment"}</div>
	
	{elseif $channel_page == "add_bulletin"}
	
	<div class="marginTop5">{include file="channel/box.tpl" style="Basic" title="`$channel.title`: `$language.post_bulletin`" box="sub/add_bulletin"}</div>
	
	{/if}
	
</div>