<?php

	if(!$admin){
		if($_GET["theme"]){
			if(array_key_exists($_GET["theme"],$themes)){
				SetCookie("theme",$_GET["theme"],time()+3600*24*365);
				$THEME = $_GET["theme"];
			}//if
		}//if
		elseif($_COOKIE["theme"]){
			if(array_key_exists($_COOKIE["theme"],$themes))
				$THEME = $_COOKIE["theme"];
			else
				SetCookie("theme","",time()-10);
		}//elseif
	}//if

	ini_set( "display_errors", "Off" );
	error_reporting(E_ALL & ~E_NOTICE);

	//load global settings
	include(DOC_ROOT."/includes/config/paths.inc.php");
	include(DOC_ROOT."/themes/".$THEME."/config/settings.inc.php");

	//load functions
	include(DOC_ROOT."/functions/mbstring_functions.php");
	include(DOC_ROOT."/functions/build_functions.php");
	include(DOC_ROOT."/functions/auth_functions.php");
	include(DOC_ROOT."/functions/load_functions.php");
	include(DOC_ROOT."/functions/validate_functions.php");
	include(DOC_ROOT."/functions/extract_functions.php");
	include(DOC_ROOT."/functions/handle_functions.php");

	//load classes
	include(DOC_ROOT."/classes/SmartyEx.class.php");
	include(DOC_ROOT."/classes/DB.class.php");
	include(DOC_ROOT."/classes/Get.class.php");
	include(DOC_ROOT."/classes/Member.class.php");
	include(DOC_ROOT."/classes/Network.class.php");

	$Mail        = object;
	$Groups      = object;	
	$Videos      = object;

	register_shutdown_function("handle_connection_close");

?>