<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");
						if(!$action)
							$action = $GLOBALS["Get"]->val("act");

							switch($action){

								case 'update':
									friends_update();
									break;
									
								case 'invite':
									friends_invite();
									break;

							}//switch

						///////////////////////////////////////

function my_friends() {
	
	$info  = $GLOBALS["Member"]->info();	
	$cache = $GLOBALS["Network"]->get_cache( $info["mem_id"] );
	
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$total = $cache["friends_count"];
	$link = "index.php?page=friends";
	
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT mem_id FROM network WHERE ".$GLOBALS["Network"]->extract_hs_query($cache["friends"])."
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$friends = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$friends[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("friends", $friends);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function friends_update() {
	
	$info = auth_member();
	$mem_id = $GLOBALS["Get"]->val("mem_id");
	
	if(is_array($mem_id) && count($mem_id)) {
		foreach($mem_id as $mem) {
			$GLOBALS["Network"]->remove_friend( $mem, $info["mem_id"] );
		}
	}
	
	load_page( $GLOBALS["Get"]->referer() );
	
}

function my_friends_videos() {
	
	$info  = $GLOBALS["Member"]->info();	
	$cache = $GLOBALS["Network"]->get_cache( $info["mem_id"] );
	
	$p = $GLOBALS["Get"]->type_val("p","integer");	
	$link = "index.php?page=friends&section=videos";
	
	$sql_query = "SELECT COUNT(*) FROM videos AS v, network AS n WHERE v.mem_id = n.mem_id
				  ".$GLOBALS["Videos"]->filter("v.")." AND ".$GLOBALS["Network"]->extract_hs_query($cache["friends"],"n.");
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT v.vid_id FROM videos AS v, network AS n WHERE v.mem_id = n.mem_id
				  ".$GLOBALS["Videos"]->filter("v.")." AND ".$GLOBALS["Network"]->extract_hs_query($cache["friends"],"n.")."
				  ORDER BY v.posted DESC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("pages", $pages);	
	
}

function my_friends_favorites() {
	
	$info  = $GLOBALS["Member"]->info();
	$cache = $GLOBALS["Network"]->get_cache( $info["mem_id"] );
	
	$p = $GLOBALS["Get"]->type_val("p","integer");	
	$link = "index.php?page=friends&section=videos";
	
	$sql_query = "SELECT COUNT(*) FROM bookmarks AS b, videos AS v, network AS n WHERE v.mem_id = n.mem_id
				  AND v.vid_id = b.item_id
				  ".$GLOBALS["Videos"]->filter("v.")." AND ".$GLOBALS["Network"]->extract_hs_query($cache["friends"],"n.");
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT b.item_id FROM bookmarks AS b, videos AS v, network AS n WHERE v.mem_id = n.mem_id
				  AND v.vid_id = b.item_id
				  ".$GLOBALS["Videos"]->filter("v.")." AND ".$GLOBALS["Network"]->extract_hs_query($cache["friends"],"n.")."
				  ORDER BY b.added DESC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["item_id"] );
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("pages", $pages);	
	
}

function my_invitations() {
	
	$info = auth_member();
	
	$sql_query = "SELECT COUNT(*) FROM invitations
				  WHERE mem_id=".$info["mem_id"];
	
	$total = $GLOBALS["DB"]->single($sql_query);
	
	$p = $GLOBALS["Get"]->type_val("p","integer");
	
	$pages = handle_multipages($p,$total,"index.php?page=friends&section=invitations");
	
	$sql_query = "SELECT *
				  FROM invitations
				  WHERE mem_id=".$info["mem_id"]."
				  GROUP BY mem_id,email
				  ORDER BY date DESC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	
	$result = $GLOBALS["DB"]->result($sql_query);
	$invitations = array();
	
	foreach($result as $res){
		$card = array();
		$card["email"]   = $res["email"];
		$card["date"]    = extract_date($res["date"]);
		$card["status"]  = extract_invitation_status($res["stat"]);
		$card["inv_id"]  = $res["inv_id"];
		$card["pending"] = ($res["stat"] == "p") ? 1 : 0;
		
		$invitations[] = $card;
		
	}//foreach
	
	$GLOBALS["smarty"]->assign("invitations",$invitations);
	$GLOBALS["smarty"]->assign("pages",$pages);
	
	
}

function friends_invite() {
	
	$info = auth_member();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("invite");	
	$values["emails"] = handle_empties(explode(",",$values["emails"]));
	
	if(count($values["emails"]) == 0)
		build_error(15,"friends","invite");
		
	$reports = array();
	foreach($values["emails"] as $email){
		$email = trim($email);
		if(!empty($email)){			
			$report = handle_external_invitation($info["mem_id"],$email,$values["subject"],$values["message"]);
			$card = array();
			$card["email"] = $email;
			if(!$report["status"]){
			switch($report["details"]){
				case 'invites_limit':
					$card["report"] = $GLOBALS["language"]["you_have_reached_allowed_number_of_invites_for_today"];
					break;
				case 'invited':
					$card["report"] = $GLOBALS["language"]["you_have_already_invited_this_member"];
					break;
				case 'themselves':
					$card["report"] = $GLOBALS["language"]["you_can_t_invite_yourself"];
					break;
				case 'connected':
					$card["report"] = $GLOBALS["language"]["user_is_already_your_friend"];
					break;
				case 'ignored':
					$card["report"] = $GLOBALS["language"]["user_has_restricted_who_can_invite_them"];
					break;
				case 'syntax':
					$card["report"] = $GLOBALS["language"]["incorrect_email"];
					break;
			}//switch
			}//if
			else
				$card["report"] = $GLOBALS["language"]["invitation_has_been_sent"];
			$reports[] = $card;
		}//if
		
	}//foreach
	$GLOBALS["smarty"]->assign("reports",$reports);

	$p_details["page"] = "friends";
	$p_details["section"] = "invite_report";
	$p_details["items_file"] = "friends_invite_report";
	
	build_page($p_details);
	
}

?>