<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case 'register':
									do_register();
									break;

								case 'verify':
									do_verify();
									break;

							}//switch

						///////////////////////////////////////

function do_register(){

	auth_join();

	include_once(DOC_ROOT."/functions/form_functions.php");

	$values = form_handle_input("join");

   	if( $GLOBALS["settings"]["min_member_age"] ) {
   		if( !$values["age_certify"] ) {
   			build_error(41,"join");
   		}
   	}

   	if(!validate_email_syntax($values["email"])){
   		build_error(32,"join");
   	}//if

   	if(!validate_join_email($values["email"])){
   		build_error(5,"join");
   	}//if

   	if(!validate_username($values["username"])){
   		build_error(23,"join");
   	}//if

   	if($GLOBALS["settings"]["use_join_code"]){

   		$join_code = $GLOBALS["GetFromForm"]->field("join_code","val");
   		$ip = $_SERVER["REMOTE_ADDR"];

   		if(!form_validate_join_code($join_code,$ip)){
   			build_error(4,"join");
   		}//if

   	}//if

   	$GLOBALS["Member"]->values = $values;
   	$mem_id = $GLOBALS["Member"]->create();

   	if($GLOBALS["settings"]["verification"]){

   		$val = build_verification_key();
   		$sql_query="INSERT INTO verification (val,email,username,password,inv_id)
   					VALUES (':0:',':1:',':2:',':3:',':4:')";

   		$GLOBALS["DB"]->values = array ($val,$values["email"],$values["username"],$values["password"],$values["inv_id"]);
   		$GLOBALS["DB"]->execute($sql_query);

		//building email message
		$mail_details = array (
			"mes_id"    => 0,
			"recipient" => $mem_id,
			"link"      => URL."/index.php?handler=join&action=verify&val=".$val,
			"code"      => $val,
			"password"  => $values["password"]
		);

		$mail_details["login"] = $values["username"];

		include_once(DOC_ROOT."/classes/Mail.class.php");

		$GLOBALS["Mail"]->details = $mail_details;
		$GLOBALS["Mail"]->send_external();
		//email sent

   		build_complete(0);
   		$p_details = array (
   			"page"       => "join",
   			"section"    => "verification",
   			"items_file" => "join_verification"
   		);
   		build_page($p_details);
   		exit;

   	}//if
   	else{

   		$sql_query = "UPDATE members SET verified='1'
   					  WHERE mem_id=".$mem_id;

   		$GLOBALS["DB"]->execute($sql_query);

   		//building email message
		$mail_details = array (
			"mes_id"    => 1,
			"recipient" => $mem_id,
			"password"  => $values["password"]
		);

		$mail_details["login"] = $values["username"];

		include_once(DOC_ROOT."/classes/Mail.class.php");

		$GLOBALS["Mail"]->details = $mail_details;
		$GLOBALS["Mail"]->send_external();
		//email sent

		$sql_query="UPDATE invitations
					SET stat='j'
					WHERE email=':0:'";

		$GLOBALS["DB"]->values = array ($values["email"]);
		$GLOBALS["DB"]->execute($sql_query);

		if(!empty($values["inv_id"])){
			$sql_query="SELECT *
						FROM invitations
						WHERE inv_id=':0:'";

			$GLOBALS["DB"]->values = array ($values["inv_id"]);
			$invitation = $GLOBALS["DB"]->row($sql_query);
			$invitee = $invitation["mem_id"];

			if($invitee){

				$GLOBALS["Network"]->add_friend($mem_id,$invitee);

				$sql_query="UPDATE invitations
							SET stat='f'
							WHERE inv_id=':0:'";

				$GLOBALS["DB"]->values = array ($values["inv_id"]);
				$GLOBALS["DB"]->execute($sql_query);

				//building email message
				$mail_details = array (
					"mes_id"    => 9,
					"recipient" => $invitee,
					"invitee_name"  => $GLOBALS["Member"]->username($mem_id)
				);

				$GLOBALS["Mail"]->details = $mail_details;
				$GLOBALS["Mail"]->send_external();
				//email sent

			}//if

		}//if

   		$GLOBALS["Member"]->login($values["username"],$values["password"]);
   		$link = "index.php?page=join&section=options";
		load_page($link);

   	}//else

}//do_register

function do_verify(){

	$val = $GLOBALS["Get"]->val("val");

	$GLOBALS["DB"]->values = array($val);

	$sql_query="SELECT *
				FROM verification
				WHERE val=':0:'";

	$get = $GLOBALS["DB"]->fetch($sql_query);

	if(empty($get->email)){

		build_error(6,"join","verification");

	}//if

	$sql_query="UPDATE members
				SET verified='1'
				WHERE email='".mysql_escape_string($get->email)."'";

	$GLOBALS["DB"]->execute($sql_query);

	$sql_query="DELETE FROM verification
				WHERE email='".mysql_escape_string($get->email)."'";

	$GLOBALS["DB"]->execute($sql_query);

	$mem_id = $GLOBALS["Member"]->login($get->username,$get->password);

	$sql_query="UPDATE invitations
				SET stat='j'
				WHERE email=':0:'";

	$GLOBALS["DB"]->values = array ($get->email);
	$GLOBALS["DB"]->execute($sql_query);

	if(!empty($get->inv_id)){

		$sql_query="SELECT *
					FROM invitations
					WHERE inv_id=':0:'";

		$GLOBALS["DB"]->values = array ($get->inv_id);
		$invitation = $GLOBALS["DB"]->row($sql_query);
		$invitee = $invitation["mem_id"];

		if($invitee){

			$GLOBALS["Network"]->add_friend($mem_id,$invitee);

			$sql_query="UPDATE invitations
						SET stat='f'
						WHERE inv_id=':0:'";

			$GLOBALS["DB"]->values = array ($get->inv_id);
			$GLOBALS["DB"]->execute($sql_query);

			//building email message
			$mail_details = array (
			"mes_id"    => 9,
			"recipient" => $invitee,
			"invitee_name"  => $GLOBALS["Member"]->username($mem_id)
			);

			include_once(DOC_ROOT."/classes/Mail.class.php");

			$GLOBALS["Mail"]->details = $mail_details;
			$GLOBALS["Mail"]->send_external();
			//email sent

		}//if

	}//if

	$change = $GLOBALS["Get"]->type_val("change","integer");

	if(!$change){

		$link = "index.php?page=join&section=options";

	}//if
	else
		$link = "index.php";

	load_page($link);

}//do_verify

?>