<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////
						
						//load global configuration
						include_once("../includes/config/config.inc.php");

						//load libraries
						include_once(DOC_ROOT."/libraries.php");
							
									//RSS 2.0
									display_rss();
							
						///////////////////////////////////////

function display_rss(){
	
	build_language();
	
	include_once(DOC_ROOT."/classes/Videos.class.php");
	
	$type = $GLOBALS["Get"]->val("type");
	
	switch($type) {
		case 'recent':
			$main_query = "SELECT vid_id FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter()."
						   ORDER BY posted DESC LIMIT 0,15";
			$title = $GLOBALS["language"]["recently_added"];
			break;
		case 'viewed':
			$main_query = "SELECT vid_id FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter()."
						   ORDER BY viewed DESC LIMIT 0,15";
			$title = $GLOBALS["language"]["most_viewed"];
			break;
		case 'discussed':
			$main_query = "SELECT v.vid_id, COUNT(*) AS ord FROM videos AS v LEFT JOIN video_comments AS vc
						   ON v.vid_id = vc.vid_id WHERE 1 ".$GLOBALS["Videos"]->filter("v.")."
						   GROUP BY v.vid_id ORDER BY ord DESC";
			$title = $GLOBALS["language"]["most_discussed"];
			break;
		case 'favorites':
			$main_query = "SELECT v.vid_id, COUNT(*) AS ord FROM videos AS v LEFT JOIN bookmarks AS b
						   ON v.vid_id = b.item_id WHERE 1 ".$GLOBALS["Videos"]->filter("v.")."
						   GROUP BY v.vid_id ORDER BY ord DESC";
			$title = $GLOBALS["language"]["top_favorites"];
			break;
	}
	
	$result = $GLOBALS["DB"]->result( $main_query );
	
	list($width, $height) = getimagesize( DOC_ROOT."/themes/".$GLOBALS["THEME"]."/gfx/logo.gif" );
	
	$rss = '<?xml version="1.0" encoding="utf-8"?>
<rss version="2.0">
	<channel>
		<title>'.htmlspecialchars($GLOBALS["settings"]["site_name"].' - '.$title).'</title>
		<link>'.htmlspecialchars(URL."/modules/rss.php?type=".$type).'</link>
		<image> 
			<url>'.htmlspecialchars(URL."/themes/".$GLOBALS["THEME"]).'/gfx/logo.gif</url>
			<link>'.htmlspecialchars(URL).'</link> 
			<title>'.htmlspecialchars($GLOBALS["settings"]["site_name"]).'</title> 
			<height>'.$height.'</height>
			<width>'.$width.'</width>
		</image>
		<description>'.htmlspecialchars($title).'</description>';
	
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		
		if(!$card["shash"])
			$image = "default";
		else
			$image = $card["shash"];
		
		$rss.= '<item>
			<author>['.htmlspecialchars($card["from"]["username"]).']</author>
			<title>'.htmlspecialchars($card["title"]).'</title>
			<link>'.htmlspecialchars(URL."/index.php?page=videos&section=view&vid_id=".$res["vid_id"]).'</link>
			<description>
				<![CDATA[
				<img src="'.URL.'/scr/'.$image.'.jpg" align="right" border="0" width="120" height="90" vspace="4" hspace="4" />
				<p>
				'.htmlspecialchars(handle_string_cut($card["description"])).'
				</p>
				<p>
					Author: <a href="'.htmlspecialchars($card["from"]["link"]).'">'.htmlspecialchars($card["from"]["username"]).'</a><br/>
					Added: '.htmlspecialchars( $card["posted"] ).'<br/>
				</p>
]]>
			</description>
			<guid isPermaLink="true">'.htmlspecialchars(URL."/index.php?page=videos&section=view&vid_id=".$res["vid_id"]).'</guid>
			<pubDate>'.htmlspecialchars(date("r", $card["posted_orig"])).'</pubDate>
		</item>';
	}
	
	$rss.= "</channel>
</rss>";
	
	$encoding = extract_encoding("html");
  	
  	Header("Content-Type:text/xml; charset=".$encoding);
	print $rss;
	exit;
	
}//display_rss

?>