<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function bookmarking_links( $title ) {

	if (isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && (strtolower($_SERVER['HTTPS']) != 'off')) {
		$https = 's://';
	} else {
		$https = '://';
	}

	if (!empty ($_SERVER['PHP_SELF']) && !empty ($_SERVER['REQUEST_URI'])) {
		$url = 'http' . $https . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
	}
	else {
		$url = 'http' . $https . $_SERVER['HTTP_HOST'] . $_SERVER['SCRIPT_NAME'];
		if (isset($_SERVER['QUERY_STRING']) && !empty($_SERVER['QUERY_STRING'])) {
			$url .= '?' . $_SERVER['QUERY_STRING'];
		}
	}

	$title = clear_title( $title.$GLOBALS["page_details"]["meta"]["title"] );

	$engines = array();

	$sql_query = "SELECT * FROM social_bookmarking_engines WHERE enabled='1' ORDER BY eng_id ASC";
	$result = $GLOBALS["DB"]->result($sql_query);
	foreach($result as $res) {
		$engine = array();
		$engine["name"] = $res["name"];
		if($res["icon"])
			$engine["icon"] = URL."/includes/sbicons/".$res["icon"];
		$engine["url"]  = $res["url"];

		if(preg_match( "/'\|link\|'/", $engine["url"] ))
			$engine["url"]  = preg_replace( "/'\|link\|'/", "'".preg_replace("/'/","\'",$url)."'", $engine["url"] );
		else
			$engine["url"]  = preg_replace( "/\|link\|/", urlencode($url), $engine["url"] );

		if(preg_match( "/'\|title\|'/", $engine["url"] ))
			$engine["url"]  = preg_replace( "/'\|title\|'/", "'".preg_replace("/'/","\'",$title)."'", $engine["url"] );
		else
			$engine["url"]  = preg_replace( "/\|title\|/", urlencode($title), $engine["url"] );

		$engines[] = $engine;
	}

	if(count($engines))
		$GLOBALS["smarty"]->assign("sbengines",$engines);
	else
		return false;

	return true;

}

function clear_title( $title ){
	$rem = ':\*?"<>|';
	$title = preg_replace("/[".preg_quote( $rem, "/" )."]/"," ",$title);
	$title = ereg_replace("[ ]+"," ",$title);
	return $title;
}

?>