<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						$action = $GLOBALS["Get"]->val("action");

							switch($action){
								case 'tagsearch':
									tag_search();
									break;
							}//switch

						///////////////////////////////////////

function tag_search() {

	if($GLOBALS["settings"]["secure_site"])
		$info = auth_member();
	else
		$info = $GLOBALS["Member"]->info();

	$tag = $GLOBALS["Get"]->val("tag");

	include_once(DOC_ROOT."/classes/Videos.class.php");
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$keyword = $tag;
	
	$keyword = preg_replace("/&#124;/", "|", $keyword);
	$keyword = stripslashes( html_entity_decode( $keyword ) );
	
	$keyword = handle_sql_patterns( $keyword );
	$keywords_arr = handle_empties(explode(" ", $keyword));
	$keywords = array();
	foreach($keywords_arr as $key => $val) {
		if(strlen($val) >= 3)
			$keywords[] = $val;
	}
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter();
	
	$query = "";
	$query.= "( tags LIKE '%|".$keyword."|%'";
	foreach($keywords as $k){
		$query.= " OR tags LIKE '%|".$k."|%' ";
	}
	$query.= ")";
	
	$order = " ORDER BY CASE ";	
	$order.= " WHEN ( tags LIKE '%|".$keyword."|%' ) THEN 0 ";
	$order.= " WHEN ( ";
	reset($keywords);
	foreach($keywords as $k){
		$order.= " tags LIKE '%|".$k."|%' OR ";
	}
	$order = rtrim( $order, " OR " );
	$order.= ") THEN 3 ELSE 4 END ";
	
	$sql_query.= " AND (".$query.") ";
	
	$total = $GLOBALS["DB"]->single( $sql_query );
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$link = "index.php?handler=tags&action=tagsearch&tag=".urlencode($keyword);
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT vid_id FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter();
	$sql_query.= " AND (".$query.") ".$order." LIMIT ".$pages["start"].",".$pages["items_per_page"];
	
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("pages", $pages);
	$GLOBALS["smarty"]->assign("type", "videos");
	
	$p_details = array (
		"page"       => "search",
		"section"    => "",
		"items_file" => "search"
	);
	build_page($p_details);

}

function generate_tags() {

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/tags.inc.php");

	if(!$tags["enabled"])
		return false;
		
	if($GLOBALS["page_details"]["page"] != "videos")
		return false;

	$type = "";
	$module = "videos";
	switch($module) {
		default:
		case 'videos':
			$type = $module;
			break;
	}

	$sql_query = "SELECT tags,weight,created FROM tags_cache WHERE `type`='".$type."'";
	$GLOBALS["DB"]->clean();
	$result = $GLOBALS["DB"]->row($sql_query);

	$cache_expire = $result["created"] + 86400*$tags["cache_lifetime"];
	if($cache_expire < time()){
		$result = generate_tags_cache( $type );
	}

	if(!$result["tags"])
		return false;

	$tags_ar = explode( ",", $result["tags"] );
	$weight_ar = explode( ",", $result["weight"] );

	$clouds = array();
	for($i=0;$i<count($tags_ar);$i++){
		$cloud["link"] = "index.php?handler=tags&action=tagsearch&tag=".urlencode( $tags_ar[$i] );
		$cloud["tag"]  = $tags_ar[$i];
		$cloud["size"] = calculate_font_size( $tags["maximum_font"], $tags["minimum_font"], $weight_ar[$i] );
		$clouds[] = $cloud;
	}

	srand((float)microtime() * 1000000);
	shuffle( $clouds );

	$GLOBALS["smarty"]->assign( "clouds", $clouds );
	return true;

}

function calculate_font_size( $max, $min, $weight ) {

	$diff = $max - $min;
	$add  = round( ($diff / 100) * $weight );

	$size = $min + $add;
	if($size > $max)
		$size = $max;
	if($size < $min)
		$size = $min;

	return $size;

}

function generate_tags_cache( $type ) {

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/tags.inc.php");

	$sql_add = "";
	switch($type) {
		default:
		case 'videos':
			include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/videos.inc.php");
			include_once(DOC_ROOT."/classes/Videos.class.php");
			$sql_add = $GLOBALS["Videos"]->filter();
			break;
	}

	$sql_query = "SELECT tags FROM `".$type."` WHERE 1 ". $sql_add ." ORDER BY posted DESC LIMIT 0,".$tags["cache_depth"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$tags_ar = array();

	foreach($result as $res) {
		$entry_tags = explode("|",trim($res["tags"]));
		foreach($entry_tags as $tag){
			if(strlen($tag) >= $tags["minimum_length"])
				$tags_ar[$tag]++;
		}
	}
	
	if(count($tags_ar) < $tags["minimum_amount"]) {
		update_tags_cache( "", "", $type );
		return false;
	}

	arsort($tags_ar);
	$tags_ar = array_slice( $tags_ar, 0, $tags["maximum_amount"] );

	$nums = array_values( $tags_ar );
	$sum = 0;
	foreach($nums as $n) {
		$sum+= $n;
	}

	$tags_cache = "";
	$weight_cache = "";

	foreach($tags_ar as $tag => $num) {
		$tags_cache.= $tag.",";
		$weight_cache.= round( ( $num/$sum) * 100 ).",";
	}

	$tags_cache = rtrim($tags_cache,",");
	$weight_cache = rtrim($weight_cache,",");

	update_tags_cache( $tags_cache, $weight_cache, $type );
	return array("tags" => $tags_cache, "weight" => $weight_cache, "type" => $type );

}

function update_tags_cache( $tags, $weight, $type ) {
	$sql_query = "REPLACE INTO tags_cache (tags,weight,created,type) VALUES (':tags:',':weight:',:time:,':type:')";
	$GLOBALS["DB"]->values = array (
		"tags"   => $tags,
		"weight" => $weight,
		"type"   => $type,
		"time"   => time()
	);
	$GLOBALS["DB"]->execute($sql_query);
}

?>