<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");
						
						switch($action){
							case 'membership':
								getpaid_membership();
								break;
								
							case 'payment_complete':
								finish_payment();
								break;
						}//switch
						
						///////////////////////////////////////
						
function getpaid_membership(){
	
	$info = auth_member();
	
	$today = mktime(0,0,0,date("n"),date("j"),date("Y"));
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("upgrade");
	
	$data = $getpaid["membership"][$values["membership"]];
	
	$sql_query="INSERT INTO payment_gateway (mem_id,psystem,order_name,order_type,order_object_id,amount,currency,recurrent,last_paid,next_payment,period,created,`status`)
				VALUES (:mem_id:,:psystem:,':order_name:','membership',:membership:,':amount:',':currency:',':recurrent:',0,:today:,':period:',:time:,'pending')";
	
	$dbvalues["mem_id"] = $info["mem_id"];
	$dbvalues["order_name"] = $GLOBALS["language"]["Membership Subscription"].": ".$data["name"];
	$dbvalues["amount"] = $data["price"];
	$dbvalues["currency"] = $data["currency"];
	$dbvalues["membership"] = $values["membership"];
	$dbvalues["psystem"] = $values["payment_system"];
	$dbvalues["today"] = $today;
	
	if(!$data["period"]){
		$dbvalues["recurrent"] = 0;
		$dbvalues["period"] = "";
	}//if
	else{
		$dbvalues["recurrent"] = 1;
		$dbvalues["period"] = $data["interval"]." ".$data["period"];		
	}//else
	
	$dbvalues["time"] = time();
	
	$GLOBALS["DB"]->values = $dbvalues;
	$order_id = $GLOBALS["DB"]->insert($sql_query);
	
	$error_link    = URL."/index.php?err_id=104";
	$complete_link = URL."/index.php?cmp_id=100";
	
	$processor_link = $getpaid["systems"][$values["payment_system"]]["payment_processor"]."?order_id=".$order_id."&error=".urlencode($error_link)."&complete=".urlencode($complete_link);
	load_page($processor_link);
	
}//getpaid_membership

function finish_payment(){
	
	include_once(DOC_ROOT."/classes/Mail.class.php");
	
	if(!$now)
		$now = time();
	
	$order_id = $GLOBALS["Get"]->type_val("order_id","integer");
	
	$sql_query = "SELECT * FROM payment_gateway WHERE order_id=".$order_id;
	$order = $GLOBALS["DB"]->row($sql_query);
	
	if($order["status"] != "paid")
		exit;
		
	if(!$order["now"])
		$order["now"] = time();
		
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
		
	switch($order["order_type"]){
		case 'membership':
			if(!$order["recurrent"])
				$values["access_end"] = 0;
			else
				$values["access_end"] = strtotime("+".$order["period"],$order["now"]);

			$values["membership"] = $order["order_object_id"];
			$values["mem_id"] = $order["mem_id"];
			$sql_query = "UPDATE members SET membership=:membership:,
						  access_end=:access_end: WHERE mem_id=:mem_id:";
			$GLOBALS["DB"]->values = $values;
			$GLOBALS["DB"]->execute($sql_query);
			
			if($order["recurrent"]){
				$values["next_payment"] = mktime(0,0,0,date("n",$values["access_end"]),date("j",$values["access_end"]),date("Y",$values["access_end"]));
				$sql_query = "UPDATE payment_gateway SET `now`=0,last_paid=:today:,next_payment=:next_payment:,`status`='pending'
							  WHERE order_id=".$order_id;
				
				$values["today"] = mktime(0,0,0,date("n"),date("j"),date("Y"));
				$GLOBALS["DB"]->values = $values;
				$GLOBALS["DB"]->execute($sql_query);
			}//if
			else{
				$sql_query = "DELETE FROM payment_gateway WHERE order_id=".$order_id;
				$GLOBALS["DB"]->execute($sql_query);
			}//else
			
			if($order["last_paid"] == 0){
				$mes_id = 34;
			}//if
			else{
				$mes_id = 35;
			}//else
				
			//building notification email
			$mail_details = array (		
				"mes_id"    => $mes_id,
				"recipient" => $order["mem_id"]
			);
		
			$GLOBALS["Mail"]->details = $mail_details;
			$GLOBALS["Mail"]->send_external();
			//notification is sent
			
			break;
	}//switch
	
	$sql_query = "INSERT INTO orders(mem_id,psystem,amount,currency,date,name,order_type,order_object_id)
				  VALUES (:mem_id:,':psystem:',':amount:',':currency:',:time:,':name:',':order_type:',:order_object_id:)";
	
	$values["mem_id"]          = $order["mem_id"];
	$values["name"]            = $order["order_name"];
	$values["amount"]          = $order["amount"];
	$values["currency"]        = $order["currency"];
	$values["psystem"]         = extract_psystem($GLOBALS["THEME"],$order["psystem"]);
	$values["order_type"]      = $order["order_type"];
	$values["order_object_id"] = $order["order_object_id"];
	$values["time"]            = time();
	
	$GLOBALS["DB"]->values = $values;
	$GLOBALS["DB"]->execute($sql_query);
	
	$sql_query = "INSERT INTO billing(mem_id,amount,currency,date,name)
				  VALUES (:mem_id:,':amount:',':currency:',:time:,':name:')";
	
	$values["mem_id"]          = $order["mem_id"];
	$values["name"]            = $order["order_name"];
	$values["amount"]          = $order["amount"];
	$values["currency"]        = $order["currency"];
	$values["time"]            = time();
	
	$GLOBALS["DB"]->values = $values;
	$GLOBALS["DB"]->execute($sql_query);
	
	exit;
	
}//finish_payment

function cancel_membership_subscription($mem_id){
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	
	$sql_query = "SELECT psystem FROM payment_gateway WHERE order_type='membership'
				  AND mem_id=".$mem_id." ORDER BY last_paid DESC LIMIT 0,1";
	
	$psystem = $GLOBALS["DB"]->single($sql_query);
	
	$sql_query = "DELETE FROM payment_gateway WHERE order_type='membership'
				  AND mem_id=".$mem_id;
	
	$GLOBALS["DB"]->execute($sql_query);
	
	if($psystem)
		load_page($getpaid["systems"][$psystem]["cancel_processor"]);
	else
		load_page("index.php?cmp_id=102");
	
}//cancel_membership_subscription

?>