<?php

	//load global configuration
	include("../../includes/config/config.inc.php");	
	
	//load libraries
	include(DOC_ROOT."/libraries.php");
	
	//load paypal class
	include("paypal.class.php");
	
	//load paypal email
	include("config.inc.php");
	
	//initiate PayPal class
	$paypal = new paypal_class;
	
	//connecting to DB
	
	//order details
	$order_id = $Get->type_val("order_id","integer");
	$error    = stripslashes(html_entity_decode($Get->val("error")));
	$complete = stripslashes(html_entity_decode($Get->val("complete")));
	
	if(!$order_id)
		die;
	
	$sql_query = "SELECT * FROM payment_gateway
				  WHERE order_id=".$order_id;
	
	$order = $DB->row($sql_query);
	
	//one time payment
	if(!$order["recurrent"]){	
		$paypal->paypal_url = 'https://www.paypal.com/cgi-bin/webscr';
		$paypal->add_field('cmd','_xclick');
		$paypal->add_field('business', $paypal_email);
    	$paypal->add_field('amount', $order["amount"]);
    	$paypal->add_field('item_name', $order["order_name"]);
    	$paypal->add_field('return', $complete);
    	$paypal->add_field('cancel_return', $error);
    	$paypal->add_field('notify_url', URL."/psystems/paypal/paypal_ipn.php");
    	$paypal->add_field('currency_code', $order["currency"]);
    	$paypal->add_field('custom', $order_id);
    	$paypal->submit_paypal_post();
	}//if
	//subscription
	else{
		list($interval,$period) = explode(" ",$order["period"]);
		$period = strtoupper(substr($period,0,1));
		$paypal->paypal_url = 'https://www.paypal.com/cgi-bin/webscr';
		$paypal->add_field('cmd','_xclick-subscriptions');
		$paypal->add_field('bn','PP-SubscriptionsBF');
		$paypal->add_field('src','1');
		$paypal->add_field('sra','1');
		$paypal->add_field('t3',$period);
		$paypal->add_field('p3',$interval);
		$paypal->add_field('business', $paypal_email);
    	$paypal->add_field('a3', $order["amount"]);
    	$paypal->add_field('item_name', $order["order_name"]);
    	$paypal->add_field('return', $complete);
    	$paypal->add_field('cancel_return', $error);
    	$paypal->add_field('notify_url', URL."/psystems/paypal/paypal_ipn.php");
    	$paypal->add_field('currency_code', $order["currency"]);
    	$paypal->add_field('custom', $order_id);
    	$paypal->submit_paypal_post();
	}//else
	
	$DB->disconnect();
	
?>