<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////
							
						admin_validate_section("setup",2);
						$action = $GLOBALS["Get"]->val("action");
								
							switch($action){								
										
								case '':									
									global_settings();
									break;
									
								case 'save':
									update_settings();
									break;
									
								case 'htaccess':
									show_htaccess();
									break;
									
							}//switch
							
						///////////////////////////////////////
						
function global_settings(){
	
	admin_validate();
	
	$data["section"] = "setup";
	$data["subsection"] = 2;
	$data["title_id"] = "16";	
	$data["themes"] = admin_get_themes();	
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
		
	$data["theme"] = $theme;
	
	include(DOC_ROOT."/themes/".$theme."/config/settings.inc.php");
	$data["settings"] = $settings;
	
	$data["settings"]["fields_order"] = explode("/",$settings["date_fields_order"]);
	
	if($settings["mailer"] == "sendmail")
		$data["settings"]["sendmail"] = $settings["mailsetup"];
		
	if($settings["mailer"] == "smtp"){
		$setup = explode("|",$settings["mailsetup"]);
		$smtp["host"] = $setup[0];
		$smtp["port"] = $setup[1];
		$smtp["username"] = $setup[2];
		$smtp["password"] = $setup[3];
		$data["settings"]["smtp"] = $smtp;
	}//if
		
	if(!$data["settings"]["sendmail"])
		$data["settings"]["sendmail"] = "/usr/sbin/sendmail";
		
	$data["javascript"] = <<<HTMLTEXT
<script language="JavaScript">
<!--
	function HS_ShowBlock(BlockID){
		var El = document.getElementById(BlockID);
		if(El)
			El.style.display = "";
	}//HS_ShowBlock
	function HS_HideBlocks(Blocks){
		var IDs = new Array;
		IDs = Blocks.split(",");
		for(var i=0;i<IDs.length;i++){
			var Elem = document.getElementById(IDs[i]);
			Elem.style.display = "none";
		}//for
	}//HS_HideBlocks
//-->
</script>
HTMLTEXT;
	
	$layout[0] = "global_settings";
	
	admin_output($layout,$data);
	
}//global_settings

function update_settings(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(empty($theme))
		$theme = $GLOBALS["THEME"];
		
	$data["theme"] = $theme;
	
	$values["settings"] = $GLOBALS["Get"]->val("settings");
	$date_fields_order = implode("/",$GLOBALS["Get"]->val("fields_order"));
	$values["settings"]["date_fields_order"] = $date_fields_order;
	
	if($values["settings"]["mailer"] == "sendmail"){
		$values["settings"]["mailsetup"] = $GLOBALS["Get"]->val("sendmail");
	}//if
	elseif($values["settings"]["mailer"] == "smtp"){
		$mailsetup = $GLOBALS["Get"]->val("smtp");
		$values["settings"]["mailsetup"] = implode("|",$mailsetup);
	}//elseif
	
	include(DOC_ROOT."/themes/".$theme."/config/settings.inc.php");
	
	$new_settings = "<?php\n\n";	
	$new_settings.= go_through_array("\$settings",$values["settings"]);	
	$new_settings.= "\n?>";
	
	$settings_file = fopen(DOC_ROOT."/themes/".$theme."/config/settings.inc.php","w");
	fwrite($settings_file,$new_settings);
	fclose($settings_file);
	
	load_page("index.php?section=global_settings&theme=".$theme);
	
}//update_settings

function show_htaccess() {

//content
$content = "<IfModule mod_security.c>
# Turn off mod_security filtering.  
SecFilterEngine Off

# The below probably isn't needed,  
# but better safe than sorry.
SecFilterScanPOST Off
</IfModule>
LimitRequestBody 10000000000000
RewriteEngine On
RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
RewriteRule ^group/([^/]+) index.php?g=$1&%{QUERY_STRING} [L]
RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
RewriteRule ^([^/]+) index.php?u=$1&%{QUERY_STRING} [L]";
	
// downloading a file
$filename = ".htaccess";

// fix for IE catching or PHP bug issue
header("Pragma: public");
header("Expires: 0"); // set expiration time
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
// browser must download file from server instead of cache

// force download dialog
header("Content-Type: application/force-download");
header("Content-Type: application/octet-stream");
header("Content-Type: application/download");

// use the Content-Disposition header to supply a recommended filename and
// force the browser to display the save dialog.
header("Content-Disposition: attachment; filename=.htaccess;");

/*
The Content-transfer-encoding header should be binary, since the file will be read
directly from the disk and the raw bytes passed to the downloading computer.
The Content-length header is useful to set for downloads. The browser will be able to
show a progress meter as a file downloads. The content-lenght can be determines by
filesize function returns the size of a file.
*/
header("Content-Transfer-Encoding: binary");
header("Content-Length: ".strlen($content));

print $content;
exit;

	
}

?>