<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////
						
						admin_validate_section("manage",8);
						$action = $GLOBALS["Get"]->val("action");
								
							switch($action){								
										
								case '':
									manage_videos();
									break;
									
								case 'delete':
									delete_videos();
									break;
									
								case 'edit':
									edit_videos();
									break;
									
								case 'save':
									save_videos();
									break;
									
								case 'featured_add':
									featured_add_videos();
									break;
									
								case 'featured_remove':
									featured_remove_videos();
									break;
									
							}//switch
							
						///////////////////////////////////////
						
function manage_videos(){
	
	admin_validate();
	
	include_once(DOC_ROOT."/classes/Videos.class.php");
	
	$data["section"] = "manage";
	$data["subsection"] = 8;
	$data["title_id"] = "55";	
	$p = $GLOBALS["Get"]->val("p");
	
	$sql_query_total  = "SELECT COUNT(*) ";
	$sql_query_result = "SELECT vid_id ";
	
	$sql_query = " FROM videos WHERE converted='1' ";
	
	$valnames = array("search_text","search_for","sort_by","sort_order","category");
	
	$values = $GLOBALS["Get"]->arr($valnames,1);
	
	if(!empty($values["search_text"]) && !empty($values["search_for"])){
		
		switch($values["search_for"]){
			case 'vid_id':
				settype($values["search_text"],"integer");
				$sql_query.= " AND vid_id=".$values["search_text"];
				break;
			case 'title':
				$sql_query.= " AND title LIKE '%".$values["search_text"]."%' ";
				break;
			case 'mem_id':
				settype($values["search_text"],"integer");
				$sql_query.= " AND mem_id=".$values["search_text"];
				break;
		}//switch
		
	}//if
	
	if($values["category"])
		$sql_query.= " AND category = ".$values["category"];
	
	switch($values["sort_by"]){
		case '':
			$sql_query.= " ORDER BY posted DESC ";
			break;
		case 'title':
			$sql_query.= " ORDER BY title ".$values["sort_order"];
			break;
		case 'posted':
			$sql_query.= " ORDER BY posted ".$values["sort_order"];
			break;
		case 'featured':
			$sql_query.= " ORDER BY featured ".$values["sort_order"];
			break;
	}//switch
	
	$data["values"] = $values;
	$data["videos"] = array();
	
	$start = $p*30;
	
	$total = $GLOBALS["DB"]->single($sql_query_total.$sql_query);
	
	$sql_query.= " LIMIT ".$start.",30";
	$results = $GLOBALS["DB"]->result($sql_query_result.$sql_query);
	
	$search_link = "index.php?section=videos";	
	while(list($key,$val) = each($values)){
		$search_link.= "&".$key."=".urlencode(stripslashes(html_entity_decode($val)));
	}//while
	$data["pages"] = handle_multipages($p,$total,$search_link,30);
	
	$data["link"] = $search_link."&p=".$p;
	
	foreach($results as $result){
		
		$card = array();
		$card = $GLOBALS["Videos"]->card( $result["vid_id"] );
			
		$card["id"]              = $result["vid_id"];
		$card["edit"]            = "index.php?section=videos&action=edit&vid_id=".$result["vid_id"]."&ret_link=".urlencode($data["link"]);
		$card["delete"]          = "index.php?section=videos&action=delete&vid_id=".$result["vid_id"]."&ret_link=".urlencode($data["link"]);
		$card["featured_add"]    = "index.php?section=videos&action=featured_add&vid_id=".$result["vid_id"]."&ret_link=".urlencode($data["link"]);
		$card["featured_remove"] = "index.php?section=videos&action=featured_remove&vid_id=".$result["vid_id"]."&ret_link=".urlencode($data["link"]);
		
		$data["videos"][] = $card;
	}//foreach
	
	$layout[0] = "videos_list";
	
	admin_output($layout,$data);
	
}//manage_videos

function edit_videos(){
	
	admin_validate();
	
	include_once(DOC_ROOT."/classes/Videos.class.php");
	
	$data["section"] = "manage";
	$data["subsection"] = 8;
	$data["title_id"] = "55";
	
	$ret_link = $GLOBALS["Get"]->val("ret_link");
	$ret_link = stripslashes(html_entity_decode($ret_link));
	$data["link"] = $ret_link;
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$data["vid_id"] = $vid_id;
	
	build_form("video_edit",$vid_id);
	
	$layout[0] = "edit_video";
	
	$data["thumbnails"] = edit_video_screenshots( $vid_id );

	admin_output($layout,$data);
	
}//edit_videos

function edit_video_screenshots( $vid_id ) {
	
	$data = $GLOBALS["Videos"]->info( $vid_id );
	$data["thumbs"] = array();
	
	if($data["source"] != "embed") {
	
		for($i = 1; $i <= $GLOBALS["Videos"]->screenshots; $i++) {
			if( file_exists( DOC_ROOT."/scr/".$data["shash"]."_".$i.".jpg" ) ) {
				$data["thumbs"][$i] = $data["shash"]."_".$i;
			}
		}
		
	} else {
		
		include_once( DOC_ROOT."/modules/grabber/".$data["service"].".php" );
		$data["thumbs"] = g_thumbnails( $data["vhash"] );
		$GLOBALS["smarty"]->assign("source","embed");
		
	}
	
	return $data;
	
}

function save_videos(){
	
	admin_validate();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("video_edit",1,1);
	
	if(!extract_null_value($values["err_id"])){
		$GLOBALS["uerr_id"] = $values["err_id"];
		edit_videos();
		exit;
	}//if
	
	$values["vid_id"] = $GLOBALS["Get"]->type_val("vid_id","integer");
	$tags = explode(" ", $values["tags"]);
	$tags = handle_empties( $tags );
	$values["tags"] = "|".implode("|", $tags)."|";
	
	load_db_update( "video_edit", $values, array("vid_id", $values["vid_id"]) );
	
	$ret_link = $GLOBALS["Get"]->val("ret_link");
	load_page("index.php?section=videos&action=edit&vid_id=".$values["vid_id"]."&ret_link=".urlencode(html_entity_decode(stripslashes($ret_link))));
	
}//save_videos

function delete_videos(){
	
	admin_validate();
	
	$vid_id = $GLOBALS["Get"]->val("vid_id");
	
	include_once(DOC_ROOT."/functions/delete_functions.php");
	
	if(is_array($vid_id) && count($vid_id) > 0){
		foreach($vid_id as $id){
			delete_video($id);
		}//foreach
	}//if
	elseif(!empty($vid_id))
		delete_video($vid_id);
		
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));		
	load_page($ret_link);
	
}//delete_videos

function featured_add_videos(){
	
	admin_validate();
	
	$vid_id = $GLOBALS["Get"]->val("vid_id");
	
	$sql_query = "UPDATE videos SET featured='1' WHERE vid_id=".$vid_id;
	$GLOBALS["DB"]->execute($sql_query);
	
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);
	
}//featured_add_videos

function featured_remove_videos(){
	
	admin_validate();
	
	$vid_id = $GLOBALS["Get"]->val("vid_id");
	
	$sql_query = "UPDATE videos SET featured='0' WHERE vid_id=".$vid_id;
	$GLOBALS["DB"]->execute($sql_query);
	
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);
	
}//featured_remove_videos
						
?>