<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

class Groups extends DB {
	
	function Groups(){
		
		$this->values = array();	
		
	}//Groups
	
	function create($values){
		
		$sql_query = "INSERT INTO groups (mem_id,name,description,category,tags,privacy,videos,forum,icon,created,updated,folder)
					  VALUES (:mem_id:,':name:',':description:',:category:,':tags:',:privacy:,:videos:,:forum:,:icon:,:time:,:time:,':folder:')";
				
		$GLOBALS["DB"]->values = $values;
		$grp_id = $GLOBALS["DB"]->insert($sql_query);

		$sql_query = "INSERT INTO group_members (mem_id,grp_id)
					  VALUES (:mem_id:,:grp_id:)";

		$values["grp_id"] = $grp_id;
		$GLOBALS["DB"]->values = $values;
		$GLOBALS["DB"]->execute($sql_query);
		
		return $grp_id;
		
	}//create
	
	function categories(){
		
		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/group_categories.inc.php");
		return $categories;
		
	}//categories
	
	function category($category){
		
		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/group_categories.inc.php");
		return $categories[$category];
		
	}//category
	
	function verify_folder($folder,$grp_id=0){
		
		if($grp_id){
			$sql_query = "SELECT folder FROM groups
						  WHERE grp_id=".$grp_id;
		
			$ex_folder = $this->single($sql_query);
		}//if
		else{
			$ex_folder = "";
		}//else
		
		$exists = 0;
		
		if($ex_folder != $folder){
			$sql_query = "SELECT COUNT(*) FROM groups WHERE folder='".$folder."'
						  AND grp_id!=".$grp_id;
			$exists = $this->single($sql_query);
		}//if
		
		return $exists;
		
	}//verify_folder
	
	function privacy( $grp_id ) {
		$sql_query = "SELECT privacy FROM groups WHERE grp_id=".$grp_id;
		return $this->single( $sql_query );
	}
	
	function icon( $grp_id ) {
		
		include_once(DOC_ROOT."/classes/Videos.class.php");
		
		$info = $this->info( $grp_id );
		$icon = "";
		if($info["icon"] == 0){
			$sql_query = "SELECT vid_id FROM group_videos WHERE grp_id = ".$grp_id." ORDER BY added DESC LIMIT 0,1";
			$vid_id = $this->single( $sql_query );
			if($vid_id){
				$icon = $GLOBALS["Videos"]->screenshot( $vid_id );
			}
		} elseif( $info["icon"] > 1 ) {
			$icon = $GLOBALS["Videos"]->screenshot( $info["icon"] );
		}
		return $icon;
		
	}
	
	function name($grp_id){
		$sql_query = "SELECT name FROM groups
					  WHERE grp_id=".$grp_id;
		
		$this->clean();
		$name = $this->single($sql_query);
		return $name;
	}//name
	
	function members($grp_id){
		
		$members = array();
		
		$sql_query = "SELECT mem_id FROM group_members
					  WHERE grp_id=".$grp_id;
		
		$this->clean();
		$result = $this->result($sql_query);
		
		foreach($result as $res){
			$members[] = $res["mem_id"];
		}//foreach
		
		return $members;
		
	}//members
	
	function member_groups($mem_id,$name = 1){
		
		$groups = array();
		
		$sql_query = "SELECT grp_id
					  FROM group_members
					  WHERE mem_id=".$mem_id;
		
		$this->clean();
		$result = $this->result($sql_query);
		
		foreach($result as $res){
			if($name)
				$groups[$res["grp_id"]] = $this->name($res["grp_id"]);
			else
				$groups[] = $res["grp_id"];
		}//foreach
		
		return $groups;
		
	}//member_groups
	
	function members_amount($grp_id){
		
		$sql_query = "SELECT count(mem_id) FROM group_members
					  WHERE grp_id=".$grp_id;
		
		$this->clean();
		$total = $this->single($sql_query);
		return $total;
		
	}//members_amount
	
	function is_member($mem_id,$grp_id){
		
		$members = $this->members($grp_id);
		if(in_array($mem_id,$members))
			return true;
		else
			return false;
		
	}//is_member
	
	function is_owner($mem_id,$grp_id){
		
		$sql_query = "SELECT count(mem_id) FROM groups
					  WHERE mem_id=".$mem_id." AND grp_id=".$grp_id;
		
		$this->clean();
		$owner = $this->single($sql_query);
		return $owner;
		
	}//is_owner
	
	function assign_member($mem_id,$grp_id){
		
		if(!$this->is_member($mem_id,$grp_id) && $mem_id && $grp_id){
			$sql_query = "INSERT INTO group_members
						  (mem_id,grp_id)
						  VALUES (".$mem_id.",".$grp_id.")";
			
			$this->clean();
			$this->execute($sql_query);
		}//if
		
	}//assign_member
	
	function remove_member($mem_id,$grp_id){
		if($this->is_member($mem_id,$grp_id)){			
			$sql_query = "DELETE FROM group_members
						  WHERE mem_id=".$mem_id."
						  AND grp_id=".$grp_id;
			
			$this->clean();
			$this->execute($sql_query);
		}//if
		
	}//remove_member
	
	function join($mem_id,$per_id,$grp_id){
		
		if($this->is_owner($per_id,$grp_id)){
			$this->assign_member($mem_id,$grp_id);
			$status = "complete";
		}//if
		elseif(!$this->is_member($mem_id,$grp_id)){
			
			$group_type = $this->privacy($grp_id);
			
			switch($group_type){
				case '1':
					$this->assign_member($mem_id,$grp_id);
					$status = "complete";
					break;
				case '2':
					$status = "request";
					break;
				case '3':
					$status = "error";
					break;
			}//switch			
			
		}//elseif
		else
			$status = "member";
		
		return $status;
		
	}//join
	
	function owner($grp_id){
		$sql_query = "SELECT mem_id FROM groups
					  WHERE grp_id=".$grp_id;
		
		$this->clean();
		$owner = $this->single($sql_query);
		
		return $owner;
	}//owner
	
	function info( $grp_id ){ 
		
		static $cache = array();
		
		if(isset($cache[$grp_id]))
			return $cache[$grp_id];
			
		$sql_query = "SELECT * FROM groups WHERE grp_id=".$grp_id;
		$info = $this->row( $sql_query );
		
		$cache[$grp_id] = $info;
		
		return $info;
		
	}
	
	function card($grp_id){
		
		$info = $GLOBALS["Member"]->info();
	
		$sql_query = "SELECT * FROM groups
					  WHERE grp_id=".$grp_id;
	
		$group = $this->row($sql_query);
	
		$card["grp_id"]        = $grp_id;
		$card["owner"]         = $GLOBALS["Member"]->card($group["mem_id"]);
		$card["category"]	   = $this->category($group["category"]);
		$card["category_id"]   = $group["category"];
		$card["name"]          = $group["name"];
		$card["name_cut_30"]   = handle_string_cut( $group["name"], 30 );
		$card["description"]   = nl2br( handle_string_cut( $group["description"] ) );
		$card["link"]          = build_group_link( $group["folder"] );
		$card["icon"]          = $this->icon( $grp_id );
		$card["is_member"]     = $this->is_member($info["mem_id"],$grp_id);
		$card["is_owner"]      = $this->is_owner( $info["mem_id"], $grp_id );
		$card["videos"]        = $this->videos( $grp_id );
		$card["members"]       = $this->members_amount( $grp_id );
		$card["discussions"]   = $this->discussions( $grp_id );
		$card["tags"]          = extract_tags( $group["tags"] );
		$card["videos"]        = $group["videos"];
		$card["videos_amount"] = $this->videos( $grp_id );
		$card["forum"]         = $group["forum"];
		$card["created"]       = extract_date( $group["created"] );

		return $card;
		
	}//card
	
	function videos( $grp_id ) {
		$sql_query = "SELECT COUNT(*) FROM group_videos AS gv,videos AS v
					  WHERE gv.vid_id = v.vid_id AND gv.grp_id=".$grp_id.$GLOBALS["Videos"]->filter("v.")."
					  AND gv.approved='1'";
		return $this->single( $sql_query );
	}
	
	function discussions( $grp_id ) {
		$sql_query = "SELECT COUNT(*) FROM group_forum WHERE reply_to=0
					  AND grp_id=".$grp_id;
		return $this->single( $sql_query );
	}
	
	function filter( $table="" ){
		
		$filter = " AND ".$table."privacy < '3' ";		
		return $filter;
		
	}//filter
	
}//Groups Class

$GLOBALS["Groups"] = new Groups;

?>