<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/
						
function converter_data( $file, $info ) {
		
	exec($GLOBALS["paths"]["mplayer"]." -vo null -ao null -frames 0 -identify ".$file, $out);
	
	$types = array (
		"width"    => "ID_VIDEO_WIDTH=",
		"height"   => "ID_VIDEO_HEIGHT=",
		"duration" => "ID_LENGTH=",
	);
	
	while(list($k,$v)=each($out)){
		if($data = strstr($v,$types[$info]))
		break;
	}
	
	$d = explode( "=", $data );
	return $d[1];
	
}

function converter_convert( $in, $out, $ext ) {
	
	$original_width = converter_data( $in, "width" );
	$original_height = converter_data( $in, "height" );
	
	if( $original_width <= $GLOBALS["Videos"]->width && $original_height <= $GLOBALS["Videos"]->height && $ext == ".flv" ) {
		if( $in != $out )
			copy( $in, $out );
		exec($GLOBALS["paths"]["flvtool2"]." -Uv ".$out." ".$out.".tmp");
		rename( $out.".tmp", $out );
		return true;
	}
	
	//if( $ext == ".wmv" )
	//	return converter_ffmpeg_convert( $in, $out, $ext );
	//else
		return converter_mencoder_convert( $in, $out, $ext );
	
}

function converter_mencoder_convert( $in, $out, $ext ) {
	
	$original_width  = converter_data( $in, "width" );
	$original_height = converter_data( $in, "height" );
	
	$scale = "";
	if( $original_width > $original_height ) {
		if( $original_width > $GLOBALS["Videos"]->width ) {
			$scale = " -vf scale -zoom -xy ".$GLOBALS["Videos"]->width;
		}
	} else {
		if( $original_height > $GLOBALS["Videos"]->height ) {
			$ratio = $GLOBALS["Videos"]->height / $original_height;
			$new_width = round( $original_width * $ratio );
			$scale = " -vf scale -zoom -xy ".$new_width;
		}
	}
		
	if($ext == ".flv" && !$scale) {
		copy( $in, $out );
		return true;
	}
	
	$ofps = ( preg_match("/\.wmv$/", $in )) ? " -ofps 25000/1001" : "";;
	$mencoder_version = '1.0rc2';
    exec($GLOBALS["paths"]["mencoder"], $mencoder_check);
    if ( isset($mencoder_check['0']) ) {
        if ( strstr($mencoder_check['0'], 'MEncoder 1.0rc1') ) {
            $mencoder_version = '1.0rc1';
        }
    }
    $lavfopts = ( $mencoder_version == '1.0rc1' ) ? ' -lavfopts i_certify_that_my_video_stream_does_not_use_b_frames' : "";
	exec($GLOBALS["paths"]["mencoder"]." ".$in.$ofps." -o ".$out." -of lavf -oac mp3lame -lameopts abr:br=".$GLOBALS["Videos"]->abitrate." -ovc lavc -lavcopts vcodec=flv:keyint=12:vbitrate=".$GLOBALS["Videos"]->vbitrate.":mbd=2:mv0:trell:v4mv:cbp:last_pred=3".$lavfopts." -srate 22050".$scale);
	exec($GLOBALS["paths"]["flvtool2"]." -Uv ".$out." ".$out.".tmp");
	rename( $out.".tmp", $out );
	
	return file_exists( $out );
	
}

function converter_ffmpeg_convert( $in, $out, $ext ) {
	
	$original_width  = converter_data( $in, "width" );
	$original_height = converter_data( $in, "height" );
	
	$scale = "";
	if( $original_width > $original_height ) {
		if( $original_width > $GLOBALS["Videos"]->width ) {
			$ratio = $GLOBALS["Videos"]->width / $original_width;
			$new_height = round( $original_height * $ratio );
			$scale = " -s ".$GLOBALS["Videos"]->width."x".$new_height;
		}
	} else {
		if( $original_height > $GLOBALS["Videos"]->height ) {
			$ratio = $GLOBALS["Videos"]->height / $original_height;
			$new_width = round( $original_width * $ratio );
			$scale = " -s ".$new_width."x".$GLOBALS["Videos"]->height;
		}
	}
		
	if($ext == ".flv" && !$scale) {
		copy( $in, $out );
		return true;
	}
		
	exec($GLOBALS["paths"]["ffmpeg"]." -y -i ".$in." -b ".$GLOBALS["Videos"]->vbitrate."k -ab ".$GLOBALS["Videos"]->abitrate."k -ar 22050 ".$out.$scale);
	exec($GLOBALS["paths"]["flvtool2"]." -Uv ".$out." ".$out.".tmp");
	rename( $out.".tmp", $out );
	
	return file_exists( $out );
	
}

function converter_screenshot( $file, $time, $tmpdir ) {
	
	$cmd = $GLOBALS["paths"]["ffmpeg"]." -y -i ".$file." -f mjpeg -r 1 -ss ".$time." -vframes 1 -an ".$tmpdir."/00000001.jpg";
	exec($cmd);
				
	$file = $tmpdir."/00000001.jpg";
		
	return $file;
	
}

?>