<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function delete_member($mem_id){
	
	$sql_query = "SELECT * FROM members WHERE mem_id=".$mem_id;
	$member    = $GLOBALS["DB"]->row( $sql_query );
	
	if($member["member_type"] == "a") 
		return false;

	set_time_limit(0);
	
	//avatar
	delete_avatar( $mem_id );
	
	$tables = array (
		"reports" => "mem_id",
		"billing" => "mem_id",
		"bookmarks" => "mem_id",
		"group_forum" => "mem_id",
		"group_members" => "mem_id",
		"ignores" => "mem_id",
		"ignores" => "per_id",
		"mailbox" => "mem_id",
		"mailbox" => "per_id",
		"invitations" => "mem_id",
		"channels" => "mem_id",
		"channel_comments" => "mem_id",
		"channel_comments" => "from",
		"members" => "mem_id",
		"members_settings" => "mem_id",
		"moderators" => "mem_id",
		"orders" => "mem_id",
		"payment_gateway" => "mem_id",
		"profiles" => "mem_id",
		"sessiondata" => "mem_id",
		"private_access" => "mem_id",
		"video_comments" => "mem_id",
		"video_votes" => "mem_id",
		"video_comment_votes" => "mem_id",
		"video_watch" => "mem_id",
		"subscriptions" => "mem_id",
		"bulletins" => "from",
		"activity" => "mem_id"
	);
	
	foreach($tables as $table => $id) {
		$sql_query = "DELETE FROM `".$table."` WHERE `".$id."` = ".$mem_id;
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
	//groups
	$sql_query = "SELECT grp_id FROM groups WHERE mem_id=".$mem_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		delete_group( $res["grp_id"] );
	}
	
	//videos
	$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$mem_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		delete_video( $res["vid_id"] );
	}
	
	//playlists
	$sql_query = "SELECT pla_id FROM playlists WHERE mem_id=".$mem_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		delete_playlist( $res["pla_id"] );
	}
	
	//subscriptions
	$sql_query = "DELETE FROM subscriptions WHERE type='channel' AND sub_id=".$mem_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	//network
	$GLOBALS["Network"]->system_remove( $mem_id );
	$sql_query = "DELETE FROM network WHERE mem_id=".$mem_id;
	$GLOBALS["DB"]->execute( $sql_query );	

	$vals["username"] = $member["username"];
	load_3rdparty("delete",$vals);

}//delete_member

function delete_group( $grp_id ) {
	
	$sql_query = "DELETE FROM groups WHERE grp_id=".$grp_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$sql_query = "DELETE FROM group_forum WHERE grp_id=".$grp_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$sql_query = "DELETE FROM group_videos WHERE grp_id=".$grp_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$sql_query = "DELETE FROM group_members WHERE grp_id=".$grp_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

function delete_video($vid_id){

	$sql_query = "SELECT * FROM videos WHERE vid_id=".$vid_id;
	$video = $GLOBALS["DB"]->row($sql_query);
	
	if($video["converted"]) {
		$disk_space = $GLOBALS["Member"]->current_diskspace_usage( $video["mem_id"] );
		$filesize = @filesize( DOC_ROOT."/vid/".$video["vhash"].".flv" );
		if(is_numeric($filesize) && $disk_space > $filesize) {
			$sql_query = "UPDATE members SET diskspace = diskspace - ".$filesize."
						  WHERE mem_id=".$video["mem_id"];
			$GLOBALS["DB"]->execute( $sql_query );
		}
	}
	
	for($i = 1; $i <= $GLOBALS["Videos"]->screenshots; $i++) {
		$file = DOC_ROOT."/scr/".$video["shash"]."_".$i.".jpg";
		if( file_exists( $file ) ) {
			@unlink( $file );
		}
	}
	
	$tables = array (
		"videos" => "vid_id",
		"video_comments" => "vid_id",
		"video_convert" => "vid_id",
		"group_videos" => "vid_id",
		"video_responses" => "vid_id",
		"video_responses" => "response_to",
		"video_votes" => "vid_id",
		"video_watch" => "vid_id",
		"playlist_videos" => "vid_id",
		"bookmarks" => "item_id",
		"activity" => "vid_id"
	);	

	foreach($tables as $table => $id) {
		$sql_query = "DELETE FROM `".$table."` WHERE `".$id."` = ".$vid_id;
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
}//delete_video

function delete_playlist( $pla_id ) {
	
	$sql_query = "DELETE FROM playlists WHERE pla_id=".$pla_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$sql_query = "DELETE FROM playlist_videos WHERE pla_id=".$pla_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$sql_query = "DELETE FROM subscriptions WHERE type='playlist' AND sub_id=".$pla_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

function delete_avatar( $mem_id ) { 
	
	$sql_query = "SELECT avatar FROM profiles WHERE mem_id=".$mem_id;
	$avatar = $GLOBALS["DB"]->single( $sql_query );
	
	if($avatar && file_exists( DOC_ROOT."/avt/".$avatar )) {
		@unlink( DOC_ROOT."/avt/".$avatar );
	}
	
	$sql_query = "UPDATE profiles SET avatar='' WHERE mem_id=".$mem_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

function delete_video_comment( $com_id ) {
	
	$sql_query = "DELETE FROM video_comments WHERE com_id=".$com_id." OR reply_to=".$com_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

function delete_channel_comment( $com_id ) {
	
	$sql_query = "DELETE FROM channel_comments WHERE com_id=".$com_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

function delete_group_post( $pst_id ) {
	
	$sql_query = "DELETE FROM group_forum WHERE pst_id=".$pst_id." OR reply_to=".$pst_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

?>