<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function form_get_from_db($form_name,$associates,$id,$id_val=0,$replace_existing=0){

	$result = array ();

	$info = $GLOBALS["Member"]->info();

	if($id == 'mem_id'){
		if(!$id_val)
			$id_val = $info["mem_id"];
	}//if
	else{
		$id_val = $GLOBALS["Get"]->type_val($id,"integer");
	}//else

	while(list($table,$fields) = each ($associates)){

		$sql_query="SELECT ".$fields."
					FROM ".$table." WHERE ".$id."=".$id_val;

		$row = array();
		$row = $GLOBALS["DB"]->row($sql_query);
		if(is_array($row))
		$result = array_merge($result,$row);

	}//while

	while(list($key,$val) = each($result)){
		if(!isset($GLOBALS["forms"][$form_name]["values"][$key]) || $replace_existing)
		$GLOBALS["forms"][$form_name]["values"][$key] = $val;
	}//while

	$GLOBALS["forms"][$form_name]["values"][$id] = $id_val;

}//form_get_from_db

function form_get_hidden($form_name){

	global $forms;

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/forms/".$form_name.".inc.php");

	foreach($form["hidden"] as $hid){

		if(extract_null_value($forms[$form_name][values][$hid])){
			$values[$hid] = $GLOBALS["Get"]->val($hid);
			$forms[$form_name][values][$hid] = $values[$hid];
		}//if

	}//foreach

	if(empty($forms[$form_name][values]["ret_link"]))
		$forms[$form_name][values]["ret_link"] = $GLOBALS["Get"]->referer();

}//form_get_hidden

function form_handle_input($form_name,$check_rules=1,$admin=0){

	global $forms;

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/forms/".$form_name.".inc.php");

	foreach($form["hidden"] as $hid){

		$value = $GLOBALS["Get"]->val($hid);
		if($GLOBALS["settings"]["badwords_handling"] > 0){
			if(!is_array( $value )) {
			$badword = form_check_badword($value);
			if($badword["status"] == 1 && $GLOBALS["settings"]["badwords_handling"] == 1)
				$error = 28;
			else
				$value = $badword["value"];
			}
		}//if
		$values[$hid] = $value;
		$forms[$form_name]["values"][$hid] = $values[$hid];

	}//foreach

	while(list($i,) = each($form["names"])){

		$name  = $form["names"][$i];
		$type  = $form["types"][$i];
		$value = $GLOBALS["GetFromForm"]->field($name,$type);
		if(!is_null($value)){
			if($type == "val" || $type == "alnum" || $type == "set" || $type == "html"){
				if($GLOBALS["settings"]["badwords_handling"] > 0){
					if(!is_array( $value )) {
					$badword = form_check_badword($value);
					if($badword["status"] == 1 && $GLOBALS["settings"]["badwords_handling"] == 1)
						$error = 28;
					else
						$value = $badword["value"];
					}
				}//if
			}//if
			$values[$name] = $value;
			$forms[$form_name]["values"][$name] = $values[$name];
		}//if

	}//while

	if($error)
		build_error($error,$form["err_page"],$form["err_section"]);

	if($check_rules){
		$result = form_validate_rules($form_name,$values,$form["rules"]);
		if(!$result["status"] && !$admin)
			build_error($result["err_id"],$form["err_page"],$form["err_section"]);
		elseif(!$result["status"] && $admin)
			return $result;
	}//if

	$values["err_page"]    = $form["err_page"];
	$values["err_section"] = $form["err_section"];

	return $values;

}//form_handle_input

function form_validate_rules($form_name,$values,$rules){

	$ret["status"] = true;

	foreach($rules as $rule_code){

		list($rule,$items,$err_id) = explode("|",$rule_code);

		switch($rule){

			case '1':
				if($ret["status"]){

				$fields = explode(",",$items);
				$origin = $values[$fields[0]];
				foreach($fields as $field){
					if($values[$field] != $origin){
						$ret["status"] = false;
						$ret["err_id"] = $err_id;
						break;
					}//if
				}//foreach

				}//if
				break;

			case '2':
				if($ret["status"]){

				$fields = explode(",",$items);

				foreach($fields as $field){

					if(extract_null_value($values[$field])){

						$ret["status"] = false;
						$ret["err_id"] = $err_id;
						break;

					}//if
				}//foreach

				}//if
				break;

			case '3':
				if($ret["status"]){

				$field = $items;
				$info = $GLOBALS["Member"]->info();

				$parts = explode("|",$info["password"]);
				$pwd  = $parts[0];
				$salt = $parts[1];
				$type = $parts[2];

				if($salt){
					if($type == "vb")
						$password = md5($values[$field].$salt);
					elseif($type == "ipb")
						$password = md5(md5($salt).$values[$field]);
				}//if
				else
					$password = $values[$field];

				if($password != $pwd){
					$ret["status"] = false;
					$ret["err_id"] = $err_id;
				}//if
				}//if
				break;

			case '4':
				if($ret["status"]){

				$fields = explode(",",$items);

				foreach($fields as $field){
					if(!extract_null_value($values[$field])){

						$ret["status"] = true;
						break;

					}//if
					else{

						$ret["status"] = false;
						$ret["err_id"] = $err_id;

					}//else
				}//foreach

				}//if
				break;

			case '5':
				if($ret["status"]){
					$info = $GLOBALS["Member"]->info();
					$field = $items;
					$sql_query = "SELECT COUNT(*) FROM members
								  WHERE email=':0:' AND mem_id!=:1:";
					$GLOBALS["DB"]->values = array($values[$field],$info["mem_id"]);
					$exists = $GLOBALS["DB"]->single($sql_query);
					$ret["status"] = abs($exists-1);
					$ret["err_id"] = $err_id;
				}//if
				break;

			case '6':
				if($ret["status"]){
					include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/profiles.inc.php");
					$info = $GLOBALS["Member"]->info();
					$field = $items;
					$exists = 0;
					if($info["folder"] != $values[$field]){
						$sql_query = "SELECT COUNT(*) FROM profiles WHERE folder='".$values[$field]."'
									  AND mem_id!=".$info["mem_id"];
						$exists = $GLOBALS["DB"]->single($sql_query);
						if(file_exists($profiles["path"]."/".$values[$field]) && is_dir($profiles["path"]."/".$values[$field]))
							$exists = 1;

						if(is_numeric($values[$field]) && $values[$field] >= 100000)
							$exists = 1;

					}//if

					$ret["status"] = abs($exists-1);
					$ret["err_id"] = $err_id;
				}//if
				break;

			case '7':
				if($ret["status"]){
					$fields = explode(",",$items);
					if(!extract_null_value($values[$fields[0]])){
						for($i=1;$i<count($fields);$i++){
							if(extract_null_value($values[$fields[$i]])){
								$ret["status"] = false;
								$ret["err_id"] = $err_id;
								break;
							}//if
						}//for
					}//if
				}//if

		}//switch

	}//foreach
	return $ret;

}//form_validate_rules

function form_validate_join_code($code,$ip){

    $sql_query="SELECT try
    			FROM code
    			WHERE ip=':0:'";

    $GLOBALS["DB"]->values = array($ip);

    $try = $GLOBALS["DB"]->single($sql_query);

    if($try == 10){

    	$ret = false;

    }//if
    else{

    	$sql_query="SELECT COUNT(*)
    				FROM code
    				WHERE code=':0:'";

    	$GLOBALS["DB"]->values = array($code,$ip);
    	$exist = $GLOBALS["DB"]->single($sql_query);

    	$ret = ($exist == 0) ? false : true;

    	if($ret){
    		$sql_query = "DELETE FROM code WHERE code=':0:' OR ip=':1:'";
    		$GLOBALS["DB"]->values = array($code,$ip);
    		$GLOBALS["DB"]->execute($sql_query);
    	}//if

    }//else

    return $ret;

}//form_validate_join_code

function form_check_badword($input){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/badwords.inc.php");

	$original = $input;

	while(list(,$word) = each($badwords)){
		/*$pattern = "(^|[^A-Za-z]{1,})";
		$chars   = handle_empties(preg_split("//",$word));
		foreach($chars as $chr){
			$pattern.= preg_quote($chr,"/")."[^A-Za-z]{0,}";
		}//foreach
		$pattern = rtrim($pattern,"[^A-Za-z]{0,}");
		$pattern.= "($|[^A-Za-z]{1,})";*/
		$pattern = "(^|[^\!|\%|\(|\)|-|\}|\{|\]|\[|\?|,|\.|\n| ])". $word ."($|[^\!|\%|\(|\)|-|\}|\{|\]|\[|\?|,|\.|\n| ])";
		if($GLOBALS["settings"]["badwords_handling"] == 2)
			$replace = $chars[0]."***";
		else
			$replace = "";

		$input = hs_ereg_replace($pattern,"\\1".$replace."\\2",$input);
	}//while

	if($original != $input)
		$status = 1;
	else
		$status = 0;

	return array("status" => $status, "value" => $input);

}//form_check_badword

?>