<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

function hs_mail($var1,$var2,$var3 = null,$var4 = null,$var5 = null){
	
	if(!$var5)
		return @mail($var1,$var2,$var3,$var4);
	else
		return @mail($var1,$var2,$var3,$var4,$var5);
	
}//hs_mail

function hs_mail_header($var,$encoding){
	
	$var = "=?".$encoding."?B?".base64_encode($var)."?=";
	return $var;
	
}//hs_mail_header

function hs_strlen($var){
	
	if(function_exists("mb_strlen"))
		return mb_strlen($var,extract_encoding("html"));
	else
		return strlen($var);
	
}//hs_strlen

function hs_strpos($var1,$var2,$var3 = null){
	
	if(function_exists("mb_strpos"))
		return mb_strpos($var1,$var2,$var3,extract_encoding("html"));
	else
		return strpos($var1,$var2,$var3);
	
}//hs_strpos

function hs_strrpos($var1,$var2){
	
	if(function_exists("mb_strrpos"))
		return mb_strrpos($var1,$var2,extract_encoding("html"));
	else
		return strrpos($var1,$var2);
	
}//hs_strrpos

function hs_substr($var1,$var2,$var3 = null){
	
	if(function_exists("mb_substr"))
		return mb_substr($var1,$var2,$var3,extract_encoding("html"));
	else
		return substr($var1,$var2,$var3);
	
}//hs_substr

function hs_strtolower($var){
	
	if(function_exists("mb_strtolower"))
		return mb_strtolower($var,extract_encoding("html"));
	else
		return strtolower($var);
	
}//hs_strtolower

function hs_strtoupper($var){
	
	if(function_exists("mb_strtoupper"))
		return mb_strtoupper($var,extract_encoding("html"));
	else
		return strtoupper($var);
	
}//hs_strtoupper

function hs_substr_count($var1,$var2){
	
	if(function_exists("mb_substr_count"))
		return mb_substr_count($var1,$var2,extract_encoding("html"));
	else
		return substr_count($var1,$var2);
	
}//hs_substr_count

function hs_ereg($var1,$var2,$var3 = null){
	
	if(function_exists("mb_ereg"))
		return mb_ereg($var1,$var2,$var3);
	else
		return ereg($var1,$var2,$var3);
	
}//hs_ereg

function hs_ereg_replace($var1,$var2,$var3){
	
	if(function_exists("mb_ereg_replace"))
		return mb_ereg_replace($var1,$var2,$var3);
	else
		return ereg_replace($var1,$var2,$var3);
	
}//hs_ereg_replace

function hs_eregi($var1,$var2,$var3 = null){
	
	if(function_exists("mb_eregi"))
		return mb_eregi($var1,$var2,$var3);
	else
		return eregi($var1,$var2,$var3);
	
}//hs_eregi

function hs_eregi_replace($var1,$var2,$var3){
	
	if(function_exists("mb_eregi_replace"))
		return mb_eregi_replace($var1,$var2,$var3);
	else
		return eregi_replace($var1,$var2,$var3);
	
}//hs_eregi_replace

function hs_split($var1,$var2,$var3 = null){
	
	if(function_exists("mb_split"))
		return mb_split($var1,$var2,$var3);
	else
		return split($var1,$var2,$var3);
	
}//hs_split

function hs_convert_encoding($var1,$var2,$var3){
	
	if(function_exists("mb_convert_encoding"))
		return mb_convert_encoding($var1,$var2,$var3);
	else
		return $var1;
	
}//hs_convert_encoding

function hs_parse_str($var1){
	
	if(function_exists("mb_parse_str"))
		mb_parse_str($var1,$var2);	
	else
		parse_str($var1,$var2);
	
	return $var2;
	
}//hs_parse_str

function hs_wordwrap($txt,$limit=10,$divider="&#8203;"){
	
	preg_match_all('/((http|https|ftp):\/\/|www)[a-z0-9\-\._]+\/?[a-z0-9_\.\-\?\+\/~=&#;,]*[a-z0-9\/]{1}/si',$txt,$links);
	$links = array_unique($links[0]);
	
	foreach( $links as $k => $lnk ) {
		$txt = preg_replace( "/".preg_quote( $lnk, "/" )."/", "[dzLink][".$k."]", $txt );
	}
	
	preg_match_all( "/[^\!|\%|\(|\)|-|\}|\{|\]|\[|\?|,|\.|\n| ]+/", $txt, $words );	
	foreach($words[0] as $word){
		if(hs_strlen($word) > $limit){
			$parts = array();
			$number_of_parts = hs_strlen($word)+($limit-(hs_strlen($word)%$limit));
			for($i=0;$i<=$number_of_parts;$i=$i+$limit){
				$parts[] = hs_substr($word,$i,$limit);
			}//for
			$parts = handle_empties($parts);
			$newword = implode($divider,$parts);
			$txt = hs_ereg_replace(preg_quote($word),$newword,$txt);
		}
	}//foreach
	
	preg_match_all( "/\[dzLink\]\[([0-9]+)\]/", $txt, $links_replaced );
	foreach( $links_replaced[0] as $k => $code ) {
		$key = $links_replaced[1][$k];
		$replace = "<a target='_blank' href='".$links[$key]."'>".substr( $links[$key], 0, ($limit - 3) )."...</a>";
		$txt = preg_replace( "/".preg_quote( $code, "/" )."/", $replace, $txt );
	}
	
	return $txt;
	
}//hs_wordwrap

function hs_unwrap($txt,$divider="&#8203;"){
	
	$txt = hs_ereg_replace($divider,"",$txt);
	return $txt;
	
}//hs_unwrap

?>