<?php

$messages["subject"][0] = "Welcome to |site_name|!";
$messages["body"][0] = "Hi |recipient_name|,

Thank you very much for registering with |site_name|.
We're sure you'll enjoy networking with us and thousands of our members.

Your login information is here consists of
Login: |login|
Password: |password|

To complete your registration, please either click on the following link
|link|
or simply insert this code to the box on a site: |code|

regards,
|site_name| support";

$messages["subject"][1] = "Welcome to |site_name|!";
$messages["body"][1] = "Hi |recipient_name|,

Thank you very much for registering with |site_name|.
We're sure you'll enjoy networking with us and thousands of our members.

Your login information is here consists of
Login: |login|
Password: |password|

regards,
|site_name| support";

$messages["subject"][2] = "|site_name|: Password changed.";
$messages["body"][2] = "Hi |recipient_name|,

You recently changed your password on a site. This email is sent
automatically to inform you about new login details.

Login: |login|
Password: |password|

regards,
|site_name| support";

$messages["subject"][3] = "|site_name|: Email changed.";
$messages["body"][3] = "Hi |recipient_name|,

You recently made a change to your email address.
This email is sent automatically to inform you about new login details.

Login: |login|
Password: |password|

regards,
|site_name| support";

$messages["subject"][4] = "|site_name|: |sender_name| wants to share videos with you";
$messages["body"][4] = "|site_name| is a new website for sharing and hosting personal videos. I've been using |site_name| to share videos with my friends and family, and I'd like to add you to the list of people with whom I can share videos.

To accept my friend request, click here.
|ilink|

Thanks,
|sender_name|";

$messages["subject"][5] = "|site_name|: New email arrived.";
$messages["body"][5] = "Hi |recipient_name|,

New message is waiting for you in your |site_name| inbox.
To read it you need to login to your account and click on a mailbox icon at the header.

regards,
|site_name| support";

$messages["subject"][6] = "|site_name|: Temporary Password";
$messages["body"][6] = "Hi |recipient_name|,

System created a temporary password for you to login and change it to something more memorable.

Login: |login|
Password: |password|

regards,
|site_name| support";

$messages["subject"][9] = "|site_name|: Your friend invitation has been accepted.";
$messages["body"][9] = "Hi |recipient_name|,

Member |invitee_name| has recently joined |site_name| through your invitation and is now added to your friends.

regards,
|site_name| Support";

$messages["subject"][10] = "|site_name|: |member_name| wants to share a channel with you";
$messages["body"][10] = "|body|

To visit channel page click on the following link:
|slink|";

$messages["subject"][11] = "|site_name|: |member_name| wants to share a video with you";
$messages["body"][11] = "|body|

To watch video:
|slink|

To accept my friend request:
|ilink|";

$messages["subject"][12] = "|site_name|: |member_name| wants to share a video with you";
$messages["body"][12] = "|body|

To watch video click on the following link:
|slink|";

$messages["subject"][13] = "|site_name|: |member_name| wants to share a video with you";
$messages["body"][13] = "|body|

To watch video:
|slink|

To accept my friend request:
|ilink|";

$messages["subject"][14] = "|site_name|: |member_name| wants to share a playlist with you";
$messages["body"][14] = "|body|

To check this playlist:
|slink|

To accept my friend request:
|ilink|";

$messages["subject"][15] = "|site_name|: |member_name| wants to share a playlist with you";
$messages["body"][15] = "|body|

To check out this playlist please click on the following link:
|slink|";

$messages["subject"][18] = "|site_name|: Invitation to join |group_name| Group";
$messages["body"][18] = "Hi |recipient_name|,

You have received an invitation to join |group_name| Group from |member_name|.
Please, check your mailbox at |site_name|.

regards,
|site_name| Support.";

$messages["subject"][19] = "|site_name|: Invitation to join |group_name| Group";
$messages["body"][19] = "|body|

To check this group:
|slink|

To accept my friend request:
|ilink|";

$messages["subject"][21] = "|site_name|: Featured Status Availability";
$messages["body"][21] = "Hi |recipient_name|,

We have got an awaiting position in our featured category for your |item_type| |item_name|.
You can now upgrade your |item_type| to the featured status.

regards,
|site_name| Support.";

$messages["subject"][34] = "|site_name|: Your Account Has Been Upgraded";
$messages["body"][34] = "Hi |recipient_name|,

Thank you for upgrading your account.
Now more features will become available for you and we hope you will like watching videos at |site_name|.

regards,
|site_name| Support";

$messages["subject"][35] = "|site_name|: Account Membership Renewed";
$messages["body"][35] = "Hi |recipient_name|,

Thank you for renewing your account.
We hope you enjoy videos at |site_name| and hope to see you on our site soon.

regards,
|site_name| Support";

$messages["subject"][44] = "Your Account Has Been Approved!";
$messages["body"][44] = "Hi |recipient_name|,

Your account at |site_name| has been recently approved by site administrator.
You can now access all sections of a site.

regards,
|site_name| support";

$messages["subject"][45] = "|site_name|: Email changed.";
$messages["body"][45] = "Hi |recipient_name|,

You recently made a change to your email address.
This email is sent automatically to inform you about new login details.

Login: |login|
Password: |password|

Please, click on the link below to confirm email change:
|link|

regards,
|site_name| support";

$messages["subject"][100] = "Friend Invite Accepted.";
$messages["body"][100] = "Member |member_name| accepted your friend invite. Member is added to your friends.";

$messages["subject"][101] = "Friend Invite Declined.";
$messages["body"][101] = "Member |member_name| declined your friend invite.";

$messages["subject"][102] = "Request to join |group_name| Group.";
$messages["body"][102] = "Member |member_name| has recently sent a request to join your group |group_name|. You may either accept or decline this request.";

$messages["subject"][104] = "Request accepted.";
$messages["body"][104] = "Member |member_name| accepted your request to join group |group_name|.";

$messages["subject"][105] = "Request declined.";
$messages["body"][105] = "Member |member_name| declined your request to join group |group_name|.";

$messages["subject"][106] = "Friend invitation from |member_name|.";
$messages["body"][106] = "|member_name| has invited you to be friends. If you accept this invitation it will make it possible for |member_name| to follow your rating and favoriting and easier for you to share videos with each other.";

$messages["subject"][110] = "Invitation to join |group_name| Group";
$messages["body"][110] = "|body|";

$messages["subject"][111] = "Member |member_name| wants to share video with you.";
$messages["body"][111] = "|body|";

$messages["subject"][112] = "Member |member_name| wants to share channel with you.";
$messages["body"][112] = "|body|";

$messages["subject"][113] = "Member |member_name| wants to share playlist with you.";
$messages["body"][113] = "|body|";

$messages["subject"][114] = "You've got a video response from |member_name|.";
$messages["body"][114] = "|member_name| has posted a video response. You can either approve or decline it.";


?>