function CH_GetThumbnails( vid_id, screenshotSpot ) {
	
	var url = "ajax.php";
	var postString = "module=videos&section=thumbnails&vid_id=" + vid_id;
	
	var oXHR = zXmlHttp.createRequest();
	oXHR.open("post", MainURL+url, true);
	oXHR.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
	oXHR.onreadystatechange = function() {
		if (oXHR.readyState == 4) {
			CH_SaveThumbnails( oXHR.responseXML, vid_id, screenshotSpot );
		}
	}
	oXHR.send( postString );
	
}

function CH_SaveThumbnails( XMLData, vid_id, screenshotSpot ) {
	var thumbs  = XMLData.getElementsByTagName("image");
	var def     = XMLData.getElementsByTagName("default");
	var saveThumbs = new Array;
	saveThumbs["default"] = def[0].firstChild.nodeValue;
	saveThumbs["images"] = new Array;
	for(var i = 0; i < thumbs.length; i++){
		var imagePath = thumbs[i].firstChild.nodeValue;
		saveThumbs["images"][i] = imagePath;
	}
	var d = document;
	d.CH_Thumbnails[vid_id] = saveThumbs;
	if( d.CH_CurrVidID == vid_id )
		CH_RotateThumbnails( vid_id, screenshotSpot );
}

function CH_StartRotateThumbnails( vid_id, screenshotSpot ) {
	CH_StopRotateThumbnails( 0, 0 );
	var d = document;
	if(!d.CH_Thumbnails) {d.CH_Thumbnails = new Array;}
	if(!d.CH_CurrImage) {d.CH_CurrImage = 0;}
	if(!d.CH_CurrVidID) {d.CH_CurrVidID = 0;}
	
	d.CH_CurrVidID = vid_id;
	
	if( !d.CH_Thumbnails[vid_id] ) {
		CH_GetThumbnails( vid_id, screenshotSpot );
	}
	else {
		CH_RotateThumbnails( vid_id, screenshotSpot );
	}
}

function CH_RotateThumbnails( vid_id, screenshotSpot ) {
	var d = document;
	
	var currImage = d.CH_CurrImage;
	currImage++;
	if( currImage > ( d.CH_Thumbnails[vid_id]["images"].length - 1 ) )
		currImage = 0;
		
	d.CH_CurrImage = currImage;
	
	var img = new Image();
	img.onload = function() { screenshotSpot.src = img.src; if( d.CH_CurrVidID == vid_id ) { d.CH_ThumbsRotateInterval = setTimeout( function() { CH_RotateThumbnails( vid_id, screenshotSpot ); } , 500 ); } }
	if( d.CH_Thumbnails[vid_id]["images"][currImage].indexOf("http") >= 0 )
		img.src = d.CH_Thumbnails[vid_id]["images"][currImage];
	else
		img.src = MainURL + "/scr/" + d.CH_Thumbnails[vid_id]["images"][currImage] + ".jpg";
}

function CH_StopRotateThumbnails( vid_id, screenshotSpot ) {
	var d = document;
	d.CH_CurrImage = 0;
	d.CH_CurrVidID = 0;
	clearTimeout( d.CH_ThumbsRotateInterval );
	if( vid_id && d.CH_Thumbnails[vid_id] ) {
		if( d.CH_Thumbnails[vid_id]["default"].indexOf("http") >= 0 )
			screenshotSpot.src = d.CH_Thumbnails[vid_id]["default"];
		else
			screenshotSpot.src = MainURL + "/scr/" + d.CH_Thumbnails[vid_id]["default"] + ".jpg";
	}
}