<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");
						if(!$action)
							$action = $GLOBALS["Get"]->val("act");

							switch($action){
									
								case 'update':
									channel_update();
									break;
									
								case 'share':
									channel_share();
									break;
									
								case 'ignore':
									channel_ignore();
									break;
									
								case 'unignore':
									channel_unignore();
									break;
									
								case 'friend':
									channel_friend();
									break;
									
								case 'add_comment':
									channel_add_comment();
									break;
									
								case 'add_bulletin':
									channel_add_bulletin();
									break;
									
								case 'cancel_subscription':
									cancel_membership();
									break;
									
								case 'delete_comment':
									channel_delete_comment();
									break;

							}//switch

						///////////////////////////////////////

function channel_info( $channel = 0 ) {
	if(!$channel) {
		$member  = $GLOBALS["Member"]->info();
		$channel = $member["mem_id"];
	}
	
	$sql_query = "SELECT * FROM members AS m,channels AS c WHERE m.mem_id = c.mem_id
				  AND m.mem_id = ".$channel;
	$info = $GLOBALS["DB"]->row( $sql_query );
	
	$info["channel"] = $channel;
	$info["link"] = build_channel_link( $info["username"] );

	$GLOBALS["smarty"]->assign( "channel", $info );
	
}

function channel_update() {
	
	$info = auth_member();
	
	$pro = $GLOBALS["Get"]->val("pro");
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("channel_".$pro);

	if($pro == "videos") {
		$videos = handle_empties(explode(",", $GLOBALS["Get"]->val("videos")));
		$sql_query = "UPDATE channels SET videos='".implode(",", $videos)."' WHERE mem_id=".$info["mem_id"];
		$GLOBALS["DB"]->execute( $sql_query );
	} elseif($pro == "favorites") {
		$videos = handle_empties(explode(",", $GLOBALS["Get"]->val("videos")));
		$sql_query = "UPDATE channels SET favorites='".implode(",", $videos)."' WHERE mem_id=".$info["mem_id"];
		$GLOBALS["DB"]->execute( $sql_query );
	} elseif($pro == "boxes") {
		$vals = array();
		$available_boxes = array(
			"box_featured", "box_subscriptions", "box_bulletins", "box_playlists", "box_recent_ratings", 
			"box_recent_comments", "box_videos", "box_favorites", "box_subscribers", "box_friends", "box_comments"
		);
		
		$boxes = array();
		foreach($values as $key => $val) {
			if(in_array($key, $available_boxes) && $val)
				$boxes[] = $key;
		}
			
		$playlists = array();
		$count = 0;
		if(is_array( $values["playlists"] )) {
			foreach($values["playlists"] as $pl) {
				$playlists[] = $pl;
				$count++;
				if($count == 3)
					break;
			}
		}
		
		if($values["featured_type"] == 2)
			$vals["featured"] = $values["featured_url"];
			
		$sql_query = "UPDATE channels SET boxes=':boxes:', featured=':featured:', playlists=':playlists:'
					  WHERE mem_id=".$info["mem_id"];
		$vals["boxes"] = implode(",",$boxes);
		$vals["playlists"] = implode(",",$playlists);
		$GLOBALS["DB"]->values = $vals;
		$GLOBALS["DB"]->execute( $sql_query );
		$pro = "design";
	} elseif($pro == "style") {
		
		//colors
		$vals = array();
		$values["colors"] = $GLOBALS["Get"]->val("colors");
		$colors = serialize( $values["colors"] );
		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/color_schemes.inc.php");
		if($scheme[$values["theme"]] == $colors)
			$vals["colors"] = $values["theme"];
		else
			$vals["colors"] = $colors;
		$sql_query = "UPDATE channels SET colors=':colors:' WHERE mem_id=".$info["mem_id"];
		$GLOBALS["DB"]->values = $vals;
		$GLOBALS["DB"]->execute( $sql_query );
		
		//background
		$cbcg      = @unserialize( $info["bcg"] );
		$bcgimg    = $GLOBALS["GetFromForm"]->file( "bcgimg" );
		$bcgrepeat = $GLOBALS["Get"]->type_val( "bcgrepeat", "integer" );
		
		if( $bcgimg["tmp"] ) {
			
			if(hs_ereg("gif",$bcgimg["type"])){
	   			$extension = ".gif";
	   		}//if
	   		elseif(hs_ereg("jpeg|jpg",$bcgimg["type"])){
	   			$extension = ".jpeg";
	   		}//elseif
	   		else{
	   			build_error(8,"channels","edit_design");
	   		}//else
	   		
	   		$image = build_unique_path( DOC_ROOT."/avt", $extension ).$extension;
			move_uploaded_file( $bcgimg["tmp"], DOC_ROOT."/avt/".$image );
			
			$bcg = array( "name" => hs_substr( $bcgimg["name"], -15, 15 ), "file" => $image, "repeat" => $bcgrepeat );
			
			
		} else {
			
			$bcg = $cbcg;
			$bcg["repeat"] = $bcgrepeat;
			
		}
		
		$sql_query = "UPDATE channels SET bcg=':bcg:' WHERE mem_id=".$info["mem_id"];
		$GLOBALS["DB"]->values = array("bcg" => serialize( $bcg ));
		$GLOBALS["DB"]->execute( $sql_query );
		
		$pro = "design";
		
	} elseif($pro == "bcg_remove") {
		$bcg = unserialize( $info["bcg"] );
		if( file_exists( DOC_ROOT."/avt/".$bcg["file"] ) )
			@unlink( DOC_ROOT."/avt/".$bcg["file"] );
			
		$sql_query = "UPDATE channels SET bcg='' WHERE mem_id=".$info["mem_id"];
		$GLOBALS["DB"]->execute( $sql_query );
		$pro = "design";
	} else {
		load_db_update( "channel_".$pro, $values, array("mem_id", $info["mem_id"]) );
	}

	load_page("index.php?page=channels&section=edit_".$pro."&cmp_id=23");
	
}

function channel_videos() {
	
	$u = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $u );
	if(!$mem_id) {
		$info = $GLOBALS["Member"]->info();
		$mem_id = $info["mem_id"];
	}
	
	$sql_query = "SELECT videos FROM channels WHERE mem_id=".$mem_id;
	$videos = $GLOBALS["DB"]->single( $sql_query );	
	if(!$videos){$videos = "0";}
	
	$sql_query = "SELECT vid_id FROM videos WHERE 1
				  ".$GLOBALS["Videos"]->filter()."
				  AND mem_id=".$mem_id." AND vid_id IN (".$videos.") ORDER BY posted DESC LIMIT 0,9";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$cards = array();
	$vids = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$cards[] = $card;
		$vids[] = $res["vid_id"];
	}
	
	if(count( $videos )) {
		$GLOBALS["page_details"]["onload"].= "CH_AddVideos('".implode(",", $vids)."');";
	}
	
	$GLOBALS["page_details"]["code"].= "<script language='JavaScript'>var languageLimit = '".$GLOBALS["language"]["you_cannot_add_more_then_videos"]."';</script>";
	
	$GLOBALS["smarty"]->assign("channel_videos", $cards);
	
}

function channel_favorites() {
	
	$u = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $u );
	if(!$mem_id) {
		$info = $GLOBALS["Member"]->info();
		$mem_id = $info["mem_id"];
	}
	
	$sql_query = "SELECT favorites FROM channels WHERE mem_id=".$mem_id;
	$favorites = $GLOBALS["DB"]->single( $sql_query );
	if(!$favorites){$favorites = "0";}
	
	$sql_query = "SELECT b.item_id FROM bookmarks AS b,videos AS v WHERE 
				  v.vid_id = b.item_id AND b.item_id IN (".$favorites.")
				  ".$GLOBALS["Videos"]->filter("v.")."
				  AND b.mem_id=".$mem_id." ORDER BY b.added DESC LIMIT 0,9";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	$vids = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["item_id"] );
		$card["channel"] = $GLOBALS["Videos"]->is_channel_fav($res["item_id"]);
		$videos[] = $card;
		$vids[] = $res["item_id"];
	}
	
	if(count( $videos )) {
		$GLOBALS["page_details"]["onload"].= "CH_AddVideos('".implode(",", $vids)."');";
	}
	
	$GLOBALS["page_details"]["code"].= "<script language='JavaScript'>var languageLimit = '".$GLOBALS["language"]["you_cannot_add_more_then_videos"]."';</script>";
	
	$GLOBALS["smarty"]->assign("channel_videos", $videos);
	
}

function channel_my_videos(){

	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$info["mem_id"]." ".$GLOBALS["Videos"]->filter();
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	$link  = "CH_ChannelMyVideosChangePage(|p|)";
	$pages = handle_multipages($p,$total,$link);

	$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$info["mem_id"]."
				  ".$GLOBALS["Videos"]->filter()."
				  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$videos[] = $GLOBALS["Videos"]->card($res["vid_id"]);
	}//foreach

	$GLOBALS["smarty"]->assign("my_videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);

}

function channel_my_favorites(){

	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT COUNT(*) FROM bookmarks AS b, videos AS v WHERE b.item_id=v.vid_id AND b.mem_id=".$info["mem_id"]."
				  ".$GLOBALS["Videos"]->filter("v.");
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	$link  = "CH_ChannelMyFavoritesChangePage(|p|)";
	$pages = handle_multipages($p,$total,$link);

	$sql_query = "SELECT item_id FROM bookmarks AS b, videos AS v WHERE b.item_id=v.vid_id AND b.mem_id=".$info["mem_id"]."
				  ".$GLOBALS["Videos"]->filter("v.")."
				  ORDER BY b.added DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$card = array();
		$card = $GLOBALS["Videos"]->card($res["item_id"]);
		$card["channel"] = $GLOBALS["Videos"]->is_channel_fav($res["item_id"]);
		$videos[] = $card;
	}//foreach
	
	$GLOBALS["smarty"]->assign("my_videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);

}

function channel_design() {
	
	global $forms;
	
	$info = $GLOBALS["Member"]->info();
	$mem_id = $info["mem_id"];
	
	$sql_query = "SELECT colors,bcg,boxes,featured,playlists FROM channels WHERE mem_id=".$mem_id;
	$code = $GLOBALS["DB"]->row( $sql_query );
	
	$boxes = explode(",", $code["boxes"]);
	foreach($boxes as $box) {
		$forms["channel_boxes"]["values"][$box] = 1;
		rebuild_form_item( "channel_boxes", $box );
	}
	
	if($code["featured"]){
		$forms["channel_boxes"]["values"]["featured_type"] = 2;
		$forms["channel_boxes"]["values"]["featured_url"] = $code["featured"];
	} else {
		$forms["channel_boxes"]["values"]["featured_type"] = 1;
	}
	
	rebuild_form_item( "channel_boxes", "featured_type" );
	rebuild_form_item( "channel_boxes", "featured_url" );
	
	$forms["channel_boxes"]["values"]["playlists"] = $code["playlists"];
	rebuild_form_item( "channel_boxes", "playlists" );
	
	$forms["channel_style"]["values"]["theme"] = "grey";
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/color_schemes.inc.php");
	if(preg_match("/^[A-Za-z|0-9|_]+$/",$code["colors"])){
		if(array_key_exists( $code["colors"], $scheme )){
			$colors_ser = $scheme[$code["colors"]];
			$forms["channel_style"]["values"]["theme"] = $code["colors"];
		}
		else{
			$colors_ser = $scheme["grey"];
		}
	} elseif( !$code["colors"] ) {
		$colors_ser = $scheme["grey"];
	} else {
		$colors_ser = $code["colors"];
	}
	rebuild_form_item( "channel_style", "theme" );
	
	$colors = unserialize( $colors_ser );
	foreach($colors as $key => $val) {
		if(!is_array($val)){
			$field = "colors[".$key."]";
			$forms["channel_style"]["values"][$field] = $val;
			rebuild_form_item( "channel_style", $field );
		} else {
			foreach($val as $k => $v) {
				$field = "colors[".$key."][".$k."]";
				$forms["channel_style"]["values"][$field] = $v;
				rebuild_form_item( "channel_style", $field );
			}
		}
	}
	
	$bcg = unserialize( $code["bcg"] );
	$field = "bcgimg";
	$forms["channel_style"]["values"][$field] = $bcg["name"];
	rebuild_form_item( "channel_style", $field );
	$field = "bcgrepeat";
	$forms["channel_style"]["values"][$field] = $bcg["repeat"];
	rebuild_form_item( "channel_style", $field );
	
	reset($scheme);
	$js = "<script language=\"JavaScript\">";
	foreach($scheme as $sc => $colcode) {
		$col = unserialize( $colcode );
		$js.= "CH_AddScheme('".$sc."' , '";
		foreach($col as $key => $val) {
			if(!is_array( $val )){
				$js.= "[".$key."]=".$val."|";
			} else {
				foreach($val as $k => $v) {
					$js.= "[".$key."][".$k."]=".$v."|";
				}
			}
		}
		$js.= "');\n";
	}
	$js.= "</script>";
	
	
	$GLOBALS["page_details"]["code"].= $js;
	$GLOBALS["page_details"]["onload"].= "CH_SetupEvents();";
	
}

function channel_view() {
	
	include_once(DOC_ROOT."/modules/playlists.php");
	
	$info = $GLOBALS["Member"]->info();
	
	$username = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $username );
	
	if(!$mem_id) {
		build_error(45, "homepage" );
		exit;
	}
	
	
	$channel = $GLOBALS["DB"]->row( "SELECT * FROM channels AS c,members AS m,profiles AS p WHERE c.mem_id=".$mem_id."
									 AND c.mem_id = m.mem_id AND c.mem_id = p.mem_id" );
	
	if($GLOBALS["settings"]["limit_unapproved"] && !$channel["approved"]) {
		build_error(40, "homepage" );
		exit;
	}
	
	//style
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/color_schemes.inc.php");
	if(preg_match("/^[A-Za-z|0-9|_]+$/",$channel["colors"])){
		if(array_key_exists( $channel["colors"], $scheme )){
			$colors_ser = $scheme[$channel["colors"]];
		}
		else{
			$colors_ser = $scheme["grey"];
		}
	} elseif( !$channel["colors"] ) {
		$colors_ser = $scheme["grey"];
	} else {
		$colors_ser = $channel["colors"];
	}	
	$colors = unserialize( $colors_ser );
	$bcg = unserialize( $channel["bcg"] );
	if($bcg["file"]) {
		$colors["bcgimg"] = URL."/avt/".$bcg["file"];
		$colors["bcgrepeat"] = $bcg["repeat"];
	}
	
		
	$GLOBALS["smarty"]->assign("cstyle", $colors);	
	
	//info box
	$card = $GLOBALS["Member"]->card( $mem_id, 1 );
	$card["title"] = $channel["title"];
	$card["last_visit"] = extract_time_relative( $channel["last_visit"] );
	$card["views"] = $channel["views"];
	$card["name"]  = ($GLOBALS["Network"]->is_trusted( $mem_id, $info["mem_id"], 1)) ? $card["fname"]." ".$card["lname"] : $card["fname"];
	$card["age"] = extract_member_age( $mem_id, $channel["birthdate"] );
	$card["about_me"] = nl2br( $channel["about_me"] );
	$card["location"] = extract_member_location( $mem_id );
	$card["website"] = $channel["website"];
	$card["allow_comment"] = auth_channel_comment( $mem_id );
	$card["allow_bulletin"] = ($channel["bulletins"] && $info["mem_id"] == $mem_id);
	$card["gender"] = extract_member_gender( $mem_id, $channel["gender"] );
	
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$mem_id." AND mem_id=".$info["mem_id"]." AND type='channel'";
	$card["subscribed"] = $GLOBALS["DB"]->single( $sql_query );
	
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'";	
	$card["subscribers"] = $GLOBALS["DB"]->single( $sql_query );
	
	//profile
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/profile.inc.php");

	$profile = array();
	$values  = handle_data_from_db($output["assoc"],"mem_id");

	while(list($i,) = each($output["names"])){

		$name = $output["names"][$i];
		$details = explode("|",$output["types"][$i]);
		$type = array_shift($details);
		$profile["descr"][$name]  = build_profile_field($values,$output["types"][$i],$output["names"][$i]);
		$profile["labels"][$name] = $output["labels"][$i];
		$profile["types"][$name]  = $type;

	}//while
	$card["profile"] = $profile;
	
	$GLOBALS["smarty"]->assign("channel", $card);

	//settings
	$settings["comments"] = $channel["comments"];
	$settings["comment_allow"] = $channel["comment_allow"];
	$GLOBALS["smarty"]->assign("settings", $settings);
	
	$pro = $GLOBALS["Get"]->val("pro");
	if(!$pro)
		$pro = "main";
	
	channel_page( $pro );

	$sql_query = "UPDATE channels SET views=views+1 WHERE mem_id=".$mem_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$GLOBALS["smarty"]->assign("channel_page", $pro );
	
	$GLOBALS["page_details"]["code"].= "<script language='JavaScript'>var languageSubscribe = '".$GLOBALS["language"]["subscribe"]."';</script>";
	$GLOBALS["page_details"]["code"].= "<script language='JavaScript'>var languageUnsubscribe = '".$GLOBALS["language"]["unsubscribe"]."';</script>";
	
}

function channel_page( $pro ) {
	
	$info = $GLOBALS["Member"]->info();
	
	$username = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $username );
	
	switch($pro) {		
		case 'groups':
			include_once(DOC_ROOT."/classes/Groups.class.php");
			$sql_query = "SELECT COUNT(*) FROM groups WHERE privacy < 3 AND mem_id=".$mem_id;
	
			$total = $GLOBALS["DB"]->single($sql_query);	
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=groups";
			$pages = handle_multipages($p,$total,$link);
		
			$sql_query = "SELECT grp_id FROM groups WHERE privacy < 3 AND mem_id=".$mem_id."
						  ORDER BY created DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result($sql_query);
		
			$groups = array();
			foreach($result as $res){
				$groups[] = $GLOBALS["Groups"]->card($res["grp_id"]);
			}//foreach
		
			$GLOBALS["smarty"]->assign("groups",$groups);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
		
		case 'videos':
			$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$mem_id." ".$GLOBALS["Videos"]->filter();
	
			$total = $GLOBALS["DB"]->single($sql_query);
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=videos";
			$pages = handle_multipages($p,$total,$link);
		
			$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$mem_id."
						  ".$GLOBALS["Videos"]->filter()."
						  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result($sql_query);
			
			$videos = array();
			foreach($result as $res){
				$videos[] = $GLOBALS["Videos"]->card($res["vid_id"]);
			}//foreach
		
			$GLOBALS["smarty"]->assign("videos",$videos);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'favorites':
			$sql_query = "SELECT COUNT(*) FROM bookmarks AS b, videos AS v WHERE v.vid_id = b.item_id AND b.mem_id=".$mem_id." ".$GLOBALS["Videos"]->filter("v.");
	
			$total = $GLOBALS["DB"]->single($sql_query);	
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=favorites";
			$pages = handle_multipages($p,$total,$link);
		
			$sql_query = "SELECT v.vid_id FROM bookmarks AS b, videos AS v WHERE v.vid_id = b.item_id AND b.mem_id=".$mem_id." ".$GLOBALS["Videos"]->filter("v.")."
						  ORDER BY b.added DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result($sql_query);
		
			$videos = array();
			foreach($result as $res){
				$videos[] = $GLOBALS["Videos"]->card($res["vid_id"]);
			}//foreach
		
			$GLOBALS["smarty"]->assign("favorites",$videos);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'playlists':
			$sql_query = "SELECT COUNT(*) FROM playlists WHERE privacy = 0 AND mem_id=".$mem_id;
			
			$total = $GLOBALS["DB"]->single($sql_query);	
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=playlists";
			$pages = handle_multipages($p,$total,$link);
			
			$sql_query = "SELECT p.pla_id,MAX(v.posted) AS updated FROM playlists AS p,playlist_videos AS pv,videos AS v WHERE pv.vid_id=v.vid_id
						  AND p.pla_id = pv.pla_id
						  AND pv.vid_id = v.vid_id
						  AND p.mem_id=".$mem_id." ".$GLOBALS["Videos"]->filter("v.")."
						  AND p.privacy=0
						  GROUP BY p.pla_id
						  ORDER BY updated DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			
			$playlists = array();
			foreach($result as $res) {
				$card = playlist_card( $res["pla_id"] );
				$playlists[] = $card;
			}
			
			$GLOBALS["smarty"]->assign("playlists",$playlists);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'friends':
			$cache = $GLOBALS["Network"]->get_cache( $mem_id );
	
			$total = $cache["friends_count"];	
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=friends";
			$pages = handle_multipages($p,$total,$link);
		
			$sql_query = "SELECT mem_id FROM network WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] )."
						  ORDER BY mem_id DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$friends = array();
			foreach($result as $res) {
				$card = $GLOBALS["Member"]->card( $res["mem_id"] );
				$friends[] = $card;
			}
			$GLOBALS["smarty"]->assign("friends",$friends);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'subscribers':
			$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'";
			
			$total = $GLOBALS["DB"]->single($sql_query);
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=subscribers";
			$pages = handle_multipages($p,$total,$link);
			
			$sql_query = "SELECT mem_id FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'
						  ORDER BY id DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$subscribers = array();
			foreach($result as $res) {
				$card = $GLOBALS["Member"]->card( $res["mem_id"] );
				$subscribers[] = $card;
			}
			$GLOBALS["smarty"]->assign("subscribers",$subscribers);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'subscriptions':
			$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE mem_id=".$mem_id;
			
			$total = $GLOBALS["DB"]->single($sql_query);
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=subscriptions";
			$pages = handle_multipages($p,$total,$link);
			
			$subscriptions = array();
			
			$sql_query = "SELECT sub_id, type FROM subscriptions WHERE mem_id=".$mem_id." LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			foreach($result as $res) {
				$card = array();
				switch($res["type"]) {
					
					case 'channel':
						$channel = $GLOBALS["DB"]->row( "SELECT title FROM channels WHERE mem_id=".$res["sub_id"] );
						$card = $GLOBALS["Member"]->card( $res["sub_id"] );
						$card["title"] = $channel["title"];
						$card["title_cut"] = $GLOBALS["Member"]->crop( $channel["title"] );
						$card["type"] = "channel";
						break;
					
					case 'playlist':
						$card = playlist_card( $res["sub_id"] );
						$card["type"] = "playlist";
						break;
					
				}
				
				$subscriptions[] = $card;
			}
			$GLOBALS["smarty"]->assign("subscriptions",$subscriptions);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'bulletins':
			$cache = $GLOBALS["Network"]->get_cache( $mem_id );
			$bulletins = array();
			
			$sql_query = "SELECT COUNT(*) FROM bulletins AS b,network AS n WHERE b.from = n.mem_id
						  AND (n.mem_id = ".$mem_id." OR ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"], "n." ).")";
			
			$total = $GLOBALS["DB"]->single($sql_query);
			$p     = $GLOBALS["Get"]->type_val("p","integer");
			$link  = build_channel_link( $username, 1)."pro=bulletins";
			$pages = handle_multipages($p,$total,$link);
			
			$sql_query = "SELECT * FROM bulletins AS b,network AS n WHERE b.from = n.mem_id
						  AND (n.mem_id = ".$mem_id." OR ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"], "n." ).")
						  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			foreach($result as $res) {
				$card = array();
				$card["from"] = $GLOBALS["Member"]->card( $res["from"] );
				$card["subject_cut"] = handle_string_cut( $res["subject"], 180 );
				$card["posted"] = extract_date( $res["posted"] );
				$card["video"] = ($res["video"]) ? 1 : 0;
				$card["link"] = build_channel_link( $username, 1)."pro=view_bulletin&bul_id=".$res["bul_id"];
				$bulletins[] = $card;
			}
			$GLOBALS["smarty"]->assign("bulletins",$bulletins);
			$GLOBALS["smarty"]->assign("pages",$pages);
			break;
			
		case 'view_bulletin':
			$bul_id = $GLOBALS["Get"]->type_val("bul_id","integer");
			$sql_query = "SELECT * FROM bulletins WHERE bul_id=".$bul_id;
			$bulletin = $GLOBALS["DB"]->row( $sql_query );
			$card = array();
			$card["from"] = $GLOBALS["Member"]->card( $bulletin["from"] );
			$card["subject"] = $bulletin["subject"];
			$card["message"] = nl2br( $bulletin["message"] );
			$card["date"] = extract_date( $bulletin["posted"] );
			$card["user"] = $GLOBALS["Member"]->username( $bulletin["from"] );
			$card["poster"] = $username;
			if($bulletin["video"])
				$card["video"] = $GLOBALS["Videos"]->card( $bulletin["video"] );
			$GLOBALS["smarty"]->assign("bulletin", $card);
			break;
			
		case 'add_comment':
			
			break;
		
		case 'main':
		default:	

			$channel = $GLOBALS["DB"]->row( "SELECT * FROM channels AS c,members AS m,profiles AS p WHERE c.mem_id=".$mem_id."
											 AND c.mem_id = m.mem_id AND c.mem_id = p.mem_id" );
			
			//boxes
			$boxes_data = handle_empties(explode(",", $channel["boxes"]));
			$boxes = array();
			foreach($boxes_data as $box) {
				switch($box) {
					case 'box_featured':
						$boxes["featured"] = channel_featured( $mem_id, $channel["featured"] );
						break;
					case 'box_subscriptions':
						$boxes["subscriptions"] = channel_subscriptions( $mem_id );
						break;
					case 'box_bulletins':
						if($channel["bulletins"])
						$boxes["bulletins"] = channel_bulletins( $mem_id );
						break;
					case 'box_playlists':
						$boxes["playlists"] = channel_playlists( $mem_id );
						break;
					case 'box_recent_ratings':
						$boxes["recent_ratings"] = channel_recent_ratings( $mem_id );
						break;
					case 'box_recent_comments':
						$boxes["recent_comments"] = channel_recent_comments( $mem_id );
						break;
					case 'box_videos':
						$boxes["videos"] = channel_videos_box( $mem_id );
						break;
					case 'box_favorites':
						$boxes["favorites"] = channel_favs_box( $mem_id );
						break;
					case 'box_subscribers':
						$boxes["subscribers"] = channel_subscribers( $mem_id );
						break;
					case 'box_friends':
						$boxes["friends"] = channel_friends( $mem_id );
						break;
					case 'box_comments':
						if($channel["comments"])
						$boxes["comments"] = channel_comments( $mem_id );
						break;
				}
			}
			$GLOBALS["smarty"]->assign("boxes", $boxes);
			break;
		
	}
	
}

function channel_featured( $mem_id, $featured ) {
	
	$featured = html_entity_decode( $featured );
	
	if($featured){
		$vid_id = channel_parse_url( $featured );
		if($vid_id) {
			$sql_query = "SELECT vid_id FROM videos WHERE vid_id=".$vid_id." ".$GLOBALS["Videos"]->filter();
			$vid_id = $GLOBALS["DB"]->single( $sql_query );
		}
	} else {
		$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$mem_id." ".$GLOBALS["Videos"]->filter()." ORDER BY posted DESC LIMIT 0,1";
		$vid_id = $GLOBALS["DB"]->single( $sql_query );
	}
	
	if(!$vid_id)
		return false;
	
	$card = $GLOBALS["Videos"]->card( $vid_id );	
	$card["video"] = '<script type="text/javascript">
		AC_FL_RunContent( "codebase", "http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0",
		"width", "480",
		"height", "390",
		"src", "swf/player",
		"quality", "high",
		"pluginspage", "http://www.macromedia.com/go/getflashplayer",
		"align", "middle",
		"play", "true",
		"loop", "true",
		"scale", "showall",
		"wmode", "window",
		"devicefont", "false",
		"id", "player",
		"bgcolor", "#000000",
		"name", "player",
		"menu", "true",
		"allowFullScreen", "true",
		"allowScriptAccess","always",
		"movie", "swf/player",
		"salign", "",
		"FlashVars","vid_id='.$vid_id.'&MainURL='.extract_mainurl().'"
		);
		</script>';
	
	return $card;
	
}

function channel_subscriptions( $mem_id ) {
	
	$subscriptions = array();
	//total
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE mem_id=".$mem_id;
	$subscriptions["total"] = $GLOBALS["DB"]->single( $sql_query );
	
	//channels
	$sql_query = "SELECT sub_id FROM subscriptions WHERE type='channel' AND mem_id=".$mem_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	$subs = array("0");
	foreach($result as $res) {
		$subs[] = $res["sub_id"];
	}
	$sql_query = "SELECT c.mem_id,c.title,MAX(v.posted) AS updated FROM channels AS c,videos AS v WHERE c.mem_id IN(".implode(",", $subs).")
				  AND c.mem_id = v.mem_id ".$GLOBALS["Videos"]->filter("v.")."
				  GROUP BY c.mem_id
				  ORDER BY updated DESC LIMIT 0,6";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["title"] = $res["title"];
		$card["title_cut"] = $GLOBALS["Member"]->crop( $res["title"] );
		$card["type"] = "channel";
		$subscriptions["cards"][] = $card;
	}
	
	//playlists
	if(count($subscriptions["cards"]) < 6){
		
		$missing = 6 - count($subscriptions["cards"]);
		
		$sql_query = "SELECT sub_id FROM subscriptions WHERE type='playlist' AND mem_id=".$mem_id;
		$result = $GLOBALS["DB"]->result( $sql_query );
		$pls = array("0");
		foreach($result as $res) {
			$pls[] = $res["sub_id"];
		}
		$sql_query = "SELECT p.pla_id,MAX(v.posted) AS updated FROM playlists AS p,playlist_videos AS pv,videos AS v WHERE p.pla_id IN(".implode(",", $pls).")
					  AND p.pla_id = pv.pla_id AND pv.vid_id = v.vid_id ".$GLOBALS["Videos"]->filter("v.")."
					  GROUP BY p.pla_id
					  ORDER BY updated DESC LIMIT 0,".$missing;
		$result = $GLOBALS["DB"]->result( $sql_query );
		foreach($result as $res) {
			$card = playlist_card( $res["pla_id"] );
			$card["type"] = "playlist";
			$subscriptions["cards"][] = $card;
		}
		
	}

	return $subscriptions;
	
}

function channel_bulletins( $mem_id ) {
	
	$username = $GLOBALS["Member"]->username( $mem_id );
	$cache = $GLOBALS["Network"]->get_cache( $mem_id );
	$bulletins = array();
	
	//total
	$sql_query = "SELECT COUNT(*) FROM bulletins AS b,network AS n WHERE b.from = n.mem_id
				  AND (n.mem_id = ".$mem_id." OR ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"], "n." ).")";
	$bulletins["total"] = $GLOBALS["DB"]->single( $sql_query );
	
	//last 5 bulletins
	$sql_query = "SELECT * FROM bulletins AS b,network AS n WHERE b.from = n.mem_id
				  AND (n.mem_id = ".$mem_id." OR ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"], "n." ).")
				  ORDER BY b.posted DESC LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = array();
		$card["from"] = $GLOBALS["Member"]->card( $res["from"] );
		$card["subject_cut"] = handle_string_cut( $res["subject"], 180 );
		$card["posted"] = extract_date( $res["posted"] );
		$card["video"] = ($res["video"]) ? 1 : 0;
		$card["link"] = build_channel_link( $username, 1)."pro=view_bulletin&bul_id=".$res["bul_id"];
		$bulletins["cards"][] = $card;
	}
	
	return $bulletins;
	
}

function channel_playlists( $mem_id ) {
	
	$playlists = array();
	
	$sql_query = "SELECT playlists FROM channels WHERE mem_id=".$mem_id;
	$pls = $GLOBALS["DB"]->single( $sql_query );	
	if(!$pls){$pls = "0";}
	
	//total
	$sql_query = "SELECT COUNT(*) FROM playlists WHERE privacy = 0 AND mem_id=".$mem_id;
	$playlists["total"] = $GLOBALS["DB"]->single($sql_query);
	
	//3 playlists
	$sql_query = "SELECT p.pla_id,MAX(v.posted) AS updated FROM playlists AS p,playlist_videos AS pv,videos AS v WHERE pv.vid_id=v.vid_id
				  AND p.pla_id = pv.pla_id
				  AND pv.vid_id = v.vid_id
				  AND p.mem_id=".$mem_id." ".$GLOBALS["Videos"]->filter("v.")."
				  AND p.privacy=0
				  AND p.pla_id IN (".$pls.")
				  GROUP BY p.pla_id
				  ORDER BY updated DESC LIMIT 0,3";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = playlist_card( $res["pla_id"] );
		$playlists["cards"][] = $card;
	}
	
	return $playlists;
	
}

function channel_recent_ratings( $mem_id ) {
	
	$ratings = array();
	
	$sql_query = "SELECT vid_id,rate FROM video_votes WHERE mem_id=".$mem_id." ORDER BY timestamp DESC LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	foreach($result as $res) {
		$card = array();
		$card["video"] = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$card["rate"] = $GLOBALS["Videos"]->rating_format( $res["rate"], 1 );
		$ratings[] = $card;
	}
	
	return $ratings;
	
}

function channel_recent_comments( $mem_id ) {
	
	$comments = array();
	
	$sql_query = "SELECT vid_id,comment FROM video_comments WHERE mem_id=".$mem_id." AND reply_to=0 AND approved='1' ORDER BY posted DESC LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	foreach($result as $res) {
		$card = array();
		$card["video"] = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$card["comment_cut"] = handle_string_cut( $res["comment"], 200 );
		$comments[] = $card;
	}
	
	return $comments;
	
}

function channel_videos_box( $mem_id ) {
	
	$videos = array();
	
	$sql_query = "SELECT videos FROM channels WHERE mem_id=".$mem_id;
	$vids = $GLOBALS["DB"]->single( $sql_query );	
		
	//total
	$sql_query = "SELECT COUNT(*) FROM videos WHERE 1
				  ".$GLOBALS["Videos"]->filter()."
				  AND mem_id=".$mem_id;
	$videos["total"] = $GLOBALS["DB"]->single( $sql_query );

	//top 9
	if($vids) {
		$sql_query = "SELECT vid_id FROM videos WHERE 1
					  ".$GLOBALS["Videos"]->filter()."
					  AND mem_id=".$mem_id." AND vid_id IN (".$vids.") ORDER BY posted DESC LIMIT 0,9";
	} else {
		$sql_query = "SELECT vid_id FROM videos WHERE 1
					  ".$GLOBALS["Videos"]->filter()."
					  AND mem_id=".$mem_id." ORDER BY posted DESC LIMIT 0,9";
	}
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$cards = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$cards[] = $card;
	}
	$videos["cards"] = $cards;
	
	return $videos;
	
}

function channel_favs_box( $mem_id ) {
	
	$favorites = array();
	
	$sql_query = "SELECT favorites FROM channels WHERE mem_id=".$mem_id;
	$favs = $GLOBALS["DB"]->single( $sql_query );	
		
	//total
	$sql_query = "SELECT COUNT(*) FROM bookmarks AS b,videos AS v WHERE b.item_id=v.vid_id
				  ".$GLOBALS["Videos"]->filter("v.")."
				  AND b.mem_id=".$mem_id;
	$favorites["total"] = $GLOBALS["DB"]->single( $sql_query );

	//top 9
	if($favs) {
		$sql_query = "SELECT vid_id FROM videos WHERE 1
					  ".$GLOBALS["Videos"]->filter()."
					  AND mem_id=".$mem_id." AND vid_id IN (".$favs.") ORDER BY posted DESC LIMIT 0,9";
	} else {
		$sql_query = "SELECT v.vid_id FROM videos AS v, bookmarks AS b WHERE v.vid_id = b.item_id
					  ".$GLOBALS["Videos"]->filter("v.")."
					  AND b.mem_id=".$mem_id." ORDER BY v.posted DESC LIMIT 0,9";
	}
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$cards = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$cards[] = $card;
	}
	$favorites["cards"] = $cards;
	
	return $favorites;
	
}

function channel_subscribers( $mem_id ) {
	
	$subscribers = array();
	
	//total
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'";
	$subscribers["total"] = $GLOBALS["DB"]->single( $sql_query );
	
	$subscribers["pages"] = handle_roundpages( 0, $subscribers["total"] );
	
	//subscribers
	$sql_query = "SELECT mem_id FROM subscriptions WHERE sub_id=".$mem_id." AND type='channel'
				  ORDER BY id DESC LIMIT 0,4";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$subscribers["cards"][] = $card;
	}
	
	return $subscribers;
	
}

function channel_friends( $mem_id ) {
	
	$friends = array();
	
	$cache = $GLOBALS["Network"]->get_cache( $mem_id );
	
	//total
	$friends["total"] = $cache["friends_count"];
	
	//pages
	$friends["pages"] = handle_roundpages( 0, $friends["total"] );

	//friends
	$sql_query = "SELECT mem_id FROM network WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] )."
				  ORDER BY mem_id DESC LIMIT 0,4";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"] );
		$friends["cards"][] = $card;
	}
	
	return $friends;
	
}

function channel_comments( $mem_id ) {
	
	$comments = array();
	$info = $GLOBALS["Member"]->info();
	
	//total
	$sql_query = "SELECT COUNT(*) FROM channel_comments WHERE mem_id=".$mem_id;
	$comments["total"] = $GLOBALS["DB"]->single( $sql_query );
	
	$username = $GLOBALS["Member"]->username( $mem_id );
	
	$comments["pages"] = handle_multipages( 0, $comments["total"], "CH_AjaxRequest( 'ajax.php?module=channels&section=comments&u=".$username."&p=|p|', 'commentsBoxHandler', 'no' )", 5 );
	
	//comments
	$sql_query = "SELECT * FROM channel_comments WHERE mem_id=".$mem_id." ORDER BY posted DESC LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	foreach($result as $res) {
		$card = array();
		$card["com_id"] = $res["com_id"];
		$card["from"] = $GLOBALS["Member"]->card( $res["from"] );
		$card["comment"] = nl2br( $res["comment"] );
		$card["posted"] = extract_date( $res["posted"] );
		if($info["mem_id"] == $mem_id || $res["from"] == $info["mem_id"])
			$card["delete"] = 1;
		$comments["cards"][] = $card;
	}
	
	return $comments;
	
}

function channel_parse_url( $url ) {
	$host = parse_url( $url );
	parse_str( $host["query"], $data );
	return $data["vid_id"];
}

function channel_share() {
	
	$info = auth_member();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("share_channel");	
	$values["to"] = handle_empties(explode(",",$values["to"]));
	
	if(count($values["to"]) == 0) {
		build_error(15,$values["err_page"],$values["err_section"]);
	}
		
	foreach($values["to"] as $contact) {
		$contact = trim($contact);
		handle_share( $info["mem_id"], $contact, $values["subject"], $values["message"], "channel", $values["u"] );
	}
	
	load_page ("popup.php?page=".$values["err_page"]."&section=".$values["err_section"]."&cmp_id=27&u=".$values["u"]);
	
}

function channel_ignore() {
	
	$info   = auth_member();
	$u      = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $u );
	
	$sql_query="SELECT count(ign_id)
				FROM ignores
				WHERE mem_id=".$info["mem_id"]."
				AND per_id=".$mem_id;
	
	$is_ignored = $GLOBALS["DB"]->single($sql_query);
	
	if($is_ignored){
		$sql_query="DELETE FROM ignores
					WHERE mem_id=".$info["mem_id"]."
					AND per_id=".$mem_id;
		
		$GLOBALS["DB"]->execute($sql_query);
	}//if
	else{
		$sql_query="INSERT INTO ignores
					(mem_id,per_id)
					VALUES (".$info["mem_id"].",".$mem_id.")";
		
		$GLOBALS["DB"]->execute($sql_query);		
	}//else
	
	$redirect = $GLOBALS["Get"]->referer();
	if(empty($redirect))
		$redirect = "index.php?page=ignores";
	
	load_page($redirect);
	
}

function channel_unignore() {
	
	$info = auth_member();
	
	$mem_id = $GLOBALS["Get"]->val("mem_id");
	
	if(is_array($mem_id) && count($mem_id)) {
		foreach($mem_id as $mem) {
			$sql_query="DELETE FROM ignores
						WHERE mem_id=".$info["mem_id"]."
						AND per_id=".$mem;
		
			$GLOBALS["DB"]->execute($sql_query);
		}
	}
	
	load_page( $GLOBALS["Get"]->referer() );
	
}

function channel_friend() {
	
	$info   = auth_member();
	$u      = $GLOBALS["Get"]->val("u");
	$mem_id = $GLOBALS["Member"]->mem_id( $u );
	
	$are_friends = $GLOBALS["Network"]->is_trusted( $info["mem_id"], $mem_id, 1 );
	if($are_friends) {
		$GLOBALS["Network"]->remove_friend($info["mem_id"],$mem_id);
		load_page( build_channel_link( $u, 1 )."cmp_id=5" );
	} else {
		include_once(DOC_ROOT."/classes/Mail.class.php");
		
		$sql_query = "SELECT COUNT(*) FROM mailbox WHERE mailbox='invites' AND per_id=".$mem_id."
					  AND mem_id=".$info["mem_id"];
		$invited = $GLOBALS["DB"]->single( $sql_query );
		if($invited) {
			channel_add_friend( $info["mem_id"], $mem_id );
			$cmp_id = 3;	
		} else {
			$GLOBALS["Mail"]->details = array (
				"mes_id" => 106,
				"recipient" => $mem_id,
				"sender" => $info["mem_id"],
				"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
				"mailbox" => "invites"
			);
			$GLOBALS["Mail"]->send_internal();
			$cmp_id = 7;
		}
		load_page( build_channel_link( $u, 1 )."cmp_id=".$cmp_id );
	}
	
}

function channel_add_friend( $mem_id, $per_id ) {
	
	include_once(DOC_ROOT."/classes/Mail.class.php");
	
	$GLOBALS["Network"]->add_friend( $mem_id, $per_id );
			
	$sql_query = "DELETE FROM mailbox WHERE mailbox='invites' AND (per_id=".$per_id."
				  AND mem_id=".$mem_id.") OR (mem_id=".$per_id."
				  AND per_id=".$mem_id.")";
	$GLOBALS["DB"]->execute( $sql_query );
	
	$GLOBALS["Mail"]->details = array (
		"mes_id" => 100,
		"recipient" => $per_id,
		"sender" => $mem_id,
		"member_name" => $GLOBALS["Member"]->username($mem_id)
	);
	$GLOBALS["Mail"]->send_internal();

	//building email message
	$mail_details = array (
		"mes_id"    => 5,
		"recipient" => $per_id
	);

	$GLOBALS["Mail"]->details = $mail_details;
	$GLOBALS["Mail"]->send_external();
	//email sent
	
	return true;
	
}

function channel_friend_decline( $mem_id, $per_id ) {
	
	include_once(DOC_ROOT."/classes/Mail.class.php");
			
	$sql_query = "DELETE FROM mailbox WHERE mailbox='invites' AND (per_id=".$per_id."
				  AND mem_id=".$mem_id.") OR (mem_id=".$per_id."
				  AND per_id=".$mem_id.")";
	$GLOBALS["DB"]->execute( $sql_query );
	
	$GLOBALS["Mail"]->details = array (
		"mes_id" => 101,
		"recipient" => $per_id,
		"sender" => $mem_id,
		"member_name" => $GLOBALS["Member"]->username($mem_id)
	);
	$GLOBALS["Mail"]->send_internal();

	//building email message
	$mail_details = array (
		"mes_id"    => 5,
		"recipient" => $per_id
	);

	$GLOBALS["Mail"]->details = $mail_details;
	$GLOBALS["Mail"]->send_external();
	//email sent
	
	return true;
	
}

function channel_add_comment() {
	
	$info = auth_member();
	
	include(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input( "channel_comment" );
	
	$u = $values["u"];
	$mem_id = $GLOBALS["Member"]->mem_id( $u );
	
	if($mem_id) {
		
		if(!auth_channel_comment( $mem_id ))
			load_page( build_channel_link( $u, 1 )."err_id=46" );
			
		$sql_query = "INSERT INTO channel_comments (mem_id, `from`, comment, posted)
					  VALUES (:mem_id:,:from:,':comment:',:time:)";
		$GLOBALS["DB"]->values = array(
			"mem_id" => $mem_id,
			"from" => $info["mem_id"],
			"comment" => $values["comment"],
			"time" => time()
		);
		$GLOBALS["DB"]->execute( $sql_query );
		
		load_page( build_channel_link( $u, 1 )."com_id=31" );
		
	}
	
}

function channel_add_bulletin() {
	
	$info = auth_member();
	
	include(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input( "channel_bulletin" );
	
	if(!$values["video"])
		$values["video"] = 0;
	
	$sql_query = "INSERT INTO bulletins (`from`, subject, message, posted, video)
				  VALUES (:from:,':subject:',':message:',:time:,:video:)";
	$GLOBALS["DB"]->values = array (
		"from" => $info["mem_id"],
		"subject" => $values["subject"],
		"message" => $values["message"],
		"time" => time(),
		"video" => $values["video"]
	);
	$GLOBALS["DB"]->execute( $sql_query );
	
	load_page( build_channel_link( $info["username"], 1 )."com_id=32" );
	
}

function channels_browse() {
	
	$info = $GLOBALS["Member"]->info();
	
	$type = $GLOBALS["Get"]->val("type");
	$t = $GLOBALS["Get"]->type_val("t","integer");
	$p = $GLOBALS["Get"]->type_val("p","integer");
	
	if($t) {
		$add = " AND c.type = ".$t;
	}
	
	$sql_query = "SELECT COUNT(*) FROM channels AS c WHERE 1".$add;
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	switch($type) {	
		case 'subscribed':
			$main_query = "SELECT c.mem_id, COUNT(*) AS ord FROM channels AS c LEFT JOIN subscriptions AS s
						   ON (c.mem_id = s.sub_id AND s.type = 'channel') WHERE 1 ".$add."
						   GROUP BY c.mem_id ORDER BY ord DESC";
			break;
		case 'viewed':
		default:
			$main_query = "SELECT c.mem_id, SUM(v.viewed) AS ord FROM channels AS c LEFT JOIN videos AS v
						   ON c.mem_id = v.mem_id WHERE 1 ".$add."
						   GROUP BY c.mem_id ORDER BY ord DESC";
			break;
	}
	
	$link = "index.php?page=channels_browse&type=".$type."&t=".$t;
	$pages = handle_multipages( $p, $total, $link );
	
	$main_query.= " LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $main_query );
	
	$channels = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"], 1 );
		$sql_query = "SELECT * FROM channels WHERE mem_id=".$res["mem_id"];
		$channel = $GLOBALS["DB"]->row( $sql_query );
		$card["type"] = extract_option( "channeltype", $channel["type"] );
		$card["video_views"] = handle_num_format( $GLOBALS["DB"]->single( "SELECT SUM(viewed) FROM videos WHERE mem_id=".$res["mem_id"] ) );
		$card["description"] = nl2br( handle_string_cut( $channel["description"] ) );
		$channels[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("channels", $channels);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function channels_browse_data() {
	
	$type = $GLOBALS["Get"]->val("type");
	
	$data["t"] = $GLOBALS["Get"]->type_val("t","integer");
	$data["display"] = $GLOBALS["Get"]->cookie("display");
	
	if(!$data["display"])
		$data["display"] = "basic";
	
	$cat = array();
	$cat["name"] = $GLOBALS["language"]["all"];
	$cat["id"] = 0;
	$cat["link"] = "index.php?page=channels_browse&type=".$type;
	
	$data["categories"][] = $cat;
	
	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/options/channeltype.inc.php");
	$cats = $options;
	
	foreach($cats as $k => $v) {
		
		$cat = array();
		$cat["name"] = $v;
		$cat["id"] = $k;
		$cat["link"] = "index.php?page=channels_browse&type=".$type."&t=".$k;
		$data["categories"][] = $cat;			
		
	}
	
	$GLOBALS["smarty"]->assign("data", $data);
	
}

function membership() {
	
	$info = $GLOBALS["Member"]->info();

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");

	if($getpaid["enabled"]){
		$sql_query = "SELECT membership,access_end FROM members WHERE mem_id=".$info["mem_id"];
		$membership = $GLOBALS["DB"]->row($sql_query);
		$my_membership["enabled"] = 1;
		$my_membership["level"] = $getpaid["membership"][$membership["membership"]]["name"];
		if(!$membership["access_end"]){
			$my_membership["access_end"] = $GLOBALS["language"]["unlimited"];
		}//if
		else{
			$my_membership["access_end"] = extract_date($membership["access_end"]);
		}//else
	}//if
	else
		$my_membership["enabled"] = 0;

	$GLOBALS["smarty"]->assign("my_membership",$my_membership);
	
}

function cancel_membership(){
	
	$info = auth_member();
	
	$sql_query = "UPDATE members SET membership='0',access_end=0
				  WHERE mem_id=".$info["mem_id"];
	$GLOBALS["DB"]->execute($sql_query);
	
	include(DOC_ROOT."/modules/upgrade.php");
	cancel_membership_subscription($info["mem_id"]);
	
	exit;
	
}//cancel_membership

function billing(){

	$info = $GLOBALS["Member"]->info();

	$sql_query = "SELECT COUNT(*) FROM billing WHERE mem_id=".$info["mem_id"];

	$total = $GLOBALS["DB"]->single($sql_query);

	$p = $GLOBALS["Get"]->type_val("p","integer");

	$pages = handle_multipages($p,$total,"index.php?page=billing");

	$sql_query = "SELECT * FROM billing WHERE mem_id=".$info["mem_id"]."
				  ORDER BY `date` DESC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];

	$result = $GLOBALS["DB"]->result($sql_query);

	foreach($result as $res){
		$card = array();
		$card["name"] = $res["name"];
		$card["cost"] = extract_option("currencies",$res["currency"]).$res["amount"];
		$card["date"] = extract_date($res["date"]);
		$billing[] = $card;
	}//foreach

	$GLOBALS["smarty"]->assign("billing",$billing);
	$GLOBALS["smarty"]->assign("billing_pages",$pages);

}

function channel_delete_comment() {
	
	$info = auth_member();
	
	$com_id = $GLOBALS["Get"]->type_val("com_id","integer");
	
	$sql_query = "SELECT * FROM channel_comments WHERE com_id=".$com_id;
	$comment = $GLOBALS["DB"]->row( $sql_query );
	
	if($info["mem_id"] == $comment["from"] || $info["mem_id"] == $comment["mem_id"]) {
		include(DOC_ROOT."/functions/delete_functions.php");
		delete_channel_comment( $com_id );
	}
	
	load_page( build_channel_link_by_id($comment["mem_id"]) );
	
}

function ignores() {
	
	$info = $GLOBALS["Member"]->info();	
	
	$sql_query = "SELECT COUNT(*) FROM ignores WHERE mem_id=".$info["mem_id"];
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$link = "index.php?page=ignores";
	
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT per_id FROM ignores WHERE mem_id=".$info["mem_id"]."
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$ignores = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["per_id"] );
		$ignores[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("ignores", $ignores);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

?>