<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");
						if(!$action)
							$action = $GLOBALS["Get"]->val("act");

							switch($action){
									
								case 'create':
									playlist_create();
									break;
									
								case 'update':
									playlist_update();
									break;
									
								case 'delete':
									playlist_delete();
									break;
									
								case 'arrange':
									playlist_arrange();
									break;
									
								case 'vid_delete';
									playlist_delete_video();
									break;
									
								case 'share':
									playlist_share();
									break;
									
								case 'play':
									playlist_play();
									break;
									
								case 'subscribe':
									playlist_subscribe();
									break;

							}//switch

						///////////////////////////////////////

function playlist_card( $pla_id ){
	
	$member = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT * FROM playlists WHERE pla_id=".$pla_id;
	$info = $GLOBALS["DB"]->row( $sql_query );
	
	$card = array();
	$card["pla_id"] = $pla_id;
	$card["title"]  = $info["title"];
	$card["title_cut"]  = $GLOBALS["Member"]->crop($info["title"]);
	$card["description"]     = nl2br( handle_string_cut( $info["description"], 500 ) );
	
	$sql_query = "SELECT COUNT(*) FROM playlist_videos WHERE pla_id=".$pla_id;	
	$card["videos"] = $GLOBALS["DB"]->single( $sql_query );
	
	$sql_query = "SELECT vid_id FROM playlist_videos WHERE pla_id=".$pla_id." AND main='1'";
	$main = $GLOBALS["DB"]->single( $sql_query );
	
	if($main)
		$card["shash"] = $GLOBALS["Videos"]->screenshot( $main );
	
	$card["owner"] = ( $member["mem_id"] == $info["mem_id"] ) ? 1 : 0;
	if($card["owner"]) {
		$card["edit"] = "index.php?page=playlists&section=edit&pla_id=".$pla_id;
		$card["modify"] = "index.php?page=playlists&section=modify&pla_id=".$pla_id;
		$card["delete"] = "index.php?handler=playlists&action=delete&pla_id=".$pla_id;
	}
	
	$card["link"] = $card["view"] = "index.php?page=playlists&section=view&pla_id=".$pla_id;
	$card["play"] = "index.php?handler=playlists&action=play&pla_id=".$pla_id;
	$card["subscribe"] = "index.php?handler=playlists&action=subscribe&pla_id=".$pla_id;
	
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE mem_id=".$member["mem_id"]." AND sub_id=".$pla_id." AND type='playlist'";
	$card["subscribed"] = $GLOBALS["DB"]->single( $sql_query );
	
	$card["url"]   = URL."/index.php?page=playlists&section=view&pla_id=".$pla_id;
	$card["embed"] = '<object width="420" height="345"><param name="movie" value="'.URL.'/swf/player.swf"></param><param name="allowFullScreen" value="true"></param><param name="flashvars" value="pla_id='.$pla_id.'&MainURL='.urlencode( URL ).'&em=1"><embed src="'.URL.'/swf/player.swf" flashvars="pla_id='.$pla_id.'&MainURL='.urlencode( URL ).'&em=1" type="application/x-shockwave-flash" allowScriptAccess="always" width="420" height="345" allowFullScreen="true"></embed></object>';
	
	$card["embedding"] = $info["embedding"];
	
	return $card;
}
						
function my_playlists(){

	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT COUNT(*) FROM playlists WHERE mem_id=".$info["mem_id"];
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	$link  = "index.php?page=playlists";
	$pages = handle_multipages($p,$total,$link);

	$sql_query = "SELECT pla_id FROM playlists WHERE mem_id=".$info["mem_id"]."
				  ORDER BY created DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$playlists = array();
	foreach($result as $res){
		$card = playlist_card($res["pla_id"]);
		$playlists[] = $card;
	}//foreach

	$GLOBALS["smarty"]->assign("playlists",$playlists);
	$GLOBALS["smarty"]->assign("pages",$pages);

}

function playlist_create() {
	
	$info = auth_member();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input( "playlist_create" );
	
	$sql_query = "INSERT INTO playlists (mem_id,title,description,tags,privacy,embedding,created)
				  VALUES (:mem_id:,':title:',':description:',':tags:',':privacy:',':embedding:',:time:)";
	$values["mem_id"] = $info["mem_id"];
	$tags = explode(" ", $values["tags"]);
	$tags = handle_empties( $tags );
	$values["tags"] = "|".implode("|", $tags)."|";
	$values["time"] = time();
	
	$GLOBALS["DB"]->values = $values;
	$pla_id = $GLOBALS["DB"]->insert( $sql_query );
	
	if($values["vid_id"]) {
		if( auth_video_access_ajax( $values["vid_id"] ) ) {
			$GLOBALS["Videos"]->add_to_playlist( $values["vid_id"], $pla_id );
		}
	}
	
	load_page( "index.php?page=playlists&section=modify&pla_id=".$pla_id );
	
}

function playlist_update(){
	$info = auth_member();
	auth_playlist_edit_access();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input("playlist_edit");

	$vals = $values;
	$vals["mem_id"] = $info["mem_id"];
	$tags = explode(" ", $vals["tags"]);
	$tags = handle_empties( $tags );
	$vals["tags"] = "|".implode("|", $tags)."|";

	load_db_update( "playlist_edit", $vals, array("pla_id", $values["pla_id"]) );

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	load_page("index.php?page=playlists&section=edit&pla_id=".$values["pla_id"]."&ret_link=".urlencode($ret_link));
}

function playlist_delete() {
	
	$info = auth_member();
	auth_playlist_edit_access();

	$del2 = $GLOBALS["Get"]->val("del2");

	if(!$del2){
		$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");

		$sql_query = "SELECT title FROM playlists WHERE pla_id=".$pla_id;
		$name = $GLOBALS["DB"]->single($sql_query);

		$GLOBALS["forms"]["delete"]["values"]["ret_link"] = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
		$GLOBALS["forms"]["delete"]["values"]["handler"] = "playlists";
		$GLOBALS["forms"]["delete"]["values"]["action"] = "delete";
		$GLOBALS["forms"]["delete"]["values"]["del2"] = 1;
		$GLOBALS["forms"]["delete"]["values"]["id"] = $pla_id;
		$GLOBALS["smarty"]->assign("item",$name);
		$GLOBALS["smarty"]->assign("link","index.php?page=playlists&section=view&pla_id=".$pla_id);
		$p_details = array(
		"page" => "delete",
		"items_file" => "delete"
		);
		build_page($p_details);
	}//if
	else{
		$pla_id = $GLOBALS["Get"]->type_val("id","integer");
		include_once(DOC_ROOT."/functions/delete_functions.php");
		delete_playlist($pla_id);
	}//else

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);
	
}

function playlist_modify() {
	
	$pla_id = $GLOBALS["Get"]->type_val("pla_id", "integer");
	
	$playlist = playlist_card( $pla_id );
	
	$sql_query = "SELECT COUNT(*) FROM playlist_videos WHERE pla_id=".$pla_id;
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	$p = $GLOBALS["Get"]->type_val("p", "integer");
	
	$pages = handle_multipages( $p, $total, "index.php?page=playlists&section=modify&pla_id=".$pla_id );	
	
	$sql_query = "SELECT vid_id,position FROM playlist_videos WHERE pla_id=".$pla_id." ORDER BY position ASC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = array();
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$card["position"] = $res["position"];
		$card["delete"] = "index.php?handler=playlists&action=vid_delete&pla_id=".$pla_id."&vid_id=".$res["vid_id"];
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign( "playlist", $playlist );
	$GLOBALS["smarty"]->assign( "videos", $videos );
	
}

function playlist_arrange() {
	
	$info = auth_member();
	auth_playlist_edit_access();
	
	$pla_id = $GLOBALS["Get"]->type_val("pla_id", "integer");
	$position = $GLOBALS["Get"]->val("position");
	
	foreach($position as $key => $val) {
		$position[$key] = (int)($val);
	}
	reset($position);
	
	$sql_query = "SELECT vid_id,position FROM playlist_videos WHERE pla_id=".$pla_id." ORDER BY position ASC";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	foreach($result as $res) {
		$vid_id = $res["vid_id"];
		$pos = $res["position"];
		
		if(key_exists( $vid_id, $position ) && $position[$vid_id] != $pos) {
			if($position[$vid_id] > $pos)
				$position[$vid_id]+= 0.1;
			else
				$position[$vid_id]-= 0.1;
		} elseif( !key_exists( $vid_id, $position ) ) {
			$position[$vid_id] = $pos;
		}
	}
	
	asort( $position );

	$newposition = array();
	$i=1;
	foreach( $position as $key => $val ) {
		$newposition[$key] = $i;
		$i++;
	}
	
	foreach($newposition as $key => $val) {
		$sql_query = "UPDATE playlist_videos SET position='".$val."' WHERE vid_id=".$key."
					  AND pla_id=".$pla_id;
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
	load_page( $GLOBALS["Get"]->referer() );
	
}

function playlist_delete_video() {
	
	$info = auth_member();
	auth_playlist_edit_access();
	
	$pla_id = $GLOBALS["Get"]->type_val("pla_id", "integer");
	$vid_id = $GLOBALS["Get"]->type_val("vid_id", "integer");
	
	$sql_query = "SELECT position FROM playlist_videos WHERE pla_id=".$pla_id." AND vid_id=".$vid_id;
	$position  = $GLOBALS["DB"]->single( $sql_query );
	
	$sql_query = "DELETE FROM playlist_videos WHERE pla_id=".$pla_id." AND vid_id=".$vid_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$sql_query = "UPDATE playlist_videos SET position=position-1 WHERE pla_id=".$pla_id."
				  AND position > ".$position;
	$GLOBALS["DB"]->execute( $sql_query );
	
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);
	
}

function playlist_view() {
	
	$info = $GLOBALS["Member"]->info();
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");
	
	$sql_query = "SELECT * FROM playlists WHERE pla_id=".$pla_id;
	$result = $GLOBALS["DB"]->row( $sql_query );
	
	$playlist = array();
	$playlist["pla_id"] = $pla_id;
	$playlist["title"] = $result["title"];
	$playlist["description"] = nl2br( $result["description"] );
	$playlist["from"] = $GLOBALS["Member"]->card( $result["mem_id"] );
	$playlist["url"]   = URL."/index.php?page=playlists&section=view&pla_id=".$pla_id;
	$playlist["embed"] = '<object width="420" height="345"><param name="movie" value="'.URL.'/swf/player.swf"></param><param name="allowFullScreen" value="true"></param><param name="flashvars" value="pla_id='.$pla_id.'&MainURL='.urlencode( URL ).'&em=1"><embed src="'.URL.'/swf/player.swf" flashvars="pla_id='.$pla_id.'&MainURL='.urlencode( URL ).'&em=1" type="application/x-shockwave-flash" allowScriptAccess="always" width="420" height="345" allowFullScreen="true"></embed></object>';
	$playlist["embedding"] = $result["embedding"];
	$playlist["play"] = "index.php?handler=playlists&action=play&pla_id=".$pla_id;
	$playlist["subscribe"] = "index.php?handler=playlists&action=subscribe&pla_id=".$pla_id;
	
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE mem_id=".$info["mem_id"]." AND sub_id=".$pla_id." AND type='playlist'";
	$playlist["subscribed"] = $GLOBALS["DB"]->single( $sql_query );
	
	$sql_query = "SELECT COUNT(*) FROM playlist_videos AS pv, videos AS v WHERE pv.vid_id=v.vid_id AND pv.pla_id=".$pla_id." ".$GLOBALS["Videos"]->filter("v.");
	
	$playlist["videos"] = $total = $GLOBALS["DB"]->single( $sql_query );
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$link = "index.php?page=playlists&section=view&pla_id=".$pla_id;
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT pv.vid_id FROM playlist_videos AS pv, videos AS v WHERE pv.vid_id=v.vid_id AND pv.pla_id=".$pla_id." ".$GLOBALS["Videos"]->filter("v.")."
				  ORDER BY pv.position DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("playlist", $playlist);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function playlist_share() {
	
	$info = auth_member();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("share_playlist");	
	$values["to"] = handle_empties(explode(",",$values["to"]));
	
	if(count($values["to"]) == 0) {
		build_error(15,$values["err_page"],$values["err_section"]);
	}
		
	foreach($values["to"] as $contact) {
		$contact = trim($contact);
		handle_share( $info["mem_id"], $contact, $values["subject"], $values["message"], "playlist", $values["pla_id"] );
	}
	
	load_page ("popup.php?page=".$values["err_page"]."&section=".$values["err_section"]."&cmp_id=30&pla_id=".$values["pla_id"]);
	
}

function playlist_play() {
	
	auth_playlist_access();
	
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");
	
	$sql_query = "SELECT vid_id FROM playlist_videos WHERE pla_id=".$pla_id."
				  ORDER BY position ASC LIMIT 0,1";
	$vid_id = $GLOBALS["DB"]->single( $sql_query );
	
	load_page( "index.php?page=videos&section=view&vid_id=".$vid_id."&pla_id=".$pla_id );
	
}

function playlist_subscribe() {
	
	$info = auth_member();
	auth_playlist_access();
	
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");
	
	$sql_query = "SELECT COUNT(*) FROM subscriptions WHERE sub_id=".$pla_id." AND mem_id=".$info["mem_id"]." AND type='playlist'";
	$exists = $GLOBALS["DB"]->single( $sql_query );
	
	if($exists) {
		$sql_query = "DELETE FROM subscriptions WHERE sub_id=".$pla_id." AND mem_id=".$info["mem_id"]." AND type='playlist'";
	}
	else {
		$sql_query = "INSERT INTO subscriptions (sub_id,mem_id,type) VALUES (".$pla_id.",".$info["mem_id"].",'playlist')";
	}
	
	$GLOBALS["DB"]->execute( $sql_query );
	load_page( URL."/index.php?page=subscriptions" );
	
}

?>