<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////

						admin_validate_section("design",2);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case '':
									composer_console();
									break;
									
								case 'delete':
									composer_delete_page();
									break;
									
								case 'save_template':
									composer_save_template();
									break;
								
								case 'newpage':
									composer_new_page();
									break;
									
								case 'do_newpage':
									composer_create_new_page();
									break;

							}//switch

						///////////////////////////////////////
						
function composer_console(){
	
	admin_validate();
	
	$data["section"] = "design";
	$data["subsection"] = 2;
	$data["title_id"] = "5";
	$data["themes"] = admin_get_themes();
		
	while(list($key,$val) = each($data["themes"])){
		$jscode.= "HS_Pages[\"".$key."\"] = new Array;\n";
		$jscode.= "HS_Pages[\"".$key."\"][\"names\"] = new Array;\n";
		$jscode.= "HS_Pages[\"".$key."\"][\"keys\"] = new Array;\n";
		$pages[$key] = admin_get_pages($key);		
		$c = 0;
		while(list($k,$v) = each($pages[$key])){
			$jscode.= "HS_Pages[\"".$key."\"][\"names\"][".$c."] = \"".ereg_replace('"','\"',$v)."\";\n";
			$jscode.= "HS_Pages[\"".$key."\"][\"keys\"][".$c."] = \"".$k."\";\n";
			$c++;
		}//while
	}//while
	reset($data["themes"]);
	
	$data["javascript"] = '
<script language="JavaScript">
<!--
	var HS_Pages = new Array;
	function HS_InitPages(){
		'.$jscode.'
	}//HS_InitPages
	function HS_PopulatePages(TrackField,DistField){
		var SelTheme = TrackField.options[TrackField.selectedIndex].value;
		for(var i=DistField.options.length-1;i>=0;i--){
			DistField.options[i] = null;
		}//for
		k=0;
		for(var Item in HS_Pages[SelTheme]["names"]){
			var text = HS_Pages[SelTheme]["names"][Item].replace(/&#124;/g,"|");
			DistField.options[k] = new Option(text,HS_Pages[SelTheme]["keys"][Item]);
			k++;
		}//for
	}//HS_PopulatePages
	function HS_SelectPage(PageName){
		var FieldHandler = document.composer_console.page;
		for(k=0;k<FieldHandler.options.length;k++){
			if(FieldHandler.options[k].value == PageName){
				FieldHandler.selectedIndex = k;
				break;
			}//if
		}//for
	}//HS_SelectPage
	function HS_ResizeFrame(FrameHeight,FrameID){
		var FrameHandler = document.getElementById(FrameID);
		if(FrameID == "composer_preview")
			FrameHeight+= 100;
		FrameHandler.style.height = FrameHeight;
	}//HS_ResizeFrame
//-->
</script>
';
	
	$theme = $GLOBALS["Get"]->val("theme");
	$page  = $GLOBALS["Get"]->val("page");
	
	$data["onload"] = "HS_InitPages();HS_PopulatePages(document.composer_console.theme,document.composer_console.page);HS_SelectPage('".$page."')";	
	
	$data["theme"] = $theme;
	$data["page"]  = $page;
	
	$items = explode("_", $page);
	$data["url"] = URL."/index.php?page=".$items[0];
	if($items[1])
		$data["url"].= "&section=".$items[1];
	
	if($theme && $page) {
		$data["template"] = file_get_contents( DOC_ROOT."/themes/".$theme."/templates/source/pages/".$page.".tpl" );
	}
	
	$layout[0] = "composer";
	admin_output( $layout, $data );
	
}//composer_console
						
function composer_new_page(){
	
	admin_validate();
	
	$data["title_id"] = "5";	
	$data["themes"] = admin_get_themes();
	$data["section"] = "design";
	$data["subsection"] = 2;
	
	$theme = $GLOBALS["Get"]->val("theme");
	$name  = $GLOBALS["Get"]->val("name");
	$page  = $GLOBALS["Get"]->val("page");
	
	$data["theme"] = $theme;
	$data["theme_name"] = $data["themes"][$theme];
	$data["name"] = $name;
	$data["page"] = $page;
	
	$layout[0] = "composer_new_page";
	
	admin_output($layout,$data);
	
	exit;
	
}//compsoer_new_page

function composer_create_new_page(){
	
	admin_validate();
	
	$vals = array("theme","page","name");
	
	$values = $GLOBALS["Get"]->arr($vals,1);
	
	$values["page"] = ereg_replace("[^A-Za-z|0-9|_]","_",strtolower($values["page"]));
	$values["page"] = ereg_replace("[_]+","_",$values["page"]);
	
	if(!eregi("^[a-z]",$values["page"])){
		$GLOBALS["aerr_id"] = 32;
		composer_new_page();
	}//if
	if(empty($values["theme"]) || empty($values["page"]) || empty($values["name"])){
		$GLOBALS["aerr_id"] = 10;
		composer_new_page();
	}//if
	
	if(file_exists(DOC_ROOT."/themes/".$values["theme"]."/templates/source/pages/".$values["page"].".tpl")){
		$GLOBALS["aerr_id"] = 31;
		composer_new_page();
	}//if
	
	$page["title"] = $values["name"];
	$page["items_file"] = $values["page"];
	$page["menus"] = array("main","top");
	
	add_new_page($values["theme"],$page);

	load_page("index.php?section=composer&theme=".$values["theme"]."&page=".$values["page"]);
	
}//composer_create_new_page

function composer_save_template(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	$page = $GLOBALS["Get"]->val("page");
	
	$template  = stripslashes(html_entity_decode(hs_ereg_replace("&#124;","|",$GLOBALS["Get"]->val("template"))));
	
	$f = fopen(DOC_ROOT."/themes/".$theme."/templates/source/pages/".$page.".tpl","w");
	fwrite($f,$template);
	fclose($f);
	
	load_page( "index.php?section=composer&theme=".$theme."&page=".$page );
	
}

function composer_delete_page() {
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	$page = $GLOBALS["Get"]->val("page");
	
	delete_page( $theme, $page );
	
	load_page( "index.php?section=composer&theme=".$theme );
	
}

?>