<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						///////////////////////////////////////

						admin_validate_section("manage",13);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case 'avatars':
									manage_avatars();
									break;

								case 'approve':
									approve_avatars();
									break;

								case 'delete':
									delete_avatars();
									break;

								case 'approve_all':
									approve_all_avatars();
									break;

								case 'delete_all':
									delete_all_avatars();
									break;

							}//switch

						///////////////////////////////////////

function manage_avatars(){

	$admin = admin_validate();
	$p = $GLOBALS["Get"]->val("p");

	$data["section"] = "manage";
	$data["subsection"] = 13;
	$data["title_id"] = "32";
	$start = $p*30;

	$ret_link = "index.php?section=manage_avatars&action=avatars&p=".$p;

	$sql_query_total = "SELECT COUNT(*) ";
	$sql_query_result = "SELECT mem_id, avatar ";

	$sql_query="FROM profiles
				WHERE avatar!='' AND avatar_approved='0'
				ORDER BY updated DESC ";

	$total = $GLOBALS["DB"]->single($sql_query_total.$sql_query);

	$sql_query.= "LIMIT ".$start.",30";

	$result = $GLOBALS["DB"]->result($sql_query_result.$sql_query);

	$data["pages"] = handle_multipages($p,$total,"index.php?section=manage_avatars&action=avatars",30);

	$avatars = array();
	foreach($result as $res){
		$avatar["avatar"]   = $res["avatar"];
		$avatar["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
		$avatar["mem_id"]  = $res["mem_id"];
		$avatar["delete"]  = "index.php?section=manage_avatars&action=delete&mem_id=".$res["mem_id"]."&ret_link=".urlencode($ret_link);
		$avatar["approve"] = "index.php?section=manage_avatars&action=approve&mem_id=".$res["mem_id"]."&ret_link=".urlencode($ret_link);
		$avatars[] = $avatar;
	}//foreach

	$data["avatars"] = $avatars;

	$data["link"] = stripslashes(html_entity_decode($ret_link));

	$layout[0] = "avatars_list";
	admin_output($layout,$data);

}//manage_avatars

function approve_avatars(){

	$admin = admin_validate();
	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	if(is_array($mem_id) && count($mem_id)){
		$sql_query = "UPDATE profiles
					  SET avatar_approved='1'
					  WHERE mem_id IN (".implode(",",$mem_id).")";
		$GLOBALS["DB"]->execute($sql_query);
	}//if
	elseif(!empty($mem_id)){
		$sql_query="UPDATE profiles
					SET avatar_approved='1'
					WHERE mem_id=".$mem_id;
		$GLOBALS["DB"]->execute($sql_query);
	}//if

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);
	load_page($ret_link);

}//approve_photo

function delete_avatars(){

	$admin = admin_validate();
	$mem_id = $GLOBALS["Get"]->val("mem_id");
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	include_once(DOC_ROOT."/functions/delete_functions.php");

	if(is_array($mem_id) && count($mem_id)){
		foreach($mem_id as $id){
			delete_avatar($id);
		}//foreach
	}//if
	elseif(!empty($mem_id))
		delete_avatar($mem_id);

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);
	load_page($ret_link);

}//delete_avatars

function approve_all_avatars(){

	$admin = admin_validate();
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	$sql_query="UPDATE profiles
				SET avatar_approved='1'";

	$GLOBALS["DB"]->execute($sql_query);

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);
	load_page($ret_link);

}//approve_all_avatars

function delete_all_avatars(){

	$admin = admin_validate();
	$ret_link = $GLOBALS["Get"]->val("ret_link");

	$sql_query = "SELECT mem_id FROM profiles WHERE avatar_approved='0' AND avatar!=''";
	$result = $GLOBALS["DB"]->result($sql_query);

	include_once(DOC_ROOT."/functions/delete_functions.php");

	foreach($result as $res){
		delete_avatar($res["mem_id"]);
	}//foreach

	$ret_link = html_entity_decode($ret_link);
	$ret_link = stripslashes($ret_link);
	load_page($ret_link);

}//delete_all_avatars

?>