<?php

						/*************************************\
						
						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com
						
						\*************************************/

						///////////////////////////////////////

						admin_validate_section("customize",3);
						$action = $GLOBALS["Get"]->val("action");

							switch($action){

								case '':
									profile_questions();
									break;
									
								case 'repos_input_item':
									reposition_input_item();
									break;
									
								case 'repos_output_item':
									reposition_output_item();
									break;
									
								case 'edit_input_item':
									edit_input_item();
									break;
									
								case 'save_input_item':
									save_input_item();
									break;
									
								case 'delete_item':
									delete_item();
									break;
									
								case 'edit_output_item':
									edit_output_item();
									break;
									
								case 'save_output_item':
									save_output_item();
									break;

							}//switch

						///////////////////////////////////////
						
	
function profile_questions(){
	
	admin_validate();
	
	$data["themes"] = admin_get_themes();
	
	$theme = $GLOBALS["Get"]->val("theme");
	if(!$theme)
		$theme = $GLOBALS["THEME"];
	
	$form_name = "account_info";
	$output_name = "profile";
	
	$form_data = form_data($theme,$form_name);
	
	$data["input_items"] = array();
	$data["output_items"] = array();
	$data["form"] = $form_name;
	
	$keys = array_keys($form_data["names"]);
	
	$start = $keys[0];
	$i = count($keys)-1;
	$end = $keys[$i];
	while(list($key,$val) = each($form_data["names"])){		
		$field = form_extract_field($form_data["fields"][$key],$theme);
		$item["label"]     = $form_data["labels"][$key];		
		$item["field"]     = $field["type"];
		$item["edit"]      = "index.php?section=profile_questions&action=edit_input_item&theme=".$theme."&item=".$key;
		$item["delete"]    = "index.php?section=profile_questions&action=delete_item&theme=".$theme."&item=".$key;
		if($key != $start)
			$item["move_up"] = "index.php?section=profile_questions&action=repos_input_item&theme=".$theme."&item=".$key."&direction=up";
		else
			$item["move_up"] = "";
		if($key != $end)
			$item["move_down"] = "index.php?section=profile_questions&action=repos_input_item&theme=".$theme."&item=".$key."&direction=down";
		else
			$item["move_down"] = "";
		$data["input_items"][] = $item;
	}//while
	
	$output_data = output_data($theme,$output_name);
	$keys = array_keys($output_data["names"]);
	
	$start = $keys[0];
	$i = count($keys)-1;
	$end = $keys[$i];
	while(list($key,$val) = each($output_data["names"])){
		$field = output_extract_field($output_data["types"][$key],$theme);
		$item["label"]     = $output_data["labels"][$key];		
		$item["field"]     = $field["type"];
		$item["edit"]      = "index.php?section=profile_questions&action=edit_output_item&theme=".$theme."&item=".$key;
		if($key != $start)
			$item["move_up"] = "index.php?section=profile_questions&action=repos_output_item&theme=".$theme."&item=".$key."&direction=up";
		else
			$item["move_up"] = "";
		if($key != $end)
			$item["move_down"] = "index.php?section=profile_questions&action=repos_output_item&theme=".$theme."&item=".$key."&direction=down";
		else
			$item["move_down"] = "";
		$data["output_items"][] = $item;
	}//while
	
	$data["theme"]   = $theme;
	
	$data["section"] = "customize";
	$data["subsection"] = 3;
	$data["title_id"] = "44";	
	$data["link"] = "index.php?section=profile_questions&theme=".$theme;
	
	$layout[0] = "profile_questions";
	
	admin_output($layout,$data);
	
}

function reposition_input_item(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");	
	$form_name = "account_info";
	$item = $GLOBALS["Get"]->val("item");
	$direction = $GLOBALS["Get"]->val("direction");
	
	include(DOC_ROOT."/themes/".$theme."/forms/".$form_name.".inc.php");
	
	$keys = array_keys($form["names"]);
	$currkey = array_search($item,$keys);
	if($direction == "up")
		$newposition = $keys[$currkey-1];
	elseif($direction == "down")
		$newposition = $keys[$currkey+1];
		
	list($form["labels"][$item],$form["labels"][$newposition]) = array ($form["labels"][$newposition],$form["labels"][$item]);
	list($form["names"][$item],$form["names"][$newposition]) = array ($form["names"][$newposition],$form["names"][$item]);
	list($form["fields"][$item],$form["fields"][$newposition]) = array ($form["fields"][$newposition],$form["fields"][$item]);
	list($form["types"][$item],$form["types"][$newposition]) = array ($form["types"][$newposition],$form["types"][$item]);
	
	save_form_data($theme,$form_name,$form);
	
	load_page($GLOBALS["Get"]->referer());
	
}//reposition_input_item

function reposition_output_item(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	$output_name = "profile";
	$item = $GLOBALS["Get"]->val("item");
	$direction = $GLOBALS["Get"]->val("direction");
	
	include(DOC_ROOT."/themes/".$theme."/system/".$output_name.".inc.php");
		
	$keys = array_keys($output["names"]);
	$currkey = array_search($item,$keys);
	if($direction == "up")
		$newposition = $keys[$currkey-1];
	elseif($direction == "down")
		$newposition = $keys[$currkey+1];
		
	list($output["labels"][$item],$output["labels"][$newposition]) = array ($output["labels"][$newposition],$output["labels"][$item]);
	list($output["names"][$item],$output["names"][$newposition]) = array ($output["names"][$newposition],$output["names"][$item]);
	list($output["types"][$item],$output["types"][$newposition]) = array ($output["types"][$newposition],$output["types"][$item]);
	
	save_output_data($theme,$output_name,$output);
	
	load_page($GLOBALS["Get"]->referer());
	
}//reposition_output_item

function edit_input_item(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	$form_name = "account_info";
	$item = $GLOBALS["Get"]->val("item");
	
	$form_data = form_data($theme,$form_name);
	
	$data["label"] = $form_data["labels"][$item];
	$data["field"] = form_extract_field($form_data["fields"][$item],$theme);
	$data["type"]  = $data["field"]["system_type"];	
	$data["link"]  = "index.php?section=profile_questions&theme=".$theme;
	
	$data["theme"]        = $theme;
	$data["form"]         = $form_name;
	$data["item"]         = $item;
	
	$data["section"]    = "customize";
	$data["subsection"] = 3;
	$data["title_id"]   = "44";
	
	$types = field_types($theme);
	$data["types"] = $types["names"];
	
	$layout[0] = "edit_input_item";
	
	admin_output($layout,$data);
	
}//edit_input_item

function save_input_item(){
	
	admin_validate();
	
	$vals = array("theme","item","label","type","properties");
	$values = $GLOBALS["Get"]->arr($vals,1);
	
	$values["label"] = stripslashes(html_entity_decode($values["label"]));
	$values["form"] = "account_info";
	
	if(!is_array($values["properties"]))
		$values["properties"] = array();
	
	while(list($key,$val) = each($values["properties"])){
		$key = stripslashes(html_entity_decode($key));
		$val = stripslashes(html_entity_decode($val));
		$values["properties"][$key] = $val;
	}//while
	
	include(DOC_ROOT."/themes/".$values["theme"]."/forms/account_info.inc.php");
	
	if(extract_null_value($values["item"])){
		$values["item"] = @max(array_keys($form["names"]))+1;
		$new_item = new_input_item($values["theme"],$values["label"],$values["type"]);
		$form["names"][$values["item"]]  = $new_item["name"];
		$form["fields"][$values["item"]] = $new_item["field"];
		$form["types"][$values["item"]]  = $new_item["type"];
		$form["labels"][$values["item"]] = $new_item["label"];
		$assoc = handle_empties(explode(",",$form["assoc"]["profiles"]));
		$assoc[] = $new_item["name"];
		$form["assoc"]["profiles"] = implode(",",$assoc);
		$output_name = "profile";
		include(DOC_ROOT."/themes/".$values["theme"]."/system/".$output_name.".inc.php");
		$new_key = @max(array_keys($output["names"]))+1;
		$output["labels"][$new_key] = $new_item["label"];
		$output["names"][$new_key]  = $new_item["name"];
		$output["types"][$new_key]  = $new_item["output"];
		$assoc = handle_empties(explode(",",$output["assoc"]["profiles"]));
		$assoc[] = $new_item["name"];
		$output["assoc"]["profiles"] = implode(",",$assoc);
		save_output_data($values["theme"],$output_name,$output);
	}//if	
	
	$form["labels"][$values["item"]] = $values["label"];
	
	$field = explode("|",$form["fields"][$values["item"]]);	
	$field_type = array_shift($field);		
	
	$fields = field_types($values["theme"],$values["properties"]);
	
	if($field_type != $values["type"] || ($field_type == "options" && $values["properties"][2] != $field[2])){				
		$form["fields"][$values["item"]] = $values["type"]."|".$fields["settings"][$values["type"]];
		$form["types"][$values["item"]] = $fields["types"][$values["type"]];
		$sql_query = "ALTER TABLE `profiles` CHANGE `".$form["names"][$values["item"]]."` `".$form["names"][$values["item"]]."` ".$fields["sql"][$values["type"]];
		$GLOBALS["DB"]->execute($sql_query);
	}//if
	
	if($field_type == $values["type"]){
		if(is_array($values["properties"])){
			$new_properties = array_keys($values["properties"]);
			$allkeys = array_merge($new_properties,array_keys($field));
			$settings_end = max($allkeys);
			for($i=0;$i<=$settings_end;$i++){
				if(in_array($i,$new_properties))
					$field[$i] = $values["properties"][$i];
			}//for
			$new_field = $field_type."|".implode("|",$field);
			$form["fields"][$values["item"]] = $new_field;
		}//if
	}//if
	
	save_form_data($values["theme"],$values["form"],$form);	
	
	load_page("index.php?section=profile_questions&action=edit_input_item&theme=".$values["theme"]."&item=".$values["item"]);
	
}//save_input_item

function edit_output_item(){
	
	admin_validate();
	
	$theme = $GLOBALS["Get"]->val("theme");
	$output_name = "profile";
	$item = $GLOBALS["Get"]->val("item");
	
	$output_data = output_data($theme,$output_name);
	
	$data["label"] = $output_data["labels"][$item];
	$data["field"] = output_extract_field($output_data["types"][$item],$theme);
	$data["type"]  = $data["field"]["system_type"];	
	$data["link"]  = "index.php?section=profile_questions&theme=".$theme;
	
	$data["theme"]        = $theme;
	$data["output"]       = $output_name;
	$data["item"]         = $item;
	
	$data["section"]    = "customize";
	$data["subsection"] = 3;
	$data["title_id"]   = "44";
	
	$types = output_types($theme);
	$data["types"] = $types["names"];
	
	$layout[0] = "edit_output_item";
	
	admin_output($layout,$data);
	
}//edit_output_item

function save_output_item(){
	
	admin_validate();
	
	$vals = array("theme","item","label","properties","type");
	$values = $GLOBALS["Get"]->arr($vals,1);
	$values["output"] = "profile";
	
	$output_data   = output_data($values["theme"],$values["output"]);	
	$default_types = output_types($values["theme"],$values["properties"]);
	
	$type = explode("|",$output_data["types"][$values["item"]]);
	$field_type = array_shift($type);	
	
	if(!is_array($values["properties"]))
		$values["properties"] = array();
		
	$values["label"] = stripslashes(html_entity_decode($values["label"]));
	while(list($key,$val) = each($values["properties"])){
		$key = stripslashes(html_entity_decode($key));
		$val = stripslashes(html_entity_decode($val));
		$values["properties"][$key] = $val;
	}//while
	
	if($field_type != $values["type"]){
		$output_data["types"][$values["item"]] = $values["type"]."|".$default_types["settings"][$values["type"]];
	}//if
	else{		
		$output_data["types"][$values["item"]] = $values["type"]."|".implode("|",$values["properties"]);
	}//else
	
	$output_data["labels"][$values["item"]] = $values["label"];

	save_output_data($values["theme"],$values["output"],$output_data);
	
	load_page("index.php?section=profile_questions&action=edit_output_item&theme=".$values["theme"]."&item=".$values["item"]);
	
}//save_output_item

function delete_item($data=0){
	
	admin_validate();
	
	if(!$data){
		$theme = $GLOBALS["Get"]->val("theme");
		$item = $GLOBALS["Get"]->val("item");
		$background = 0;
	}//if
	else{
		$background = 1;
		extract($data);
	}//else
	
	$form_name = "account_info";
	$output_name = "profile";
	
	$form_data = form_data($theme,$form_name);
	$remove_name = $form_data["names"][$item];
		
	unset($form_data["labels"][$item]);
	unset($form_data["fields"][$item]);
	unset($form_data["types"][$item]);
	unset($form_data["names"][$item]);
	
	$assoc = handle_empties(explode(",",$form_data["assoc"]["profiles"]));
	$remove = array_search($remove_name,$assoc);
	if(!extract_null_value($remove))
		unset($assoc[$remove]);

	if(count($assoc))
		$form_data["assoc"]["profiles"] = implode(",",$assoc);
	else
		unset($form_data["assoc"]["profiles"]);
	
	save_form_data($theme,$form_name,$form_data);
	
	$output_data = output_data($theme,$output_name);
	$remove_id = array_search($remove_name,$output_data["names"]);
	if(!extract_null_value($remove_id)){
		unset($output_data["labels"][$remove_id]);
		unset($output_data["names"][$remove_id]);
		unset($output_data["types"][$remove_id]);
	}//if
	
	$assoc = handle_empties(explode(",",$output_data["assoc"]["profiles"]));
	$remove2 = array_search($remove_name,$assoc);
	if(!extract_null_value($remove2))
		unset($assoc[$remove2]);
	$output_data["assoc"]["profiles"] = implode(",",$assoc);
	
	save_output_data($theme,$output_name,$output_data);
	
	if(!$background)
		load_page("index.php?section=profile_questions&theme=".$theme);
	
}//delete_item

function new_input_item($theme,$label,$type){
	
	$sql_query = "SHOW FIELDS FROM profiles";
	$result = $GLOBALS["DB"]->result($sql_query);
	$token_fields = array();
	foreach($result as $res){
		$token_fields[] = $res["Field"];
	}//foreach
	
	$sql_query = "SHOW FIELDS FROM members";
	$result = $GLOBALS["DB"]->result($sql_query);
	foreach($result as $res){
		$token_fields[] = $res["Field"];
	}//foreach
	
	$name = ereg_replace("[^A-Za-z|0-9|_]","_",strtolower($label));
	$name = ereg_replace("[_]+","_",$name);
	if(in_array($name,$token_fields) || !eregi("^[a-z]",$name)){
		mt_srand((double) microtime() * 100000);
		$name = "field_".hs_substr(md5(time().mt_rand(0,1000)),0,10);
	}//if
	
	$fields = field_types($theme);
	
	$item["field"]  = $type."|".$fields["settings"][$type];
	$item["label"]  = $label;
	$item["type"]   = $fields["types"][$type];	
	$item["name"]   = $name;
	$item["output"] = $fields["output"][$type];
	
	$sql_query = "ALTER TABLE `profiles` ADD `".$name."` ".$fields["sql"][$type];
	$GLOBALS["DB"]->execute($sql_query);
	
	return $item;
	
}//new_input_item

function form_data($theme,$form_name){
	
	include(DOC_ROOT."/themes/".$theme."/forms/".$form_name.".inc.php");
	return $form;
	
}//form_data

function save_form_data($theme,$form_name,$form){
	
	$form_str = "<?php\n\n";
	$form_str.= go_through_array("\$form",$form);
	$form_str.= "\n?>";
	
	$form_file = DOC_ROOT."/themes/".$theme."/forms/".$form_name.".inc.php";
	$file_handler = fopen($form_file,"w");
	fwrite($file_handler,$form_str);
	fclose($file_handler);
	
}//save_form_data

function save_output_data($theme,$output_name,$output){
	
	$output_str = "<?php\n\n";
	$output_str.= go_through_array("\$output",$output);
	$output_str.= "\n?>";
	
	$output_file = DOC_ROOT."/themes/".$theme."/system/".$output_name.".inc.php";
	$file_handler = fopen($output_file,"w");
	fwrite($file_handler,$output_str);
	fclose($file_handler);
	
}//save_output_data

function output_data($theme,$output_name){
	
	include(DOC_ROOT."/themes/".$theme."/system/".$output_name.".inc.php");
	return $output;
	
}//output_data

function output_extract_field($field_code,$theme){
	
	$details = explode("|",$field_code);
	$field_type = array_shift($details);
	$field = array();
	
	$field["properties"] = array();
	
	switch($field_type){
		case 'yes_no':
			$field["type"] = "Yes/No single chekbox output";
			$field["properties"]["Yes"] = array("type" => "input", "size" => 10, "name" => "properties[0]", "value" => $details[0]);
			$field["properties"]["No"] = array("type" => "input", "size" => 10, "name" => "properties[1]", "value" => $details[1]);
			break;
		case 'option':
			$field["type"] = "Selected option (dropdown, radio buttons, etc.) output";
			$src_options = admin_get_options($theme);
			$field["properties"]["Options Source"] = array("type" => "select", "options" => $src_options, "name" => "properties[0]", "value" => $details[0], "javascript" => "onChange='this.form.submit()'");
			break;
		case 'set':
			$field["type"] = "Selected options (multiple drodown, checkboxes set) output";
			$src_options = admin_get_options($theme);
			$field["properties"]["Options Source"] = array("type" => "select", "options" => $src_options, "name" => "properties[0]", "value" => $details[0], "javascript" => "onChange='this.form.submit()'");
			break;
		case 'txt_set':
			$field["type"] = "Set of text fields output";
			break;
		case 'txt_url_set':
			$field["type"] = "Set of text fields output converted into external links";
			break;
		case 'link':
			$field["type"] = "Output converted into external link";
			break;
		case 'txt_block':
			$field["type"] = "Text with paragraphs output";
			break;
		case 'text':
			$field["type"] = "Simple text output";			
			break;
		case 'date':
			$field["type"] = "Date output";
			break;
		case 'date_time':
			$field["type"] = "Date &amp; Time output";
			break;
		case 'time':
			$field["type"] = "Time output";
			break;
	}//switch
	
	$field["system_type"] = $field_type;
	return $field;
	
}//output_extract_field

function output_types($theme,$properties=array()){
	
	$options = array_keys(admin_get_options($theme));
	
	if($properies[0] && in_array($properties[0],$options))
		$option = $properties[0];
	else
		$option = $options[0];
		
	$fields["names"] = array(
		"yes_no" => "Yes/No single chekbox output",
		"option" => "Selected option (dropdown, radio buttons, etc.) output",
		"set" => "Selected options (multiple drodown, checkboxes set) output",
		"txt_set" => "Set of text fields output",
		"txt_url_set" => "Set of text fields output converted into external links",
		"link" => "Output converted into external link",
		"txt_block" => "Text with paragraphs output",
		"text" => "Simple text output",
		"date" => "Date output",
		"date_time" => "Date &amp; Time output",
		"time" => "Time output"
	);
	
	$fields["settings"] = array (
		"yes_no" => "Yes|No",
		"option" => $option,
		"set" => $option,
		"txt_set" => "",
		"txt_url_set" => "",
		"link" => "",
		"txt_block" => "",
		"text" => "",
		"date" => "",
		"date_time" => "",
		"time" => ""
	);
	
	return $fields;
	
}//output_types

function field_types($theme,$properties=array()){
	
	$options = array_keys(admin_get_options($theme));
	
	if($properies[0] && in_array($properties[0],$options))
		$option = $properties[0];
	else
		$option = $options[0];
	
	$fields["names"] = array (
		"textfield" => "Text Field",
		"textfield_set" => "Set of Text Fields",		
		"checkbox" => "Checkbox",
		"options" => "Dropdown List",
		"radio" => "Set of Radio Buttons",
		"set" => "Set of Checkboxes",
		"date" => "Date Fields",
		"date_time" => "Date &amp; Time Fields",
		"time" => "Time Fields",
		"textarea" => "Text Box"
	);
	
	$fields["types"] = array (
		"textfield" => "val",
		"textfield_set" => "set",
		"checkbox" => "switch",
		"options" => "val",
		"radio" => "val",
		"set" => "set",
		"date" => "date",
		"date_time" => "date",
		"time" => "time",
		"textarea" => "val"
	);
	
	$fields["settings"] = array (
		"textfield" => "30",
		"textfield_set" => "30|3|1",		
		"checkbox" => "0",
		"options" => $option,
		"radio" => $option,
		"set" => $option,
		"date" => "",
		"date_time" => "",
		"time" => "",
		"textarea" => "6|40"
	);
	
	$fields["sql"] = array (
		"textfield" => "VARCHAR(250) NOT NULL",
		"textfield_set" => "TEXT NOT NULL",
		"checkbox" => "ENUM('0','1') NOT NULL",
		"options" => "INT UNSIGNED NOT NULL",
		"radio" => "TINYINT UNSIGNED NOT NULL",
		"set" => "VARCHAR(250) NOT NULL",
		"date" => "BIGINT UNSIGNED NOT NULL",
		"date_time" => "BIGINT UNSIGNED NOT NULL",
		"time" => "BIGINT UNSIGNED NOT NULL",
		"textarea" => "TEXT NOT NULL"
	);
	
	if($properties[2]){
		$fields["types"]["options"] = "set";
		$fields["sql"]["options"] = "VARCHAR(250) NOT NULL";
	}//if
		
	$fields["output"] = array (
		"textfield" => "text",
		"textfield_set" => "txt_set",
		"checkbox" => "yes_no|Yes|No",
		"options" => "option|".$option,
		"radio" => "option|".$option,
		"set" => "set|".$option,
		"date" => "date",
		"date_time" => "date_time",
		"time" => "time",
		"textarea" => "txt_block"
	);
	
	return $fields;
	
}//field_types

function form_extract_field($field_code,$theme){
	
	$details = explode("|",$field_code);
	$field_type = array_shift($details);
	$field = array();
	
	$field["properties"] = array();
	
	switch($field_type){
		case 'textfield':
			$field["type"] = "Text Field";
			$field["properties"]["Field Length"] = array ("type" => "input", "size" => 10, "name" => "properties[0]", "value" => $details[0]);
			break;
		case 'textfield_set':
			$field["type"] = "Set of Text Fields";
			$field["properties"]["Each Field Length"] = array ( "type" => "input", "size" => "10", "name" => "properties[0]", "value" => $details[0] );
			$field["properties"]["Number of Fields"] = array ( "type" => "input", "size" => "10", "name" => "properties[1]", "value" => $details[1] );
			$options = array(
				"Fields One by One",
				"Multiple Lines"
			);
			$field["properties"]["Output Style"] = array ( "type" => "select", "options" => $options, "name" => "properties[2]", "value" => $details[2] );
			break;
		case 'checkbox':
			$field["type"] = "Checkbox";
			$options = array (
				"No",
				"Yes"
			);
			$field["properties"]["Ticked by Default"] = array ("type" => "select", "options" => $options, "name" => "properties[0]", "value" => $details[0]);
			break;
		case 'options':
			$field["type"] = "Dropdown List";
			$options = array ("No","Yes");
			$field["properties"]["Multiple"] = array ("type" => "select", "options" => $options, "name" => "properties[2]", "value" => $details[2]);
			$src_options = admin_get_options($theme);			
			$field["properties"]["Options Source"] = array("type" => "select", "options" => $src_options, "name" => "properties[0]", "value" => $details[0], "javascript" => "onChange='this.form.submit()'");
			$options = array();
			include(DOC_ROOT."/themes/".$theme."/options/".$details[0].".inc.php");
			$def_options[""] = "Please, select...";
			while(list($key,$val) = each($options)){
				$def_options[$key] = $val;
			}//while
			$field["properties"]["Selected by Default"] = array ("type" => "select", "options" => $def_options, "name" => "properties[1]", "value" => $details[1]);
			$options = array (
				"No",
				"Yes"
			);
			$field["properties"]["Enable Empty Option"] = array ("type" => "select", "options" => $options, "name" => "properties[3]", "value" => $details[3]);
			break;
		case 'radio':
			$field["type"] = "Set of Radio Buttons";
			$options[""] = "Please, select...";
			include(DOC_ROOT."/themes/".$theme."/options/".$details[0].".inc.php");
			$src_options = admin_get_options($theme);
			$field["properties"]["Options Source"] = array("type" => "select", "options" => $src_options, "name" => "properties[0]", "value" => $details[0], "javascript" => "onChange='this.form.submit()'");
			$field["properties"]["Selected by Default"] = array ("type" => "select", "options" => $options, "name" => "properties[1]", "value" => $details[1]);
			$options = array(
				"Fields One by One",
				"Multiple Lines"
			);
			$field["properties"]["Output Style"] = array ( "type" => "select", "options" => $options, "name" => "properties[2]", "value" => $details[2] );
			break;
		case 'set':
			$field["type"] = "Set of Checkboxes";
			$src_options = admin_get_options($theme);
			$field["properties"]["Options Source"] = array("type" => "select", "options" => $src_options, "name" => "properties[0]", "value" => $details[0], "javascript" => "onChange='this.form.submit()'");
			$options = array(
				"Fields One by One",
				"Multiple Lines"
			);
			$field["properties"]["Output Style"] = array ( "type" => "select", "options" => $options, "name" => "properties[1]", "value" => $details[1] );
			break;
		case 'date':
			$field["type"] = "Date Fields";
			$options = array(
				"Date in Past",
				"Date in Future"
			);
			$field["properties"]["Date Type"] = array ( "type" => "select", "options" => $options, "name" => "properties[1]", "value" => $details[1] );
			break;
		case 'date_time':
			$field["type"] = "Date &amp; Time Fields";
			$field["properties"] = array();
			break;
		case 'time':
			$field["type"] = "Time Fields";
			$field["properties"] = array();
			break;
		case 'textarea':
			$field["type"] = "Text Box";
			$field["properties"]["Rows"] = array ("type" => "input", "size" => 10, "name" => "properties[0]", "value" => $details[0]);
			$field["properties"]["Cols"] = array ("type" => "input", "size" => 10, "name" => "properties[1]", "value" => $details[1]);
			break;
	}//switch
	
	$field["system_type"] = $field_type;
	$field["preview"] = build_field($field_type,array("dets" => $details),$theme);
	return $field;
	
}//form_extract_field

?>