<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

class Network extends Member {

	var $cache = array();

	function Network(){

		$this->values = array ();

	}//Network

	function add_friend($id1,$id2){

		set_time_limit(0);

		$cache[$id1] = $this->get_cache($id1);
		$cache[$id2] = $this->get_cache($id2);

		$are_friends = $this->intersect($cache[$id1]["friends"],$id2);

		if(!$are_friends){

			$friendship = array (

				$id1 => $id2,
				$id2 => $id1

			);

			while(list($member,$friend) = each($friendship)){

				$this->cache($member,$friend);

			}//while

		}//if

		return true;

	}//add_friend

	function remove_friend($id1,$id2){

		set_time_limit(0);

		$cache[$id1] = $this->get_cache($id1);
		$cache[$id2] = $this->get_cache($id2);

		$are_friends = $this->intersect($cache[$id1]["friends"],$id2);

		if($are_friends){

			$friendship = array (

				$id1 => $id2,
				$id2 => $id1

			);

			while(list($member,$friend) = each($friendship)){

				$this->cache($member,0,$friend);

			}//while

		}//if

	}//remove_friend

	function system_remove($remove_member){

		set_time_limit(0);

		$cache = $this->get_cache($remove_member);

		$sql_query = "UPDATE network SET `update`='1' WHERE ".$this->extract_hs_query($cache["friends"]);
		$this->execute($sql_query);

	}//system_remove
	
	function friends( $mem_id, $limits = 0 ){
		$cache = $this->get_cache( $mem_id );
		$sql_query = "SELECT mem_id FROM network WHERE ".$this->extract_hs_query($cache["friends"]);
		if($limits)
			$sql_query.= " LIMIT ".$limits[0].",".$limits[1];
		$result = $this->execute( $sql_query );
		$friends = array();
		while($row = mysql_fetch_assoc( $result )) {
			$friends[] = $row["mem_id"];
		}
		return $friends;
	}

	function get_cache($mem_id){

		if(!$mem_id)
			return array();

		if(isset($this->cache["get_cache"][$mem_id]))
			return $this->cache["get_cache"][$mem_id];

		$this->cache_update($mem_id);
		$this->clean();

		$select = "`friends`,`friends_count`,`update`";

		$sql_query = "SELECT ".$select." FROM network WHERE mem_id=".$mem_id;
		$cache = $this->row($sql_query);
		$this->cache["get_cache"][$mem_id] = $cache;

		return $cache;

	}//cache

	function cache($member,$add_friend=0,$remove_friend=0){

		if(!$member)
			return;

		$count[1] = 0;
		$cache[1] = "";

		$sql_query = "SELECT friends FROM network WHERE mem_id=".$member;
		$friends = $this->single($sql_query);
		$sql_query = "SELECT mem_id FROM network WHERE ".$this->extract_hs_query($friends);
		if($add_friend)
			$sql_query.= " OR mem_id = ".$add_friend;
		if($remove_friend)
			$sql_query.= " AND mem_id != ".$remove_friend;
		$sql_query.= " ORDER BY mem_id ASC";
		$result = $this->execute($sql_query);
		$count[1] = mysql_num_rows($result);

		$unique = "";
		$cons = "";
		$consistencies = "";
		$prev = 0;

		$row = 1;

		while($get = mysql_fetch_assoc($result)){
			$id = $get["mem_id"];
			$last = ($row == $count[1]);
			if($prev){
				if($id == $prev+1){
					if(!$cons)
						$cons = $prev;
				}
				else{
					if($cons){
						$consistencies.= $cons."-".$prev.",";
						$cons = "";
					}
					else{
						$unique.= $prev.",";
					}
				}

			}

			if($last){
				if($id == $prev+1)
					$consistencies.= $cons."-".$id.",";
				else
					$unique.= $id.",";
			}
			$prev = $id;
			$row++;
		}//while

		$cache[1] = trim($unique,",")."|".trim($consistencies,",");

		$sql_query = "UPDATE network SET
					  `friends` = '".$cache[1]."',
					  `friends_count` = ".$count[1].",
					  `update`='0'
					  WHERE mem_id=".$member;

		$this->execute($sql_query);

	}//cache

	function cache_update($member){

		if(!$member)
			return;

		if(isset($this->cache["cache_update"][$member]))
			$update = 0;
		else{

			$sql_query = "SELECT `update`
						  FROM network
						  WHERE mem_id=".$member;

			$update = $this->single($sql_query);
			$this->cache["cache_update"][$member] = 1;

		}//else

		if($update){
			set_time_limit(0);
			$this->cache($member);
		}//if

	}//cache_update

	function connection($member=0,$friend=0){

		if(isset($this->cache["connection"][$member."_".$friend]))
			return $this->cache["connection"][$member."_".$friend];
		
		$cache[$member] = $this->get_cache($member);
		
		$connection = $this->intersect($cache[$member]["friends"],$friend);
		$this->cache["connection"][$member."_".$friend] = $connection;
		
		return $connection;

	}//connection

	function amount($mem_id){

		if(!$mem_id)
			return 0;

		if(isset($this->cache["amount"][$mem_id]))
			return $this->cache["amount"][$mem_id];

		//verify cache is up to date
		$this->cache_update($mem_id);

		//prepare information
		$cache = $this->get_cache($mem_id);
		$number = $cache["friends_count"];

		$this->cache["amount"][$mem_id] = $number;

		return $number;

	}//amount

	function is_trusted($member,$person,$level){
		
		if($member == $person)
			return true;

		//prepare information
		$connection = $this->connection($member,$person);

		switch($level){

			case '0':
				return true;
				break;

			case '1':
				return $connection;
				break;

		}//switch

	}//is_trusted

	function extract_hs($hs_code){

		$parts = explode("|",$hs_code);
		$friends = explode(',',$parts[0]);

		$consistencies = explode(',',$parts[1]);
		foreach($consistencies as $consistency){
			$ends = explode("-",$consistency);
			for($i=$ends[0];$i<=$ends[1];$i++){
				$friends[] = $i;
			}//for
		}//foreach

		$friends = handle_empties($friends);
		return $friends;

	}//extract_hs

	function extract_hs_query($code,$table="",$negative=""){

		$parts = explode("|",$code);
		$uniques = $parts[0];
		$consistencies = handle_empties(explode(",",$parts[1]));

		if(!$negative){

			$sql_query = " (0 ";
			if(eregi("[0-9]",$uniques))
				$sql_query.= " OR ".$table."mem_id IN (".$uniques.") ";
			foreach($consistencies as $c){
				$ends = explode("-",$c);
				$sql_query.= " OR (".$table."mem_id >= ".$ends[0]." AND ".$table."mem_id <= ".$ends[1].") ";
			}//foreach
			$sql_query.= ") ";

		}//if
		else{

			$sql_query = " (1 ";
			if(eregi("[0-9]",$uniques))
				$sql_query.= " AND ".$table."mem_id NOT IN (".$uniques.") ";
			foreach($consistencies as $c){
				$ends = explode("-",$c);
				$sql_query.= " AND (".$table."mem_id < ".$ends[0]." OR mem_id > ".$ends[1].") ";
			}//foreach
			$sql_query.= ") ";

		}//else

		return $sql_query;

	}//extract_hs_query

	function intersect($friends_1,$friends_2,$return_type="amount"){

		if($return_type == "amount")
			$sql_query = "SELECT count(mem_id) ";
		elseif($return_type == "array")
			$sql_query = "SELECT mem_id ";

		$sql_query.= " FROM network WHERE ".$this->extract_hs_query($friends_1)." AND ".$this->extract_hs_query($friends_2);
		
		if($return_type == "amount"){
			return $this->single($sql_query);
		}//if
		elseif($return_type == "array"){
			$result = $this->result($sql_query);
			$retarr = array();
			foreach($result as $res){
				$retarr[] = $res["mem_id"];
			}//foreach
			return $retarr;
		}//elseif

	}//intersect

}//Network class

$Network = new Network;

?>