<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

function admin_load_section(){

	$section = handle_non_alpha($GLOBALS["Get"]->val("section"));
	$section = (empty($section)) ? "login" : $section;

	build_language();

	if(file_exists(DOC_ROOT."/administrator/sections/".$section.".php"))
		include(DOC_ROOT."/administrator/sections/".$section.".php");
	else
		load_page("index.php");

}//admin_load_section

function admin_output($layout,$data){

	$theme = $GLOBALS["Get"]->val("theme");

	$encoding = extract_encoding("html",$theme);

	if(substr_count($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')){
		ob_start('ob_gzhandler');
		Header("Content-Encoding: gzip");
	}//if
	else
		ob_start();

	Header("Content-Type: text/html; charset=".$encoding);
	Header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    Header("Cache-Control: no-cache, must-revalidate");
	Header("Pragma: no-cache");

	$error = admin_check_error();
	$sess_id = $GLOBALS["Get"]->cookie("sess_id");

	if($GLOBALS["moderator"]){
		$path = "../administrator/";
		$logo = "moderator_console.gif";
	}//if
	else{
		$path = "./";
		$logo = "admin_console.gif";
	}//if

	$title = admin_title($data["title_id"]);

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $encoding; ?>">
<title><?php echo $title; ?></title>
<link rel="stylesheet" type="text/css" href="<?php echo $path; ?>gfx/style.css">
<script language="JavaScript">
<!--
	function HS_FocusOnError(){
		ErrorArea = document.getElementById('error_area');
		if(ErrorArea)
			ErrorArea.focus();
	}//HS_FocusOnError
	function HS_TickAll(SetName,FormHandler){
		FormElements = FormHandler.elements;
		TickTracker = FormHandler.tick_tracker.checked;
		for(i=0;i<FormElements.length;i++){
			FElement = FormHandler.elements[i];
			if( (FElement.type == "checkbox") && (FElement.name == SetName || FElement.name.indexOf(SetName) != -1) ){
				if(TickTracker)
					FElement.checked = true;
				else
					FElement.checked = false;
			}//if
		}//for
	}//HS_TickAll
	function HS_Popup (URL, PARAMS){
   		HSwin = window.open(URL, "POPUP", PARAMS);
   		HSwin.focus();
	}//HS_Popup
//-->
</script>
<?php echo $data["javascript"]; ?>
</head>
<body bgcolor="#E5E5E5" leftmargin="0" topmargin="0" rightmargin="0" onLoad="<?php echo $data["onload"]; ?>;HS_FocusOnError();">
<table width="804" border="0" cellspacing="0" cellpadding="0" height="100%" align="center">
<tr><td class="maincell">
<table width="802" border="0" cellspacing="0" cellpadding="0" height="100%">
<tr>
<td height="67">
<table width="802" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td><?php admin_output_image($logo); ?></td>
    <td><?php admin_output_image("header_bcg.gif"); ?></td>
    <td><?php admin_output_image("chlogo.gif", URL, 0, "", 1); ?></td>
  </tr>
</table>
</td>
</tr>
<tr><td height="2" class="header_line"><?php admin_output_image("spacer.gif"); ?></td></tr>
<?php if($sess_id){ ?>
<tr><td class="menu" valign="top"><?php admin_menu($data["section"]); ?></td></tr>
<?php } ?>
<tr>
<td height="100%">
<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td bgcolor="#FFFFFF" valign="top">
    	<table width="100%" border="0" cellspacing="0" cellpadding="0">
    		<?php if($error): ?>
    			<tr>
    				<td>
    					<table width="100%" cellpadding="0" cellspacing="0" border="0">
    						<tr>
    							<td class="error" align="center" width="50"><?php admin_output_image("error_sign.gif"); ?></td>
    							<td class="error"><?php echo $error; ?></td>
    						</tr>
    					</table>
    				</td>
    			</tr>
    		<?php endif; ?>
    		<?php foreach($layout as $tpl){ ?>
    		<tr><td class="mainbody"><?php include(DOC_ROOT."/administrator/templates/".$tpl.".inc.php"); ?></td></tr>
    		<?php } ?>
    	</table>
    </td>
    <?php if($data["section"] && !$data["hide_submenu"]){ ?>
    <td class="submenu" width="168" valign="top"><?php admin_submenu($data["section"],$data["subsection"]); ?></td>
    <?php } ?>
  </tr>
</table>
</td>
</tr>
</table>
</td>
</tr>
</table>
</body>
</html>
<?php

}//admin_output

function admin_title($title_id){

	include(DOC_ROOT."/administrator/includes/titles.inc.php");

	if($GLOBALS["moderator"])
		return $moderator.$titles[$title_id];
	else
		return $admin.$titles[$title_id];

}//admin_title

function admin_menu($section){

	$info = $GLOBALS["Member"]->info();
	$access = array();

	include(DOC_ROOT."/administrator/includes/admin_menu.inc.php");

	$links = array();

	if($info["member_type"] == "m"){
		$sql_query = "SELECT access FROM moderators WHERE mem_id=".$info["mem_id"];
		$access_code = $GLOBALS["DB"]->single($sql_query);
		$access_sections = explode("|",$access_code);
		foreach($access_sections as $access_section){
			$dets = explode("_",$access_section);
			$access[$dets[0]] = 1;
			if(!$links[$dets[0]] || $links[$dets[0]] > $dets[1])
				$links[$dets[0]] = $dets[1];
		}//foreach
	}//if
	elseif($info["member_type"] == "a"){
		while(list($key,$val) = each($menu)){
			$access[$key] = 1;
			$links[$key] = min( array_keys($submenulinks[$key]) );
		}//while
		reset($menu);
	}//elseif

	$access["logout"] = 1;
	$links["logout"]  = 1;

	?><table cellpadding="0" cellspacing="2" border="0"><tr><?php
	while(list($key,$val) = each($menu)){
		if(!$access[$key]){
			$but = $val["disabled"];
		}//if
		elseif($key == $section)
			$but = $val["on"];
		else
			$but = $val["off"];
		?><td><?php admin_output_image("buttons/".$but, $submenulinks[$key][$links[$key]]); ?></td><?php
	}//while
	?></tr></table><?php

}//admin_menu

function admin_submenu($section,$subsection){

	$info = $GLOBALS["Member"]->info();
	$access = array();

	include(DOC_ROOT."/administrator/includes/admin_menu.inc.php");

	if($info["member_type"] == "m"){
		$sql_query = "SELECT access FROM moderators WHERE mem_id=".$info["mem_id"];
		$access_code = $GLOBALS["DB"]->single($sql_query);
		$access_sections = explode("|",$access_code);
		foreach($access_sections as $access_section){
			$dets = explode("_",$access_section);
			if($dets[0] == $section)
				$access[$dets[1]] = 1;
		}//foreach
	}//if
	elseif($info["member_type"] == "a"){
		while(list($key,$val) = each($submenu[$section])){
			$access[$key] = 1;
		}//while
		reset($submenu[$section]);
	}//elseif

	?><table cellpadding="0" cellspacing="2" border="0" width="100%"><?php
	while(list($key,$val) = each($submenu[$section])){
		if($key == $subsection && $access[$key]){
			?><tr><td class="item_on"><a href="<?php echo $submenulinks[$section][$key]; ?>" <?php echo ($linkstarget[$section][$key]) ? "target=\"".$linkstarget[$section][$key]."\"" : ""; ?>><?php echo $val; ?></a></td></tr><?php
		}//if
		elseif($access[$key]){
			?><tr><td class="item_off" onMouseOver="this.className='item_hover'" onMouseOut="this.className='item_off'"><a href="<?php echo $submenulinks[$section][$key]; ?>" <?php echo ($linkstarget[$section][$key]) ? "target=\"".$linkstarget[$section][$key]."\"" : ""; ?>><?php echo $val; ?></a></td></tr><?php
		}//else
	}//while
	?></table><?php

}//admin_submenu

function admin_popup_output($layout,$data){

	$encoding = extract_encoding("html");

	if(substr_count($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')){
		ob_start('ob_gzhandler');
		Header("Content-Encoding: gzip");
	}//if
	else
		ob_start();

	Header("Content-Type: text/html; charset=".$encoding);
	Header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    Header("Cache-Control: no-cache, must-revalidate");
	Header("Pragma: no-cache");

	$error = admin_check_error();

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $encoding; ?>">
<title><?php echo $data["title"]; ?></title>
<link rel="stylesheet" type="text/css" href="gfx/style.css">
<script src="../jscript/AC_RunActiveContent.js" type="text/javascript"></script>
<script src="../jscript/AC_ActiveX.js" type="text/javascript"></script>
<?php echo $data["javascript"]; ?>
</head>
<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" rightmargin="0" onLoad="<?php echo $data["onload"]; ?>">
    <table width="100%" border="0" cellspacing="0" cellpadding="0">
    	<?php if($error): ?>
    		<tr>
    			<td class="error-cell">
    				<table width="100%" cellpadding="0" cellspacing="0" border="0" id="error_area">
    					<tr>
    						<td align="center" width="50"><?php admin_output_image("icons/stop_sign.gif"); ?></td>
    						<td class="error"><?php echo $error; ?></td>
    					</tr>
    				</table>
    			</td>
    		</tr>
    	<?php endif; ?>
    	<tr><td><?php
    	foreach($layout as $template){
    		include(DOC_ROOT."/administrator/templates/".$template.".inc.php");
    	}//foreach
    	?></td></tr>
    </table>
</body>
</html>
<?php

}//admin_popup_output

function admin_output_image($file,$link=0,$path=0,$alt="",$new_window=0,$print=1){

	if($path){
		$file_path = DOC_ROOT."/".$path."/".$file;
		$url_path  = URL."/".$path."/".$file;
	}//if
	else{
		$file_path = DOC_ROOT."/administrator/gfx/".$file;
		$url_path  = URL."/administrator/gfx/".$file;
	}//else

	list($width, $height) = getimagesize($file_path);

	if($link){
		$output.= "<a href=\"".$link."\"";
		$output.= ($new_window) ? " target=\"_blank\"" : "";

		if ($alt == "delete")
			$output.= " onclick=\"return confirm('Are you sure you want to delete?')\"";

		$output.= ">";
	}//if

	$output.= "<img src=\"".$url_path."\" width=\"".$width."\" height=\"".$height."\" border=\"0\" alt=\"".$alt."\">";

	if($link)
		$output.= "</a>";

	if($print)
		echo $output;
	else
		return $output;

}//admin_output_image

function admin_output_hover_image($file_off,$file_on,$link){

	$file_path = DOC_ROOT."/administrator/gfx/".$file_off;
	$url_on    = URL."/administrator/gfx/".$file_on;
	$url_off   = URL."/administrator/gfx/".$file_off;

	list($width,$height) = 	getimagesize($file_path);

	$img_id = "hover_img_".rand(0,100);

	echo "<a href=\"".$link."\" onMouseOut=\"MM_swapImgRestore()\" onMouseOver=\"MM_swapImage('".$img_id."','','".$url_on."',1)\">";
	echo "<img src=\"".$url_off."\" width=\"".$width."\" height=\"".$height."\" border=\"0\" name=\"".$img_id."\">";
	echo "</a>";

}//admin_output_hover_image

function admin_login($login,$password,$mem_id=0){

	if($GLOBALS["moderator"])
		$login_type = 2;
	else
		$login_type = 1;

	if(!$mem_id)
	$mem_id = $GLOBALS["Member"]->login($login,$password,$login_type);

	if(is_numeric($mem_id)){
		$info = $GLOBALS["Member"]->info($mem_id);
		if($info["member_type"] == "a"){
			$sql_query = "DELETE FROM
						  admin_session
						  WHERE started < ".time();

			$GLOBALS["DB"]->execute($sql_query);

			mt_srand((double) microtime() * 1000000);
			$rand    = mt_rand();
			$sess_id = md5($rand.time());

			$sql_query = "INSERT INTO admin_session
						  VALUES ('".$sess_id."',".time().")";

			$GLOBALS["DB"]->execute($sql_query);

			load_cookie("sess_id", $sess_id, 0);
			return true;
		}//if
		elseif($info["member_type"] == "m"){
			$sql_query = "DELETE FROM
						  mod_session
						  WHERE started < ".time()."
						  AND mem_id=".$mem_id;

			$GLOBALS["DB"]->execute($sql_query);

			mt_srand((double) microtime() * 1000000);
			$rand    = mt_rand();
			$sess_id = md5($rand.time());

			$sql_query = "INSERT INTO mod_session
						  VALUES ('".$sess_id."',".$mem_id.",".time().")";

			$GLOBALS["DB"]->execute($sql_query);

			load_cookie("sess_id", $sess_id, 0);
			return true;
		}//elseif
	}//if

	return false;

}//admin_login

function admin_logout(){

	$info = $GLOBALS["Member"]->info();

	if($info["member_type"] == "a"){

		$sql_query="DELETE FROM admin_session WHERE 1";
		$GLOBALS["DB"]->execute($sql_query);

		load_cookie("sess_id", "", -1);

	}//if
	elseif($info["member_type"] == "m"){

		$sql_query="DELETE FROM mod_session WHERE mem_id=".$info["mem_id"];
		$GLOBALS["DB"]->execute($sql_query);

		load_cookie("sess_id", "", -1);

	}//elseif

	$GLOBALS["Member"]->logout();

	return true;

}//admin_logout

function admin_validate(){

	$info = $GLOBALS["Member"]->info();

	if($info["member_type"] == "a"){

		$sess_id = $GLOBALS["Get"]->cookie("sess_id");

		$sql_query="SELECT COUNT(*)
					FROM admin_session
					WHERE ses_id='".$sess_id."'";

		$valid = $GLOBALS["DB"]->single($sql_query);

	}//if
	elseif($info["member_type"] == "m"){

		$sess_id = $GLOBALS["Get"]->cookie("sess_id");

		$sql_query="SELECT COUNT(*)
					FROM mod_session
					WHERE ses_id='".$sess_id."'";

		$valid = $GLOBALS["DB"]->single($sql_query);

	}//elseif

	if($valid){
		return $info;
	}//if
	else{
		admin_logout();
		if($GLOBALS["moderator"])
			admin_load_page(URL."/moderator/index.php?err_id=1");
		else
			admin_load_page(URL."/administrator/index.php?err_id=1");
	}//else

}//admin_validate

function admin_validate_section($section,$subsection,$redirect=1){

	$info = $GLOBALS["Member"]->info();

	if($info["member_type"] == "a"){

		return true;

	}//if
	elseif($info["member_type"] == "m"){

		$sql_query = "SELECT access FROM moderators WHERE mem_id=".$info["mem_id"];
		$access_code = $GLOBALS["DB"]->single($sql_query);
		$access_sections = explode("|",$access_code);
		if(!in_array($section."_".$subsection,$access_sections)){
			if($redirect)
				load_page("index.php?section=home&err_id=38");
			else
				return false;
		}//if
		else{
			return true;
		}//else

	}//elseif

	return false;

}//admin_validate_section

function admin_load_page($location){

	?><script language="JavaScript">
	<!--
		parent.window.location = "<?php echo $location; ?>";
	//-->
	</script><?php

	exit;

}//admin_load_page

function admin_check_error(){

	$err_id = $GLOBALS["Get"]->type_val("err_id","integer");
	if(empty($err_id) && !empty($GLOBALS["aerr_id"])){
		$err_id = $GLOBALS["aerr_id"];
	}//if

	if(!empty($err_id)){
		include(DOC_ROOT."/administrator/includes/errors.inc.php");
		return nl2br($errors[$err_id]);
	}//if
	elseif(!extract_null_value($GLOBALS["uerr_id"])){
		include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/system/errors.inc.php");
		return nl2br($errors[$GLOBALS["uerr_id"]]);
	}//elseif
	else{
		return false;
	}//else

}//admin_check_error

function admin_form_element($params){

	extract($params);
	if(!$nostrip)
		$value = stripslashes($value);
	if($type != "textarea")
		$value = hs_ereg_replace('"','&quot;',$value);
	else
		$value = htmlspecialchars(html_entity_decode($value));

	if(empty($class)){
		$class = "textfield";
	}//if

	switch($type){
		case 'input':
			?><input type="text" class="<?php echo $class; ?>" size="<?php echo $size; ?>" name="<?php echo $name; ?>" value="<?php echo $value; ?>" <?php echo $javascript; ?>><?php
			break;
		case 'password':
			?><input type="password" class="<?php echo $class; ?>" size="<?php echo $size; ?>" name="<?php echo $name; ?>" value="<?php echo $value; ?>" <?php echo $javascript; ?>><?php
			break;
		case 'select':
			?><select class="<?php echo $class; ?>" name="<?php echo $name; ?>" <?php echo ($size > 0) ? "size=\"".$size."\"" : ""; ?> <?php echo ($width) ? "style=\"width:".$width."\"" : ""; ?> <?php echo ($multiple) ? "multiple" : ""; ?> <?php echo $javascript; ?>><?php
			while(list($key,$val) = each($options)){
				?><option value="<?php echo $key; ?>" <?php echo ($key == $value) ? "selected" : "" ; ?>><?php echo $val; ?></option><?php
			}//while
			?></select><?php
			break;
		case 'checkbox':
			?><input type="checkbox" name="<?php echo $name; ?>" value="<?php echo $ovalue; ?>" <?php echo ($value == $ovalue) ? "checked" : "" ; ?> <?php echo $javascript; ?>><?php
			break;
		case 'radio':
			?><input type="radio" name="<?php echo $name; ?>" value="<?php echo $ovalue; ?>" <?php echo ($value == $ovalue) ? "checked" : "" ; ?> <?php echo $javascript; ?>><?php
			break;
		case 'textarea':
			?><textarea <?php echo ($wrap) ? "wrap=\"".$wrap."\"" : ""; ?> class="textfield" name="<?php echo $name; ?>" rows="<?php echo $rows; ?>" cols="<?php echo $cols; ?>"><?php echo $value; ?></textarea><?php
			break;
		case 'file':
			?><input type="file" name="<?php echo $name; ?>" class="textfield"><?php
			break;
		case 'button':
			if($file){
				$file_path = DOC_ROOT."/administrator/gfx/buttons/".$file;
				list($width,$height) = getimagesize($file_path);
			}//if
			if($onclick) {
				if($file){
				?><a href="javascript:<?php echo $onclick; ?>"><img src="<?php echo URL."/administrator/gfx/buttons/".$file; ?>" width="<?php echo $width; ?>" height="<?php echo $height; ?>" border="0"></a><?php
				} else {
				?><input type="button" class="button" onclick="javascript:<?php echo $onclick; ?>" value="<?php echo $value; ?>"><?php
				}
			}//if
			elseif($link){
				?><input type="button" class="button" value="<?php echo $value; ?>" onclick="window.location='<?php echo hs_ereg_replace("'","\'",$link); ?>'"><?php
			}//elseif
			elseif($bsubmit) {
				if($file){
				?><input type="image" src="<?php echo URL."/administrator/gfx/buttons/".$file; ?>" width="<?php echo $width; ?>" height="<?php echo $height; ?>" border="0" onclick="<?php echo $bsubmit; ?>"><?php
				} else {
				?><input type="submit" class="button" onclick="javascript:<?php echo $bsubmit; ?>" value="<?php echo $value; ?>"><?php
				}
			}//elseif
			else {
				if($file){
				?><input type="image" src="<?php echo URL."/administrator/gfx/buttons/".$file; ?>" width="<?php echo $width; ?>" height="<?php echo $height; ?>" border="0"><?php
				} else {
				?><input type="submit" class="button" value="<?php echo $value; ?>" <?php echo $javascript; ?>><?php
				}
			}//else
			break;
	}//switch

}//admin_form_element

function admin_replace_search_string($text){

	$text = preg_replace("/\n|\r| /","",$text);
	$text = preg_replace("/[,]+/",",",$text);
	$text = trim($text,",");

	return $text;

}//admin_replace_search_string

function admin_build_cards($results,$link){

	$cards = array ();
	$i = 0;
	foreach($results as $result){
		$cards[$i]["name"] = implode(" ",$GLOBALS["Member"]->name($result["mem_id"]));
		if(hs_strlen($cards[$i]["name"]) > 18)
			$cards[$i]["name"] = hs_substr($cards[$i]["name"],0,16)."...";
		$level = $GLOBALS["Member"]->level($result["mem_id"]);
		$free_level = extract_free_package();
		if($level > 0 && $level != $free_level)
			$cards[$i]["paid"] = 1;

		$cards[$i]["mem_id"]   = $result["mem_id"];
		$cards[$i]["banned"]   = $GLOBALS["Member"]->is_banned($result["mem_id"]);
		$cards[$i]["verified"] = $GLOBALS["Member"]->is_verified($result["mem_id"]);
		$cards[$i]["view"]     = build_channel_link($GLOBALS["Member"]->username($result["mem_id"]));
		$cards[$i]["edit"]     = "index.php?section=manage_members&action=edit_member&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);
		$cards[$i]["ban"]      = "index.php?section=manage_members&action=ban_member&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);
		$cards[$i]["unban"]    = "index.php?section=manage_members&action=unban_member&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);
		$cards[$i]["delete"]   = "index.php?section=manage_members&action=delete_member&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);
		$cards[$i]["approve"]  = "index.php?section=manage_profiles&action=approve_profile&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);
		$cards[$i]["resend"]   = "index.php?section=manage_unverified&action=resend_verification&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);
		$cards[$i]["verify"]   = "index.php?section=manage_unverified&action=verify&mem_id=".$result["mem_id"]."&ret_link=".urlencode($link);

		$sql_query = "SELECT members.username,members.email,profiles.joined,profiles.last_click,
					  profiles.country,profiles.gender,profiles.birthdate
					  FROM profiles,members
					  WHERE members.mem_id=profiles.mem_id
					  AND members.mem_id=".$result["mem_id"];

		$member = $GLOBALS["DB"]->row($sql_query);
		$cards[$i]["email"] = $member["email"];
		$cards[$i]["username"] = $member["username"];
		$cards[$i]["username_cut"] = handle_string_cut( $member["username"], 30 );
		$i++;
	}//foreach

	return $cards;

}//admin_build_cards

function admin_popup_close($reload){

	?>
	<script language="JavaScript">
	<!--
	<?php
	if($reload){
		?>opener.location.reload( true );<?php
	}//if
	?>
	self.close();
	//-->
	</script>
	<?php

}//admin_popup_close

function admin_get_pages($theme){

	include(DOC_ROOT."/themes/".$theme."/config/settings.inc.php");

	include(DOC_ROOT."/themes/".$theme."/titles.inc.php");
	asort($titles);

	while(list($key,$val) = each($titles)){
		$titles[$key] = eregi_replace("\|site_name\|",$settings["site_name"],$val);
		$titles[$key] = eregi_replace("\|","&#124;",$titles[$key]);
	}//while
	reset($titles);

	return $titles;

}//admin_get_pages

function admin_get_modules(){

	include(DOC_ROOT."/includes/config/modules.inc.php");
	asort($modules);

	return $modules;

}//admin_get_modules

function admin_get_themes(){

	include(DOC_ROOT."/includes/themes.inc.php");

	$themes_list = array();

	while(list($key,$val) = each($themes)){
		$k = $val["folder"];
		$v = $val["name"];
		$themes_list[$k] = $v;
	}//while

	return $themes_list;

}//admin_get_themes

function admin_get_tasks($theme){

	include(DOC_ROOT."/themes/".$theme."/tasks.inc.php");
	return $tasks;

}//admin_get_tasks

function admin_get_options($theme){

	$options_folder = DOC_ROOT."/themes/".$theme."/options";
	$dir_handler = opendir($options_folder);
	while($file = readdir($dir_handler)){
		if(is_file($options_folder."/".$file) && eregi("\.inc\.php$",$file)){
			include($options_folder."/".$file);
			$file_name = ereg_replace("\.inc\.php","",$file);
			$site_options[$file_name] = $options_name;
		}//if
	}//while
	closedir($dir_handler);

	return $site_options;

}//admin_get_options

function admin_get_getpaid_packages(){

	$packages = array ();

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	if($getpaid["enabled"]){
		while(list($key,$val) = each($getpaid["membership"])){
			if($val["price"]){
				$packages[$key] = $val["name"];
			}//if
		}//while
	}//if

	return $packages;

}//admin_get_getpaid_packages

function admin_getpaid_isenabled(){

	include(DOC_ROOT."/themes/".$GLOBALS["THEME"]."/modules/getpaid.inc.php");
	return $getpaid["enabled"];

}//admin_getpaid_isenabled

function admin_sections(){
	
	include(DOC_ROOT."/administrator/includes/admin_menu.inc.php");
	
	$section = array();
	foreach($menu as $key => $val) {
		if($key != "logout") {
			
		$section[$key] = ucfirst( $key );
		if(is_array( $submenu[$key] ) && count( $submenu[$key] )) {
			foreach($submenu[$key] as $k => $v) {
				if( $key."_".$k != "setup_1" && $key."_".$k != "tools_4" )
					$subsection[$key][$k] = $v;
			}
		}
		
		}
	}

	$retar["sections"]    = $section;
	$retar["subsections"] = $subsection;

	return $retar;

}//admin_sections

function go_through_array($prepend,$arr){

	$config_line = "";

	if(count($arr)){
		reset($arr);
		while(list($key,$val) = each($arr)){
			if(is_array($val)){
				$config_line.= go_through_array($prepend."[\"".$key."\"]",$val);
			}//if
			else{
				$val = stripslashes(html_entity_decode($val));
				$val = hs_ereg_replace(preg_quote("&#124;"),"|",$val);
				$config_line.= $prepend."[\"".$key."\"] = \"".ereg_replace('"','\"',$val)."\";\n";
			}//else
		}//while
	}//if
	else{
		$config_line.= $prepend." = array();\n";
	}//else

	return $config_line;

}//go_through_array

function add_new_page($theme,$data){

	//forms
	if(is_array($data["forms"])){
		foreach($data["forms"] as $form_name){
			$sql_query = "INSERT INTO associations (`assoc_type`,`page`,`association`,`theme`)
						  VALUES ('form','".$data["items_file"]."','".$form_name."','".$theme."')";
			$GLOBALS["DB"]->execute($sql_query);
		}//foreach
	}//if

	//authentification
	if(is_array($data["auth"])){
		foreach($data["auth"] as $auth_name){
			$sql_query = "INSERT INTO associations (`assoc_type`,`page`,`association`,`theme`)
						  VALUES ('auth','".$data["items_file"]."','".$auth_name."','".$theme."')";
			$GLOBALS["DB"]->execute($sql_query);
		}//foreach
	}//if

	//menus
	if(is_array($data["menus"])){
		foreach($data["menus"] as $menu_name){
			$sql_query = "INSERT INTO associations (`assoc_type`,`page`,`association`,`theme`)
						  VALUES ('menu','".$data["items_file"]."','".$menu_name."','".$theme."')";
			$GLOBALS["DB"]->execute($sql_query);
		}//foreach
	}//if

	//tasks
	if(is_array($data["tasks"])){
		foreach($data["tasks"] as $task_name){
			$sql_query = "INSERT INTO associations (`assoc_type`,`page`,`association`,`theme`)
						  VALUES ('task','".$data["items_file"]."','".$task_name."','".$theme."')";
			$GLOBALS["DB"]->execute($sql_query);
		}//foreach
	}//if

	//javascript
	$onload  = stripslashes(html_entity_decode($data["javascript"]["onload"]));
	$onload  = hs_ereg_replace(preg_quote("&#124;"),"|",$onload);
	$code    = stripslashes(html_entity_decode($data["javascript"]["code"]));
	$code    = hs_ereg_replace(preg_quote("&#124;"),"|",$code);
	$onload  = ereg_replace("\\\\","\\\\",$onload);
	$onload  = ereg_replace("'","\'",$onload);
	$code    = ereg_replace("\\\\","\\\\",$code);
	$code    = ereg_replace("'","\'",$code);

	$sql_query = "REPLACE INTO javascripts (page,theme,onload,code)
				  VALUES ('".$data["items_file"]."','".$theme."','".$onload."','".$code."')";
	$GLOBALS["DB"]->execute($sql_query);

	//page groups
	if(is_array($data["groups"])){
		include(DOC_ROOT."/themes/".$theme."/page_groups.inc.php");
		foreach($data["groups"] as $group){
			$page_groups[$group]["pages"].= ",".$data["items_file"];
		}//foreach
		save_config_file(DOC_ROOT."/themes/".$theme."/page_groups.inc.php","page_groups",$page_groups);
	}//if

	//tip
	$data["tip"] = ereg_replace("\\\\","\\\\",$data["tip"]);
	$data["tip"] = ereg_replace("'","\'",$data["tip"]);
	$sql_query = "REPLACE INTO tips (page,theme,message)
				  VALUES ('".$data["items_file"]."','".$theme."','".$data["tip"]."')";
	$GLOBALS["DB"]->execute($sql_query);

	//title
	include(DOC_ROOT."/themes/".$theme."/titles.inc.php");
	$titles[$data["items_file"]] = $data["title"];
	save_config_file(DOC_ROOT."/themes/".$theme."/titles.inc.php","titles",$titles);

	//template file
	$f = fopen(DOC_ROOT."/themes/".$theme."/templates/source/pages/".$data["items_file"].".tpl","w");
	fwrite($f,"");
	fclose($f);

}//add_new_page

function delete_page($theme,$page){

	$sql_query = "DELETE FROM associations WHERE page='".$page."' AND theme='".$theme."'";
	$GLOBALS["DB"]->execute($sql_query);

	//javascript
	$sql_query = "DELETE FROM javascripts WHERE page='".$page."' AND theme='".$theme."'";
	$GLOBALS["DB"]->execute($sql_query);

	//page groups
	include(DOC_ROOT."/themes/".$theme."/page_groups.inc.php");
	while(list($key,$val) = each($page_groups)){
		$pages = explode(",",$val["pages"]);
		$rem = array_search($page,$pages);
		if(!extract_null_value($rem))
			unset($page_groups[$key][$rem]);
		$page_groups[$key]["pages"] = implode(",",$pages);
	}//while
	save_config_file(DOC_ROOT."/themes/".$theme."/page_groups.inc.php","page_groups",$page_groups);

	//tip
	$sql_query = "DELETE FROM tips WHERE page='".$page."' AND theme='".$theme."'";
	$GLOBALS["DB"]->execute($sql_query);

	//title
	include(DOC_ROOT."/themes/".$theme."/titles.inc.php");
	unset($titles[$page]);
	save_config_file(DOC_ROOT."/themes/".$theme."/titles.inc.php","titles",$titles);

	//layout file
	@unlink(DOC_ROOT."/themes/".$theme."/templates/source/pages/".$page.".tpl");

}//delete_page

function save_config_file($file,$settings_name,$settings){

	$write_str = "<?php\n\n";
	$write_str.= go_through_array("$".$settings_name,$settings);
	$write_str.= "\n?>";

	$file_handler = fopen($file,"w");
	fwrite($file_handler,$write_str);
	fclose($file_handler);

}//save_config_file

function module_save_settings($theme,$module,$settings){

	$file_path = DOC_ROOT."/themes/".$theme."/modules/".$module.".inc.php";

	$str = "<?php\n\n";
	$str.= go_through_array("$".$module,$settings);
	$str.= "\n?>";

	$file_handler = fopen($file_path,"w");
	fwrite($file_handler,$str);
	fclose($file_handler);

}//module_save_settings

?>