<div class="mailboxMessage">
	<div class="details">
		{include file="items/avatar.tpl" size="Small" link=$message.from.link image=$message.from.avatar}
		<div class="vinfo">
			<span class="label">{if $message.mailbox != "sent"}{$language.from}{else}{$language.to}{/if}:</span> <a href="{$message.from.link}">{$message.from.username}</a><br />
			<span class="label">{$language.date}:</span> {$message.date}<br />
			{if $message.mailbox != "comments"}<span class="label">{$language.subject}:</span> {$message.subject}<br />{/if}
			{if $message.video}<span class="label">{$language.video}:</span> <a href="{$message.video.link}" target="_blank">{$message.video.title}</a>{/if}
		</div>
	</div>
	<div class="body">{$message.message}</div>
	{if ($message.mailbox == "shared" || $message.mailbox == "responses" || $message.mailbox == "groups") && $message.card}
		{if $message.card.type == "channel"}
			<div class="column">{include file="items/user.tpl" card=$message.card}</div><div class="listClear"></div>
		{elseif $message.card.type == "video"}
			<div class="column">{include file="items/video.tpl" video=$message.card}</div><div class="listClear"></div>
		{elseif $message.card.type == "playlist"}
			<div id="playlist">{include file="items/playlist_no_buttons.tpl" playlist=$message.card}</div>
		{elseif $message.card.type == "group"}
			<div>{include file="items/group_no_buttons.tpl" group=$message.card}</div>
		{/if}
	{/if}
	<div class="centerText">
	{$forms.message_view.start}
	{if $message.mailbox == "inbox" || $message.mailbox == "shared"}
	{$forms.message_view.buttons.0} {$forms.message_view.buttons.1} {$forms.message_view.buttons.2}
	{elseif $message.mailbox == "sent"}
	{$forms.message_view.buttons.1} {$forms.message_view.buttons.2}
	{elseif $message.mailbox == "invites"}
	{$forms.message_view.buttons.3} {$forms.message_view.buttons.4}
	{elseif $message.mailbox == "comments"}
	{$forms.message_view.buttons.5} {$forms.message_view.buttons.6}
	{elseif $message.mailbox == "responses"}
	{$forms.message_view.buttons.7} {$forms.message_view.buttons.8}
	{elseif $message.mailbox == "groups"}
	{$forms.message_view.buttons.9} {$forms.message_view.buttons.10}
	{/if}
	{$forms.message_view.end}
	</div>
</div>