{include file="boxes/white/open.tpl"}
<h1>{$language.rss_feeds}</h1>

<div class="margin10">
	<div class="marginBottom10"><h3 class="marginBottom10">What RSS?</h3>
	Really Simple Syndication (RSS) is an XML based format used for content distribution and syndication. Subscribing to RSS Feeds allows you to receive custom, up-to-date information from your favorite online content sources without having to regularly check the site for updates.
	</div>

	<div class="marginBottom10"><h3 class="marginBottom10">How to Access RSS Feeds?</h3>
	Installing a news reader that displays RSS feeds from the websites you specify allows you to keep up to date with all your favorite content by checking the RSS feeds you have subscribed to and displaying new items from each feed. Instead of downloading a dedicated news reader, you can also use a web-based news reader.
	</div>

	<div class="marginBottom10"><h3 class="marginBottom10">Getting RSS Feeds</h3>
	We offer several RSS feeds for categorized groups of videos (such as most recent, most viewed, most discussed, etc). To subscribe to categorized groups of videos, simply click on the orange 'RSS' button next to each feed below.
	</div>
	
	{foreach from=$rss item=rss_link key=key}
	<div class="rssLine">
	<div class="label">{$rss_link.title}</div> <a href="{$rss_link.href}">{html_image file="$root/icons/rss.gif"}</a><br />
	</div>
	{/foreach}

</div>
{include file="boxes/white/close.tpl"}