function CH_AddScheme( name, colors ){
	var d = document;
	if(!d.Schemes) {d.Schemes = new Array;}
	d.Schemes[name] = colors;
}

function CH_UpdateColors() {
	var d = document;
	var formHandler = d.forms["channel_style"];
	var currentSelection = CH_GetRadioValue(formHandler.theme);
	if(d.Schemes[currentSelection]){
		var Items = new Array;
		Items = d.Schemes[currentSelection].split("|");
		for(var Item in Items) {
			if(Items[Item]){
				var Data = new Array;
				Data = Items[Item].split("=");
				var Field = "colors"+Data[0];
				var Value = Data[1];
				if(formHandler.elements[Field][0] && formHandler.elements[Field][0].type == "radio"){
					if(formHandler.elements[Field][0].value == Value){
						formHandler.elements[Field][0].checked = true;
					} else {
						formHandler.elements[Field][1].checked = true;
					}
				}
				else if(formHandler.elements[Field]){
					formHandler.elements[Field].value = Value;
				}
			}
		}
	}
}

function CH_ShowColorSelector( id ) {
	var colSel = document.getElementById("colorSelector");
	var Position = new Array;
	Position = CH_Position( document.forms["channel_style"].elements[id] );
	colSel.style.top = Position['Top'] + "px";
	colSel.style.left = Position['Left'] + 62 + "px";
	colSel.style.display = "block";
	document.colorCell = id;
}

function CH_SetColor( color ) {
	var id = document.colorCell;
	document.forms["channel_style"].elements[id].value = color;
	CH_HideColorSelector();
}

function CH_HideColorSelector() {
	var colSel = document.getElementById("colorSelector");
	colSel.style.display = "none";
}

function CH_Position(Obj){
	var Position = new Array();
	Position['Top']  = 0;
	Position['Left'] = 0;
	if (Obj.offsetParent){
		while (Obj.offsetParent){
			Position['Top']+= Obj.offsetTop;
			Position['Left']+= Obj.offsetLeft;
			Obj = Obj.offsetParent;
		}
	}
	else if (Obj.x && Obj.y){
		Position['Left']+= Obj.x;
		Position['Top']+= Obj.y;
	}
	return Position;
}

function CH_SetupEvents() {
	var layoutHandler = document.forms["channel_boxes"];
	var styleHandler = document.forms["channel_style"];
	if(document.all){
		layoutHandler.box_featured.attachEvent( 'onclick', CH_ToggleFeaturedBox );
		for(var i=0; i < layoutHandler.featured_type.length; i++){
			layoutHandler.featured_type[i].attachEvent( 'onclick', CH_ToggleFeaturedURLBox );
		}
		layoutHandler.box_playlists.attachEvent( 'onclick', CH_TogglePlaylistBox );
		for(var i=0; i < styleHandler.theme.length; i++){
			styleHandler.theme[i].attachEvent( 'onclick', CH_UpdateColors );
		}
	}
	else{
		layoutHandler.box_featured.addEventListener( 'click',  CH_ToggleFeaturedBox, false );
		for(var i=0; i < layoutHandler.featured_type.length; i++){
			layoutHandler.featured_type[i].addEventListener( 'click', CH_ToggleFeaturedURLBox, false );
		}
		layoutHandler.box_playlists.addEventListener( 'click', CH_TogglePlaylistBox, false );
		for(var i=0; i < styleHandler.theme.length; i++){
			styleHandler.theme[i].addEventListener( 'click', CH_UpdateColors, false );
		}
	}
}

function CH_ToggleFeaturedBox() {
	var checkboxHandler = document.forms["channel_boxes"].box_featured;		
	CH_ToggleArea( "featured_type", checkboxHandler.checked, true);
	CH_ToggleFeaturedURLBox();
}

function CH_TogglePlaylistBox() {
	var checkboxHandler = document.forms["channel_boxes"].box_playlists;
	CH_ToggleArea( "playlists", checkboxHandler.checked, true);
}

function CH_ToggleFeaturedURLBox() {
	var checkboxHandler = document.forms["channel_boxes"].box_featured;
	var radioHandler = document.forms["channel_boxes"].featured_type;
	CH_ToggleArea( "featured_url", (CH_GetRadioValue( radioHandler ) == 2 && checkboxHandler.checked), true);
}

function CH_ToggleArea( areaId, compareWhat, compareTo ) {
	var area = document.getElementById( areaId );
	if( compareWhat == compareTo ){
		area.style.display = "block";
	} else {
		area.style.display = "none";
	}
}

function CH_GetRadioValue(radioObj) {
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}