<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Groups.class.php");
						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////
						$action = $GLOBALS["Get"]->val("action");

							switch($action){
								case 'create':
									create_group();
									break;

								case 'invite':
									invite_to_group();
									break;

								case 'join':
									join_leave_group();
									break;
									
								case 'add_post':
									group_add_post();
									break;
									
								case 'add_videos':
									group_add_videos();
									break;
									
								case 'update':
									group_update();
									break;
									
								case 'delete_post':
									group_delete_post();
									break;

							}//switch

						///////////////////////////////////////

function create_group(){

	include_once(DOC_ROOT."/functions/form_functions.php");

	$info = auth_member();

	$values = form_handle_input("group_create");
	$exists = $GLOBALS["Groups"]->verify_folder($values["folder"]);
	if($exists){
		build_error(24,"groups","create");
	}			

	$values["mem_id"]  = $info["mem_id"];
	$values["time"]    = time();
	
	$tags = explode(" ", $values["tags"]);
	$tags = handle_empties( $tags );
	$values["tags"] = "|".implode("|", $tags)."|";
	
	settype($values["privacy"],"integer");
	settype($values["videos"],"integer");
	settype($values["forum"],"integer");
	settype($values["icon"],"integer");

	$grp_id = $GLOBALS["Groups"]->create($values);

	load_page("index.php?page=groups&section=invite&grp_id=".$grp_id."&ret_link=".urlencode(build_group_link( $values["folder"] ) ) );

}//create_group

function groupinfo() {
	
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	$info = $GLOBALS["Groups"]->card( $grp_id );
	$GLOBALS["smarty"]->assign("group", $info);
	
}

function group_pro() {
	
	$pro = $GLOBALS["Get"]->val("pro");
	$GLOBALS["smarty"]->assign("pro", $pro);
	
}

function group_view() {
	
	$info = $GLOBALS["Member"]->info();
	
	$g = $GLOBALS["Get"]->val("g");
	
	$sql_query = "SELECT * FROM groups WHERE folder=':0:'";
	$GLOBALS["DB"]->values = array ( $g );
	$group = $GLOBALS["DB"]->row( $sql_query );
	
	if(!$group["grp_id"]) {
		load_page( "index.php?page=groups_browse&err_id=400" );
	}
	
	$grp_id = $group["grp_id"];
	
	$card = $GLOBALS["Groups"]->card( $grp_id );
	$GLOBALS["smarty"]->assign("group", $card);
	
	//videos
	$sql_query = "SELECT gv.vid_id FROM group_videos AS gv, videos AS v
				  WHERE gv.vid_id = v.vid_id ".$GLOBALS["Videos"]->filter("v.")."
				  AND gv.grp_id = ".$grp_id."
				  AND gv.approved='1'
				  ORDER BY gv.added DESC
				  LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	$GLOBALS["smarty"]->assign("videos", $videos);
	
	//discussions
	$sql_query = "SELECT * FROM group_forum WHERE grp_id=".$grp_id."
				  AND approved='1'
				  AND reply_to=0 ORDER BY posted DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$discussions = array();
	foreach($result as $res) {
		$card = array();
		$card["pst_id"] = $res["pst_id"];
		$card["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["message"] = nl2br( handle_string_cut( $res["message"], 100 ) );
		$sql_query = "SELECT COUNT(*) FROM group_forum WHERE reply_to=".$res["pst_id"];
		$card["replies"] = $GLOBALS["DB"]->single( $sql_query );
		$sql_query = "SELECT posted FROM group_forum WHERE reply_to=".$res["pst_id"]." OR pst_id=".$res["pst_id"]."
					  ORDER BY posted DESC LIMIT 0,1";
		$card["last"] = extract_date( $GLOBALS["DB"]->single( $sql_query ) );
		
		if($res["mem_id"] == $info["mem_id"])
			$card["delete"] = 1;
		
		$discussions[] = $card;
	}
	$GLOBALS["smarty"]->assign("discussions", $discussions);
	
	$GLOBALS["page_details"]["meta"]["description"] = $group["name"].": ".handle_string_cut( $group["description"] );
	$GLOBALS["page_details"]["meta"]["keywords"] = build_keywords($group["name"]." ".$group["description"]." ".$group["tags"]);
	$GLOBALS["page_details"]["meta"]["title"] = $group["name"];
	
}

function group_add_post() {
	
	$info = auth_member();
	auth_group_action_access();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input( "group_topic" );
	if(!$values["pst_id"])
		$values["pst_id"] = 0;
	
	if(!$values["grp_id"]) {
		$sql_query = "SELECT * FROM groups WHERE folder=':0:'";
		$GLOBALS["DB"]->values = array( $values["g"] );
		$group = $GLOBALS["DB"]->row( $sql_query );
	} else {
		$group = $GLOBALS["Groups"]->info( $values["grp_id"] );
		$values["g"] = $group["folder"];
	}
	
	if(!$group["grp_id"]) {
		load_page( "index.php?page=groups&section=browse&err_id=400" );
	}
	
	$grp_id = $group["grp_id"];
	
	if($group["forum"] == 3 && !$GLOBALS["Groups"]->is_owner( $info["mem_id"], $grp_id ) && !$values["pst_id"]) {
		load_page( build_group_link( $values["g"], 1 )."err_id=409" );
	}
	
	$approved = ($group["forum"] == 2) ? 0 : 1;
	
	$sql_query = "INSERT INTO group_forum(reply_to, mem_id, grp_id, message, posted, approved)
				  VALUES (:pst_id:,:mem_id:,:grp_id:,':message:',:time:,':approved:')";
	$GLOBALS["DB"]->values = array (
		"pst_id" => $values["pst_id"],
		"mem_id" => $info["mem_id"],
		"grp_id" => $grp_id,
		"message" => $values["post"],
		"time" => time(),
		"approved" => $approved
	);
	$GLOBALS["DB"]->execute( $sql_query );
	
	$cmp_id = ( $approved ) ? 35 : 36;
	
	if(!$values["pst_id"])
		load_page( build_group_link( $values["g"], 1 )."cmp_id=".$cmp_id );
	else
		load_page( "index.php?page=groups&section=view_discussion&grp_id=".$grp_id."&pst_id=".$values["pst_id"]."&cmp_id=".$cmp_id );
	
}

function group_add_videos() {
	
	$info = auth_member();
	auth_group_action_access();
	
	$grp_id = $GLOBALS["Get"]->type_val("grp_id", "integer");
	$videos = $GLOBALS["Get"]->val("vid_id");
	$vids = array();
	$pro = $GLOBALS["Get"]->val("pro");
	
	$group = $GLOBALS["Groups"]->info( $grp_id );
		
	if($group["videos"] == 3 && !$GLOBALS["Groups"]->is_owner( $info["mem_id"], $grp_id )) {
		load_page( build_group_link( $group["folder"], 1 )."err_id=408" );
	}
	
	if(is_array($videos) && count($videos)) {
	
		$sql_query = "SELECT vid_id FROM videos WHERE vid_id IN (".implode(",", $videos).")
					  ".$GLOBALS["Videos"]->filter();
		$result = $GLOBALS["DB"]->result( $sql_query );
		foreach($result as $res) {
			$vids[] = $res["vid_id"];
		}
		
	}
	
	if(count($vids)) {		
		$approved = ($group["videos"] == 2) ? 0 : 1;
		foreach($vids as $vid) {
			$sql_query = "INSERT INTO group_videos (grp_id, vid_id, added, approved)
						  VALUES (:grp_id:, :vid_id:, :time:, ':approved:')";
			$GLOBALS["DB"]->values = array (
				"grp_id" => $grp_id,
				"vid_id" => $vid,
				"time" => time(),
				"approved" => $approved
			);
			$GLOBALS["DB"]->execute( $sql_query );
		}
	} else {
		load_page( "index.php?page=groups_add_videos&pro=".$pro."&grp_id=".$grp_id."&err_id=410" );
	}
	
	$cmp_id = ($approved) ? 407 : 408;
	load_page( "index.php?page=groups_add_videos&pro=".$pro."&grp_id=".$grp_id."&cmp_id=".$cmp_id );
	
}

function my_group_videos() {
	
	$info = $GLOBALS["Member"]->info();
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	
	$sql_query = "SELECT vid_id FROM group_videos WHERE grp_id=".$grp_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	$exclude = array(0);
	foreach($result as $res) {
		$exclude[] = $res["vid_id"];
	}
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$info["mem_id"].$GLOBALS["Videos"]->filter()."
				  AND vid_id NOT IN (".implode(",", $exclude).")";
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");	
	$link  = "index.php?page=groups&section=add_videos&grp_id=".$grp_id."&pro=vid";	
	$pages = handle_multipages($p,$total,$link);

	$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$info["mem_id"]." ".$GLOBALS["Videos"]->filter()."
				  AND vid_id NOT IN (".implode(",", $exclude).")
				  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$videos[] = $GLOBALS["Videos"]->card($res["vid_id"]);
	}//foreach

	$GLOBALS["smarty"]->assign("my_videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);
	
}

function my_group_favorites(){

	$info = $GLOBALS["Member"]->info();
	
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	
	$sql_query = "SELECT vid_id FROM group_videos WHERE grp_id=".$grp_id;
	$result = $GLOBALS["DB"]->result( $sql_query );
	$exclude = array(0);
	foreach($result as $res) {
		$exclude[] = $res["vid_id"];
	}
	
	$sql_query = "SELECT COUNT(*) FROM bookmarks AS b, videos AS v WHERE b.item_id = v.vid_id
				  AND b.mem_id=".$info["mem_id"].$GLOBALS["Videos"]->filter("v.")."
				  AND b.item_id NOT IN (".implode(",", $exclude).")";
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");
	if($GLOBALS["page_details"]["items_file"] == "favorites")
		$link  = "index.php?page=favorites";
	elseif($GLOBALS["page_details"]["items_file"] == "groups_add_videos") {
		$link  = "index.php?page=groups&section=add_videos&grp_id=".$GLOBALS["Get"]->type_val("grp_id","integer")."&pro=fav";
	}
	$pages = handle_multipages($p,$total,$link);

	$sql_query = "SELECT item_id AS vid_id FROM bookmarks AS b, videos AS v WHERE b.item_id = v.vid_id AND b.mem_id=".$info["mem_id"]."
				  ".$GLOBALS["Videos"]->filter("v.")."
				  AND b.item_id NOT IN (".implode(",", $exclude).")
				  ORDER BY b.added DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$card = $GLOBALS["Videos"]->card($res["vid_id"]);
		$videos[] = $card;
	}//foreach

	$GLOBALS["smarty"]->assign("favorites",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);

}

function group_videos() {
	
	$info = $GLOBALS["Member"]->info();
	
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	
	$sql_query = "SELECT COUNT(*) FROM group_videos AS gv, videos AS v
				  WHERE gv.vid_id = v.vid_id ".$GLOBALS["Videos"]->filter("v.")."
				  AND gv.grp_id = ".$grp_id;
	
	$total = $GLOBALS["DB"]->single( $sql_query );
	$p     = $GLOBALS["Get"]->type_val("p", "integer");
	$link  = "index.php?page=groups&section=videos&grp_id=".$grp_id;
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT gv.vid_id FROM group_videos AS gv, videos AS v
				  WHERE gv.vid_id = v.vid_id ".$GLOBALS["Videos"]->filter("v.")."
				  AND gv.grp_id = ".$grp_id."
				  AND gv.approved='1'
				  ORDER BY gv.added DESC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function group_discussions() {
	
	$info = $GLOBALS["Member"]->info();
	
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	
	$sql_query = "SELECT COUNT(*) FROM group_forum WHERE grp_id=".$grp_id."
				  AND reply_to=0";
	
	$total = $GLOBALS["DB"]->single( $sql_query );
	$p     = $GLOBALS["Get"]->type_val("p", "integer");
	$link  = "index.php?page=groups&section=discussions&grp_id=".$grp_id;
	$pages = handle_multipages( $p, $total, $link );
	
	//discussions
	$sql_query = "SELECT * FROM group_forum WHERE grp_id=".$grp_id."
				  AND approved='1'
				  AND reply_to=0 ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	$discussions = array();
	foreach($result as $res) {
		$card = array();
		$card["pst_id"] = $res["pst_id"];
		$card["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["message"] = nl2br( handle_string_cut( $res["message"], 100 ) );
		$sql_query = "SELECT COUNT(*) FROM group_forum WHERE reply_to=".$res["pst_id"];
		$card["replies"] = $GLOBALS["DB"]->single( $sql_query );
		$sql_query = "SELECT posted FROM group_forum WHERE reply_to=".$res["pst_id"]." OR pst_id=".$res["pst_id"]."
					  ORDER BY posted DESC LIMIT 0,1";
		$card["last"] = extract_date( $GLOBALS["DB"]->single( $sql_query ) );
		
		if($res["mem_id"] == $info["mem_id"])
			$card["delete"] = 1;
		
		$discussions[] = $card;
	}
	$GLOBALS["smarty"]->assign("discussions", $discussions);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function group_discussion() {
	
	$info = $GLOBALS["Member"]->info();	
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	$pst_id = $GLOBALS["Get"]->type_val("pst_id","integer");
	
	$sql_query = "SELECT * FROM group_forum WHERE grp_id=".$grp_id." AND pst_id=".$pst_id;
	$result = $GLOBALS["DB"]->row( $sql_query );
	
	$post["from"] = $GLOBALS["Member"]->card( $result["mem_id"] );
	$post["message"] = nl2br( $result["message"] );
	$post["posted"] = extract_date( $result["posted"] );
	$post["pst_id"] = $pst_id;
	
	$GLOBALS["smarty"]->assign("post", $post);
	
	$sql_query = "SELECT * FROM group_forum WHERE reply_to = ".$pst_id." ORDER BY posted DESC";
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$comments = array();
	foreach($result as $res) {
		$card = array();
		$card["pst_id"] = $res["pst_id"];
		$card["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
		$card["message"] = nl2br( $res["message"] );
		$card["posted"] = extract_date( $res["posted"] );
		
		if($res["mem_id"] == $info["mem_id"])
		$card["delete"] = 1;
		
		$comments[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("comments", $comments);
		 
}

function join_leave_group(){

	$info = auth_member();
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");

	if(!$GLOBALS["Groups"]->is_owner($info["mem_id"],$grp_id)){

	$status = $GLOBALS["Groups"]->join($info["mem_id"],0,$grp_id);
	if($status == "request"){
		include_once(DOC_ROOT."/classes/Mail.class.php");
	
		$sql_query = "SELECT name FROM groups WHERE grp_id=".$grp_id;
		$group_name = $GLOBALS["DB"]->single($sql_query);
	
		$mail_details1 = array (
			"mes_id" => 102,
			"sender" => $info["mem_id"],
			"group_name" => $group_name,
			"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
			"special" => "group_join|".$grp_id,
			"mailbox" => "groups",
			"body" => ""
		);
	
		$GLOBALS["Mail"]->details = $mail_details1;
		$GLOBALS["Mail"]->details["recipient"] = $GLOBALS["Groups"]->owner( $grp_id );
		$GLOBALS["Mail"]->send_internal();

		load_page(build_group_link_by_id($grp_id,1)."cmp_id=400");
	}//if
	elseif($status == "error")
		load_page("index.php?page=groups_browse&err_id=402");
	elseif($status == "member"){
		$GLOBALS["Groups"]->remove_member($info["mem_id"],$grp_id);
		load_page("index.php?page=groups_browse&cmp_id=405");
	}//elseif
	else
		load_page(build_group_link_by_id($grp_id,1)."cmp_id=404");
	}//if
	else{
		load_page(build_group_link_by_id($grp_id,1)."err_id=404");
	}//else

}//join_leave_group

function group_edit() {
	
	$info = auth_member();
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");
	$pro = $GLOBALS["Get"]->val("pro");
	$p = $GLOBALS["Get"]->type_val("p","integer");
	
	$GLOBALS["smarty"]->assign("pro", $pro);
	
	switch($pro) {
		case 'members':			
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM group_members WHERE grp_id=".$grp_id." AND mem_id != ".$info["mem_id"] );
			$link = "index.php?page=groups&section=edit&pro=members&grp_id=".$grp_id;
			$pages = handle_multipages( $p, $total, $link );
			$sql_query = "SELECT mem_id FROM group_members WHERE grp_id=".$grp_id." AND mem_id != ".$info["mem_id"]."
						  LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$members = array();
			foreach($result as $res) {
				$card = $GLOBALS["Member"]->card( $res["mem_id"] );
				$members[] = $card;
			}
			$GLOBALS["smarty"]->assign("members", $members);
			$GLOBALS["smarty"]->assign("pages", $pages);
			break;
		case 'videos':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM group_videos WHERE grp_id=".$grp_id." AND approved='1'" );
			$link = "index.php?page=groups&section=edit&pro=videos&grp_id=".$grp_id;
			$pages = handle_multipages( $p, $total, $link );
			$sql_query = "SELECT vid_id FROM group_videos WHERE grp_id=".$grp_id." AND approved='1'
						  ORDER BY added DESC
						  LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$videos = array();
			foreach($result as $res) {
				$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
				$videos[] = $card;
			}
			$sql_query = "SELECT icon FROM groups WHERE grp_id=".$grp_id;
			$icon = $GLOBALS["DB"]->single( $sql_query );
			$GLOBALS["smarty"]->assign("videos", $videos);
			$GLOBALS["smarty"]->assign("pages", $pages);
			$GLOBALS["smarty"]->assign("icon", $icon);
			break;
		case 'discussions':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM group_forum WHERE grp_id=".$grp_id." AND approved='1' AND reply_to=0" );
			$link = "index.php?page=groups&section=edit&pro=discussions&grp_id=".$grp_id;
			$pages = handle_multipages( $p, $total, $link );
			$sql_query = "SELECT * FROM group_forum WHERE grp_id=".$grp_id." AND approved='1' AND reply_to=0
						  ORDER BY posted DESC
						  LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$discussions = array();
			foreach($result as $res) {
				$card = array();
				$card["pst_id"] = $res["pst_id"];
				$card["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
				$card["message"] = nl2br( handle_string_cut( $res["message"], 100 ) );
				$discussions[] = $card;
				$sql_query = "SELECT * FROM group_forum WHERE grp_id=".$grp_id." AND approved='1' AND reply_to=".$res["pst_id"]."
							  ORDER BY posted ASC";
				$result2 = $GLOBALS["DB"]->result( $sql_query );
				foreach($result2 as $r) {
					$card = array();
					$card["pst_id"] = $r["pst_id"];
					$card["from"] = $GLOBALS["Member"]->card( $r["mem_id"] );
					$card["message"] = nl2br( handle_string_cut( $r["message"], 100 ) );
					$card["reply"] = 1;
					$discussions[] = $card;
				}
			}
			$GLOBALS["smarty"]->assign("discussions", $discussions);
			$GLOBALS["smarty"]->assign("pages", $pages);
			break;
		case 'approve_videos':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM group_videos WHERE grp_id=".$grp_id." AND approved='0'" );
			$link = "index.php?page=groups&section=edit&pro=approve_videos&grp_id=".$grp_id;
			$pages = handle_multipages( $p, $total, $link );
			$sql_query = "SELECT vid_id FROM group_videos WHERE grp_id=".$grp_id." AND approved='0'
						  ORDER BY added DESC
						  LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$videos = array();
			foreach($result as $res) {
				$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
				$videos[] = $card;
			}
			$GLOBALS["smarty"]->assign("videos", $videos);
			$GLOBALS["smarty"]->assign("pages", $pages);
			break;
		case 'approve_discussions':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM group_forum WHERE grp_id=".$grp_id." AND approved='0'" );
			$link = "index.php?page=groups&section=edit&pro=approve_discussions&grp_id=".$grp_id;
			$pages = handle_multipages( $p, $total, $link );
			$sql_query = "SELECT * FROM group_forum WHERE grp_id=".$grp_id." AND approved='0'
						  ORDER BY posted DESC
						  LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$discussions = array();
			foreach($result as $res) {
				$card = array();
				$card["pst_id"] = $res["pst_id"];
				$card["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
				$card["message"] = nl2br( handle_string_cut( $res["message"], 100 ) );
				$card["reply"] = ($res["reply_to"]) ? 1 : 0;
				$discussions[] = $card;
			}
			$GLOBALS["smarty"]->assign("discussions", $discussions);
			$GLOBALS["smarty"]->assign("pages", $pages);
			break;
		default:			
			break;
	}
	
}

function group_update() {
	
	$info = auth_member();
	auth_group_edit_access();
	
	$pro      = $GLOBALS["Get"]->val("pro");
	$grp_id   = $GLOBALS["Get"]->type_val("grp_id","integer");
	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	
	switch($pro) {
		case 'members':
			$mem_id = $GLOBALS["Get"]->val("mem_id");
			if(count($mem_id)) {
				foreach($mem_id as $mem) {
					$GLOBALS["Groups"]->remove_member( $mem, $grp_id );
				}
			}
			break;
		case 'videos':
			$vid_id = $GLOBALS["Get"]->val("vid_id");
			if(count($vid_id)) {
				foreach($vid_id as $vid) {
					$sql_query = "DELETE FROM group_videos WHERE vid_id=".$vid." AND grp_id=".$grp_id;
					$GLOBALS["DB"]->execute( $sql_query );
				}
			}
			break;
		case 'discussions':
			$pst_id = $GLOBALS["Get"]->val("mes_id");
			if(count($pst_id)) {
				foreach($pst_id as $pst) {
					$sql_query = "DELETE FROM group_forum WHERE (pst_id=".$pst." OR reply_to=".$pst.") AND grp_id=".$grp_id;
					$GLOBALS["DB"]->execute( $sql_query );
				}
			}
			break;
		case 'approve_videos':
			$vid_id = $GLOBALS["Get"]->val("vid_id");
			if(count($vid_id)) {
				$act = $GLOBALS["Get"]->val("act");
				$all = $GLOBALS["Get"]->type_val("all","integer");
				if($all) {
					$sql_query = "UPDATE group_videos SET approved='1' WHERE grp_id=".$grp_id;
					$GLOBALS["DB"]->execute( $sql_query );
				} else {
					foreach($vid_id as $vid) {
						if($act == "del"){
							$sql_query = "DELETE FROM group_videos WHERE vid_id=".$vid." AND grp_id=".$grp_id;
							$GLOBALS["DB"]->execute( $sql_query );
						} else {
							$sql_query = "UPDATE group_videos SET approved='1' WHERE vid_id=".$vid." AND grp_id=".$grp_id;
							$GLOBALS["DB"]->execute( $sql_query );
						}
					}
				}
			}
			break;
		case 'approve_discussions':
			$pst_id = $GLOBALS["Get"]->val("mes_id");
			if(count($pst_id)) {
				$act = $GLOBALS["Get"]->val("act");
				$all = $GLOBALS["Get"]->type_val("all","integer");
				if($all) {
					$sql_query = "UPDATE group_forum SET approved='1' WHERE grp_id=".$grp_id;
					$GLOBALS["DB"]->execute( $sql_query );
				} else {
					foreach($pst_id as $pst) {
						if($act == "del"){
							$sql_query = "DELETE FROM group_forum WHERE (pst_id=".$pst." OR reply_to=".$pst.") AND grp_id=".$grp_id;
							$GLOBALS["DB"]->execute( $sql_query );
						} else {
							$sql_query = "UPDATE group_forum SET approved='1' WHERE pst_id=".$pst." AND grp_id=".$grp_id;
							$GLOBALS["DB"]->execute( $sql_query );
						}
					}
				}
			}
			break;
		case 'remove':
			include(DOC_ROOT."/functions/delete_functions.php");
			delete_group( $grp_id );
			load_page("index.php?page=groups&section=manage&cmp_id=406");
			break;
		case 'icon':
			$vid_id = $GLOBALS["Get"]->type_val("vid_id", "integer");
			$sql_query = "UPDATE groups SET icon=".$vid_id." WHERE grp_id=".$grp_id;
			$GLOBALS["DB"]->execute( $sql_query );
			$pro = "videos";
			break;
		default:
			include(DOC_ROOT."/functions/form_functions.php");
			$values = form_handle_input( "group_edit" );
			$tags = explode(" ", $values["tags"]);
			$tags = handle_empties( $tags );
			$values["tags"] = "|".implode("|", $tags)."|";
			load_db_update( "group_edit", $values, array("grp_id", $values["grp_id"]) );
			break;
	}
	
	if(!$ret_link)
		load_page( "index.php?page=groups&section=edit&pro=".$pro."&grp_id=".$grp_id );
	else
		load_page( $ret_link );
	
}

function my_groups() {
	
	$pro = $GLOBALS["Get"]->val("pro");
	
	if(!$pro)
		groups_i_own();
	elseif($pro == "membership")
		groups_i_joined();
	
	$GLOBALS["smarty"]->assign("pro", $pro);
	
}

function groups_i_own() {
	
	$info = $GLOBALS["Member"]->info();
	
	$p = $GLOBALS["Get"]->type_val("p", "integer");
	$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM groups WHERE mem_id=".$info["mem_id"] );
	$link = "index.php?page=groups&section=manage";
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT grp_id FROM groups WHERE mem_id=".$info["mem_id"]."
				  ORDER BY created DESC
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$groups = array();
	foreach($result as $res) {
		$card = $GLOBALS["Groups"]->card( $res["grp_id"] );
		$groups[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("groups", $groups);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function groups_i_joined() {
	
	$info = $GLOBALS["Member"]->info();
	
	$p = $GLOBALS["Get"]->type_val("p", "integer");
	$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM group_members AS gm, groups AS g WHERE 
									  g.grp_id = gm.grp_id AND g.mem_id != ".$info["mem_id"]." AND gm.mem_id=".$info["mem_id"] );
	$link = "index.php?page=groups&section=manage&pro=membership";
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT gm.grp_id FROM group_members AS gm, groups AS g WHERE 
				  g.grp_id = gm.grp_id AND g.mem_id != ".$info["mem_id"]." AND gm.mem_id=".$info["mem_id"]."
				  LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$groups = array();
	foreach($result as $res) {
		$card = $GLOBALS["Groups"]->card( $res["grp_id"] );
		$groups[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("groups", $groups);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function groups_browse() {
	
	$info = $GLOBALS["Member"]->info();
	
	$type = $GLOBALS["Get"]->val("type");
	$c = $GLOBALS["Get"]->type_val("c","integer");
	$p = $GLOBALS["Get"]->type_val("p","integer");
	
	$sql_query = "SELECT COUNT(*) FROM groups WHERE privacy < 3";
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	if($c) {
		$add = " AND g.category = ".$c;
	}
	
	switch($type) {	
		case 'featured':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM groups AS g WHERE privacy < 3 AND featured='1'".$add );
			$main_query = "SELECT grp_id FROM groups AS g WHERE privacy < 3 AND featured='1' ".$add." ORDER BY created DESC";
			break;
		case 'discussions':
			$main_query = "SELECT g.grp_id, COUNT(*) AS ord FROM groups AS g LEFT JOIN group_forum AS gf
						   ON (g.grp_id = gf.grp_id AND gf.reply_to = 0) WHERE g.privacy < 3 ".$add."
						   GROUP BY g.grp_id ORDER BY ord DESC";
			break;
		case 'members':
			$main_query = "SELECT g.grp_id, COUNT(*) AS ord FROM groups AS g LEFT JOIN group_members AS gm
						   ON (g.grp_id = gm.grp_id) WHERE g.privacy < 3 ".$add."
						   GROUP BY g.grp_id ORDER BY ord DESC";
			break;
		default:
		case 'videos':
			$main_query = "SELECT g.grp_id, COUNT(*) AS ord FROM groups AS g LEFT JOIN group_videos AS gv
						   ON (g.grp_id = gv.grp_id AND gv.approved='1') WHERE g.privacy < 3 ".$add."
						   GROUP BY g.grp_id ORDER BY ord DESC";
			break;
	}
	
	$link = "index.php?page=groups_browse&type=".$type."&c=".$c;
	$pages = handle_multipages( $p, $total, $link );
	
	$main_query.= " LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $main_query );
	
	$groups = array();
	foreach($result as $res) {
		$card = $GLOBALS["Groups"]->card( $res["grp_id"] );
		$groups[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("groups", $groups);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function groups_browse_data() {
	
	$type = $GLOBALS["Get"]->val("type");
	
	$data["c"] = $GLOBALS["Get"]->type_val("c","integer");

	$cat = array();
	$cat["name"] = $GLOBALS["language"]["all"];
	$cat["id"] = 0;
	$cat["link"] = "index.php?page=groups&type=".$type;
	
	$data["categories"][] = $cat;
	
	$cats = $GLOBALS["Groups"]->categories();
	foreach($cats as $k => $v) {
		
		$cat = array();
		$cat["name"] = $v;
		$cat["id"] = $k;
		$cat["link"] = "index.php?page=groups&section=browse&type=".$type."&c=".$k;
		$data["categories"][] = $cat;			
		
	}
	
	$GLOBALS["smarty"]->assign("data", $data);
	
}

function invite_to_group(){

	$info = auth_member();
	auth_group_action_access();
	$grp_id = $GLOBALS["Get"]->type_val("grp_id","integer");

	

	include_once(DOC_ROOT."/functions/form_functions.php");

	$values = form_handle_input("group_invite");
	$values["to"] = handle_empties(explode(",", $values["to"]));
	
	if(!count($values["to"]) && !count($values["invitees"])) {
		build_error( 411, "groups", "invite" );
	}	

	if( count( $values["invitees"] ) ) {
		foreach($values["invitees"] as $member) {	
			invite_to_group_internal( $member, $grp_id, $values["message"] );
		}
	}
	
	if( count($values["to"]) ) {
		foreach($values["to"] as $recipient) {
			if(preg_match("/^\[/", $recipient)) {
				$username  = rtrim( $recipient, "]" );
				$username  = ltrim( $username, "[" );
				$sql_query = "SELECT mem_id FROM members WHERE username=':0:'";
				$GLOBALS["DB"]->values = array( $username );
				$to = $GLOBALS["DB"]->single( $sql_query );
				if($to)
					invite_to_group_internal( $member, $grp_id, $values["message"] );
			} else {
				if(validate_email_syntax( $recipient )){
					$sql_query = "SELECT mem_id FROM members WHERE email=':0:'";
					$GLOBALS["DB"]->values = array( $recipient );
					$to = $GLOBALS["DB"]->single( $sql_query );
					if(!$to)
						invite_to_group_external( $recipient, $grp_id, $values["message"] );
					else
						invite_to_group_internal( $to, $grp_id, $values["message"] );
				}
			}
		}
	}
		
	load_page( build_group_link_by_id( $grp_id, 1 )."cmp_id=403" );

}//invite_to_group

function invite_to_group_internal( $recipient, $grp_id, $message ) {
	
	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT name FROM groups WHERE grp_id=".$grp_id;
	$group_name = $GLOBALS["DB"]->single($sql_query);
	
	build_access( "group", array( $grp_id, $recipient ) );
	
	include_once(DOC_ROOT."/classes/Mail.class.php");
	
	$mail_details1 = array (
		"mes_id" => 110,
		"sender" => $info["mem_id"],
		"group_name" => $group_name,
		"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
		"special" => "group_invite|".$grp_id,
		"mailbox" => "groups",
		"body" => $message
	);

	$GLOBALS["Mail"]->details = $mail_details1;
	$GLOBALS["Mail"]->details["recipient"] = $recipient;
	$GLOBALS["Mail"]->send_internal();

	$mail_details2 = array (
		"mes_id"      => 18,
		"recipient"   => $recipient,
		"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
		"group_name"   => $group_name
	);
	
	$GLOBALS["Mail"]->details = $mail_details2;
	$GLOBALS["Mail"]->send_mass();
	
}

function invite_to_group_external( $recipient, $grp_id, $message ) {
	
	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT name FROM groups WHERE grp_id=".$grp_id;
	$group_name = $GLOBALS["DB"]->single($sql_query);
	
	$viewkey = build_viewkey( "group", array($grp_id, $recipient) );
	
	$additional["invitation_link"] = build_group_link_by_id( $grp_id,1 );
	if($viewkey){$additional["invitation_link"].= "viewkey=".$viewkey."&";}
	$additional["slink"] = $additional["invitation_link"];
	$additional["invitation_link"].= "inv_id=";
	$additional["update_query"]    = "UPDATE invitations SET grp_id=".$grp_id;
	$additional["group_name"]      = $group_name;
	handle_external_invitation($info["mem_id"],$recipient,"",$message,19,$additional);
	
}

function group_delete_post() {
	
	$info = auth_member();
	$pst_id = $GLOBALS["Get"]->type_val("pst_id","integer");
	
	$post = $GLOBALS["DB"]->row( "SELECT * FROM group_forum WHERE pst_id=".$pst_id );
	if($post["mem_id"] == $info["mem_id"]) {
		include(DOC_ROOT."/functions/delete_functions.php");
		delete_group_post( $pst_id );
	}
		
	load_page( $GLOBALS["Get"]->referer() );
	
}

?>