<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");
						if(!$action)
							$action = $GLOBALS["Get"]->val("act");

							switch($action){

								case 'upload':
									video_upload();
									break;
									
								case 'update':
									video_update();
									break;
									
								case 'delete':
									video_delete();
									break;
									
								case 'show':
									video_show();
									break;
									
								case 'respond':
									video_post_respond();
									break;
									
								case 'delete_comment':
									video_delete_comment();
									break;
									
								case 'related':
									videos_related();
									break;
									
								case 'download':
									video_download();
									break;

							}//switch

						///////////////////////////////////////

function video_upload() {

	global $forms;

	$info = auth_member();
	include_once(DOC_ROOT."/functions/form_functions.php");

	$step = $GLOBALS["Get"]->val("step");

	switch($step) {

		case '1':
			$values = form_handle_input("video_upload_general");
			$source = $GLOBALS["Get"]->val("source");
			$values["source"] = $source;
			$values["session"] = handle_session_data( $values, $info["mem_id"], $values["session"] );
			if($source == "upload") {
				progress_bar();
				$forms["video_upload"]["values"] = $values;
				$p_details = array(
					"page" => "videos",
					"section" => "upload",
					"items_file" => "videos_upload"
				);
			}
			build_page($p_details);
			break;

		case 'upload':
			$values = form_handle_input("video_upload");
			$values = array_merge( $values, extract_session_data( $values["session"], $info["mem_id"] ) );
			
			if($values["source"] == "upload") {
				progress_bar();
			}
			
			$upload_id = $GLOBALS["Get"]->val("upload_id");
			if($upload_id) {
				$upload_info = file( DOC_ROOT."/uploader/tmp/".$upload_id.".redirect" );
				list( $name, $type, $size ) = explode( ":", trim($upload_info[0]) );
				$fileinfo["tmp"]  = DOC_ROOT."/vid/".$name;
				$fileinfo["name"] = $name;
				$fileinfo["type"] = $type;
				$fileinfo["size"] = $size;
				if($fileinfo["size"] > $GLOBALS["Videos"]->maxsize*1048576){
					@unlink($fileinfo["tmp"]);
					build_error(7,"videos","upload");
				}
			} else {
				$fileinfo = $values["upfile_0"];
				if($fileinfo["size"] > $GLOBALS["Videos"]->maxsize*1048576){
					build_error(7,"videos","upload");
				}
			}

			if(!$fileinfo["tmp"]) {
				build_error(13,"videos","upload");
			}

			$extension = video_file_extension( $fileinfo );
			
			if(!$extension){
				@unlink( $fileinfo["tmp"] );
				build_error(2000,"videos","upload");
			}
			
			$hash = build_unique_path( DOC_ROOT."/vid", ".flv" );
			$dist_file = DOC_ROOT."/vid/".$hash.$extension;

			if($upload_id) {
				rename( $fileinfo["tmp"], $dist_file );
			} else {
				move_uploaded_file( $fileinfo["tmp"], $dist_file );
			}
			@chmod($dist_file, 0644);
			
			$duration = extract_duration_from_file( $dist_file );
			if( $GLOBALS["Videos"]->maxtime > 0 && $duration > $GLOBALS["Videos"]->maxtime * 60 ) {
				@unlink( $dist_file );
				build_error(59, "videos", "upload");
			}
			
			$tags = explode(" ", $values["tags"]);
			$tags = handle_empties( $tags );
			$values["tags"] = "|".implode("|", $tags)."|";
			
			$sql_query = "INSERT INTO videos (mem_id,title,description,category,tags,date,country,location,broadcast,comments,comment_voting,responses,ratings,embedding,vhash,posted,approved)
						  VALUES (:mem_id:,':title:',':description:',:category:,':tags:',':date:',':country:',':location:',':broadcast:',':comments:',':comment_voting:',':responses:',':ratings:',':embedding:',':hash:',:time:,':approved:')";
			
			$values["mem_id"] = $info["mem_id"];
			$values["approved"] = ( $GLOBALS["Videos"]->approve ) ? 0 : 1;
			$values["time"] = time();
			$values["hash"] = $hash;
			
			$GLOBALS["DB"]->values = $values;
			$vid_id = $GLOBALS["DB"]->insert( $sql_query );
			
			$GLOBALS["DB"]->clean();
			
			if($GLOBALS["Videos"]->convert == "instant") {
				
				$cgi = ( strpos(php_sapi_name(), 'cgi') || SUPHP ) ? 'env -i ' : NULL;
				$cmd = $cgi.$GLOBALS["paths"]["php"].' '.DOC_ROOT.'/crons/convert.php "'.DOC_ROOT.'" "'.$vid_id.'" "'.$hash.'" "'.$extension.'" >/dev/null &';
				exec($cmd);
				
			} else {
			
				$sql_query = "INSERT INTO video_convert (vid_id, hash, ext, tstamp) 
							  VALUES (:vid_id:,':hash:',':ext:',:time:)";
				$GLOBALS["DB"]->values = array ("vid_id" => $vid_id, "hash" => $hash, "ext" => $extension, "time" => time());
				$GLOBALS["DB"]->execute( $sql_query );
				
			}
			
			if($values["response_to"]) {
				if(auth_video_access_ajax( $values["response_to"] )) {
					$video = $GLOBALS["Videos"]->info( $values["response_to"] );
					switch($video["responses"]) {		
						case '1':
							$approved = 1;
							break;
						case '2':
							$approved = 0;
							break;
						case '3':
						default:
							$approved = -1;
						
					}
					
					$sql_query = "SELECT COUNT(*) FROM video_responses WHERE vid_id=:vid_id: AND response_to=:response_to:";
					$GLOBALS["DB"]->values = array (
						"vid_id" => $vid_id,
						"response_to" => $values["response_to"]
					);
					$exists = $GLOBALS["DB"]->single( $sql_query );
					
					if($approved >= 0 && !$exists) {
				
						$sql_query = "INSERT INTO video_responses (vid_id, response_to, approved, posted)
									  VALUES (:vid_id:,:response_to:,':approved:',:time:)";
						
						$GLOBALS["DB"]->values = array (
							"vid_id" => $vid_id,
							"response_to" => $values["response_to"],
							"approved" => $approved,
							"time" => time()
						);
						
						$GLOBALS["DB"]->execute( $sql_query );
						
						if(!$approved) {
							include_once(DOC_ROOT."/classes/Mail.class.php");
						
							$mail_details1 = array (
								"mes_id" => 114,
								"sender" => $info["mem_id"],
								"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
								"special" => $vid_id."|".$values["response_to"],
								"mailbox" => "responses"
							);
							
							$GLOBALS["Mail"]->details = $mail_details1;
							$GLOBALS["Mail"]->details["recipient"] = $video["mem_id"];
							$GLOBALS["Mail"]->send_internal();
						}
						
					}
				}
			}
			
			load_page( "index.php?page=videos&section=upload_complete&vid_id=".$vid_id );

			break;

	}

}

function video_file_extension( $fileinfo ) {
	$oextension = substr( $fileinfo["name"], strrpos( $fileinfo["name"], "." ) );
	$formats = $GLOBALS["Videos"]->formats;
	$extension = "";
	$mime = "";
	while(list($key,$val) = each($formats)){
		if( $oextension == $val ){
			$extension = $val;
		}//if
	}//while
	
	return $extension;
}

function progress_bar() {
	if($GLOBALS["Videos"]->progress_bar) {

		$extensions = array();
		$formats = $GLOBALS["Videos"]->formats;
		foreach($formats as $format) {
			$extensions[] = trim( $format, "." );
		}

		$GLOBALS["page_details"]["code"].=
	   	 "<style>
		    .debug {font:16px Arial; background-color:#FFFFFF; border:1px solid #898989; width:700px; height:100px; overflow:auto;}
		    .data {background-color:#FFFFFF; width:400px;}
		    .data tr td {background-color:#FFFFFF; font: 8pt Tahoma, Arial, sans-serif; width:35%; color: #000000;}
		    .bar1 {background-image:url(/uploader/images/progress_bar_white.gif); layer-background-image:url(/uploader/images/progress_bar_white.gif); position:relative; text-align:left; height:15px; width:400px; border:1px solid #B3B3B3;}
			.bar2 {background-image:url(/uploader/images/progress_bar_blue.gif); layer-background-image:url(/uploader/images/progress_bar_blue.gif); position:relative; text-align:left; height:15px; width:0%;}
		  </style>
		  <script language=\"javascript\" type=\"text/javascript\">
		    var path_to_link_script = \"uploader/ubr_link_upload.php\";
		    var path_to_set_progress_script = \"uploader/ubr_set_progress.php\";
		    var path_to_get_progress_script = \"uploader/ubr_get_progress.php\";
		    var path_to_upload_script = \"./cgi-bin/ubr_upload.pl\";
		    var multi_configs_enabled = 0;
		    var check_allow_extensions_on_client = 0;
		    var check_disallow_extensions_on_client = 0;
		    var allow_extensions = /(".implode("|",$extensions).")$/i;
		    var check_file_name_format = 0;
		    var check_null_file_count = 1;
		    var check_duplicate_file_count = 1;
		    var max_upload_slots = 1;
		    var cedric_progress_bar = 1;
		    var cedric_hold_to_sync = 0;
		    var progress_bar_width = 400;
		    var show_percent_complete = 1;
		    var show_current_position = 1;
		    var show_elapsed_time = 1;
		    var show_est_time_left = 1;
		    var show_est_speed = 1;
		    var show_files_uploaded = 0;
		    var upload_form_name = \""."video_upload"."\";
		  </script>
		  <script language=\"javascript\" type=\"text/javascript\" src=\"uploader/ubr_file_upload.js\"></script>";

		$GLOBALS["page_details"]["onload"] = "iniFilePage();";

		$GLOBALS["smarty"]->assign("progress_bar", "1");
	} else {
		$GLOBALS["page_details"]["code"].= "<script language=\"javascript\" type=\"text/javascript\">
		function linkUpload() {
			document.form_upload.action = 'index.php';
			document.form_upload.submit();
		}
		</script>";
	}
}

function vidinfo() {
	
	$vid_id = $GLOBALS["Get"]->type_val( "vid_id", "integer" );
	$sql_query = "SELECT * FROM videos WHERE vid_id=".$vid_id;
	$video = $GLOBALS["DB"]->row( $sql_query );
	
	$video["card"] = $GLOBALS["Videos"]->card( $vid_id );
	
	$video["url"]   = URL."/index.php?page=videos&section=view&vid_id=".$vid_id;
	$video["embed"] = '<object width="420" height="345"><param name="movie" value="'.URL.'/swf/player.swf"></param><param name="allowFullScreen" value="true"></param><param name="flashvars" value="vid_id='.$vid_id.'&MainURL='.urlencode( URL ).'&em=1"><embed src="'.URL.'/swf/player.swf" flashvars="vid_id='.$vid_id.'&MainURL='.urlencode( URL ).'&em=1" type="application/x-shockwave-flash" allowScriptAccess="always" width="420" height="345" allowFullScreen="true"></embed></object>';
	$GLOBALS["smarty"]->assign("vidinfo", $video);
}

function video_screenshots() {
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$data = $GLOBALS["Videos"]->info( $vid_id );
	$data["thumbs"] = array();
	
	if($data["server"])
		include(DOC_ROOT."/includes/config/servers.inc.php");
	
	if($data["source"] != "embed") {
	
		for($i = 1; $i <= $GLOBALS["Videos"]->screenshots; $i++) {
			if( $data["server"] ) {
				$file = $servers[$data["server"]]["url"]."/scr/".$data["shash"]."_".$i.".jpg";
				if( fopen( $file, "r" ) )
					$data["thumbs"][$i] = $file;
			}
			else {
				$file = DOC_ROOT."/scr/".$data["shash"]."_".$i.".jpg";
				$img  = $data["shash"]."_".$i;
				if( file_exists( $file ) ) {
					$data["thumbs"][$i] = $img;
				}
			}			
			
		}
		
	} else {
		
		include_once( DOC_ROOT."/modules/grabber/".$data["service"].".php" );
		$data["thumbs"] = g_thumbnails( $data["vhash"] );
		$GLOBALS["smarty"]->assign("source","embed");
		
	}
	
	$GLOBALS["smarty"]->assign( "thumbnails", $data );
	
}

function my_videos(){

	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$info["mem_id"]." AND converted='1'";
	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");	
	$link  = "index.php?page=videos&section=manage";	
	$ajax_link = "CH_AjaxRequest( 'ajax.php?module=videos&section=videos&p=|p|', 'videosList', 'no' )";
	$pages = handle_multipages($p,$total,$link);
	$ajax_pages = handle_multipages($p,$total,$ajax_link);

	$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$info["mem_id"]." AND converted='1'
				  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result($sql_query);

	$videos = array();
	foreach($result as $res){
		$videos[] = $GLOBALS["Videos"]->card($res["vid_id"]);
	}//foreach

	$GLOBALS["smarty"]->assign("my_videos",$videos);
	$GLOBALS["smarty"]->assign("pages",$pages);
	$GLOBALS["smarty"]->assign("ajax_pages",$ajax_pages);

}//my_videos

function video_update() {
	
	$info = auth_member();
	auth_video_edit_access();
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input("video_edit");

	$vals = $values;
	$vals["mem_id"] = $info["mem_id"];
	$tags = explode(" ", $vals["tags"]);
	$tags = handle_empties( $tags );
	$vals["tags"] = "|".implode("|", $tags)."|";

	load_db_update( "video_edit", $vals, array("vid_id", $values["vid_id"]) );
	
	if($vals["broadcast"] == 1) {
		$sql_query = "DELETE FROM group_videos WHERE vid_id=".$values["vid_id"];
		$GLOBALS["DB"]->execute( $sql_query );
	}

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));

	load_page("index.php?page=videos&section=edit&vid_id=".$values["vid_id"]."&ret_link=".urlencode($ret_link));
	
}

function video_delete(){

	$info = auth_member();
	auth_video_edit_access();

	$del2 = $GLOBALS["Get"]->val("del2");

	if(!$del2){
		$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");

		$sql_query = "SELECT title FROM videos WHERE vid_id=".$vid_id;
		$name = $GLOBALS["DB"]->single($sql_query);

		$GLOBALS["forms"]["delete"]["values"]["ret_link"] = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
		$GLOBALS["forms"]["delete"]["values"]["handler"] = "videos";
		$GLOBALS["forms"]["delete"]["values"]["action"] = "delete";
		$GLOBALS["forms"]["delete"]["values"]["del2"] = 1;
		$GLOBALS["forms"]["delete"]["values"]["id"] = $vid_id;
		$GLOBALS["smarty"]->assign("item",$name);
		$GLOBALS["smarty"]->assign("link","index.php?page=videos&section=view&vid_id=".$vid_id);
		$p_details = array(
		"page" => "delete",
		"items_file" => "delete"
		);
		build_page($p_details);
	}//if
	else{
		$vid_id = $GLOBALS["Get"]->type_val("id","integer");
		include_once(DOC_ROOT."/functions/delete_functions.php");
		delete_video($vid_id);
	}//else

	$ret_link = stripslashes(html_entity_decode($GLOBALS["Get"]->val("ret_link")));
	load_page($ret_link);

}

function video_show(){

	set_time_limit(0);
	
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$ext    = $GLOBALS["Get"]->val("ext");
	
	$reply = $GLOBALS["Videos"]->show( $vid_id, $pla_id, $ext );

	$encoding = extract_encoding("html");
	Header("Content-Type:text/xml; charset=".$encoding);
	echo $reply;

	exit;

}

function video_view(){

	$info = auth_member();

	$output = "";
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");

	if($vid_id){

		$entry = $GLOBALS["Videos"]->info( $vid_id );
		if(!$entry || !$entry["converted"])
			build_error(2002,"videos");

		$output = '<script type="text/javascript">
		AC_FL_RunContent( "codebase", "http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0",
		"width", "'.$GLOBALS["Videos"]->pwidth.'",
		"height", "'.($GLOBALS["Videos"]->pheight + 30).'",
		"src", "swf/player",
		"quality", "high",
		"pluginspage", "http://www.macromedia.com/go/getflashplayer",
		"align", "middle",
		"play", "true",
		"loop", "true",
		"scale", "showall",
		"wmode", "window",
		"devicefont", "false",
		"id", "player",
		"bgcolor", "#000000",
		"name", "player",
		"menu", "true",
		"allowFullScreen", "true",
		"allowScriptAccess","always",
		"movie", "swf/player",
		"salign", "",
		"FlashVars","vid_id='.$vid_id.'&MainURL='.extract_mainurl().'&pla_id='.$pla_id.'&aplay=1"
		);
		</script>';
		
		$video["vid_id"]          = $vid_id;
		$video["video"]           = $output;
		$video["from"]            = $GLOBALS["Member"]->card( $entry["mem_id"], 1 );
		$video["response_to"]     = $GLOBALS["Videos"]->response_to( $vid_id );
		$video["is_bookmarked"]   = $GLOBALS["Videos"]->is_bookmarked( $vid_id );
		$video["views"]           = handle_num_format($entry["viewed"]);
		$video["favorited"]       = handle_num_format($GLOBALS["Videos"]->bookmarks( $vid_id ));
		$video["title"]           = $entry["title"];
		$video["description"]     = nl2br( hs_wordwrap( $entry["description"], 30 ) );
		$video["category"]        = $GLOBALS["Videos"]->category($entry["category"]);
		$video["category_id"]     = $entry["category"];
		$video["tags"]            = extract_tags( $entry["tags"] );
		$video["url"]             = URL."/index.php?page=videos&section=view&vid_id=".$vid_id;
		$video["embed"]           = '<object width="420" height="345"><param name="movie" value="'.URL.'/swf/player.swf"></param><param name="allowFullScreen" value="true"></param><param name="flashvars" value="vid_id='.$vid_id.'&MainURL='.urlencode( URL ).'&em=1"><embed src="'.URL.'/swf/player.swf" flashvars="vid_id='.$vid_id.'&MainURL='.urlencode( URL ).'&em=1" type="application/x-shockwave-flash" allowScriptAccess="always" width="420" height="345" allowFullScreen="true"></embed></object>';
		$video["added"]           = extract_time_relative( $entry["posted"] );
		$video["comments_count"]  = handle_num_format($GLOBALS["Videos"]->comments( $vid_id ));
		
		$responses_count          = $GLOBALS["Videos"]->responses( $vid_id );
		$video["responses_count"] = handle_num_format($responses_count);
		
		//also watching
		$sql_query = "SELECT mem_id FROM video_watch WHERE vid_id=".$vid_id." AND mem_id!=".$info["mem_id"]." AND expire > ".time()." LIMIT 0,30";
		$result = $GLOBALS["DB"]->result( $sql_query );
		$watching = array();
		foreach($result as $res) {
			$watching[] = $GLOBALS["Member"]->card( $res["mem_id"] );
		}
		$GLOBALS["smarty"]->assign("watching", $watching);
		
		if($entry["ratings"]) {
			$video["rating"] = $GLOBALS["Videos"]->rating( $vid_id );
			//recent ratings
			$sql_query = "SELECT mem_id,rate FROM video_votes WHERE vid_id=".$vid_id." ORDER BY timestamp DESC LIMIT 0,5";
			$result = $GLOBALS["DB"]->result( $sql_query );
			$ratings = array();
			foreach($result as $res) {
				$card = array();
				$card["from"] = $GLOBALS["Member"]->card( $res["mem_id"] );
				$card["rate"] = $GLOBALS["Videos"]->rating_format( $res["rate"], 1 );
				$ratings[] = $card;
			}
			$GLOBALS["smarty"]->assign("ratings", $ratings);
		}
		
		if($entry["responses"]) {
			//video responses
			$sql_query = "SELECT v.vid_id, v.mem_id FROM video_responses AS vr,videos AS v WHERE v.vid_id=vr.vid_id
						  AND vr.approved='1'
						  AND vr.response_to=".$vid_id." ".$GLOBALS["Videos"]->filter("v.")." ORDER BY vr.posted DESC LIMIT 0,4";
			$result = $GLOBALS["DB"]->result( $sql_query );
			$responses = array();
			foreach($result as $res) {
				$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
				if($res["mem_id"] == $info["mem_id"] || $info["mem_id"] == $entry["mem_id"])
					$card["delete"] = 1;
				$responses[] = $card;
			}
			$GLOBALS["smarty"]->assign("responses", $responses);
			
			$responses_pages = handle_roundpages( 0, $video["responses_count"] );
			$GLOBALS["smarty"]->assign("responses_pages", $responses_pages);
		}
		
		if($entry["comments"]) {
			//text comments
			$sql_query = "DELETE FROM video_comment_votes WHERE timestamp < ".(time() - 3600*24);
			$GLOBALS["DB"]->execute( $sql_query );
			
			$p = 0;
			$sql_query = "SELECT COUNT(*) FROM video_comments WHERE vid_id=".$vid_id." AND reply_to = 0 AND approved='1'";
			$total = $GLOBALS["DB"]->single( $sql_query );
			$pages = handle_multipages( $p, $total, "CH_AjaxRequest( 'ajax.php?module=videos&section=comments&vid_id=".$vid_id."&p=|p|', 'videoCommentsBody', 'no' )", 5 );
			$sql_query = "SELECT * FROM video_comments WHERE vid_id=".$vid_id." AND reply_to = 0 AND approved='1'
						  ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
			$result = $GLOBALS["DB"]->result( $sql_query );
			$comments = array();
			foreach($result as $res) {
				$comment = array();
				$comment["comment"] = nl2br( $res["comment"] );
				$comment["com_id"]  = $res["com_id"];
				$comment["from"]    = $GLOBALS["Member"]->card( $res["mem_id"] );
				$comment["posted"]  = extract_time_relative( $res["posted"] );
				$comment["rating"]  = $res["rating"];
				$comment["owner"]   = ($info["mem_id"] == $res["mem_id"]) ? true : false;
				if($res["mem_id"] == $info["mem_id"] || $entry["mem_id"] == $info["mem_id"])
					$comment["delete"] = 1;
				
				$sql_query = "SELECT COUNT(*) FROM video_comments WHERE reply_to=".$res["com_id"]." AND approved='1'";
				$comment["replies"] = $GLOBALS["DB"]->single($sql_query);
				$comments[] = $comment;
			}
			$GLOBALS["smarty"]->assign("comments", $comments);
			$GLOBALS["smarty"]->assign("comments_pages", $pages);
		}
		
		//more videos from this user
		$sql_query = "SELECT vid_id FROM videos WHERE mem_id=".$entry["mem_id"]." ".$GLOBALS["Videos"]->filter()." AND vid_id != ".$vid_id." ORDER BY posted DESC LIMIT 0,5";
		$result = $GLOBALS["DB"]->result( $sql_query );
		$more = array();
		foreach($result as $res) {
			$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
			$more[] = $card;
		}
		$GLOBALS["smarty"]->assign("more", $more);
		
		//related videos
		$tags = explode("|", $entry["tags"]);
		$sql_query = "SELECT vid_id FROM videos WHERE 1 ";
		if(count($tags))
			$sql_query.= " AND (";
		foreach($tags as $tag) {
			if($tag)
			$sql_query.= " tags LIKE '%|".handle_sql_patterns( $tag )."|%' OR ";
		}
		$sql_query = rtrim( $sql_query, " OR ");
		if(count($tags))
			$sql_query.= ")";
		$sql_query.= " AND vid_id != ".$vid_id." ".$GLOBALS["Videos"]->filter()." ORDER BY posted DESC LIMIT 0,5";
		$result = $GLOBALS["DB"]->result( $sql_query );
		$related = array();
		foreach($result as $res) {
			$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
			$related[] = $card;
		}
		$GLOBALS["smarty"]->assign("related", $related);
		
		$settings = array();
		$settings["comments"]       = $entry["comments"];
		$settings["comment_voting"] = $entry["comment_voting"];
		$settings["responses"]      = $entry["responses"];
		$settings["ratings"]        = $entry["ratings"];
		$settings["embedding"]      = $entry["embedding"];
		
		if($info["mem_id"] && $GLOBALS["Videos"]->download && auth_getpaid_download_access()) {
			$settings["download"] = 1;
		}

		$GLOBALS["smarty"]->assign("video",$video);
		$GLOBALS["smarty"]->assign("vsettings",$settings);

		$sql_query = "SELECT COUNT(*) FROM video_watch WHERE vid_id=".$vid_id."
					  AND mem_id=".$info["mem_id"]." AND expire > ".time();
		$watching  = $GLOBALS["DB"]->single( $sql_query );
		if(!$watching) {
			$sql_query = "UPDATE videos SET viewed=viewed+1 WHERE vid_id=".$vid_id;
			$GLOBALS["DB"]->execute($sql_query);
		}
		
		if(($info["mem_id"] && !$info["hide_status"]) || !$info["mem_id"]) {
			$sql_query = "REPLACE INTO video_watch (vid_id,mem_id,expire)
						  VALUES (".$vid_id.",".$info["mem_id"].",".(time() + $entry["length"]).")";
			$GLOBALS["DB"]->execute( $sql_query );
		}//if
		
		$GLOBALS["page_details"]["code"].= "<script language='JavaScript'>
		var languageLoading = '".$GLOBALS["language"]["loading"]."';
		var languageVotes = '".$GLOBALS["language"]["votes"]."';
		var languageThanksForRating = '".$GLOBALS["language"]["thanks_for_your_rating"]."';
		var languageRatings = new Array;
		languageRatings[1] = '".$GLOBALS["language"]["poor"]."';
		languageRatings[2] = '".$GLOBALS["language"]["nothing_special"]."';
		languageRatings[3] = '".$GLOBALS["language"]["worth_watching"]."';
		languageRatings[4] = '".$GLOBALS["language"]["pretty_cool"]."';
		languageRatings[5] = '".$GLOBALS["language"]["awesome"]."';
		</script>";
		
		$static_info = "";
		if ($GLOBALS["Videos"]->rated( $info["mem_id"], $vid_id )) {
			$static_info = $GLOBALS["language"]["already_rated"];
		}
		
		
		if($settings["ratings"]) {$GLOBALS["page_details"]["onload"].= "CH_RatingInit( ".$video["rating"]["rounded"].", ".$video["rating"]["votes"].", '".URL."/themes/".$GLOBALS["THEME"]."/gfx/icons/star_on.gif', '".URL."/themes/".$GLOBALS["THEME"]."/gfx/icons/star_off.gif', '".$static_info."' );";}
		$GLOBALS["page_details"]["meta"]["description"] = $entry["title"].": ".handle_string_cut( $entry["description"] );
		$GLOBALS["page_details"]["meta"]["keywords"] = build_keywords($entry["title"]." ".$entry["description"]." ".$entry["tags"]);
		$GLOBALS["page_details"]["meta"]["title"] = $entry["title"];

	}//if

}

function video_post_respond() {
	
	$info = auth_member();
	auth_video_access();
	
	include(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input( "video_response" );
	
	$pro = $GLOBALS["Get"]->type_val("pro","integer");
	
	if($pro)
		load_page( "index.php?page=videos&section=upload_general&response_to=".$values["vid_id"] );
		
	if(!$values["respond_with"])
		build_error( 49, $values["err_page"], $values["err_section"] );
		
	auth_video_edit_access( $values["respond_with"] );
	
	$video = $GLOBALS["Videos"]->info( $values["vid_id"] );
	switch($video["responses"]) {		
		case '1':
			$approved = 1;
			break;
		case '2':
			$approved = 0;
			break;
		case '3':
		default:
			build_error( 50, $values["err_page"], $values["err_section"] );
			break;
		
	}
	
	$sql_query = "SELECT COUNT(*) FROM video_responses WHERE vid_id=:vid_id: AND response_to=:response_to:";
	$GLOBALS["DB"]->values = array (
		"vid_id" => $values["respond_with"],
		"response_to" => $values["vid_id"]
	);
	$exists = $GLOBALS["DB"]->single( $sql_query );
	
	if($exists)
		build_error( 51, $values["err_page"], $values["err_section"] );
	
	if(!$exists) {

		$sql_query = "INSERT INTO video_responses (vid_id, response_to, approved, posted)
					  VALUES (:vid_id:,:response_to:,':approved:',:time:)";
		
		$GLOBALS["DB"]->values = array (
			"vid_id" => $values["respond_with"],
			"response_to" => $values["vid_id"],
			"approved" => $approved,
			"time" => time()
		);
		
		$GLOBALS["DB"]->execute( $sql_query );
		
		if(!$approved) {
			include_once(DOC_ROOT."/classes/Mail.class.php");
		
			$mail_details1 = array (
				"mes_id" => 114,
				"sender" => $info["mem_id"],
				"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
				"special" => $values["respond_with"]."|".$values["vid_id"],
				"mailbox" => "responses"
			);
			
			$GLOBALS["Mail"]->details = $mail_details1;
			$GLOBALS["Mail"]->details["recipient"] = $video["mem_id"];
			$GLOBALS["Mail"]->send_internal();
		} else {
			$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date,details) VALUES (".$info["mem_id"].",".$values["vid_id"].",4,".time().",'".$values["respond_with"]."')";
			$GLOBALS["DB"]->execute( $sql_query );
		}
		
	}
	
	load_page( "index.php?page=videos&section=view&vid_id=".$values["vid_id"]."&cmp_id=34" );
	
}

function videos_browse() {
	
	$info = $GLOBALS["Member"]->info();
	
	$type = $GLOBALS["Get"]->val("type");
	$c = $GLOBALS["Get"]->type_val("c","integer");
	$p = $GLOBALS["Get"]->type_val("p","integer");
	
	if($c) {
		$add = " AND v.category = ".$c;
	}
	
	$sql_query = "SELECT COUNT(*) FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter("v.").$add;
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	switch($type) {
		case 'featured':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter()." AND featured='1'".$add );
			$main_query = "SELECT vid_id FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter().$add."
						   AND featured='1' ORDER BY posted DESC";
			break;
		case 'discussed':
			$main_query = "SELECT v.vid_id, vc.com_id AS ex, COUNT(*) AS ord FROM videos AS v LEFT JOIN video_comments AS vc
						   ON v.vid_id = vc.vid_id WHERE (vc.approved = '1' OR ISNULL(vc.approved)) ".$GLOBALS["Videos"]->filter("v.").$add."
						   GROUP BY v.vid_id ORDER BY ord DESC, CASE WHEN ( ex > 0 ) THEN 0 ELSE 1 END";
			break;
		case 'responded':
			$main_query = "SELECT v.vid_id, vr.vid_id AS ex, COUNT(*) AS ord FROM videos AS v LEFT JOIN video_responses AS vr
						   ON v.vid_id = vr.vid_id WHERE (vr.approved='1' OR ISNULL(vr.approved)) ".$GLOBALS["Videos"]->filter("v.").$add."
						   GROUP BY v.vid_id ORDER BY ord DESC, CASE WHEN ( ex > 0 ) THEN 0 ELSE 1 END";
			break;
		case 'viewed':
			$main_query = "SELECT vid_id FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter().$add."
						   ORDER BY viewed DESC";
			break;
		case 'favorites':
			$total = $GLOBALS["DB"]->single( "SELECT COUNT(*) FROM videos AS v LEFT JOIN bookmarks AS b
						   ON v.vid_id = b.item_id WHERE 1 ".$GLOBALS["Videos"]->filter("v.").$add );
			$main_query = "SELECT v.vid_id, b.item_id AS ex, COUNT(*) AS ord FROM videos AS v LEFT JOIN bookmarks AS b
						   ON v.vid_id = b.item_id WHERE 1 ".$GLOBALS["Videos"]->filter("v.").$add."
						   GROUP BY v.vid_id ORDER BY ord DESC, CASE WHEN ( ex > 0 ) THEN 0 ELSE 1 END";
			break;
		case 'rated':
			$main_query = "SELECT vid_id FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter().$add."
						   ORDER BY (rating/votes) DESC";
			break;
		case 'recent':
		default:
			$main_query = "SELECT vid_id FROM videos AS v WHERE 1 ".$GLOBALS["Videos"]->filter().$add."
						   ORDER BY posted DESC";
			break;
	}
	
	$link = "index.php?page=videos&type=".$type."&c=".$c;
	$pages = handle_multipages( $p, $total, $link );
	
	$main_query.= " LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $main_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function videos_browse_data() {
	
	$type = $GLOBALS["Get"]->val("type");
	
	$data["c"] = $GLOBALS["Get"]->type_val("c","integer");
	$data["display"] = $GLOBALS["Get"]->cookie("display");
	
	if(!$data["display"])
		$data["display"] = "basic";
	
	$cat = array();
	$cat["name"] = $GLOBALS["language"]["all"];
	$cat["id"] = 0;
	$cat["link"] = "index.php?page=videos&type=".$type;
	
	$data["categories"][] = $cat;
	
	$cats = $GLOBALS["Videos"]->categories();
	foreach($cats as $k => $v) {
		
		$cat = array();
		$cat["name"] = $v;
		$cat["id"] = $k;
		$cat["link"] = "index.php?page=videos&type=".$type."&c=".$k;
		$data["categories"][] = $cat;			
		
	}
	
	$GLOBALS["smarty"]->assign("data", $data);
	
}

function videos_homepage_boxes() {
	
	$info = $GLOBALS["Member"]->info();
	
	$boxes = array();
	
	//featured
	$sql_query = "SELECT vid_id FROM videos WHERE featured='1' ".$GLOBALS["Videos"]->filter()."
				  ORDER BY posted DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$boxes["featured"] = array();
	foreach($result as $res) {
		$boxes["featured"][] = $GLOBALS["Videos"]->card( $res["vid_id"] );
	}
	
	//most viewed
	$sql_query = "SELECT vid_id FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter()."
				  ORDER BY viewed DESC LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$boxes["viewed"] = array();
	foreach($result as $res) {
		$boxes["viewed"][] = $GLOBALS["Videos"]->card( $res["vid_id"] );
	}
	
	//most discussed
	$main_query = "SELECT v.vid_id, vc.vid_id AS ex, COUNT(*) AS ord FROM videos AS v LEFT JOIN video_comments AS vc
				   ON v.vid_id = vc.vid_id WHERE (vc.approved = '1' OR ISNULL(vc.approved)) ".$GLOBALS["Videos"]->filter("v.").$add."
				   GROUP BY v.vid_id ORDER BY ord DESC, CASE WHEN ( ex > 0 ) THEN 0 ELSE 1 END LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $main_query );
	$boxes["discussed"] = array();
	foreach($result as $res) {
		$boxes["discussed"][] = $GLOBALS["Videos"]->card( $res["vid_id"] );
	}
	
	//top favorites
	$main_query = "SELECT v.vid_id, b.item_id AS ex, COUNT(*) AS ord FROM videos AS v LEFT JOIN bookmarks AS b
				   ON v.vid_id = b.item_id WHERE 1 ".$GLOBALS["Videos"]->filter("v.").$add."
				   GROUP BY v.vid_id ORDER BY ord DESC, CASE WHEN ( ex > 0 ) THEN 0 ELSE 1 END LIMIT 0,10";
	$result = $GLOBALS["DB"]->result( $main_query );
	$boxes["favorites"] = array();
	foreach($result as $res) {
		$boxes["favorites"][] = $GLOBALS["Videos"]->card( $res["vid_id"] );
	}
	
	//recent videos
	$sql_query = "SELECT vid_id FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter()."
				  ORDER BY posted DESC LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$boxes["recent"] = array();
	foreach($result as $res) {
		$boxes["recent"][] = $GLOBALS["Videos"]->card( $res["vid_id"] );
	}
	
	//recent logins
	$sql_query = "SELECT m.mem_id FROM members AS m, profiles AS p WHERE m.mem_id = p.mem_id 
				  AND m.verified='1' ORDER BY p.last_click DESC LIMIT 0,9";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$boxes["members"] = array();
	foreach($result as $res) {
		$boxes["members"][] = $GLOBALS["Member"]->card( $res["mem_id"] );
	}
	
	//friend activity
	$sql_query = "DELETE FROM activity WHERE date < ".(time() - 3600 * 24 * 100);
	$GLOBALS["DB"]->execute( $sql_query );
	
	$cache = $GLOBALS["Network"]->get_cache( $info["mem_id"] );
	$sql_query = "SELECT * FROM activity WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] )."
				  ORDER BY date DESC LIMIT 0,5";
	$result = $GLOBALS["DB"]->result( $sql_query );
	$boxes["activity"] = array();
	
	$types = array(
		1 => "upload",
		2 => "rate",
		3 => "comment",
		4 => "response",
		5 => "favorited"
	);
	
	foreach($result as $res) {
		$feed = array();
		$feed["date"]    = extract_time( $res["date"], 1 );
		$feed["member"]  = $GLOBALS["Member"]->card( $res["mem_id"] );
		$feed["action"]  = $types[$res["action"]];
		$feed["card"]    = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$feed["details"] = $res["details"];
		if($feed["action"] == "response")
			$feed["card2"] = $GLOBALS["Videos"]->card( $res["details"] );
		$boxes["activity"][] = $feed;
	}
	
	$GLOBALS["page_details"]["code"].= "<script language='JavaScript'>
		var languageVideoAreas = new Array;
		languageVideoAreas['featured'] = '".$GLOBALS["language"]["featured_videos"]."';
		languageVideoAreas['viewed'] = '".$GLOBALS["language"]["most_viewed_videos"]."';
		languageVideoAreas['discussed'] = '".$GLOBALS["language"]["most_discussed_videos"]."';
		languageVideoAreas['favorites'] = '".$GLOBALS["language"]["top_favorites"]."';
		</script>";
	
	$GLOBALS["smarty"]->assign("boxes", $boxes);
	
}

function friend_activity() {
	
	$info = $GLOBALS["Member"]->info();
	
	$sql_query = "DELETE FROM activity WHERE date < ".(time() - 3600 * 24 * 100);
	$GLOBALS["DB"]->execute( $sql_query );
	
	$cache = $GLOBALS["Network"]->get_cache( $info["mem_id"] );
	
	$sql_query = "SELECT COUNT(*) FROM activity WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] );	
	$total = $GLOBALS["DB"]->single($sql_query);	
	$p     = $GLOBALS["Get"]->type_val("p","integer");	
	$link  = "index.php?page=videos&section=activity";	
	$pages = handle_multipages($p,$total,$link);
	
	$sql_query = "SELECT * FROM activity WHERE ".$GLOBALS["Network"]->extract_hs_query( $cache["friends"] )."
				  ORDER BY date DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	$activity = array();
	
	$types = array(
		1 => "upload",
		2 => "rate",
		3 => "comment",
		4 => "response",
		5 => "favorited"
	);
	
	foreach($result as $res) {
		$feed = array();
		$feed["date"]    = extract_time( $res["date"], 1 );
		$feed["member"]  = $GLOBALS["Member"]->card( $res["mem_id"] );
		$feed["action"]  = $types[$res["action"]];
		$feed["card"]    = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$feed["details"] = $res["details"];
		if($feed["action"] == "response")
			$feed["card2"] = $GLOBALS["Videos"]->card( $res["details"] );
		$activity[] = $feed;
	}
	
	$GLOBALS["smarty"]->assign("activity", $activity);
	$GLOBALS["smarty"]->assign("pages", $pages);
	
}

function videos_statistics() {
	
	$stats = array();
	
	//videos
	$sql_query = "SELECT COUNT(*) FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter();
	$stats["videos"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
	
	//members
	$sql_query = "SELECT COUNT(*) FROM members WHERE verified='1'";
	$stats["members"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
	
	//views
	$sql_query = "SELECT SUM(viewed) FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter();
	$stats["views"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
	
	//groups
	$sql_query = "SELECT COUNT(*) FROM groups WHERE privacy < 3";
	$stats["groups"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
	
	$GLOBALS["smarty"]->assign("stats", $stats);
	
	$info = $GLOBALS["Member"]->info();
	$my_stats = array();
	if($info["mem_id"]) {
		//videos
		$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$info["mem_id"]." AND converted='1'";
		$my_stats["videos"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
		
		//videos viewed
		$sql_query = "SELECT SUM(viewed) FROM videos WHERE mem_id=".$info["mem_id"]." AND converted='1'";
		$my_stats["videos_viewed"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
		
		//channel viewed
		$sql_query = "SELECT views FROM channels WHERE mem_id=".$info["mem_id"];
		$my_stats["channel_viewed"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
		
		//friends
		$cache = $GLOBALS["Network"]->get_cache( $info["mem_id"] );
		$my_stats["friends"] = handle_num_format( $cache["friends_count"] );
		
		//groups
		$sql_query = "SELECT COUNT(*) FROM groups WHERE mem_id=".$info["mem_id"];
		$my_stats["groups"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
		
		//mailbox
		$sql_query = "SELECT COUNT(*) FROM mailbox WHERE (mailbox='inbox' OR mailbox='shared')
					  AND mem_id=".$info["mem_id"]." AND viewed='0'";
		$my_stats["inbox"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
		
		//friend requests
		$sql_query = "SELECT COUNT(*) FROM mailbox WHERE mailbox='invites'
					  AND mem_id=".$info["mem_id"];
		$my_stats["invites"] = handle_num_format( $GLOBALS["DB"]->single( $sql_query ) );
	}
	$GLOBALS["smarty"]->assign("my_stats", $my_stats);
	
}

function video_delete_comment() {
	
	$info = auth_member();
	
	$com_id = $GLOBALS["Get"]->type_val("com_id","integer");
	
	$sql_query = "SELECT * FROM video_comments WHERE com_id=".$com_id;
	$comment = $GLOBALS["DB"]->row( $sql_query );
	
	$video = $GLOBALS["Videos"]->info( $comment["vid_id"] );
	
	if($info["mem_id"] == $video["mem_id"] || $info["mem_id"] == $comment["mem_id"]) {
		include(DOC_ROOT."/functions/delete_functions.php");
		delete_video_comment( $com_id );
	}
	
	load_page( "index.php?page=videos&section=view&vid_id=".$comment["vid_id"] );
	
}

function videos_related() {
	
	set_time_limit(0);
	
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	$pla_id = $GLOBALS["Get"]->type_val("pla_id","integer");
	$entry  = $GLOBALS["Videos"]->info( $vid_id );
	
	if($pla_id) {
		
		$sql_query = "SELECT pv.vid_id FROM playlist_videos AS pv, videos AS v WHERE pv.vid_id=v.vid_id AND pv.pla_id=".$pla_id." ".$GLOBALS["Videos"]->filter("v.")."
					  ORDER BY pv.position DESC";
		$result = $GLOBALS["DB"]->result( $sql_query );
		
	} else {

		$tags = explode("|", $entry["tags"]);
		$sql_query = "SELECT vid_id FROM videos WHERE 1 ";
		if(count($tags))
			$sql_query.= " AND (";
		foreach($tags as $tag) {
			if($tag)
				$sql_query.= " tags LIKE '%|".handle_sql_patterns( $tag )."|%' OR ";
		}
		$sql_query = rtrim( $sql_query, " OR ");
		if(count($tags))
			$sql_query.= ")";
		$sql_query.= " AND vid_id != ".$vid_id." ".$GLOBALS["Videos"]->filter()." ORDER BY posted DESC LIMIT 0,10";
		$result = $GLOBALS["DB"]->result( $sql_query );
		
	}
	
	$related = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$rating = $card["rating"]["int"];
		if($card["rating"]["residue"] >= 4)
			$rating+= 0.5;
		$card["rating"] = $rating;
		$related[] = $card;
	}

	$reply = "<reply>\n";
	$reply.= "<language><from>".htmlspecialchars($GLOBALS["language"]["from"])."</from><views>".htmlspecialchars($GLOBALS["language"]["views"])."</views></language>\n";
	$reply.= "<videos>\n";
	foreach($related as $video) {
		$reply.= "<video><url>".htmlspecialchars($video["link"])."</url><shash>".htmlspecialchars($video["shash"])."</shash>".
				 "<title>".htmlspecialchars($video["title_cut_30"])."</title><duration>".htmlspecialchars($video["duration"])."</duration>".
				 "<from>".htmlspecialchars($video["from"]["username_cut"])."</from><rating>".htmlspecialchars($video["rating"])."</rating>".
				 "<views>".htmlspecialchars($video["views"])."</views><vidid>".htmlspecialchars($video["vid_id"])."</vidid></video>\n";
	}
	$reply.= "\n</videos>\n</reply>";

	$encoding = extract_encoding("html");
	Header("Content-Type:text/xml; charset=".$encoding);
	echo $reply;

	exit;
	
}

function video_download() {
	
	$info = auth_member();
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	
	auth_video_access();
	
	if(!$info["mem_id"] || !$GLOBALS["Videos"]->download || !auth_getpaid_download_access()) {
		load_page( "index.php?page=videos&section=view&vid_id=".$vid_id."&err_id=56" );
	}
	
	$entry = $GLOBALS["Videos"]->info( $vid_id );
	$file  = DOC_ROOT."/vid/".$entry["vhash"].".flv";
	
	// downloading a file
	$filename = substr( $entry["vhash"], strrpos( $entry["vhash"], "/" ) + 1 ).".flv";
	
	// fix for IE catching or PHP bug issue
	header("Pragma: public");
	header("Expires: 0"); // set expiration time
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	// browser must download file from server instead of cache
	
	// force download dialog
	header("Content-Type: application/force-download");
	header("Content-Type: application/octet-stream");
	header("Content-Type: application/download");
	
	// use the Content-Disposition header to supply a recommended filename and
	// force the browser to display the save dialog.
	header("Content-Disposition: attachment; filename=".$filename);
	
	/*
	The Content-transfer-encoding header should be binary, since the file will be read
	directly from the disk and the raw bytes passed to the downloading computer.
	The Content-length header is useful to set for downloads. The browser will be able to
	show a progress meter as a file downloads. The content-lenght can be determines by
	filesize function returns the size of a file.
	*/
	header("Content-Transfer-Encoding: binary");
	header("Content-Length: ".filesize( $file ));
	
	@readfile( $file );
	
	exit;
	
}

?>