<?php

	//load global configuration
	include("../../includes/config/config.inc.php");	
	
	//load libraries
	include(DOC_ROOT."/libraries.php");
	
	//load paypal class
	include("paypal.class.php");
	
	//initiate PayPal class
	$paypal = new paypal_class;
	$paypal->paypal_url = 'https://www.paypal.com/cgi-bin/webscr';
	
	$today = mktime(0,0,0,date("n"),date("j"),date("Y"));
	
	//checking status and updating DB
	if($paypal->validate_ipn()){
		
	   	$sql_query = "UPDATE payment_gateway SET `status`='paid'
	   				  WHERE order_id=".$paypal->ipn_data['custom']."
	   				  AND `status`='pending'
	   				  AND `next_payment` = ".$today;
	   	
	   	$GLOBALS["DB"]->execute($sql_query);
	   	
	   	//redirect to the getpaid module, which will finalize the order
	   	$redirect = file(URL."/index.php?handler=upgrade&action=payment_complete&order_id=".$paypal->ipn_data['custom']);
	   	
	}//if
	else{
		
		$sql_query = "DELETE FROM payment_gateway WHERE order_id=".$paypal->ipn_data['custom'];
		$GLOBALS["DB"]->execute($sql_query);
		
	}//else
	
	$DB->disconnect();
	
	Header("HTTP/1.1 200 OK");

?>