<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

class Member extends DB{

	function Member(){

		$this->values = array();

	}//Member

	function create($md5=0){

		if(!$md5)
			$pline = "md5(':password:')";
		else
			$pline = "':password:'";

		if($this->values["username"])
			$sql_add = "username=':username:' OR ";

		$sql_query = "SELECT COUNT(*) FROM members WHERE ".$sql_add." email=':email:'";
		$exists = $this->single($sql_query);

		if($exists)
			return false;

		$sql_query="INSERT INTO members (email,username,password,fname,lname)
					VALUES (':email:',':username:',".$pline.",':fname:',':lname:')";

		$mem_id = $this->insert($sql_query);
		
		$sql_query = "INSERT INTO channels(mem_id,type,title,colors,boxes) VALUES (".$mem_id.",1,':username:','grey','box_featured,box_subscriptions,box_bulletins,box_videos,box_favorites,box_friends,box_comments')";
		$this->execute($sql_query);

		$sql_query="INSERT INTO members_settings (mem_id) VALUES (".$mem_id.")";
		$this->execute($sql_query);

		if($GLOBALS["settings"]["track_profiles"])
			$approved = 0;
		else
			$approved = 1;

		$sql_query = "INSERT INTO profiles(mem_id,joined,updated,last_visit,last_click,approved)
					  VALUES (".$mem_id.",".time().",".time().",".time().",".time().",'".$approved."')";
		$this->execute($sql_query);

		$sql_query="INSERT INTO network(mem_id)
					VALUES(".$mem_id.")";
		$this->execute($sql_query);

		load_3rdparty("register",$this->values);

		return $mem_id;

	}//create

	function login($username,$password,$admin=0,$md5=0,$remember=0){

		$sql_query = "SELECT * FROM members WHERE username=':0:'";

		if($admin == 1)
			$sql_query.= " AND member_type='a'";
		elseif($admin == 2)
			$sql_query.= " AND member_type='m'";

		$this->values = array($username);
		$orig_mem = $mem = $this->row($sql_query);

		$password_parts = explode("|",$mem["password"]);
		$pwd = $password_parts[0];
		$salt = $password_parts[1];
		$type = $password_parts[2];

		if(!$md5){
			if($salt){
				if($type == "vb")
					$password_md5 = md5(md5($password).$salt);
				elseif($type == "ipb")
					$password_md5 = md5(md5($salt).md5($password));
			}//if
			else
				$password_md5 = md5($password);
		}//if
		else
			$password_md5 = $password;

		if($pwd != $password_md5)
			$mem["mem_id"] = 0;

		if(empty($mem["mem_id"])){
			$res = "n";
		}//if
		elseif(!$mem["verified"]){
			$res = "v";
		}//elseif
		elseif($mem["banned"]){
			$res = "b";
		}//elseif
		else{

			$mem_id = $mem["mem_id"];
			$sql_query = "UPDATE profiles SET last_visit=last_click
						  WHERE mem_id=".$mem_id;
			$this->execute($sql_query);

			$res = $mem_id;

			$mem["password"] = $password;
			$mem["remember"] = $remember;
			load_3rdparty("login",$mem);

			if($remember)
				$time = time()+3600*24*365*10;
			else
				$time = 0;

			load_cookie("mem_id",$mem_id,$time);
			load_cookie("password",$orig_mem["password"],$time);

		}//else

		return $res;

	}//login
	
	function card( $mem_id, $full = 0 ){
		
		static $cache = array();
		if(isset($cache[$mem_id]))
			return $cache[$mem_id];
		
		$info = $this->info( $mem_id );
		
		$card["username"] = $info["username"];
		$card["username_cut"] = $this->crop( $info["username"] );
		$card["title"] = $info["title"];
		$card["title_cut"] = $this->crop( $info["title"] );
		$card["link"] = build_channel_link($info["username"]);
		$card["linkq"] = build_channel_link($info["username"], 1);
		$card["avatar"] = ($info["avatar_approved"] || $GLOBALS["settings"]["show_unapproved_avatars"]) ? $info["avatar"] : "";
		$card["mem_id"] = $mem_id;
		$card["fname"] = $info["fname"];
		$card["lname"] = $info["lname"];
		if($full) {
			$card["joined"] = extract_date( $info["joined"] );
			$card["videos"] = $this->videos( $mem_id );
			$card["favorites"] = $this->favorites( $mem_id );
		}
		
		$cache[$mem_id] = $card;
		
		return $card;
	}
	
	function crop( $name ) {
		if($GLOBALS["settings"]["cropname"] && hs_strlen( $name ) > $GLOBALS["settings"]["cropname"]) {
			$name = hs_substr( $name, 0, $GLOBALS["settings"]["cropname"]-2 )."...";
		}
		return $name;
	}
	
	function favorites( $mem_id ){
		$sql_query = "SELECT COUNT(*) FROM bookmarks WHERE mem_id=".$mem_id;
		return $this->single( $sql_query );
	}
	
	function videos( $mem_id ){
		$sql_query = "SELECT COUNT(*) FROM videos WHERE mem_id=".$mem_id." AND converted='1' AND approved='1'";
		return $this->single( $sql_query );
	}

	function logout(){

		$member = $this->info();
        $logout = time()- $GLOBALS["settings"][autologout]*60;
        $sql_query = "UPDATE profiles SET last_click = '".$logout."' WHERE mem_id=".$member["mem_id"];
        $this->execute($sql_query);
        load_3rdparty("logout",array());
        load_cookie("mem_id","",-1);
        load_cookie("password","",-1);

	}//logout

	function info($mem_id=0){

		static $cache = array();

		if(empty($mem_id)){
			$info["mem_id"]   = $GLOBALS["Get"]->cookie("mem_id","integer");
			$info["password"] = preg_replace("/".preg_quote("&#124;")."/","|",html_entity_decode($GLOBALS["Get"]->cookie("password")));
			$mem_id = $info["mem_id"];
		}//if
		else{
			$info["mem_id"] = $mem_id;
		}//else

		if(!empty($info["mem_id"])){

			if(isset($cache[$mem_id]))
				return $cache[$mem_id];

			$sql_query="SELECT *
						FROM members,profiles,members_settings,channels
						WHERE members.mem_id=profiles.mem_id AND members.mem_id=members_settings.mem_id
						AND members.mem_id=channels.mem_id
						AND members.mem_id=".$info["mem_id"];

			$this->clean();
			$get = $this->row($sql_query);
			if(is_array($get)){
				while(list($key,$val) = each($get)){
					if($key != "mem_id" && $key != "password"){
						$info[$key] = $val;
					}//if
				}//while
			}//if

		}//if

		$cache[$mem_id] = $info;
		return $info;

	}//info

	function member_type($mem_id){

		$info = $this->info( $mem_id );
		return $info["member_type"];

	}//member_type

	function is_banned($mem_id){

		$info = $this->info( $mem_id );
		return $info["banned"];

	}//is_banned

	function is_verified($mem_id){

		$info = $this->info( $mem_id );
		return $info["verified"];

	}//is_verified

	function name( $mem_id ){

		$info = $this->info( $mem_id );
		return array( $info["fname"], $info["lname"] );

	}//name
	
	function mem_id( $username ) {
		$sql_query = "SELECT mem_id FROM members WHERE username=':0:'";
		$this->values = array( $username );
		$mem_id = $this->single( $sql_query );
		if(!$mem_id)
			$mem_id = 0;
		return $mem_id;
	}

	function username( $mem_id = 0 ){

		if(!$mem_id) {
			$info = $this->info();
			$mem_id = $info["mem_id"];
		}

		$info = $this->info( $mem_id );
		return $info["username"];

	}//username

	function avatar( $mem_id ){
		$info = $this->info( $mem_id );
		return ($info["avatar_approved"] || $GLOBALS["settings"]["show_unapproved_avatars"]) ? $info["avatar"] : "";
	}

	function is_ignored($mem_id,$per_id){

		$ignored = 0;
		if($mem_id && $per_id) {
			$sql_query="SELECT count(ign_id)
						FROM ignores
						WHERE mem_id=".$mem_id."
						AND per_id=".$per_id;
	
			$ignored = $this->single($sql_query);
		}
		return $ignored;

	}//is_ignored

	function ignore_list($mem_id){

		$ignores = array();

		$sql_query="SELECT per_id
					FROM ignores
					WHERE mem_id=".$mem_id;

		$result = $this->result($sql_query);
		foreach($result as $res){
			$ignores[] = $res["per_id"];
		}//foreach

		return $ignores;

	}//ignore_list

	function is_online($per_id,$ignore_settings=0){

		$sql_query="SELECT hide_status FROM members_settings
					WHERE mem_id=".$per_id;

		$hide_status = $this->single($sql_query);

		$sql_query="SELECT last_click
					FROM profiles
					WHERE mem_id=".$per_id;

		$last_click = $this->single($sql_query);
		$allowed    = time() - $GLOBALS["settings"]["autologout"]*60;

		if($last_click <= $allowed){
			return false;
		}//if
		elseif(!$hide_status || $ignore_settings){
			return true;
		}//else

	}//is_online
	
	function settings($mem_id){

		$sql_query="SELECT *
					FROM members_settings
					WHERE mem_id=".$mem_id;

		$this->clean();
		$settings = $this->row($sql_query);
		return $settings;

	}//settings	

	function level($mem_id){

		$sql_query="SELECT membership
					FROM members
					WHERE mem_id=".$mem_id;

		$level = $this->single($sql_query);
		return $level;

	}//level
	
	function current_diskspace_usage( $mem_id ) {
		
		$sql_query = "SELECT diskspace FROM members WHERE mem_id=".$mem_id;
		$space = $this->single( $sql_query );
		return $space;
		
	}
	
	function clean_watch( $mem_id ) {
		$sql_query = "DELETE FROM video_watch WHERE mem_id=".$mem_id;
		$this->execute( $sql_query );
	}

}//Member class

$Member = new Member;

?>