<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/
	
	set_time_limit(0);
	ignore_user_abort(1);
	
	$path   = $_SERVER['argv']['1'];
	$vid_id = $_SERVER['argv']['2'];
	$hash   = $_SERVER['argv']['3'];
	$ext    = $_SERVER['argv']['4'];
	
	if(!$path)
		$path = "..";

	//load global configuration
	include($path."/includes/config/config.inc.php");

	//load libraries
	include(DOC_ROOT."/libraries.php");
	
	include_once(DOC_ROOT."/classes/Videos.class.php");
	include_once(DOC_ROOT."/functions/delete_functions.php");
	include_once(DOC_ROOT."/classes/Mail.class.php");
	include_once(DOC_ROOT."/themes/".$THEME."/system/errors.inc.php");
	
	$language = array();
	build_language();
	
	$sql_query = "SELECT mem_id FROM members WHERE member_type='a'";
	$admin_id = $GLOBALS["DB"]->single( $sql_query );
	
	if($vid_id) {
		
		$sql_query = "SELECT mem_id FROM videos WHERE vid_id=".$vid_id;
		$mem_id    = $GLOBALS["DB"]->single( $sql_query );
		
		if($GLOBALS["Videos"]->diskspace > 0) {
			$disk_space = $GLOBALS["Member"]->current_diskspace_usage( $mem_id );
		} else {
			$disk_space = 0;
		}
		$status = handle_video_convert( $hash, $ext, $vid_id, $disk_space );
		if( !$status[0] ) {
			$sql_query = "SELECT title FROM videos WHERE vid_id=".$vid_id;
			$title = $GLOBALS["DB"]->single( $sql_query );
			@delete_video( $vid_id );
			$maild = array();
			$maild["subject"]   = preg_replace("/:video:/", $title, $GLOBALS["language"]["video_deleted"]);
			$maild["body"]      = $errors[$status[1]];
			$maild["recipient"] = $mem_id;
			$maild["sender"]    = $admin_id;
			$GLOBALS["Mail"]->details = $maild;
			$GLOBALS["Mail"]->send_internal();
		} else {
			$filesize  = @filesize( DOC_ROOT."/vid/".$hash.".flv" );
			if(is_numeric($filesize)) {
				$sql_query = "UPDATE members SET diskspace = diskspace + ".$filesize."
							  WHERE mem_id=".$mem_id;
				$GLOBALS["DB"]->execute( $sql_query );
			}
			$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date) VALUES (".$mem_id.",".$vid_id.",1,".time().")";
			$GLOBALS["DB"]->execute( $sql_query );
		}
		
	} elseif( $GLOBALS["videos"]["convert"] == "cron" ) {
	
		$sql_query = "SELECT * FROM video_convert LIMIT 0,10";
		$result = $GLOBALS["DB"]->result( $sql_query );
		
		$delete = array();
		foreach($result as $res) {
			
			$sql_query = "SELECT mem_id FROM videos WHERE vid_id=".$res["vid_id"];
			$mem_id    = $GLOBALS["DB"]->single( $sql_query );
			
			if($GLOBALS["Videos"]->diskspace > 0) {
				$disk_space = $GLOBALS["Member"]->current_diskspace_usage( $mem_id );
			} else {
				$disk_space = 0;
			}
			$status = handle_video_convert( $res["hash"], $res["ext"], $res["vid_id"], $disk_space );
			if( $status[0] ) {
				$delete[]  = $res["vid_id"];
				$filesize  = @filesize( DOC_ROOT."/vid/".$res["hash"].".flv" );
				if(is_numeric($filesize)) {
					$sql_query = "UPDATE members SET diskspace = diskspace + ".$filesize."
								  WHERE mem_id=".$mem_id;
					$GLOBALS["DB"]->execute( $sql_query );
				}
				$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date) VALUES (".$mem_id.",".$res["vid_id"].",1,".time().")";
				$GLOBALS["DB"]->execute( $sql_query );
			}
			elseif( $status[1] != 57 ) {
				$sql_query = "SELECT title FROM videos WHERE vid_id=".$res["vid_id"];
				$title = $GLOBALS["DB"]->single( $sql_query );
				@delete_video( $res["vid_id"] );
				$maild = array();
				$maild["subject"]   = preg_replace("/:video:/", $title, $GLOBALS["language"]["video_deleted"]);
				$maild["body"]      = $errors[$status[1]];
				$maild["recipient"] = $mem_id;
				$maild["sender"]    = $admin_id;
				$GLOBALS["Mail"]->details = $maild;
				$GLOBALS["Mail"]->send_internal();
			}
			
		}
		
		if(count($delete)) {
			$sql_query = "DELETE FROM video_convert WHERE vid_id IN (".implode(",", $delete).")";
			$DB->execute( $sql_query );
		}
		
	}
	
	$DB->disconnect();
	exit;

?>