<?php

						///////////////////////////////////////

						$action = $GLOBALS["page_details"][action];

							switch($action){

								case 'send':
									mailbox_send_message();
									break;
									
								case 'delete':
									delete_mailbox_messages();
									break;
									
								case 'reply':
									mailbox_reply('r');
									break;
									
								case 'forward':
									mailbox_reply('f');
									break;
									
								case 'invite_approve':
									mailbox_invite_action( 'a' );
									break;
									
								case 'invite_decline':
									mailbox_invite_action( 'd' );
									break;
									
								case 'comment_approve':
									mailbox_comment_action( 'a' );
									break;
									
								case 'comment_decline':
									mailbox_comment_action( 'd' );
									break;
									
								case 'response_approve':
									mailbox_response_action( 'a' );
									break;
									
								case 'response_decline':
									mailbox_response_action( 'd' );
									break;
									
								case 'group_accept':
									mailbox_group_action( 'a' );
									break;
									
								case 'group_decline':
									mailbox_group_action( 'd' );
									break;

							}//switch

						///////////////////////////////////////

function mailbox_inbox() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "inbox" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_invites() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "invites" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_shared() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "shared" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_sent() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "sent" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_comments() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "comments" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_groups() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "groups" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_responses() {
	
	$info = $GLOBALS["Member"]->info();
	
	$data = mailbox_box( $info["mem_id"], "responses" );
	$GLOBALS["smarty"]->assign("messages", $data);	
	
}

function mailbox_message() {
	
	$mes_id = $GLOBALS["Get"]->type_val("mes_id","integer");	
	$type = $GLOBALS["Get"]->val("t");
	$recipient = $GLOBALS["Get"]->val("recipient");
	
	if($mes_id && $type) {
		$sql_query="SELECT per_id,subject,message
					FROM mailbox
					WHERE mes_id=".$mes_id;
	
		$original = $GLOBALS["DB"]->row($sql_query);
	
		if($type == "r"){
			$subject = $GLOBALS["language"]["re"]." ".$original["subject"];
			$recipient = $GLOBALS["Member"]->username($original["per_id"]);
		}
		elseif($type == "f")
			$subject = $GLOBALS["language"]["fw"]." ".$original["subject"];
	
		$message = hs_ereg_replace("\n","\n> ",strip_tags($original["message"]));
		$message = "\n\n\n\n> ".$message;
		$message = hs_wordwrap($message, 55, "\n> ");
	
		$GLOBALS["forms"]["message"]["values"]["message"] = $message;
		$GLOBALS["forms"]["message"]["values"]["subject"] = $subject;
		
		rebuild_form_item( "message", "message" );
		rebuild_form_item( "message", "subject" );
	}
	
	if($recipient){
		$GLOBALS["forms"]["message"]["values"]["to"] = "[".$recipient."]";
		rebuild_form_item( "message", "to" );
	}
	
}

function mailbox_box( $mem_id, $type ) {
	
	//total
	$sql_query = "SELECT COUNT(*) FROM mailbox WHERE mailbox='".$type."' AND mem_id=".$mem_id;
	$total = $GLOBALS["DB"]->single( $sql_query );
	
	//this page
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$section = ($type == "inbox") ? "" : $type;
	$pages = handle_multipages( $p, $total, "index.php?page=mailbox&section=".$section );
	
	$sql_query = "SELECT * FROM mailbox WHERE mailbox='".$type."' AND mem_id=".$mem_id."
				  ORDER BY date DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$cards = array();
	foreach($result as $res) {
		$card = array();
		$card["from"] = $GLOBALS["Member"]->card( $res["per_id"] );
		$card["subject"] = mailbox_subject( $res );
		$card["date"] = extract_date( $res["date"] );
		$card["mes_id"] = $res["mes_id"];
		$card["viewed"] = ($type != "sent") ? $res["viewed"] : 1;
		$card["mailbox"] = $res["mailbox"];
		$cards[] = $card;
	}
	
	return array("pages" => $pages, "cards" => $cards );
		
}

function mailbox_subject( $message ){
	
	switch($message["mailbox"]) {
		case 'inbox':
		case 'sent':
		case 'invites':
		case 'groups':
			return handle_string_cut( $message["subject"], 60 );
			break;
		case 'shared':
			$subject = array();
			$data = explode("|", $message["special"] );
			if($data[0] == "video") {
				$vid_id = $data[1];
				include_once( DOC_ROOT."/classes/Videos.class.php" );
				$subject["shash"] = $GLOBALS["Videos"]->screenshot( $vid_id );
				$subject["subject"] = $message["subject"];
			} elseif ($data[0] == "channel") {
				$mem_id = $GLOBALS["Member"]->mem_id( $data[1] );
				$sql_query = "SELECT avatar FROM profiles WHERE mem_id=".$mem_id;
				$subject["avatar"] = $GLOBALS["DB"]->single( $sql_query );
				$subject["subject"] = $message["subject"];
			} elseif ($data[0] == "playlist") {
				$pla_id = $data[1];				
				$sql_query = "SELECT vid_id FROM playlist_videos WHERE pla_id=".$pla_id." AND main='1'";
				$main = $GLOBALS["DB"]->single( $sql_query );				
				if($main)
					$subject["shash"] = $GLOBALS["Videos"]->screenshot( $main );
				$subject["subject"] = $message["subject"];
			}
			return $subject;
			break;
		case 'comments':
			$sql_query = "SELECT comment FROM video_comments WHERE com_id=".$message["special"];
			return handle_string_cut( $GLOBALS["DB"]->single( $sql_query ), 60 );
			break;
		case 'responses':
			$subject = array();
			$data = explode("|", $message["special"]);
			$vid_id = $data[0];
			$sql_query = "SELECT shash FROM videos WHERE vid_id=".$vid_id;
			$subject["shash"] = $GLOBALS["DB"]->single( $sql_query );
			$subject["subject"] = $message["subject"];
			return $subject;
			break;
	}
	
}

function delete_mailbox_messages() {
	
	$info = auth_member();
	$messages = $GLOBALS["Get"]->val("mes_id");
	
	include(DOC_ROOT."/functions/delete_functions.php");
	
	$redirect = $GLOBALS["Get"]->referer();
	
	if(!is_array($messages)){
		$mes_id = $messages;
		if($mes_id > 0) {
			$messages = array( $mes_id );
			
			$sql_query = "SELECT * FROM mailbox WHERE mes_id=".$mes_id;
			$message = $GLOBALS["DB"]->row( $sql_query );
			$section = ($message["mailbox"] == "inbox") ? "" : $message["mailbox"];
			$redirect = "index.php?page=mailbox&section=".$section;
		}
	}
	
	if(is_array($messages) && count($messages)) {
		$sql_query = "DELETE FROM mailbox WHERE mem_id=".$info["mem_id"]." AND mes_id IN (".implode(",", $messages).")";
		$GLOBALS["DB"]->execute( $sql_query );
	}
	
	load_page( $redirect );
	
}

function mailbox_send_message() {
	
	$info = auth_member();
	
	include(DOC_ROOT."/functions/form_functions.php");
	$values = form_handle_input( "message" );
	
	$recipients = handle_empties( explode(",", $values["to"]) );
	
	$mail_details = array (
		"sender" => $info["mem_id"],
		"subject" => $values["subject"],
		"body" => $values["message"],
		"mailbox" => "inbox",
		"video" => $values["vid_id"]
	);
	
	$mail_details2 = array (
		"mes_id" => 5
	);
	
	include(DOC_ROOT."/classes/Mail.class.php");
	
	foreach($recipients as $recipient) {
		$recipient = str_replace("[", "", $recipient);
		$recipient = str_replace("]", "", $recipient);
		$mem_id = $GLOBALS["Member"]->mem_id( trim( $recipient ) );
		if($mem_id) {
			$mail_details["recipient"] = $mem_id;
			$mail_details2["recipient"] = $mem_id;
			$GLOBALS["Mail"]->details = $mail_details;
			$GLOBALS["Mail"]->send_internal();
			$GLOBALS["Mail"]->details = $mail_details2;
			$GLOBALS["Mail"]->send_external();
		}
	}
	
	load_page( "index.php?page=mailbox&section=sent&cmp_id=26" ); 
	
}

function mailbox_view() {
	
	$info = $GLOBALS["Member"]->info();	
	$mes_id = $GLOBALS["Get"]->type_val("mes_id", "integer");
	
	include(DOC_ROOT."/classes/Videos.class.php");	
	
	$sql_query = "SELECT * FROM mailbox WHERE mes_id=".$mes_id;
	$result = $GLOBALS["DB"]->row( $sql_query );
	
	$card = array();
	$card["from"]    = $GLOBALS["Member"]->card( $result["per_id"] );
	$card["date"]    = extract_date( $result["date"] );
	$card["subject"] = $result["subject"];
	
	if($result["mailbox"] == "comments") {
		$sql_query = "SELECT vid_id,comment FROM video_comments WHERE com_id=".$result["special"];
		$data = $GLOBALS["DB"]->row( $sql_query );
		$card["message"] = nl2br( $data["comment"] );
		$card["video"] = $GLOBALS["Videos"]->card( $data["vid_id"] );
	} elseif($result["mailbox"] == "responses") {
		$data = explode("|", $result["special"]);
		$vid_id = $data[1];
		$card["video"] = $GLOBALS["Videos"]->card( $vid_id );
	} elseif($result["mailbox"] == "groups") {
		include_once(DOC_ROOT."/classes/Groups.class.php");
		$data = explode("|", $result["special"]);
		$type = $data[0];
		$grp_id = $data[1];
		if($type == "group_invite") {
			$group = $GLOBALS["Groups"]->info( $grp_id );
			if($group["privacy"] != 2)
				$message = $GLOBALS["language"]["group_invite_public"];
			elseif($group["privacy"] == 2 && !$GLOBALS["Groups"]->is_owner( $group["mem_id"], $grp_id ))
				$message = $GLOBALS["language"]["group_invite_moderated"];
		}
		$card["message"] = $message."<br /><br />".nl2br( $result["message"] );
	} else {
		$card["message"] = nl2br( $result["message"] );
	}
	
	$card["mailbox"] = $result["mailbox"];
	
	if($result["video"]) {
		$sql_query = "SELECT COUNT(*) FROM videos WHERE vid_id=".$result["video"]." ".$GLOBALS["Videos"]->filter();
		$exists = $GLOBALS["DB"]->single( $sql_query );
		if($exists)
			$card["video"]   = $GLOBALS["Videos"]->card( $result["video"] );
	}
	
	if($result["mailbox"] == "shared") {
		$data = explode( "|", $result["special"] );
		if($data[0] == "channel") {
			$mem_id = $GLOBALS["Member"]->mem_id( $data[1] );
			$card["card"] = $GLOBALS["Member"]->card( $mem_id );
			$card["card"]["type"] = "channel";
		}
		elseif($data[0] == "video"){
			$card["card"] = $GLOBALS["Videos"]->card( $data[1] );
			$card["card"]["type"] = "video";
		}
		elseif($data[0] == "playlist"){
			include_once(DOC_ROOT."/modules/playlists.php");
			$card["card"] = playlist_card( $data[1] );
			$card["card"]["type"] = "playlist";
		}
	}

	if($result["mailbox"] == "responses") {
		$data = explode("|", $result["special"]);
		$card["card"] = $GLOBALS["Videos"]->card( $data[0] );
		$card["card"]["type"] = "video";
	}
	
	if($result["mailbox"] == "groups") {
		include_once(DOC_ROOT."/classes/Groups.class.php");
		$data = explode("|", $result["special"]);
		$card["card"] = $GLOBALS["Groups"]->card( $data[1] );
		$card["card"]["type"] = "group";
	}
	
	$GLOBALS["smarty"]->assign("message", $card);
	
	$sql_query = "UPDATE mailbox SET viewed='1' WHERE mes_id=".$mes_id;
	$GLOBALS["DB"]->execute( $sql_query );
	
}

function mailbox_reply( $type ) {
	
	$mes_id = $GLOBALS["Get"]->type_val("mes_id","integer");
	load_page( "index.php?page=mailbox&section=message&mes_id=".$mes_id."&t=".$type );
	
}

function mailbox_invite_action( $reply ) {
	
	$info = auth_member();
	$message = $GLOBALS["Get"]->val("mes_id");
	
	$messages = array();
	
	if(is_numeric( $message )) {	
		auth_view_message();
		$messages[] = $message;
	} elseif(is_array($message) && count($message)) {
		$messages = $message;
	}
	
	include_once(DOC_ROOT."/modules/channels.php");
	
	foreach($messages as $mes_id) {
	
		$sql_query = "SELECT per_id FROM mailbox WHERE mes_id=".$mes_id." AND mem_id=".$info["mem_id"];
		$per_id = $GLOBALS["DB"]->single( $sql_query );
	
		if($per_id) {
		
			if($reply == "a") {
				channel_add_friend( $info["mem_id"], $per_id );
				$cmp_id = 3;
			} elseif( $reply == "d" ) {
				channel_friend_decline( $info["mem_id"], $per_id );
				$cmp_id = 4;
			}
			
		}
		
	}
	
	load_page( "index.php?page=mailbox&section=invites&cmp_id=".$cmp_id );
	
}

function mailbox_comment_action( $reply ) {
	
	$info = auth_member();
	$message = $GLOBALS["Get"]->val("mes_id");
	
	$messages = array();
	
	if(is_numeric( $message )) {	
		auth_view_message();
		$messages[] = $message;
	} elseif(is_array($message) && count($message)) {
		$messages = $message;
	}
	
	foreach($messages as $mes_id) {
	
		$sql_query = "SELECT special FROM mailbox WHERE mes_id=".$mes_id." AND mem_id=".$info["mem_id"];
		$com_id = $GLOBALS["DB"]->single( $sql_query );
	
		if($com_id) {
		
			if($reply == "a") {
				$sql_query = "UPDATE video_comments SET approved='1' WHERE com_id=".$com_id;
				$GLOBALS["DB"]->execute( $sql_query );
				
				$sql_query = "SELECT mem_id, vid_id FROM video_comments WHERE com_id=".$com_id;
				$data = $GLOBALS["DB"]->row( $sql_query );
				
				$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date) VALUES (".$data["mem_id"].",".$data["vid_id"].",3,".time().")";
				$GLOBALS["DB"]->execute( $sql_query );
				
				$cmp_id = 8;
			} elseif( $reply == "d" ) {
				$sql_query = "DELETE FROM video_comments WHERE com_id=".$com_id;
				$GLOBALS["DB"]->execute( $sql_query );
				$cmp_id = 9;
			}
			
			$sql_query = "DELETE FROM mailbox WHERE mes_id=".$mes_id;
			$GLOBALS["DB"]->execute( $sql_query );
			
		}
		
	}
	
	load_page( "index.php?page=mailbox&section=comments&cmp_id=".$cmp_id );
	
}

function mailbox_response_action( $reply ) {
	
	$info = auth_member();
	$message = $GLOBALS["Get"]->val("mes_id");
	
	$messages = array();
	
	if(is_numeric( $message )) {	
		auth_view_message();
		$messages[] = $message;
	} elseif(is_array($message) && count($message)) {
		$messages = $message;
	}
	
	foreach($messages as $mes_id) {
	
		$sql_query = "SELECT per_id,special FROM mailbox WHERE mes_id=".$mes_id." AND mem_id=".$info["mem_id"];
		$row = $GLOBALS["DB"]->row( $sql_query );
		$data = explode("|",$row["special"]);
		
		$vid_id = $data[0];
		$response_to = $data[1];
	
		if($vid_id) {
		
			if($reply == "a") {
				$sql_query = "UPDATE video_responses SET approved='1' WHERE vid_id=".$vid_id." AND response_to=".$response_to;
				$GLOBALS["DB"]->execute( $sql_query );
				
				$sql_query = "REPLACE INTO activity (mem_id,vid_id,action,date,details) VALUES (".$row["per_id"].",".$response_to.",4,".time().",'".$vid_id."')";
				$GLOBALS["DB"]->execute( $sql_query );
				
				$cmp_id = 28;
			} elseif( $reply == "d" ) {
				$sql_query = "DELETE FROM video_responses WHERE vid_id=".$vid_id." AND response_to=".$response_to;
				$GLOBALS["DB"]->execute( $sql_query );
				$cmp_id = 29;
			}
			
			$sql_query = "DELETE FROM mailbox WHERE mes_id=".$mes_id;
			$GLOBALS["DB"]->execute( $sql_query );
			
		}
		
	}
	
	load_page( "index.php?page=mailbox&section=responses&cmp_id=".$cmp_id );
	
}

function mailbox_group_action( $reply ) {
	
	include_once( DOC_ROOT."/classes/Groups.class.php" );
	
	$info = auth_member();
	$message = $GLOBALS["Get"]->val("mes_id");
	
	$messages = array();
	
	if(is_numeric( $message )) {	
		auth_view_message();
		$messages[] = $message;
	} elseif(is_array($message) && count($message)) {
		$messages = $message;
	}
	
	foreach($messages as $mes_id) {
	
		$sql_query = "SELECT per_id,special FROM mailbox WHERE mes_id=".$mes_id." AND mem_id=".$info["mem_id"];
		$row = $GLOBALS["DB"]->row( $sql_query );
		$per_id = $row["per_id"];
		$data = explode("|",$row["special"]);
		
		$grp_id = $data[1];
		$type = $data[0];
	
		if($grp_id) {
		
			if($reply == "a") {
				
				if($type == "group_invite") {
					$join = $GLOBALS["Groups"]->join( $info["mem_id"], $per_id, $grp_id );
					if($join == "complete")
						$cmp_id = 404;
					elseif($join == "request") {
						include_once(DOC_ROOT."/classes/Mail.class.php");
	
						$sql_query = "SELECT name FROM groups WHERE grp_id=".$grp_id;
						$group_name = $GLOBALS["DB"]->single($sql_query);
					
						$mail_details1 = array (
							"mes_id" => 102,
							"sender" => $info["mem_id"],
							"group_name" => $group_name,
							"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
							"special" => "group_join|".$grp_id,
							"mailbox" => "groups",
							"body" => $message
						);
					
						$GLOBALS["Mail"]->details = $mail_details1;
						$GLOBALS["Mail"]->details["recipient"] = $GLOBALS["Groups"]->owner( $grp_id );
						$GLOBALS["Mail"]->send_internal();
					
						$cmp_id = 400;
					} elseif($join == "error") {
						$err_id = 406;
					} elseif($join == "member") {
						$err_id = 407;
					}
				} elseif ($type == "group_join") {
					$GLOBALS["Groups"]->assign_member($per_id,$grp_id);
					include_once(DOC_ROOT."/classes/Mail.class.php");
	
					$sql_query = "SELECT name FROM groups WHERE grp_id=".$grp_id;
					$group_name = $GLOBALS["DB"]->single($sql_query);
				
					$mail_details1 = array (
						"mes_id" => 104,
						"sender" => $info["mem_id"],
						"group_name" => $group_name,
						"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
						"mailbox" => "inbox",
						"body" => $message
					);
				
					$GLOBALS["Mail"]->details = $mail_details1;
					$GLOBALS["Mail"]->details["recipient"] = $per_id;
					$GLOBALS["Mail"]->send_internal();
					
					
					$cmp_id = 401;
					
				}
			} elseif ($reply == "d") {
				if ($type == "group_join") {
					include_once(DOC_ROOT."/classes/Mail.class.php");
	
					$sql_query = "SELECT name FROM groups WHERE grp_id=".$grp_id;
					$group_name = $GLOBALS["DB"]->single($sql_query);
				
					$mail_details1 = array (
						"mes_id" => 105,
						"sender" => $info["mem_id"],
						"group_name" => $group_name,
						"member_name" => $GLOBALS["Member"]->username($info["mem_id"]),
						"mailbox" => "inbox",
						"body" => $message
					);
				
					$GLOBALS["Mail"]->details = $mail_details1;
					$GLOBALS["Mail"]->details["recipient"] = $per_id;
					$GLOBALS["Mail"]->send_internal();
					$cmp_id = 402;
				}
			}
			
			$sql_query = "DELETE FROM mailbox WHERE mes_id=".$mes_id;
			$GLOBALS["DB"]->execute( $sql_query );
			
		}
		
	}
	$link = "index.php?page=mailbox&section=groups";
	if($cmp_id)
		$link.= "&cmp_id=".$cmp_id;
	if($err_id)
		$link.= "&err_id=".$err_id;
		
	load_page( $link );
	
}

?>