<?php

						/*************************************\

						           ClipHouse (1.0)
						            by DZOIC LTD
						       Copyright(c) 2007-2008
						        http://www.dzoic.com

						\*************************************/

						include_once(DOC_ROOT."/classes/Videos.class.php");

						///////////////////////////////////////

						$action = $GLOBALS["Get"]->val("action");
						if(!$action)
							$action = $GLOBALS["Get"]->val("act");

							switch($action){

								case 'do_search':
									search_perform();
									break;
									
								case 'search_related':
									search_related();
									break;

							}//switch

						///////////////////////////////////////
						
function search_perform() {
	
	auth_member();
	
	$type = $GLOBALS["Get"]->val("type");
	switch($type) {
		case 'channels':
			search_channels();
			break;
		case 'videos':
		default:
			search_videos();
			break;
	}
	
}

function search_related() {
	
	$info = auth_member();
	$vid_id = $GLOBALS["Get"]->type_val("vid_id","integer");
	
	$entry = $GLOBALS["Videos"]->info( $vid_id );
	$video = $GLOBALS["Videos"]->card( $vid_id );
	
	$tags = explode("|", $entry["tags"]);
	$sql_query_total  = "SELECT COUNT(*) FROM videos WHERE 1 ";
	$sql_query_result = "SELECT vid_id FROM videos WHERE 1 ";
	$sql_query = "";
	if(count($tags)) {
		$sql_query.= " AND (";
	}
	foreach($tags as $tag) {
		if($tag)
			$sql_query.= " tags LIKE '%|".handle_sql_patterns( $tag )."|%' OR ";
	}
	$sql_query = rtrim( $sql_query, " OR ");
	if(count($tags))
		$sql_query.= ")";
	$sql_query.= " AND vid_id != ".$vid_id." ".$GLOBALS["Videos"]->filter();
	
	$total = $GLOBALS["DB"]->single( $sql_query_total.$sql_query );
	$p = $GLOBALS["Get"]->type_val("p", "integer");
	$link = "index.php?handler=search&action=search_related&vid_id=".$vid_id;
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query_result.= $sql_query." ORDER BY posted DESC LIMIT ".$pages["start"].",".$pages["items_per_page"];
	$result = $GLOBALS["DB"]->result( $sql_query_result );
	$related = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$related[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("video", $video);
	$GLOBALS["smarty"]->assign("videos", $related);
	$GLOBALS["smarty"]->assign("pages", $pages);
	$GLOBALS["smarty"]->assign("type", "videos");
	
	$p_details = array (
		"page"       => "search",
		"section"    => "",
		"items_file" => "search"
	);
	build_page($p_details);
	
}

function search_channels() {
	
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("search");
	
	$values["keyword"] = preg_replace("/&#124;/", "|", $values["keyword"]);
	$values["keyword"] = stripslashes( html_entity_decode( $values["keyword"] ) );
	
	if(strlen($values["keyword"]) < 3) {
		build_error( 52, $values["err_page"], $values["err_section"] );
	}
	
	$sql_query = "SELECT COUNT(*) FROM channels WHERE 1 ";
	$query = search_build_query( $values["keyword"], "channels" );
	$sql_query.= " AND (".$query["query"].") ";
	
	$total = $GLOBALS["DB"]->single( $sql_query );
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$link = "index.php?handler=search&action=do_search&keyword=".urlencode($values["keyword"])."&type=channels";
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT mem_id FROM channels WHERE 1 ";
	$sql_query.= " AND (".$query["query"].") ".$query["order"]." LIMIT ".$pages["start"].",".$pages["items_per_page"];
	
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$channels = array();
	foreach($result as $res) {
		$card = $GLOBALS["Member"]->card( $res["mem_id"], 1 );
		$sql_query = "SELECT * FROM channels WHERE mem_id=".$res["mem_id"];
		$channel = $GLOBALS["DB"]->row( $sql_query );
		$card["type"] = extract_option( "channeltype", $channel["type"] );
		$card["video_views"] = handle_num_format( $GLOBALS["DB"]->single( "SELECT SUM(viewed) FROM videos WHERE mem_id=".$res["mem_id"] ) );
		$card["description"] = nl2br( handle_string_cut( $channel["description"] ) );
		$channels[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("channels", $channels);
	$GLOBALS["smarty"]->assign("pages", $pages);
	$GLOBALS["smarty"]->assign("type", "channels");
	
	$p_details = array (
		"page"       => "search",
		"section"    => "",
		"items_file" => "search"
	);
	build_page($p_details);
	
}

function search_videos() {
	
	include_once(DOC_ROOT."/classes/Videos.class.php");
	include_once(DOC_ROOT."/functions/form_functions.php");
	
	$values = form_handle_input("search");
	
	$values["keyword"] = preg_replace("/&#124;/", "|", $values["keyword"]);
	$values["keyword"] = stripslashes( html_entity_decode( $values["keyword"] ) );
	
	if(strlen($values["keyword"]) < 3) {
		build_error( 52, $values["err_page"], $values["err_section"] );
	}
	
	$sql_query = "SELECT COUNT(*) FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter();
	$query = search_build_query( $values["keyword"], "videos" );
	$sql_query.= " AND (".$query["query"].") ";
	
	$total = $GLOBALS["DB"]->single( $sql_query );
	$p = $GLOBALS["Get"]->type_val("p","integer");
	$link = "index.php?handler=search&action=do_search&keyword=".urlencode($values["keyword"])."&type=videos";
	$pages = handle_multipages( $p, $total, $link );
	
	$sql_query = "SELECT vid_id FROM videos WHERE 1 ".$GLOBALS["Videos"]->filter();
	$sql_query.= " AND (".$query["query"].") ".$query["order"]." LIMIT ".$pages["start"].",".$pages["items_per_page"];
	
	$result = $GLOBALS["DB"]->result( $sql_query );
	
	$videos = array();
	foreach($result as $res) {
		$card = $GLOBALS["Videos"]->card( $res["vid_id"] );
		$videos[] = $card;
	}
	
	$GLOBALS["smarty"]->assign("videos", $videos);
	$GLOBALS["smarty"]->assign("pages", $pages);
	$GLOBALS["smarty"]->assign("type", "videos");
	
	$p_details = array (
		"page"       => "search",
		"section"    => "",
		"items_file" => "search"
	);
	build_page($p_details);
	
}

function search_build_query( $keyword, $type ) {	
	
	$keyword = handle_sql_patterns( $keyword );
	$keywords_arr = handle_empties(explode(" ", $keyword));
	$keywords = array();
	foreach($keywords_arr as $key => $val) {
		if(strlen($val) >= 3)
			$keywords[] = $val;
	}
	
	$query = "";
	
	if($type == "videos") {
	
		//tags
		$query.= "( tags LIKE '%|".$keyword."|%'";
		foreach($keywords as $k){
			$query.= " OR tags LIKE '%|".$k."|%' ";
		}
		$query.= ") OR ";
		
	}
	
	//title
	$query.= " ( ".search_pattern( "title", $keyword );
	reset($keywords);
	foreach($keywords as $k){
		$query.= " OR ".search_pattern( "title", $k );
	}
	$query.= ") ";
	
	//description
	$query.= " OR ( ".search_pattern( "description", $keyword );
	reset($keywords);
	foreach($keywords as $k){
		$query.= " OR ".search_pattern( "description", $k );
	}
	$query.= ") ";
	
	//order
	$order = " ORDER BY CASE ";
	
	if($type == "videos")
		$order.= " WHEN ( tags LIKE '%|".$keyword."|%' ) THEN 0 ";
	
	$order.= " WHEN ( ".search_pattern( "title", $keyword )." ) THEN 1 ";	
	$order.= " WHEN ( ".search_pattern( "description", $keyword ).") THEN 2 ";
	
	if(count($keywords)) {
	
	if($type == "videos") {
		$order.= " WHEN ( ";
		reset($keywords);
		foreach($keywords as $k){
			$order.= " tags LIKE '%|".$k."|%' OR ";
		}
		$order = rtrim( $order, " OR " );
		$order.= ") THEN 3 ";
	}
	
	//title
	
	reset($keywords);
	$order.= " WHEN ( ";
	foreach($keywords as $k){
		$order.= " ".search_pattern( "title", $k )." OR ";
	}
	$order = rtrim( $order, " OR " );
	$order.= ") THEN 4 ";
	
	//description
	
	reset($keywords);
	$order.= " WHEN ( ";
	foreach($keywords as $k){
		$order.= " ".search_pattern( "description", $k )." OR ";
	}
	$order = rtrim( $order, " OR " );
	$order.= ") THEN 5 ";
	
	}
	
	$order.= " ELSE 6 END ";
	
	return array("query" => $query, "order" => $order);
	
}

function search_pattern( $field, $keyword ) {
	
	$query = " ( ".$field." LIKE '".$keyword."%' OR ".$field." LIKE '%".$keyword."%' 
			 OR ".$field." LIKE '%".$keyword."' OR ".$field." = '".$keyword."' ) ";
	
	return $query;
	
	
}


						
?>